/*** sciDrv.h - TMS320F28035 (piccolo) SCI Driver ***/

/*** Copyright(C) 2011 Sansei System Co.,Ltd. ***/

/*** HISTORY ***
 * 2011/02/15 mimu
              First Version
 */

#ifndef	INC_sciDrv_H
#define	INC_sciDrv_H

int sciDrvInit( unsigned long _baseClock );
int sciCtrl( unsigned long bps, int charLen, char parity, int stop );
int sciOpen( void );
int sciClose( void );
int sciTx( unsigned char * pData, int len, int lenMin );
int sciRx( unsigned char * pData, int len, int lenMin );



#endif	/* INC_sciDrv_H */

/*** end of file : sciDrv.h ***/
