L 1 "../src/bsp/sysLib.c"
N
N#include "config.h"
L 1 "..\src\bsp\config.h" 1
N/*** config.h ***/
N
N
N#ifndef	INC_config_H
N#define	INC_config_H
N
N/******************************************************************************/
N/* NvRam Configuration                                                        */
N/******************************************************************************/
N#define	FLASH_PROGRAM_SEC_NO		0
N#define	FLASH_PROGRAM_SEC_NUM		6
N
N#define	FLASH_BOOTLOADER_SEC_NO		(FLASH_PROGRAM_SEC_NO + FLASH_PROGRAM_SEC_NUM)
N#define	FLASH_BOOTLOADER_SEC_NUM	2
N
N/******************************************************************************/
N/* Driver Configuration                                                       */
N/******************************************************************************/
N
N/*** CPU TIMER ***/
N#define	SUPPORT_CPU_TIMER_0		/* !! ATTATION !! system need timer0 */
N//#define	SUPPORT_CPU_TIMER_1
N//#define	SUPPORT_CPU_TIMER_2
N
N/*** SCI ***/
N#define	SUPPORT_SCI_A
N
N/*** Flash Mem. ***/
N//#define	SUPPORT_FLASH
N
N/******************************************************************************/
N/* GPIO map                                                                   */
N/******************************************************************************/
N#define	GPIO_NO_CPU_LED	39
N
N//#define	GPIO_NO_SCIRXDA	7
N#define	GPIO_NO_SCIRXDA	28
N
N//#define	GPIO_NO_SCITXDA	12
N#define	GPIO_NO_SCITXDA	29
N
N
N/*-----------------------------------------------------------------------------
N      Specify the PLL control register (PLLCR) and divide select (DIVSEL) value.
N-----------------------------------------------------------------------------*/
N
N//#define DSP28_DIVSEL   0 // Enable /4 for SYSCLKOUT
N//#define DSP28_DIVSEL   1 // Disable /4 for SYSCKOUT
N#define DSP28_DIVSEL   2 // Enable /2 for SYSCLKOUT
N//#define DSP28_DIVSEL   3 // Enable /1 for SYSCLKOUT
N
N
N#define DSP28_PLLCR   12    // Uncomment for 60 MHz devices [60 MHz = (10MHz * 12)/2]
N//#define DSP28_PLLCR   11
N//#define DSP28_PLLCR   10
N//#define DSP28_PLLCR    9
N//#define DSP28_PLLCR    8      // Uncomment for 40 MHz devices [40 MHz = (10MHz * 8)/2]
N//#define DSP28_PLLCR    7
N//#define DSP28_PLLCR    6
N//#define DSP28_PLLCR    5
N//#define DSP28_PLLCR    4
N//#define DSP28_PLLCR    3
N//#define DSP28_PLLCR    2
N//#define DSP28_PLLCR    1
N//#define DSP28_PLLCR    0  // PLL is bypassed in this mode
N//----------------------------------------------------------------------------
N
N/*-----------------------------------------------------------------------------
N      Specify the clock rate of the CPU (SYSCLKOUT) in nS.
N
N      Take into account the input clock frequency and the PLL multiplier
N      selected in step 1.
N
N      Use one of the values provided, or define your own.
N      The trailing L is required tells the compiler to treat
N      the number as a 64-bit value.
N
N      Only one statement should be uncommented.
N
N      Example:   60 MHz devices:
N                 CLKIN is a 10 MHz crystal or internal 10 MHz oscillator
N
N                 In step 1 the user specified PLLCR = 0xC for a
N                 60 MHz CPU clock (SYSCLKOUT = 60 MHz).
N
N                 In this case, the CPU_RATE will be 16.667L
N                 Uncomment the line: #define CPU_RATE 16.667L
N
N-----------------------------------------------------------------------------*/
N
N#define CPU_RATE   16.667L   // for a 60MHz CPU clock speed (SYSCLKOUT)
N//#define CPU_RATE   20.000L   // for a 50MHz CPU clock speed  (SYSCLKOUT)
N//#define CPU_RATE   25.000L   // for a 40MHz CPU clock speed  (SYSCLKOUT)
N//#define CPU_RATE   33.333L   // for a 30MHz CPU clock speed  (SYSCLKOUT)
N//#define CPU_RATE   41.667L   // for a 24MHz CPU clock speed  (SYSCLKOUT)
N//#define CPU_RATE   50.000L   // for a 20MHz CPU clock speed  (SYSCLKOUT)
N//#define CPU_RATE   66.667L   // for a 15MHz CPU clock speed  (SYSCLKOUT)
N//#define CPU_RATE  100.000L   // for a 10MHz CPU clock speed  (SYSCLKOUT)
N
N#if 0
S//----------------------------------------------------------------------------
S
S// The following pointer to a function call calibrates the ADC and internal oscillators
S#define Device_cal (void   (*)(void))0x3D7C80
S
S//---------------------------------------------------------------------------
S// Include Example Header Files:
S//
S
S#include "DSP2803x_GlobalPrototypes.h"         // Prototypes for global functions within the
S                                               // .c files.
S#include "DSP2803x_EPwm_defines.h"             // Macros used for PWM examples.
S#include "DSP2803x_I2C_defines.h"              // Macros used for I2C examples.
S#include "DSP2803x_Cla_Defines.h"              // Macros used for CLA examples.
S
S
S#define   PARTNO_28030PAG   0xAA
S#define   PARTNO_28030PN    0xAB
S
S#define   PARTNO_28031PAG   0xAE
S#define   PARTNO_28031PN    0xAF
S
S#define   PARTNO_28032PAG   0xB2
S#define   PARTNO_28032PN    0xB3
S
S#define   PARTNO_28033PAG   0xB6
S#define   PARTNO_28033PN    0xB7
S
S#define   PARTNO_28034PAG   0xBA
S#define   PARTNO_28034PN    0xBB
S
S#define   PARTNO_28035PAG   0xBE
S#define   PARTNO_28035PN    0xBF
S
S// Include files not used with DSP/BIOS
S#ifndef DSP28_BIOS
S#include "DSP2803x_DefaultISR.h"
S#endif
N#endif
N
Nextern void DSP28x_usDelay(unsigned long Count);
N// DO NOT MODIFY THIS LINE.
N#define DELAY_US(A)  DSP28x_usDelay(((((long double) A * 1000.0L) / (long double)CPU_RATE) - 9.0L) / 5.0L)
N
N#endif	/* INC_config_H */
N
N/*** end of file : config.h ***/
L 3 "../src/bsp/sysLib.c" 2
N#include "sysLib.h"
L 1 "..\src\bsp\sysLib.h" 1
N/*** sysLib.h - system i/f header ***/
N
N/*** Copyright(C) 2008 mimu ***/
N
N/*** NOTE ***
N */
N
N/*** HISTORY ***
N * 2007/08/xx mimu@emb
N              First version for SH-4A
N */
N
N#ifndef	INC_sysLib_H
N#define	INC_sysLib_H
N
N#ifndef	_ASMLANGUAGE
N
N#include	"config.h"
N
N//#include	"kernel.h"
N
N#ifdef	__cplusplus
Sextern "C" {
N#endif
N
N
Nint sysInit( void );
N
Nvoid sysDummyFunc();
Nvoid sysHalt( const char * msg );
N
N/* interrupt mask */
Nint		sysIntLock( void );
Nvoid	sysIntUnlock( int );
N
Nvoid bspDelay100nSec( int count );
N
Nconst char * sysOptionStringSerch( const char * pOpt, int *pLen, char startcode );
N
N/* for interrupt */
Nint sysIntConnect( unsigned int vecNo, void (*pFunc)(unsigned int vecNo) );
Nint sysIntEnable( unsigned int vecNo );
Nint sysIntDisable( unsigned int vecNo );
N
N//void * sysAlloc( unsigned long size, unsigned long aligne, int bDma );
N
N//extern void cachePurge( void * p, unsigned long size);	/* this function defined in romInit.src */
N
N/*** for NV-RAM ***/
N
N#if 0
S//int sysNvRamInit( void );
S//
S//int	sysNvRamMacGet( int ch, unsigned char * pMac );
S//int sysNvRamMacSet( int ch, unsigned char * pMac );
S//
S//int sysNvRamNetGet( int ch, SysNetCfg * pNet );
S//int sysNvRamNetSet( int ch, SysNetCfg * pNet );
S//
S//int sysNvRamExceptionGet( SysException * pSysException );
S//
S//int sysNvRamConsoleBpsGet( void );
S//int sysNvRamConsoleBpsSet( int bps );
S//
S//int sysNvRamPasswordGet( unsigned char * password );
S//int sysNvRamPasswordSet( unsigned char * password, int len );
S//
S//int sysNvRamLcdContrastGet( void );
S//int sysNvRamLcdContrastSet( int contrast );
N#endif
N
N#if 0	/* move to sysNvRam.h */
Sint	sysNvRamMacGet( int ch, unsigned char * );
Sint sysNvRamMacSet( int ch, unsigned char * );
N#endif
N
N#ifdef	__cplusplus
S}
N#endif
N
N#endif	/* _ASMLANGUAGE */
N#endif	/* INC_sysLib_H */
N
N/*** end of file : sysLib.h ***/
L 4 "../src/bsp/sysLib.c" 2
N
N//#include "DSP2803x_Device.h"
N#include "tms320f28035/tms320f28035.h"
L 1 "..\src\bsp\tms320f28035/tms320f28035.h" 1
N/*** tms320f28035.h - TI TMS320F28035 ***/
N
N/*** Copyright(C) 2011 Sansei System Co.,Ltd. ***/
N
N/*** HISTORY ***
N * 2011/02/22 mimu
N              First Version
N */
N
N#ifndef	INC_tms320f28035_H
N#define	INC_tms320f28035_H
N
N
N/*** Core control ***/
Nextern cregister volatile unsigned int IFR;
Nextern cregister volatile unsigned int IER;
N
N#define  EINT   asm(" clrc INTM")
N#define  DINT   asm(" setc INTM")
N#define  ERTM   asm(" clrc DBGM")
N#define  DRTM   asm(" setc DBGM")
N#define  EALLOW asm(" EALLOW")
N#define  EDIS   asm(" EDIS")
N#define  ESTOP0 asm(" ESTOP0")
N
N
N/*** Memory Map ***/
N
N#define	PIE_VECT_ADRS	0x000d00
N
N
N#endif	/* INC_tms320f28035_H */
N
N/*** end of file : tms320f28035.h ***/
L 7 "../src/bsp/sysLib.c" 2
N
Nextern void InitSysCtrl(void);
Nextern void InitPieCtrl( void );
N
N#define PIECTRL  (volatile unsigned short *)0x00000CE0 /* PIE, Control Register            */
N#define PIEACK   (volatile unsigned short *)0x00000CE1 /* PIE, Acknowledge Register        */
N#define PIEIER1  (volatile unsigned short *)0x00000CE2 /* PIE, INT1 Group Enable Register  */
N#define PIEIFR1  (volatile unsigned short *)0x00000CE3 /* PIE, INT1 Group Flag Register    */
N#define PIEIER2  (volatile unsigned short *)0x00000CE4 /* PIE, INT2 Group Enable Register  */
N#define PIEIFR2  (volatile unsigned short *)0x00000CE5 /* PIE, INT2 Group Flag Register    */
N#define PIEIER3  (volatile unsigned short *)0x00000CE6 /* PIE, INT3 Group Enable Register  */
N#define PIEIFR3  (volatile unsigned short *)0x00000CE7 /* PIE, INT3 Group Flag Register    */
N#define PIEIER4  (volatile unsigned short *)0x00000CE8 /* PIE, INT4 Group Enable Register  */
N#define PIEIFR4  (volatile unsigned short *)0x00000CE9 /* PIE, INT4 Group Flag Register    */
N#define PIEIER5  (volatile unsigned short *)0x00000CEA /* PIE, INT5 Group Enable Register  */
N#define PIEIFR5  (volatile unsigned short *)0x00000CEB /* PIE, INT5 Group Flag Register    */
N#define PIEIER6  (volatile unsigned short *)0x00000CEC /* PIE, INT6 Group Enable Register  */
N#define PIEIFR6  (volatile unsigned short *)0x00000CED /* PIE, INT6 Group Flag Register    */
N#define PIEIER7  (volatile unsigned short *)0x00000CEE /* PIE, INT7 Group Enable Register  */
N#define PIEIFR7  (volatile unsigned short *)0x00000CEF /* PIE, INT7 Group Flag Register    */
N#define PIEIER8  (volatile unsigned short *)0x00000CF0 /* PIE, INT8 Group Enable Register  */
N#define PIEIFR8  (volatile unsigned short *)0x00000CF1 /* PIE, INT8 Group Flag Register    */
N#define PIEIER9  (volatile unsigned short *)0x00000CF2 /* PIE, INT9 Group Enable Register  */
N#define PIEIFR9  (volatile unsigned short *)0x00000CF3 /* PIE, INT9 Group Flag Register    */
N#define PIEIER10 (volatile unsigned short *)0x00000CF4 /* PIE, INT10 Group Enable Register */
N#define PIEIFR10 (volatile unsigned short *)0x00000CF5 /* PIE, INT10 Group Flag Register   */
N#define PIEIER11 (volatile unsigned short *)0x00000CF6 /* PIE, INT11 Group Enable Register */
N#define PIEIFR11 (volatile unsigned short *)0x00000CF7 /* PIE, INT11 Group Flag Register   */
N#define PIEIER12 (volatile unsigned short *)0x00000CF8 /* PIE, INT12 Group Enable Register */
N#define PIEIFR12 (volatile unsigned short *)0x00000CF9 /* PIE, INT12 Group Flag Register   */
N
N#define	PIE_REG_END (volatile unsigned short *)0x00000CFA
N
Nstatic void intDummyFunc( unsigned int vecNo ){ sysIntDisable(vecNo); /* for(;;){;}*/ }
N//static void intFunc( unsigned int vecNo );
N
N#define	_intFuncName( _id )	intFunc_##_id
N#define	_IntFunc( _id ) interrupt void _intFuncName(_id)( ) { intFunc(_id); }
N
N
Nextern void _intFuncName(0)(void);
Xextern void intFunc_0(void);
Nextern void _intFuncName(1)(void);
Xextern void intFunc_1(void);
Nextern void _intFuncName(2)(void);
Xextern void intFunc_2(void);
Nextern void _intFuncName(3)(void);
Xextern void intFunc_3(void);
Nextern void _intFuncName(4)(void);
Xextern void intFunc_4(void);
Nextern void _intFuncName(5)(void);
Xextern void intFunc_5(void);
Nextern void _intFuncName(6)(void);
Xextern void intFunc_6(void);
Nextern void _intFuncName(7)(void);
Xextern void intFunc_7(void);
Nextern void _intFuncName(8)(void);
Xextern void intFunc_8(void);
Nextern void _intFuncName(9)(void);
Xextern void intFunc_9(void);
Nextern void _intFuncName(10)(void);
Xextern void intFunc_10(void);
Nextern void _intFuncName(11)(void);
Xextern void intFunc_11(void);
Nextern void _intFuncName(12)(void);
Xextern void intFunc_12(void);
Nextern void _intFuncName(13)(void);
Xextern void intFunc_13(void);
Nextern void _intFuncName(14)(void);
Xextern void intFunc_14(void);
Nextern void _intFuncName(15)(void);
Xextern void intFunc_15(void);
Nextern void _intFuncName(16)(void);
Xextern void intFunc_16(void);
Nextern void _intFuncName(17)(void);
Xextern void intFunc_17(void);
Nextern void _intFuncName(18)(void);
Xextern void intFunc_18(void);
Nextern void _intFuncName(19)(void);
Xextern void intFunc_19(void);
Nextern void _intFuncName(20)(void);
Xextern void intFunc_20(void);
Nextern void _intFuncName(21)(void);
Xextern void intFunc_21(void);
Nextern void _intFuncName(22)(void);
Xextern void intFunc_22(void);
Nextern void _intFuncName(23)(void);
Xextern void intFunc_23(void);
Nextern void _intFuncName(24)(void);
Xextern void intFunc_24(void);
Nextern void _intFuncName(25)(void);
Xextern void intFunc_25(void);
Nextern void _intFuncName(26)(void);
Xextern void intFunc_26(void);
Nextern void _intFuncName(27)(void);
Xextern void intFunc_27(void);
Nextern void _intFuncName(28)(void);
Xextern void intFunc_28(void);
Nextern void _intFuncName(29)(void);
Xextern void intFunc_29(void);
Nextern void _intFuncName(30)(void);
Xextern void intFunc_30(void);
Nextern void _intFuncName(31)(void);
Xextern void intFunc_31(void);
Nextern void _intFuncName(32)(void);
Xextern void intFunc_32(void);
Nextern void _intFuncName(33)(void);
Xextern void intFunc_33(void);
Nextern void _intFuncName(34)(void);
Xextern void intFunc_34(void);
Nextern void _intFuncName(35)(void);
Xextern void intFunc_35(void);
Nextern void _intFuncName(36)(void);
Xextern void intFunc_36(void);
Nextern void _intFuncName(37)(void);
Xextern void intFunc_37(void);
Nextern void _intFuncName(38)(void);
Xextern void intFunc_38(void);
Nextern void _intFuncName(39)(void);
Xextern void intFunc_39(void);
Nextern void _intFuncName(40)(void);
Xextern void intFunc_40(void);
Nextern void _intFuncName(41)(void);
Xextern void intFunc_41(void);
Nextern void _intFuncName(42)(void);
Xextern void intFunc_42(void);
Nextern void _intFuncName(43)(void);
Xextern void intFunc_43(void);
Nextern void _intFuncName(44)(void);
Xextern void intFunc_44(void);
Nextern void _intFuncName(45)(void);
Xextern void intFunc_45(void);
Nextern void _intFuncName(46)(void);
Xextern void intFunc_46(void);
Nextern void _intFuncName(47)(void);
Xextern void intFunc_47(void);
Nextern void _intFuncName(48)(void);
Xextern void intFunc_48(void);
Nextern void _intFuncName(49)(void);
Xextern void intFunc_49(void);
Nextern void _intFuncName(50)(void);
Xextern void intFunc_50(void);
Nextern void _intFuncName(51)(void);
Xextern void intFunc_51(void);
Nextern void _intFuncName(52)(void);
Xextern void intFunc_52(void);
Nextern void _intFuncName(53)(void);
Xextern void intFunc_53(void);
Nextern void _intFuncName(54)(void);
Xextern void intFunc_54(void);
Nextern void _intFuncName(55)(void);
Xextern void intFunc_55(void);
Nextern void _intFuncName(56)(void);
Xextern void intFunc_56(void);
Nextern void _intFuncName(57)(void);
Xextern void intFunc_57(void);
Nextern void _intFuncName(58)(void);
Xextern void intFunc_58(void);
Nextern void _intFuncName(59)(void);
Xextern void intFunc_59(void);
Nextern void _intFuncName(60)(void);
Xextern void intFunc_60(void);
Nextern void _intFuncName(61)(void);
Xextern void intFunc_61(void);
Nextern void _intFuncName(62)(void);
Xextern void intFunc_62(void);
Nextern void _intFuncName(63)(void);
Xextern void intFunc_63(void);
Nextern void _intFuncName(64)(void);
Xextern void intFunc_64(void);
Nextern void _intFuncName(65)(void);
Xextern void intFunc_65(void);
Nextern void _intFuncName(66)(void);
Xextern void intFunc_66(void);
Nextern void _intFuncName(67)(void);
Xextern void intFunc_67(void);
Nextern void _intFuncName(68)(void);
Xextern void intFunc_68(void);
Nextern void _intFuncName(69)(void);
Xextern void intFunc_69(void);
Nextern void _intFuncName(70)(void);
Xextern void intFunc_70(void);
Nextern void _intFuncName(71)(void);
Xextern void intFunc_71(void);
Nextern void _intFuncName(72)(void);
Xextern void intFunc_72(void);
Nextern void _intFuncName(73)(void);
Xextern void intFunc_73(void);
Nextern void _intFuncName(74)(void);
Xextern void intFunc_74(void);
Nextern void _intFuncName(75)(void);
Xextern void intFunc_75(void);
Nextern void _intFuncName(76)(void);
Xextern void intFunc_76(void);
Nextern void _intFuncName(77)(void);
Xextern void intFunc_77(void);
Nextern void _intFuncName(78)(void);
Xextern void intFunc_78(void);
Nextern void _intFuncName(79)(void);
Xextern void intFunc_79(void);
Nextern void _intFuncName(80)(void);
Xextern void intFunc_80(void);
Nextern void _intFuncName(81)(void);
Xextern void intFunc_81(void);
Nextern void _intFuncName(82)(void);
Xextern void intFunc_82(void);
Nextern void _intFuncName(83)(void);
Xextern void intFunc_83(void);
Nextern void _intFuncName(84)(void);
Xextern void intFunc_84(void);
Nextern void _intFuncName(85)(void);
Xextern void intFunc_85(void);
Nextern void _intFuncName(86)(void);
Xextern void intFunc_86(void);
Nextern void _intFuncName(87)(void);
Xextern void intFunc_87(void);
Nextern void _intFuncName(88)(void);
Xextern void intFunc_88(void);
Nextern void _intFuncName(89)(void);
Xextern void intFunc_89(void);
Nextern void _intFuncName(90)(void);
Xextern void intFunc_90(void);
Nextern void _intFuncName(91)(void);
Xextern void intFunc_91(void);
Nextern void _intFuncName(92)(void);
Xextern void intFunc_92(void);
Nextern void _intFuncName(93)(void);
Xextern void intFunc_93(void);
Nextern void _intFuncName(94)(void);
Xextern void intFunc_94(void);
Nextern void _intFuncName(95)(void);
Xextern void intFunc_95(void);
Nextern void _intFuncName(96)(void);
Xextern void intFunc_96(void);
Nextern void _intFuncName(97)(void);
Xextern void intFunc_97(void);
Nextern void _intFuncName(98)(void);
Xextern void intFunc_98(void);
Nextern void _intFuncName(99)(void);
Xextern void intFunc_99(void);
Nextern void _intFuncName(100)(void);
Xextern void intFunc_100(void);
Nextern void _intFuncName(101)(void);
Xextern void intFunc_101(void);
Nextern void _intFuncName(102)(void);
Xextern void intFunc_102(void);
Nextern void _intFuncName(103)(void);
Xextern void intFunc_103(void);
Nextern void _intFuncName(104)(void);
Xextern void intFunc_104(void);
Nextern void _intFuncName(105)(void);
Xextern void intFunc_105(void);
Nextern void _intFuncName(106)(void);
Xextern void intFunc_106(void);
Nextern void _intFuncName(107)(void);
Xextern void intFunc_107(void);
Nextern void _intFuncName(108)(void);
Xextern void intFunc_108(void);
Nextern void _intFuncName(109)(void);
Xextern void intFunc_109(void);
Nextern void _intFuncName(110)(void);
Xextern void intFunc_110(void);
Nextern void _intFuncName(111)(void);
Xextern void intFunc_111(void);
Nextern void _intFuncName(112)(void);
Xextern void intFunc_112(void);
Nextern void _intFuncName(113)(void);
Xextern void intFunc_113(void);
Nextern void _intFuncName(114)(void);
Xextern void intFunc_114(void);
Nextern void _intFuncName(115)(void);
Xextern void intFunc_115(void);
Nextern void _intFuncName(116)(void);
Xextern void intFunc_116(void);
Nextern void _intFuncName(117)(void);
Xextern void intFunc_117(void);
Nextern void _intFuncName(118)(void);
Xextern void intFunc_118(void);
Nextern void _intFuncName(119)(void);
Xextern void intFunc_119(void);
Nextern void _intFuncName(120)(void);
Xextern void intFunc_120(void);
Nextern void _intFuncName(121)(void);
Xextern void intFunc_121(void);
Nextern void _intFuncName(122)(void);
Xextern void intFunc_122(void);
Nextern void _intFuncName(123)(void);
Xextern void intFunc_123(void);
Nextern void _intFuncName(124)(void);
Xextern void intFunc_124(void);
Nextern void _intFuncName(125)(void);
Xextern void intFunc_125(void);
Nextern void _intFuncName(126)(void);
Xextern void intFunc_126(void);
Nextern void _intFuncName(127)(void);
Xextern void intFunc_127(void);
N
Nstatic const unsigned long _intFuncInitTbl[] =
N{
N	(unsigned long)_intFuncName(0),
X	(unsigned long)intFunc_0,
N	(unsigned long)_intFuncName(1),
X	(unsigned long)intFunc_1,
N	(unsigned long)_intFuncName(2),
X	(unsigned long)intFunc_2,
N	(unsigned long)_intFuncName(3),
X	(unsigned long)intFunc_3,
N	(unsigned long)_intFuncName(4),
X	(unsigned long)intFunc_4,
N	(unsigned long)_intFuncName(5),
X	(unsigned long)intFunc_5,
N	(unsigned long)_intFuncName(6),
X	(unsigned long)intFunc_6,
N	(unsigned long)_intFuncName(7),
X	(unsigned long)intFunc_7,
N	(unsigned long)_intFuncName(8),
X	(unsigned long)intFunc_8,
N	(unsigned long)_intFuncName(9),
X	(unsigned long)intFunc_9,
N	(unsigned long)_intFuncName(10),
X	(unsigned long)intFunc_10,
N	(unsigned long)_intFuncName(11),
X	(unsigned long)intFunc_11,
N	(unsigned long)_intFuncName(12),
X	(unsigned long)intFunc_12,
N	(unsigned long)_intFuncName(13),
X	(unsigned long)intFunc_13,
N	(unsigned long)_intFuncName(14),
X	(unsigned long)intFunc_14,
N	(unsigned long)_intFuncName(15),
X	(unsigned long)intFunc_15,
N	(unsigned long)_intFuncName(16),
X	(unsigned long)intFunc_16,
N	(unsigned long)_intFuncName(17),
X	(unsigned long)intFunc_17,
N	(unsigned long)_intFuncName(18),
X	(unsigned long)intFunc_18,
N	(unsigned long)_intFuncName(19),
X	(unsigned long)intFunc_19,
N	(unsigned long)_intFuncName(20),
X	(unsigned long)intFunc_20,
N	(unsigned long)_intFuncName(21),
X	(unsigned long)intFunc_21,
N	(unsigned long)_intFuncName(22),
X	(unsigned long)intFunc_22,
N	(unsigned long)_intFuncName(23),
X	(unsigned long)intFunc_23,
N	(unsigned long)_intFuncName(24),
X	(unsigned long)intFunc_24,
N	(unsigned long)_intFuncName(25),
X	(unsigned long)intFunc_25,
N	(unsigned long)_intFuncName(26),
X	(unsigned long)intFunc_26,
N	(unsigned long)_intFuncName(27),
X	(unsigned long)intFunc_27,
N	(unsigned long)_intFuncName(28),
X	(unsigned long)intFunc_28,
N	(unsigned long)_intFuncName(29),
X	(unsigned long)intFunc_29,
N	(unsigned long)_intFuncName(30),
X	(unsigned long)intFunc_30,
N	(unsigned long)_intFuncName(31),
X	(unsigned long)intFunc_31,
N	(unsigned long)_intFuncName(32),
X	(unsigned long)intFunc_32,
N	(unsigned long)_intFuncName(33),
X	(unsigned long)intFunc_33,
N	(unsigned long)_intFuncName(34),
X	(unsigned long)intFunc_34,
N	(unsigned long)_intFuncName(35),
X	(unsigned long)intFunc_35,
N	(unsigned long)_intFuncName(36),
X	(unsigned long)intFunc_36,
N	(unsigned long)_intFuncName(37),
X	(unsigned long)intFunc_37,
N	(unsigned long)_intFuncName(38),
X	(unsigned long)intFunc_38,
N	(unsigned long)_intFuncName(39),
X	(unsigned long)intFunc_39,
N	(unsigned long)_intFuncName(40),
X	(unsigned long)intFunc_40,
N	(unsigned long)_intFuncName(41),
X	(unsigned long)intFunc_41,
N	(unsigned long)_intFuncName(42),
X	(unsigned long)intFunc_42,
N	(unsigned long)_intFuncName(43),
X	(unsigned long)intFunc_43,
N	(unsigned long)_intFuncName(44),
X	(unsigned long)intFunc_44,
N	(unsigned long)_intFuncName(45),
X	(unsigned long)intFunc_45,
N	(unsigned long)_intFuncName(46),
X	(unsigned long)intFunc_46,
N	(unsigned long)_intFuncName(47),
X	(unsigned long)intFunc_47,
N	(unsigned long)_intFuncName(48),
X	(unsigned long)intFunc_48,
N	(unsigned long)_intFuncName(49),
X	(unsigned long)intFunc_49,
N	(unsigned long)_intFuncName(50),
X	(unsigned long)intFunc_50,
N	(unsigned long)_intFuncName(51),
X	(unsigned long)intFunc_51,
N	(unsigned long)_intFuncName(52),
X	(unsigned long)intFunc_52,
N	(unsigned long)_intFuncName(53),
X	(unsigned long)intFunc_53,
N	(unsigned long)_intFuncName(54),
X	(unsigned long)intFunc_54,
N	(unsigned long)_intFuncName(55),
X	(unsigned long)intFunc_55,
N	(unsigned long)_intFuncName(56),
X	(unsigned long)intFunc_56,
N	(unsigned long)_intFuncName(57),
X	(unsigned long)intFunc_57,
N	(unsigned long)_intFuncName(58),
X	(unsigned long)intFunc_58,
N	(unsigned long)_intFuncName(59),
X	(unsigned long)intFunc_59,
N	(unsigned long)_intFuncName(60),
X	(unsigned long)intFunc_60,
N	(unsigned long)_intFuncName(61),
X	(unsigned long)intFunc_61,
N	(unsigned long)_intFuncName(62),
X	(unsigned long)intFunc_62,
N	(unsigned long)_intFuncName(63),
X	(unsigned long)intFunc_63,
N	(unsigned long)_intFuncName(64),
X	(unsigned long)intFunc_64,
N	(unsigned long)_intFuncName(65),
X	(unsigned long)intFunc_65,
N	(unsigned long)_intFuncName(66),
X	(unsigned long)intFunc_66,
N	(unsigned long)_intFuncName(67),
X	(unsigned long)intFunc_67,
N	(unsigned long)_intFuncName(68),
X	(unsigned long)intFunc_68,
N	(unsigned long)_intFuncName(69),
X	(unsigned long)intFunc_69,
N	(unsigned long)_intFuncName(70),
X	(unsigned long)intFunc_70,
N	(unsigned long)_intFuncName(71),
X	(unsigned long)intFunc_71,
N	(unsigned long)_intFuncName(72),
X	(unsigned long)intFunc_72,
N	(unsigned long)_intFuncName(73),
X	(unsigned long)intFunc_73,
N	(unsigned long)_intFuncName(74),
X	(unsigned long)intFunc_74,
N	(unsigned long)_intFuncName(75),
X	(unsigned long)intFunc_75,
N	(unsigned long)_intFuncName(76),
X	(unsigned long)intFunc_76,
N	(unsigned long)_intFuncName(77),
X	(unsigned long)intFunc_77,
N	(unsigned long)_intFuncName(78),
X	(unsigned long)intFunc_78,
N	(unsigned long)_intFuncName(79),
X	(unsigned long)intFunc_79,
N	(unsigned long)_intFuncName(80),
X	(unsigned long)intFunc_80,
N	(unsigned long)_intFuncName(81),
X	(unsigned long)intFunc_81,
N	(unsigned long)_intFuncName(82),
X	(unsigned long)intFunc_82,
N	(unsigned long)_intFuncName(83),
X	(unsigned long)intFunc_83,
N	(unsigned long)_intFuncName(84),
X	(unsigned long)intFunc_84,
N	(unsigned long)_intFuncName(85),
X	(unsigned long)intFunc_85,
N	(unsigned long)_intFuncName(86),
X	(unsigned long)intFunc_86,
N	(unsigned long)_intFuncName(87),
X	(unsigned long)intFunc_87,
N	(unsigned long)_intFuncName(88),
X	(unsigned long)intFunc_88,
N	(unsigned long)_intFuncName(89),
X	(unsigned long)intFunc_89,
N	(unsigned long)_intFuncName(90),
X	(unsigned long)intFunc_90,
N	(unsigned long)_intFuncName(91),
X	(unsigned long)intFunc_91,
N	(unsigned long)_intFuncName(92),
X	(unsigned long)intFunc_92,
N	(unsigned long)_intFuncName(93),
X	(unsigned long)intFunc_93,
N	(unsigned long)_intFuncName(94),
X	(unsigned long)intFunc_94,
N	(unsigned long)_intFuncName(95),
X	(unsigned long)intFunc_95,
N	(unsigned long)_intFuncName(96),
X	(unsigned long)intFunc_96,
N	(unsigned long)_intFuncName(97),
X	(unsigned long)intFunc_97,
N	(unsigned long)_intFuncName(98),
X	(unsigned long)intFunc_98,
N	(unsigned long)_intFuncName(99),
X	(unsigned long)intFunc_99,
N	(unsigned long)_intFuncName(100),
X	(unsigned long)intFunc_100,
N	(unsigned long)_intFuncName(101),
X	(unsigned long)intFunc_101,
N	(unsigned long)_intFuncName(102),
X	(unsigned long)intFunc_102,
N	(unsigned long)_intFuncName(103),
X	(unsigned long)intFunc_103,
N	(unsigned long)_intFuncName(104),
X	(unsigned long)intFunc_104,
N	(unsigned long)_intFuncName(105),
X	(unsigned long)intFunc_105,
N	(unsigned long)_intFuncName(106),
X	(unsigned long)intFunc_106,
N	(unsigned long)_intFuncName(107),
X	(unsigned long)intFunc_107,
N	(unsigned long)_intFuncName(108),
X	(unsigned long)intFunc_108,
N	(unsigned long)_intFuncName(109),
X	(unsigned long)intFunc_109,
N	(unsigned long)_intFuncName(110),
X	(unsigned long)intFunc_110,
N	(unsigned long)_intFuncName(111),
X	(unsigned long)intFunc_111,
N	(unsigned long)_intFuncName(112),
X	(unsigned long)intFunc_112,
N	(unsigned long)_intFuncName(113),
X	(unsigned long)intFunc_113,
N	(unsigned long)_intFuncName(114),
X	(unsigned long)intFunc_114,
N	(unsigned long)_intFuncName(115),
X	(unsigned long)intFunc_115,
N	(unsigned long)_intFuncName(116),
X	(unsigned long)intFunc_116,
N	(unsigned long)_intFuncName(117),
X	(unsigned long)intFunc_117,
N	(unsigned long)_intFuncName(118),
X	(unsigned long)intFunc_118,
N	(unsigned long)_intFuncName(119),
X	(unsigned long)intFunc_119,
N	(unsigned long)_intFuncName(120),
X	(unsigned long)intFunc_120,
N	(unsigned long)_intFuncName(121),
X	(unsigned long)intFunc_121,
N	(unsigned long)_intFuncName(122),
X	(unsigned long)intFunc_122,
N	(unsigned long)_intFuncName(123),
X	(unsigned long)intFunc_123,
N	(unsigned long)_intFuncName(124),
X	(unsigned long)intFunc_124,
N	(unsigned long)_intFuncName(125),
X	(unsigned long)intFunc_125,
N	(unsigned long)_intFuncName(126),
X	(unsigned long)intFunc_126,
N	(unsigned long)_intFuncName(127),
X	(unsigned long)intFunc_127,
N};
Nstatic unsigned long vVec[128];
N
N#if 0
S0
S1
S2
S3
S4
S5
S6
S7
S8
S9
S10
S11
S12
S13
S14
S15
S16
S17
S18
S19
S20
S21
S22
S23
S24
S25
S26
S27
S28
S29
S30
S31
S32
S33
S34
S35
S36
S37
S38
S39
S40
S41
S42
S43
S44
S45
S46
S47
S48
S49
S50
S51
S52
S53
S54
S55
S56
S57
S58
S59
S60
S61
S62
S63
S64
S65
S66
S67
S68
S69
S70
S71
S72
S73
S74
S75
S76
S77
S78
S79
S80
S81
S82
S83
S84
S85
S86
S87
S88
S89
S90
S91
S92
S93
S94
S95
S96
S97
S98
S99
S100
S101
S102
S103
S104
S105
S106
S107
S108
S109
S110
S111
S112
S113
S114
S115
S116
S117
S118
S119
S120
S121
S122
S123
S124
S125
S126
S127
N#endif
N
N//#ifdef	SUPPORT_CPU_TIMER_0
N//_IntFunc(IntID_Timer0)
N//#endif
N//#ifdef	SUPPORT_CPU_TIMER_1
N//_IntFunc(IntID_Timer1)
N//#endif
N//#ifdef	SUPPORT_CPU_TIMER_2
N//_IntFunc(IntID_Timer2)
N//#endif
N
N//#ifdef	SUPPORT_SCI_A
N//_IntFunc(IntID_SciA_RX)
N//_IntFunc(IntID_SciA_TX)
N//#endif
N
N//static const struct int_cfg_t {
N//	unsigned short ierVal;
N//	volatile unsigned short * pPieieReg;
N//	unsigned short pieieVal;
N//	unsigned short pieackVal;
N//
N//	unsigned long vect;
N//	void (*pIntFunc)( );
N//
N//} intCfgTbl[IntID_Num] =
N//{
N//	/* ierVal, pPieieReg, pieieVal, pieackVal, vect,       pIntFunc */
N//#ifdef	SUPPORT_CPU_TIMER_0
N//	{  0x0001, PIEIER1,   0x40,     0x0001,    0x00000D4C, intFuncName(IntID_Timer0) },		/* cpu timer 0 (int 1.7) */
N//#endif
N//#ifdef	SUPPORT_CPU_TIMER_1
N//	{  0x0001, PIEIER1,   0x08,     0x0001,    0x00000d46, intFuncName(IntID_Timer1) },		/* cpu timer 1 (int 1.4) */
N//#endif
N//#ifdef	SUPPORT_CPU_TIMER_2
N//	{  0x0001, PIEIER1,   0x10,     0x0001,    0x00000d48, intFuncName(IntID_Timer2) },		/* cpu timer 2 (int 1.5) */
N//#endif
N//
N//#ifdef	SUPPORT_SCI_A
N//	{  0x0100, PIEIER9,   0x01,     0x0100,    0x00000dc0, intFuncName(IntID_SciA_RX) },		/* sci A Rx (int 9.1) */
N//	{  0x0100, PIEIER9,   0x02,     0x0100,    0x00000dc2, intFuncName(IntID_SciA_TX) },		/* sci A Tx (int 9.2) */
N//#endif
N//
N//};
N
N//static struct int_mng_t {
N//	void (*pDrvFunc)( void * arg );
N//	void * arg;
N//} intMngTbl[IntID_Num];
N
N#ifdef	SUPPORT_INT_0
N#endif	/* SUPPORT_INT_0 */
N
Nextern unsigned int ramfuncs_loadstart;
Nextern unsigned int ramfuncs_loadsize;
Nextern unsigned int ramfuncs_runstart;
N
N/*******************************************************************************
N *
N */
Nint sysInit( void )
N{
N	/*
N	 * Step 0. 'ramfunc' section initialize
N	 */
N	if( ramfuncs_runstart != ramfuncs_loadstart ) {
N		memcpy( & ramfuncs_runstart,
N		        & ramfuncs_loadstart,
W "../src/bsp/sysLib.c" 507 11 conversion from pointer to smaller integer
W "../src/bsp/sysLib.c" 507 16 integer conversion resulted in truncation
N		        (int)& ramfuncs_runstart );
N	}
N
N	/*
N	 * Step 1. Initialize System Control:
N	 */
N	InitSysCtrl();		/* PLL, WatchDog, enable Peripheral Clocks
N						 * This example function is found in the DSP2803x_SysCtrl.c file.
N						 */
N
N	/*
N	 * Step 2. Initalize GPIO:
N	 */
N/*	 InitGpio();		?*
N						 * This example function is found in the DSP2803x_Gpio.c file and
N						 * illustrates how to set the GPIO to it's default state.
N						 */
N
N	/*
N	 * Step 3. Clear all interrupts and initialize PIE vector table:
N	 */
N	DINT;				/* Disable CPU interrupts */
X	asm(" setc INTM");				 
N
N//	InitPieCtrl();		/* Initialize the PIE control registers to their default state.
N//						 * The default state is all PIE interrupts disabled and flags
N//						 * are cleared.
N//						 * This function is found in the DSP2803x_PieCtrl.c file.
N//						 */
N	// Disable the PIE
N//	PieCtrlRegs.PIECTRL.bit.ENPIE = 0;
N	*PIECTRL &= ~1;
X	*(volatile unsigned short *)0x00000CE0 &= ~1;
N
N//	// Clear all PIEIER registers:
N//	PieCtrlRegs.PIEIER1.all = 0;
N//	PieCtrlRegs.PIEIER2.all = 0;
N//	PieCtrlRegs.PIEIER3.all = 0;
N//	PieCtrlRegs.PIEIER4.all = 0;
N//	PieCtrlRegs.PIEIER5.all = 0;
N//	PieCtrlRegs.PIEIER6.all = 0;
N//	PieCtrlRegs.PIEIER7.all = 0;
N//	PieCtrlRegs.PIEIER8.all = 0;
N//	PieCtrlRegs.PIEIER9.all = 0;
N//	PieCtrlRegs.PIEIER10.all = 0;
N//	PieCtrlRegs.PIEIER11.all = 0;
N//	PieCtrlRegs.PIEIER12.all = 0;
N//
N//	// Clear all PIEIFR registers:
N//	PieCtrlRegs.PIEIFR1.all = 0;
N//	PieCtrlRegs.PIEIFR2.all = 0;
N//	PieCtrlRegs.PIEIFR3.all = 0;
N//	PieCtrlRegs.PIEIFR4.all = 0;
N//	PieCtrlRegs.PIEIFR5.all = 0;
N//	PieCtrlRegs.PIEIFR6.all = 0;
N//	PieCtrlRegs.PIEIFR7.all = 0;
N//	PieCtrlRegs.PIEIFR8.all = 0;
N//	PieCtrlRegs.PIEIFR9.all = 0;
N//	PieCtrlRegs.PIEIFR10.all = 0;
N//	PieCtrlRegs.PIEIFR11.all = 0;
N//	PieCtrlRegs.PIEIFR12.all = 0;
N	{
N		volatile unsigned short * pReg;
N
N		for( pReg=PIEIER1; pReg!=PIE_REG_END; pReg++ ) {
X		for( pReg=(volatile unsigned short *)0x00000CE2; pReg!=(volatile unsigned short *)0x00000CFA; pReg++ ) {
N			*pReg = 0;
N		}
N	}
N
N	IER = 0x0000;		/* Disable CPU interrupts */
N	IFR = 0x0000;		/* and clear all CPU interrupt flags: */
N
N//	InitPieVectTable();	/* Initialize the PIE vector table with pointers to the shell Interrupt
N//						 * Service Routines (ISR).
N//						 * This will populate the entire table, even if the interrupt
N//						 * is not used in this example.  This is useful for debug purposes.
N//						 * The shell ISR routines are found in DSP2803x_DefaultIsr.c.
N//						 * This function is found in DSP2803x_PieVect.c.
N//						 */
N	{
N		int vecNo;
N		unsigned long * p = (unsigned long *)PIE_VECT_ADRS;
X		unsigned long * p = (unsigned long *)0x000d00;
N
N		/* Do not write over first 3 32-bit locations (these locations are
N		 * initialized by Boot ROM with boot variables)
N		 */
N		p += 3;
N		vecNo = 3;
N
N		EALLOW;
X		asm(" EALLOW");
N		for( ; vecNo<128; vecNo++, p++ ) {
N			*p = (unsigned long)_intFuncInitTbl[vecNo];
N			vVec[vecNo] = (unsigned long)intDummyFunc;
N		}
N		EDIS;
X		asm(" EDIS");
N
N//		PieCtrlRegs.PIECTRL.bit.ENPIE = 1;
N		*PIECTRL |= 1;
X		*(volatile unsigned short *)0x00000CE0 |= 1;
N	}
N
N// Enable global Interrupts and higher priority real-time debug events:
N   EINT;   // Enable Global interrupt INTM
X   asm(" clrc INTM");   
N   ERTM;   // Enable Global realtime interrupt DBGM
X   asm(" clrc DBGM");   
N
N   return 0;
N}
N
N/*******************************************************************************
N *
N */
N//int sysIntLock(void);
N//     move to sysLibasm.asm
N// {
N// }
N//
N
N/*******************************************************************************
N *
N */
Nvoid sysIntUnlock( int mask )
N{
N	if( ! mask ) {
N		EINT;
X		asm(" clrc INTM");
N	}
N}
N
N/*******************************************************************************
N *
N */
Nint sysIntConnect( unsigned int vecNo, void (*pFunc)(unsigned int) )
N{
N	int retVal = -1;
N	int	intLockVal;
N
N	if( vecNo < 128 ) {
N
N		intLockVal = sysIntLock();
N
N//		EALLOW;
N//		*(unsigned long *)intCfgTbl[id].vect = (unsigned long)intCfgTbl[id].pIntFunc;
N//		EDIS;
N//
N//		intMngTbl[id].pDrvFunc = pFunc;
N//		intMngTbl[id].arg      = arg;
N
N		vVec[vecNo] = (unsigned long)pFunc;
N
N		sysIntUnlock( intLockVal );
N
N		retVal = 0;
N	}
N
N	return retVal;
N}
N
N/*******************************************************************************
N *
N */
Nint sysIntDisconnect( unsigned int vecNo )
N{
N	int retVal = -1;
N	int intLockVal;
N
N	if( vecNo < 128 ) {
N		sysIntDisable( vecNo );
N		intLockVal = sysIntLock();
N		vVec[vecNo] = (unsigned long)intDummyFunc;
N		sysIntUnlock( intLockVal );
N
N		retVal = 0;
N	}
N
N	return retVal;
N}
N
N/*******************************************************************************
N *
N */
Nint sysIntEnable( unsigned int vecNo )
N{
N	int retVal = -1;
N	int intLockVal;
N	int regNo;
N	int	bit;
N	volatile unsigned short * pPieieReg;
N
N	if( vecNo < 32 ) {
N
N		/* nothing todo. but not error */
N		retVal = 0;
N
N	} else if( vecNo < 128 ) {
N
N		regNo = vecNo - 32;
N		bit = regNo & 0x07;
N		regNo /= 8;
N
N		pPieieReg = PIEIER1;
X		pPieieReg = (volatile unsigned short *)0x00000CE2;
N		pPieieReg += regNo;
N
N		intLockVal = sysIntLock();
N		*pPieieReg |= (1<<bit);
N		IER |= (1<<regNo);
N		sysIntUnlock( intLockVal );
N
N		retVal = 0;
N	} else {
N		/* error : nothing todo */
N	}
N
N//	if( id <IntID_Num ) {
N//		intLockVal = sysIntLock();
N//
N//		IER |= intCfgTbl[id].ierVal;
N//		* intCfgTbl[id].pPieieReg |= intCfgTbl[id].pieieVal;
N//
N//		sysIntUnlock( intLockVal );
N//
N//		retVal = 0;
N//	}
N
N	return retVal;
N}
N
N/*******************************************************************************
N *
N */
Nint sysIntDisable( unsigned int vecNo )
N{
N	int retVal = -1;
N	int intLockVal;
N
N	int regNo;
N	int bit;
N	volatile unsigned short * pPieieReg;
N
N	if( vecNo < 32 ) {
N		/* nothing todo. but not error */
N		retVal = 0;
N	} else if( vecNo < 128 ) {
N		regNo = vecNo - 32;
N		bit = regNo & 0x07;
N		regNo /= 8;
N
N		pPieieReg = PIEIER1;
X		pPieieReg = (volatile unsigned short *)0x00000CE2;
N		pPieieReg += regNo;
N
N		intLockVal = sysIntLock();
N		*pPieieReg &= ~(1<<bit);
N		if( *pPieieReg == 0 ) {
N			IER &= ~(1<<regNo);
N		}
N		sysIntUnlock( intLockVal );
N
N		retVal = 0;
N	} else {
N		/* error : nothing todo */
N	}
N
N
N
N//	if( id <IntID_Num ) {
N//		intLockVal = sysIntLock();
N//
N////		IER &= ~intCfgTbl[id].ierVal;
N//		* intCfgTbl[id].pPieieReg &= ~intCfgTbl[id].pieieVal;
N//
N//		sysIntUnlock( intLockVal );
N//
N//		retVal = 0;
N//	}
N
N	return retVal;
N}
N
N/*******************************************************************************
N *
N */
N//static interrupt intDummyFunc( void )
N//{
N//	for( ; ; ) {
N//		;
N//	}
N//}
N
N/*******************************************************************************
N *
N */
Nvoid intFunc( unsigned int vecNo )
N{
N//	intMngTbl[id].pDrvFunc( intMngTbl[id].arg );
N	((void (*)(unsigned int))vVec[vecNo])( vecNo );
N
N//	*PIEACK = intCfgTbl[id].pieackVal;
N	if( vecNo < 32 ) {
N		/* nothing todo */
N	} else {
N		vecNo -= 32;
N		vecNo /= 8;
N		*PIEACK = (1<<vecNo);
X		*(volatile unsigned short *)0x00000CE1 = (1<<vecNo);
N	}
N}
N
N/*******************************************************************************
N *
N */
Nvoid sysDummyFunc()
N{
N}
N
N/*******************************************************************************
N *
N */
Nvoid sysHalt( const char * msg )
N{
N	for( ; ; ) {
N		;
N	}
N}
