L 1 "../src/cores/f_gpio_pinMode.c"
N/*** f_gpio_pinMode.c - fpallet GPIO control : pinMode() ***/
N
N/*** Copyright(C) 2011 Sansei System Co.,Ltd. ***/
N
N/*** HISTORY ***
N * 2011/03/01 mimu
N              First Version
N */
N
N/*** NOTE ***/
N
N/*** INCLUDE ***/
N
N#include "f_gpio.h"
L 1 "..\src\cores\f_gpio.h" 1
N/*** f_gpio.h - fpallet GPIO control ***/
N
N/*** Copyright(C) 2011 Sansei System Co.,Ltd. ***/
N
N/*** HISTORY ***
N * 2011/03/01 mimu
N              First Version
N */
N
N#ifndef	INC_f_gpio_H
N#define	INC_f_gpip_H
N
N#include "f_types.h"
L 1 "..\src\cores\f_types.h" 1
N/*** f_types.h - ***/
N
N#ifndef	INC_f_types_H
N#define	INC_f_types_H
N
N#include <stdint.h>
L 1 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/stdint.h" 1
N/*****************************************************************************/
N/* STDINT.H v5.2.6                                                           */
N/* Copyright (c) 2002-2010 Texas Instruments Incorporated                    */
N/*****************************************************************************/
N#ifndef _STDINT_H_
N#define _STDINT_H_
N
N/* 7.18.1.1 Exact-width integer types */
N
N    typedef          int    int16_t;
N    typedef unsigned int   uint16_t;
N    typedef          long   int32_t;
N    typedef unsigned long  uint32_t;
N
N
N#if defined(__TMS470__) || defined(_TMS320C6X) || defined(__TMS320C28X__)
X#if 0L || 0L || 1L
N    typedef          long long  int64_t;
N    typedef unsigned long long uint64_t;
N#endif
N
N/* 7.18.1.2 Minimum-width integer types */
N
N    typedef  int16_t  int_least8_t;
N    typedef uint16_t uint_least8_t;
N
N    typedef  int16_t  int_least16_t;
N    typedef uint16_t uint_least16_t;
N    typedef  int32_t  int_least32_t;
N    typedef uint32_t uint_least32_t;
N
N
N#if defined(__TMS470__) || defined(_TMS320C6X) || defined(__TMS320C28X__)
X#if 0L || 0L || 1L
N    typedef  int64_t  int_least64_t;
N    typedef uint64_t uint_least64_t;
N#else
S/* sorry, int_least64_t not implemented for C54x, C55x, MSP430 */
N#endif
N
N/* 7.18.1.3 Fastest minimum-width integer types */
N
N    typedef  int16_t  int_fast8_t;
N    typedef uint16_t uint_fast8_t;
N    typedef  int16_t  int_fast16_t;
N    typedef uint16_t uint_fast16_t;
N
N    typedef  int32_t  int_fast32_t;
N    typedef uint32_t uint_fast32_t;
N
N
N#if defined(__TMS470__) || defined(_TMS320C6X) || defined(__TMS320C28X__)
X#if 0L || 0L || 1L
N    typedef  int64_t  int_fast64_t;
N    typedef uint64_t uint_fast64_t;
N#endif
N
N/* 7.18.1.4 Integer types capable of holding object pointers */
N    typedef          long intptr_t;
N    typedef unsigned long uintptr_t;
N
N/* 7.18.1.5 Greatest-width integer types */
N#if defined(__TMS320C55X__) || defined(__TMS470__) || defined(_TMS320C6X) || defined(__TMS320C28X__)
X#if 0L || 0L || 0L || 1L
N    typedef          long long intmax_t;
N    typedef unsigned long long uintmax_t;
N#elif defined(_TMS320C5XX) || defined(__TMS320C27X__) || defined(__MSP430__)
S    typedef          long intmax_t;
S    typedef unsigned long uintmax_t;
N#endif
N
N/* 
N   According to footnotes in the 1999 C standard, "C++ implementations
N   should define these macros only when __STDC_LIMIT_MACROS is defined
N   before <stdint.h> is included." 
N*/
N#if !defined(__cplusplus) || defined(__STDC_LIMIT_MACROS)
X#if !0L || 0L
N
N/* 7.18.2 Limits of specified width integer types */
N
N
N    #define  INT16_MAX  0x7fff
N    #define  INT16_MIN  (-INT16_MAX-1)
N    #define UINT16_MAX  0xffff
N
N    #define  INT32_MAX  0x7fffffff
N    #define  INT32_MIN  (-INT32_MAX-1)
N    #define UINT32_MAX  0xffffffff
N
N
N#if defined(__TMS470__) || defined(_TMS320C6X) || defined(__TMS320C28X__)
X#if 0L || 0L || 1L
N    #define  INT64_MAX  0x7fffffffffffffff
N    #define  INT64_MIN  (-INT64_MAX-1)
N    #define UINT64_MAX  0xffffffffffffffff
N#endif
N
N    #define  INT_LEAST8_MAX   INT16_MAX
N    #define  INT_LEAST8_MIN   INT16_MIN
N    #define UINT_LEAST8_MAX   UINT16_MAX
N
N    #define  INT_LEAST16_MAX  INT16_MAX
N    #define  INT_LEAST16_MIN  INT16_MIN
N    #define UINT_LEAST16_MAX  UINT16_MAX
N    #define  INT_LEAST32_MAX  INT32_MAX
N    #define  INT_LEAST32_MIN  INT32_MIN
N    #define UINT_LEAST32_MAX  UINT32_MAX
N
N
N#if defined(__TMS470__) || defined(_TMS320C6X) || defined(__TMS320C28X__)
X#if 0L || 0L || 1L
N    #define  INT_LEAST64_MAX  INT64_MAX
N    #define  INT_LEAST64_MIN  INT64_MIN
N    #define UINT_LEAST64_MAX  UINT64_MAX
N#endif
N
N    #define  INT_FAST8_MAX   INT16_MAX
N    #define  INT_FAST8_MIN   INT16_MIN
N    #define UINT_FAST8_MAX   UINT16_MAX
N    #define  INT_FAST16_MAX  INT16_MAX
N    #define  INT_FAST16_MIN  INT16_MIN
N    #define UINT_FAST16_MAX  UINT16_MAX
N
N    #define  INT_FAST32_MAX  INT32_MAX
N    #define  INT_FAST32_MIN  INT32_MIN
N    #define UINT_FAST32_MAX  UINT32_MAX
N
N
N#if defined(__TMS470__) || defined(_TMS320C6X) || defined(__TMS320C28X__)
X#if 0L || 0L || 1L
N    #define  INT_FAST64_MAX  INT64_MAX
N    #define  INT_FAST64_MIN  INT64_MIN
N    #define UINT_FAST64_MAX  UINT64_MAX
N#endif
N
N    #define INTPTR_MAX   INT32_MAX
N    #define INTPTR_MIN   INT32_MIN
N    #define UINTPTR_MAX  UINT32_MAX
N
N#if defined(__TMS470__) || defined(_TMS320C6X) || defined(__TMS320C28X__)
X#if 0L || 0L || 1L
N    #define INTMAX_MIN   INT64_MIN
N    #define INTMAX_MAX   INT64_MAX
N    #define UINTMAX_MAX  UINT64_MAX
N#elif defined(_TMS320C5XX) || defined(__TMS320C27X__) || defined(__MSP430__)
S    #define INTMAX_MIN   INT32_MIN
S    #define INTMAX_MAX   INT32_MAX
S    #define UINTMAX_MAX  UINT32_MAX
N#endif
N
N/* 7.18.3 Limits of other integer types */
N
N    #define PTRDIFF_MAX INT32_MAX
N    #define PTRDIFF_MIN INT32_MIN
N
N    #define SIG_ATOMIC_MIN INT32_MIN
N    #define SIG_ATOMIC_MAX INT32_MAX
N
N    #define SIZE_MAX INT32_MAX
N
N#ifndef WCHAR_MAX
N#define WCHAR_MAX 0xffffu
N#endif
N
N#ifndef WCHAR_MIN
N#define WCHAR_MIN 0
N#endif
N
N    #define WINT_MIN INT32_MIN
N    #define WINT_MAX INT32_MAX
N
N/* 7.18.4.1 Macros for minimum-width integer constants */
N
N/*
N   There is a defect report filed against the C99 standard concerning how 
N   the (U)INTN_C macros should be implemented.  Please refer to --
N   http://wwwold.dkuug.dk/JTC1/SC22/WG14/www/docs/dr_209.htm 
N   for more information.  These macros are implemented according to the
N   suggestion given at this web site.
N*/
N
N    #define  INT8_C(value)  ((int_least8_t)(value))
N    #define UINT8_C(value)  ((uint_least8_t)(value))
N    #define  INT16_C(value) ((int_least16_t)(value))
N    #define UINT16_C(value) ((uint_least16_t)(value))
N    #define  INT32_C(value) ((int_least32_t)(value))
N    #define UINT32_C(value) ((uint_least32_t)(value))
N
N
N#if defined(__TMS470__) || defined(_TMS320C6X) || defined(__TMS320C28X__)
X#if 0L || 0L || 1L
N    #define  INT64_C(value) ((int_least64_t)(value))
N    #define UINT64_C(value) ((uint_least64_t)(value))
N#endif
N
N/* 7.18.4.2 Macros for greatest-width integer constants */
N
N    #define  INTMAX_C(value) ((intmax_t)(value))
N    #define UINTMAX_C(value) ((uintmax_t)(value))
N
N#endif /* !defined(__cplusplus) || defined(__STDC_LIMIT_MACROS) */
N
N#endif /* _STDINT_H_ */
L 7 "..\src\cores\f_types.h" 2
N
N//typedef	unsigned short	uint16_t;
Ntypedef	unsigned char	uint8_t;
N
N
Ntypedef unsigned int word;
N
N//typedef uint8_t boolean;
Ntypedef unsigned int boolean;
Ntypedef uint8_t byte;
N
N#define lowByte(w) ((uint8_t) ((w) & 0xff))
N#define highByte(w) ((uint8_t) ((w) >> 8))
N
N#define bit(b) (1UL << (b))
N
N#define bitRead(value, bit) (((value) >> (bit)) & 0x01)
N#define bitSet(value, bit) ((value) |= (1UL << (bit)))
N#define bitClear(value, bit) ((value) &= ~(1UL << (bit)))
N#define bitWrite(value, bit, bitvalue) (bitvalue ? bitSet(value, bit) : bitClear(value, bit))
N
N
N#endif	/* INC_f_types_H */
N
N/*** end of file : f_types.h ***/
L 14 "..\src\cores\f_gpio.h" 2
N#include "f_const.h"
L 1 "..\src\cores\f_const.h" 1
N/*** f_const.h - fpallet const data define ***/
N
N/*** Copyright(C) 2011 Sansei System Co.,Ltd. ***/
N
N/*** HISTORY ***
N * 2011/02/28 mimu
N              First Version
N */
N
N#ifndef	INC_f_const_H
N#define	INC_f_const_H
N
N#ifdef	__cplusplus
Sextern "C" {
N#endif
N
N#define LOW		0x0
N#define HIGH	0x1
N#define	TOGGLE	0x02
N
N#define	INPUT	0
N#define	OUTPUT	1
N#define	MODE_2	2
N#define	MODE_3	3
N
N#define true 0x1
N#define false 0x0
N
N//#define PI 3.1415926535897932384626433832795
N//#define HALF_PI 1.5707963267948966192313216916398
N//#define TWO_PI 6.283185307179586476925286766559
N//#define DEG_TO_RAD 0.017453292519943295769236907684886
N//#define RAD_TO_DEG 57.295779513082320876798154814105
N
N//#define SERIAL  0x0
N//#define DISPLAY 0x1
N
N#define LSBFIRST 0
N#define MSBFIRST 1
N
N//#define CHANGE 1
N//#define FALLING 2
N//#define RISING 3
N
N//#if defined(__AVR_ATmega1280__) || defined(__AVR_ATmega2560__)
N//#define INTERNAL1V1 2
N//#define INTERNAL2V56 3
N//#else
N//#define INTERNAL 3
N//#endif
N
N//#define DEFAULT 1
N//#define EXTERNAL 0
N
N
N
N#ifdef	__cplusplus
S} /* extern "C" */
N#endif
N
N#endif	/* INC_f_const_H */
N
N/*** end of file : f_const.h ***/
L 15 "..\src\cores\f_gpio.h" 2
N
N#ifdef	__cplusplus
Sextern "C" {
N#endif
N
Nvoid pinMode( uint8_t pin, uint8_t mode );
Nvoid digitalWrite(uint8_t, uint8_t);
Nint digitalRead(uint8_t);
N
Nunsigned long pulseIn(uint8_t pin, uint8_t state, unsigned long timeout);
N
Nvoid shiftOut(uint8_t dataPin, uint8_t clockPin, uint8_t bitOrder, uint8_t val);
Nuint8_t shiftIn(uint8_t dataPin, uint8_t clockPin, uint8_t bitOrder);
N
N
N#ifdef	__cplusplus
S}	/* extern "C" */
N#endif
N
N#endif	/* INC_f_gpio_H */
N
N/*** end of file : f_gpio.h ***/
L 15 "../src/cores/f_gpio_pinMode.c" 2
N
N#include "tms320f28035/gpioDrv.h"
L 1 "D:/project/fpalette/ccs4/fpalette/ide_led/src/bsp/tms320f28035/gpioDrv.h" 1
N/*** gpioDrv.h - TMS320F28035(piccolo) GPIO driver ***/
N
N/*** Copyright(C) 2011 Sansei System Co.,Ltd. ***/
N
N/*** HISTORY ***
N * 2011/02/09 mimu
N              First Version
N */
N
N#ifndef	INC_gpioDrv_H
N#define	INC_gpioDrv_H
N
N#ifdef	__cplusplus
Sextern "C" {
N#endif
N
N#define	GPIO_MAX	44
N#define	GPIO_NUM	45
N
Nint gpioInit( void );
Nint gpioConfig( int no, int mode );
N#define	GPIO_MODE_GPIO			0x001
N#define	GPIO_MODE_1				0x002
N#define	GPIO_MODE_2				0x004
N#define	GPIO_MODE_3				0x008
N
N#define	GPIO_MODE_IN			0x010
N#define	GPIO_MODE_OUT			0x020
N#define	GPIO_MODE_PULLUP_DIS	0x040
N#define	GPIO_MODE_PULLUP		0x080
N
N#define	GPIO_MODE_QUALIFIER_0	0x100
N#define	GPIO_MODE_QUALIFIER_1	0x200
N#define	GPIO_MODE_QUALIFIER_2	0x400
N#define	GPIO_MODE_QUALIFIER_3	0x800
N#define	GPIO_MODE_QUALIFILER(_x)	(0x100<<(_x))&0x0f00))
N
N#define	GPIO_CTRL_SET		0
N#define	GPIO_CTRL_CLR		1
N#define	GPIO_CTRL_TOGGLE	2
N#define	GPIO_CTRL_GET		3
Nint gpioCtrl( int no, int ctrl );
N
N//int gpioControl( int no, int bHigh );
N#define	gpioControl( _no, _bH )	(bH?gpioCtrl(_no, GPIO_CTRL_SET):gpioCtrl(_no, GPIO_CTRL_CLR))
N//int gpioSet( int no );
N#define	gpioSet( _no )		gpioCtrl( _no, GPIO_CTRL_SET )
N//int gpioClear( int no );
N#define	gpioClear( _no )	gpioCtrl( _no, GPIO_CTRL_CLR )
N//int gpioToggle( int no );
N#define	gpioToggle( _no )	gpioCtrl( _no, GPIO_CTRL_TOGGLE )
N//int gpioGet( int no );
N#define	gpioGet( _no )		gpioCtrl( _no, GPIO_CTRL_GET )
N
Nint gpioCtrlRegSet( int reg, int value );
N#define	GPIO_CTRLREG_QUALPRD_0_7	0		/* GPIO 0-7 */
N#define	GPIO_CTRLREG_QUALPRD_8_15	1		/* GPIO 8-15 */
N#define	GPIO_CTRLREG_QUALPRD_16_23	2		/* GPIO 16-23 */
N#define	GPIO_CTRLREG_QUALPRD_24_31	3		/* GPIO 24-31 */
N
N#define	GPIO_CTRLREG_QUBLPRD_32_39	4		/* GPIO 32-39 */
N#define	GPIO_CTRLREG_QUBLPRD_40_44	5		/* GPIO 32-44 */
N
N#ifdef	__cplusplus
S} /* extern "C" */
N#endif
N
N#endif	/* INC_gpioDrv_H */
N
N/*** end of file : gpioDrv.h ***/
L 17 "../src/cores/f_gpio_pinMode.c" 2
N
N/*** DEFINE ***/
N
N/*** FUNCTION ***/
N
N/*** WORK ***/
N
N/*******************************************************************************
N *
N */
Nvoid pinMode( uint8_t pin, uint8_t mode )
N{
N	int gpio_mode;
N
N	gpio_mode = 0;
N	switch( mode ) {
N	case INPUT :
X	case 0 :
N		gpio_mode = GPIO_MODE_GPIO | GPIO_MODE_IN | GPIO_MODE_PULLUP;
X		gpio_mode = 0x001 | 0x010 | 0x080;
N		break;
N	case OUTPUT :
X	case 1 :
N		gpio_mode = GPIO_MODE_GPIO | GPIO_MODE_OUT | GPIO_MODE_PULLUP;
X		gpio_mode = 0x001 | 0x020 | 0x080;
N		break;
N	case MODE_2 :
X	case 2 :
N		gpio_mode = GPIO_MODE_2;
X		gpio_mode = 0x004;
N		break;
N	case MODE_3 :
X	case 3 :
N		gpio_mode = GPIO_MODE_3;
X		gpio_mode = 0x008;
N		break;
N	default :
N		break;
N	}
N
N	if( gpio_mode ) {
N		gpioConfig( pin, gpio_mode );
N	}
N}
N
N/*** end of file : f_gpio_pinMode.c ***/
