L 1 "../src/cores/f_math.cpp"
N/* -*- mode: jde; c-basic-offset: 2; indent-tabs-mode: nil -*- */
N
N/*
N  Part of the Wiring project - http://wiring.org.co
N  Copyright (c) 2004-06 Hernando Barragan
N  Modified 13 August 2006, David A. Mellis for Arduino - http://www.arduino.cc/
N  
N  This library is free software; you can redistribute it and/or
N  modify it under the terms of the GNU Lesser General Public
N  License as published by the Free Software Foundation; either
N  version 2.1 of the License, or (at your option) any later version.
N
N  This library is distributed in the hope that it will be useful,
N  but WITHOUT ANY WARRANTY; without even the implied warranty of
N  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
N  Lesser General Public License for more details.
N
N  You should have received a copy of the GNU Lesser General
N  Public License along with this library; if not, write to the
N  Free Software Foundation, Inc., 59 Temple Place, Suite 330,
N  Boston, MA  02111-1307  USA
N  
N  $Id$
N*/
N
Nextern "C" {
N  #include "stdlib.h"
L 1 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/stdlib.h" 1
N/*****************************************************************************/
N/* stdlib.h   v5.2.6                                                         */
N/* Copyright (c) 1993-2010 Texas Instruments Incorporated                    */
N/*****************************************************************************/
N
N#ifndef _STDLIB
N#define _STDLIB
N
N
N#ifdef __cplusplus
N//----------------------------------------------------------------------------
N// <cstdlib> IS RECOMMENDED OVER <stdlib.h>.  <stdlib.h> IS PROVIDED FOR 
N// COMPATIBILITY WITH C AND THIS USAGE IS DEPRECATED IN C++
N//----------------------------------------------------------------------------
Nextern "C" namespace std {
N#endif /* !__cplusplus */
N
Ntypedef struct { int quot, rem; } div_t;
N
Ntypedef struct { long quot, rem; } ldiv_t;
N
N#define _LLONG_AVAILABLE 1
Ntypedef struct { long long quot, rem; } lldiv_t;
N
N#define MB_CUR_MAX    1
N
N#ifndef NULL
N#define NULL          0
N#endif
N
N#ifndef _SIZE_T
N#define _SIZE_T
Ntypedef __SIZE_T_TYPE__ size_t;
Xtypedef unsigned long size_t;
N#endif
N
N#ifndef __cplusplus
S#ifndef _WCHAR_T
S#define _WCHAR_T
Stypedef __WCHAR_T_TYPE__ wchar_t;
S#endif
N#endif
N
N#define EXIT_FAILURE  1
N#define EXIT_SUCCESS  0
N
N#define RAND_MAX      32767
N
N#include <linkage.h>
L 1 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/linkage.h" 1
N/*****************************************************************************/
N/* linkage.h   v5.2.6                                                         */
N/* Copyright (c) 1998-2010 Texas Instruments Incorporated                    */
N/*****************************************************************************/
N
N#ifndef _LINKAGE
N#define _LINKAGE
N
N/* No modifiers needed to access code */
N
N#define _CODE_ACCESS
N
N/*--------------------------------------------------------------------------*/
N/* Define _DATA_ACCESS ==> how to access RTS global or static data          */
N/*--------------------------------------------------------------------------*/
N#ifndef _FAR_RTS
N#define _DATA_ACCESS
N#else
S#define _DATA_ACCESS far
N#endif
N#define _DATA_ACCESS_NEAR
N
N/*--------------------------------------------------------------------------*/
N/* Define _OPTIMIZE_FOR_SPACE ==> Always optimize for space.                */
N/*--------------------------------------------------------------------------*/
N#ifndef _OPTIMIZE_FOR_SPACE
S#define _OPTIMIZE_FOR_SPACE 1
N#endif
N
N/*--------------------------------------------------------------------------*/
N/* Define _IDECL ==> how inline functions are declared                      */
N/*--------------------------------------------------------------------------*/
N#ifdef _INLINE
S#define _IDECL static __inline
S#define _IDEFN static __inline
N#else
N#define _IDECL extern _CODE_ACCESS
N#define _IDEFN _CODE_ACCESS
N#endif
N
N#endif /* _LINKAGE */
L 49 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/stdlib.h" 2
N
N/*---------------------------------------------------------------*/
N/* NOTE - Normally, abs, labs, and fabs are expanded inline, so  */
N/*        no formal definition is really required. However, ANSI */
N/*        requires that they exist as separate functions, so     */
N/*        they are supplied in the library.  The prototype is    */
N/*        here mainly for documentation.                         */
N/*---------------------------------------------------------------*/
N    _CODE_ACCESS  int       abs(int _val); 
X      int       abs(int _val); 
N    _CODE_ACCESS  long      labs(long _val);
X      long      labs(long _val);
N#if defined(_LLONG_AVAILABLE)
X#if 1L
N    _CODE_ACCESS  long long llabs(long long _val);
X      long long llabs(long long _val);
N#endif
N    _CODE_ACCESS int       atoi(const char *_st);
X     int       atoi(const char *_st);
N    _CODE_ACCESS long      atol(const char *_st);
X     long      atol(const char *_st);
N#if defined(_LLONG_AVAILABLE)
X#if 1L
N    _CODE_ACCESS long long atoll(const char *_st);
X     long long atoll(const char *_st);
N#endif
N    _CODE_ACCESS int       ltoa(long val, char *buffer);
X     int       ltoa(long val, char *buffer);
N          _IDECL double    atof(const char *_st);
X          extern  double    atof(const char *_st);
N
N    _CODE_ACCESS long      strtol(const char *_st, char **_endptr, int _base);
X     long      strtol(const char *_st, char **_endptr, int _base);
N    _CODE_ACCESS unsigned long strtoul(const char *_st, char **_endptr,
X     unsigned long strtoul(const char *_st, char **_endptr,
N    					  int _base);
N#if defined(_LLONG_AVAILABLE)
X#if 1L
N    _CODE_ACCESS long long strtoll(const char *_st, char **_endptr, int _base);
X     long long strtoll(const char *_st, char **_endptr, int _base);
N    _CODE_ACCESS unsigned long long strtoull(const char *_st, char **_endptr,
X     unsigned long long strtoull(const char *_st, char **_endptr,
N					     int _base);
N#endif
N    _CODE_ACCESS double    strtod(const char *_st, char **_endptr);
X     double    strtod(const char *_st, char **_endptr);
N    _CODE_ACCESS long double strtold(const char *_st, char **_endptr);
X     long double strtold(const char *_st, char **_endptr);
N    
N    _CODE_ACCESS int    rand(void);
X     int    rand(void);
N    _CODE_ACCESS void   srand(unsigned _seed);
X     void   srand(unsigned _seed);
N    
N    _CODE_ACCESS void  *calloc(size_t _num, size_t _size);
X     void  *calloc(size_t _num, size_t _size);
N    _CODE_ACCESS void  *malloc(size_t _size);
X     void  *malloc(size_t _size);
N    _CODE_ACCESS void  *realloc(void *_ptr, size_t _size);
X     void  *realloc(void *_ptr, size_t _size);
N    _CODE_ACCESS void   free(void *_ptr);
X     void   free(void *_ptr);
N    _CODE_ACCESS void  *memalign(size_t _aln, size_t _size);
X     void  *memalign(size_t _aln, size_t _size);
N    
N    _CODE_ACCESS void   abort(void); 
X     void   abort(void); 
N    _CODE_ACCESS int    atexit(void (*_func)(void));
X     int    atexit(void (*_func)(void));
N    _CODE_ACCESS void  *bsearch(const void *_key, const void *_base,
X     void  *bsearch(const void *_key, const void *_base,
N    				   size_t _nmemb, size_t _size, 
N    			           int (*compar)(const void *,const void *));
N    _CODE_ACCESS void   qsort(void *_base, size_t _nmemb, size_t _size, 
X     void   qsort(void *_base, size_t _nmemb, size_t _size, 
N    			         int (*_compar)(const void *, const void *));
N    _CODE_ACCESS void   exit(int _status);
X     void   exit(int _status);
N    
N    _CODE_ACCESS div_t  div(int _numer, int _denom);
X     div_t  div(int _numer, int _denom);
N    _CODE_ACCESS ldiv_t ldiv(long _numer, long _denom);
X     ldiv_t ldiv(long _numer, long _denom);
N#if defined(_LLONG_AVAILABLE)
X#if 1L
N    _CODE_ACCESS lldiv_t lldiv(long long _numer, long long _denom);
X     lldiv_t lldiv(long long _numer, long long _denom);
N#endif
N
N    _CODE_ACCESS char  *getenv(const char *_string);
X     char  *getenv(const char *_string);
N    _CODE_ACCESS int    system(const char *_name);
X     int    system(const char *_name);
N
N    _CODE_ACCESS int    mblen(const char *, size_t);
X     int    mblen(const char *, size_t);
N    _CODE_ACCESS size_t mbstowcs(wchar_t *, const char *, size_t);
X     size_t mbstowcs(wchar_t *, const char *, size_t);
N    _CODE_ACCESS int    mbtowc(wchar_t *, const char *, size_t);
X     int    mbtowc(wchar_t *, const char *, size_t);
N
N    _CODE_ACCESS size_t wcstombs(char *, const wchar_t *, size_t);
X     size_t wcstombs(char *, const wchar_t *, size_t);
N    _CODE_ACCESS int    wctomb(char *, wchar_t);
X     int    wctomb(char *, wchar_t);
N
N#ifdef __cplusplus
N} /* extern "C" namespace std */
N#endif /* __cplusplus */
N
N
N#ifdef _INLINE
S
S#ifdef __cplusplus
Snamespace std {
S#endif
S
Sstatic __inline double atof(const char *_st) 
S{
S  return strtod(_st, (char **)0); 
S}
S
S#ifdef __cplusplus
S} /* namespace std */
S#endif
S
N#endif  /* _INLINE */
N
N#endif  /* ! _STDLIB */
N
N#if defined(__cplusplus) && !defined(_CPP_STYLE_HEADER)
X#if 1L && !0L
Nusing std::div_t;
Nusing std::ldiv_t;
N#if defined(_LLONG_AVAILABLE)
X#if 1L
Nusing std::lldiv_t;
N#endif
Nusing std::size_t;
Nusing std::abs;
Nusing std::labs;
Nusing std::atoi;
Nusing std::atol;
N#if defined(_LLONG_AVAILABLE)
X#if 1L
Nusing std::llabs;
Nusing std::atoll;
N#endif
Nusing std::atof;
Nusing std::strtol;
Nusing std::strtoul;
N#if defined(_LLONG_AVAILABLE)
X#if 1L
Nusing std::strtoll;
Nusing std::strtoull;
N#endif
Nusing std::strtod;
Nusing std::rand;
Nusing std::srand;
Nusing std::calloc;
Nusing std::malloc;
Nusing std::realloc;
Nusing std::free;
Nusing std::memalign;
Nusing std::abort;
Nusing std::atexit;
Nusing std::bsearch;
Nusing std::qsort;
Nusing std::exit;
Nusing std::div;
Nusing std::ldiv;
N#if defined(_LLONG_AVAILABLE)
X#if 1L
Nusing std::lldiv;
N#endif
Nusing std::getenv;
Nusing std::system;
N#endif /* ! _CPP_STYLE_HEADER */
N
N#include <stdlibf.h>     /* far versions of stdlib fns */
L 1 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/stdlibf.h" 1
N/*****************************************************************************/
N/* stdlibf.h   v5.2.6                                                        */
N/*     far versions of stdlib.h functions                                    */
N/* Copyright (c) 1996-2010 Texas Instruments Incorporated                    */
N/*****************************************************************************/
N#ifndef _STDLIBF
N#define _STDLIBF
N
N#ifndef __cplusplus
S_CODE_ACCESS long          far_strtol (const far char *st, far char **endptr, 
S				   int base);
S_CODE_ACCESS unsigned long far_strtoul(const far char *st, far char **endptr, 
S				   int base);
S_CODE_ACCESS double        far_strtod (const far char *st, far char **endptr);
S_CODE_ACCESS long double   far_strtold (const far char *st, far char **endptr);
S_CODE_ACCESS long long     far_strtoll(const far char *st, far char **endptr, 
S		 						    int base);
S_CODE_ACCESS unsigned long long far_strtoull(const far char *st, 
S                                                   far char **endptr, int base);
S_CODE_ACCESS int           far_atoi(const far char *st);
S_CODE_ACCESS long          far_atol(const far char *st);
S_IDECL       double        far_atof(const far char *st);
S_CODE_ACCESS long long     far_atoll(const far char *st);
S
S_CODE_ACCESS far void     *far_calloc  (unsigned long num, unsigned long size);
S_CODE_ACCESS far void     *far_malloc  (unsigned long size);
S_CODE_ACCESS far void     *far_realloc (far void *ptr, unsigned long size);
S_CODE_ACCESS void          far_free    (far void *ptr);
S
S_CODE_ACCESS far void     *far_bsearch(const far void *key, 
S                                       const far void *base, 
S			               size_t nmemb, size_t size, 
S			               int (*compar)(const far void *,
S                                                     const far void *));
S_CODE_ACCESS void          far_qsort  (far void *base, 
S                                       size_t nmemb, size_t size,
S			               int (*compar)(const far void *, 
S                                                     const far void *));
S
S_CODE_ACCESS int	   free_memory(void);
S_CODE_ACCESS int           max_free(void);
S_CODE_ACCESS void         *chkheap();
S
S#ifdef _INLINE
Sstatic __inline double far_atof(const far char *st) 
S{ 
S   return far_strtod(st, NULL);
S}
S#endif /* _INLINE */
S
N#else /* __cplusplus */
N
Nnamespace std {
N
Nextern "C" int	       free_memory(void);
Nextern "C" int         max_free(void);
Nextern "C" void        *chkheap();
N
N_CODE_ACCESS long      far_calloc  (unsigned long num, unsigned long size);
X long      far_calloc  (unsigned long num, unsigned long size);
N_CODE_ACCESS long      far_malloc  (unsigned long size);
X long      far_malloc  (unsigned long size);
N_CODE_ACCESS long      far_realloc (long ptr, unsigned long size);
X long      far_realloc (long ptr, unsigned long size);
N_CODE_ACCESS void      far_free    (long ptr);
X void      far_free    (long ptr);
N_CODE_ACCESS long      far_free_memory(void);
X long      far_free_memory(void);
N_CODE_ACCESS long      far_max_free(void);
X long      far_max_free(void);
N_CODE_ACCESS long      far_chkheap(void);
X long      far_chkheap(void);
N
N}
N#endif /* __cplusplus */
N#endif /* _STDLIBF */
N
N#if defined(__cplusplus) && !defined(_CPP_STYLE_HEADER)
X#if 1L && !0L
Nusing std::free_memory; 
Nusing std::max_free;
Nusing std::chkheap;
Nusing std::far_calloc;
Nusing std::far_malloc;
Nusing std::far_realloc;
Nusing std::far_free;
Nusing std::far_free_memory; 
Nusing std::far_max_free;
Nusing std::far_chkheap;
N#endif /* _CPP_STYLE_HEADER */
L 184 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/stdlib.h" 2
L 28 "../src/cores/f_math.cpp" 2
N}
N
Nvoid randomSeed(unsigned int seed)
N{
N	if (seed != 0) {
N//		srandom(seed);
N		srand(seed);
N  }
N}
N
Nlong random( )
N{
N	unsigned long r;
N	r = (unsigned long)rand();
N	r<<=16;
N	r |= (unsigned long)rand();
N
N	return r;
N}
N
Nlong random(long howbig)
N{
N  if (howbig == 0) {
N    return 0;
N  }
N  return random() % howbig;
N}
N
Nlong random(long howsmall, long howbig)
N{
N  if (howsmall >= howbig) {
N    return howsmall;
N  }
N  long diff = howbig - howsmall;
N  return random(diff) + howsmall;
N}
N
Nlong map(long x, long in_min, long in_max, long out_min, long out_max)
N{
N  return (x - in_min) * (out_max - out_min) / (in_max - in_min) + out_min;
N}
N
Nint map( int x, int in_min, int in_max, int out_min, int out_max )
N{
N  return (x - in_min) * (out_max - out_min) / (in_max - in_min) + out_min;
N}
N
Nunsigned int makeWord(unsigned int w)
N{
N	 return w;
N}
Nunsigned int makeWord(unsigned char h, unsigned char l)
N{
N	return (h << 8) | l;
N}
