L 1 "../src/cores/f_stdlib.c"
N/*** f_stdlib.c - stdlib ***/
N
N/*** Copyright(C) 2011 Sansei System Co.,Ltd. ***/
N
N/*** HISTORY ***
N * 2011/05/21 mimu
N              First Version
N */
N
N#include <stdio.h>
L 1 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/stdio.h" 1
N/*****************************************************************************/
N/* STDIO.H v5.2.6                                                            */
N/* Copyright (c) 1993-2010 Texas Instruments Incorporated                    */
N/*****************************************************************************/
N#ifndef _STDIO 
N#define _STDIO
N
N#include <linkage.h>
L 1 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/linkage.h" 1
N/*****************************************************************************/
N/* linkage.h   v5.2.6                                                         */
N/* Copyright (c) 1998-2010 Texas Instruments Incorporated                    */
N/*****************************************************************************/
N
N#ifndef _LINKAGE
N#define _LINKAGE
N
N/* No modifiers needed to access code */
N
N#define _CODE_ACCESS
N
N/*--------------------------------------------------------------------------*/
N/* Define _DATA_ACCESS ==> how to access RTS global or static data          */
N/*--------------------------------------------------------------------------*/
N#ifndef _FAR_RTS
N#define _DATA_ACCESS
N#else
S#define _DATA_ACCESS far
N#endif
N#define _DATA_ACCESS_NEAR
N
N/*--------------------------------------------------------------------------*/
N/* Define _OPTIMIZE_FOR_SPACE ==> Always optimize for space.                */
N/*--------------------------------------------------------------------------*/
N#ifndef _OPTIMIZE_FOR_SPACE
S#define _OPTIMIZE_FOR_SPACE 1
N#endif
N
N/*--------------------------------------------------------------------------*/
N/* Define _IDECL ==> how inline functions are declared                      */
N/*--------------------------------------------------------------------------*/
N#ifdef _INLINE
S#define _IDECL static __inline
S#define _IDEFN static __inline
N#else
N#define _IDECL extern _CODE_ACCESS
N#define _IDEFN _CODE_ACCESS
N#endif
N
N#endif /* _LINKAGE */
L 9 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/stdio.h" 2
N#include <stdarg.h>
L 1 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/stdarg.h" 1
N/*****************************************************************************/
N/* stdarg.h   v5.2.6                                                         */
N/* Copyright (c) 1996-2010 Texas Instruments Incorporated                    */
N/*****************************************************************************/
N
N#ifndef _STDARG
N#define _STDARG
N
N#include <linkage.h>
N
N#ifdef __cplusplus
S#define va_start(ap, parmN) (ap = ((std::va_list)__va_parmadr(parmN)))
Snamespace std {
N#else
N#define va_start(ap, parmN) (ap = ((va_list)__va_parmadr(parmN)))
N#endif /* __cplusplus */
N
Ntypedef char *va_list;
N
N#ifdef __cplusplus
S} /* namespace std */
N#endif
N
N#define va_end(ap)
N
N/****************************************************************************/
N/* RETURN THE NEXT VALUE ON THE STACK ...                                   */
N/*                                                                          */
N/* (<advance ap>, <access the value>) BECOMES ...                           */
N/*                                                                          */
N/* ap -= 1 (stack grows toward high addresses)                              */
N/* ap -= 1 more if type is long or float                                    */
N/* ap -= 1 more if type is long or float and to account for alignment       */
N/*       if necessary                                                       */
N/*                                                                          */
N/* if      (<type is passed by address [struct or union]>) return **ap;     */
N/* else if (<type is integer size>)                        return *ap;      */
N/*                                                                          */
N/* LONG/FLOATS ARE ALWAYS ALIGNED ON AN EVEN WORD BOUNDARY, EVEN WHEN       */
N/* PASSED AS PARAMETERS, THUS ap MUST BE ALIGNED FOR THOSE ACCESSES.        */
N/****************************************************************************/
N#if __LARGE_MODEL__
X#if 1
N#define va_arg(ap, type)                                                 \
N( (ap -= 1 + (__va_argref(type) ? (((long)ap & 1) ? 2 : 1) :		 \
N				  (sizeof(type) == sizeof(int)) ? 0 :    \
N                                   ((long)ap & 1) ? sizeof(type) :       \
N                                                    sizeof(type) - 1 )), \
N   (__va_argref(type)             ? (** (type **) (ap)) : (* (type *) (ap)) ))
X#define va_arg(ap, type)                                                 ( (ap -= 1 + (__va_argref(type) ? (((long)ap & 1) ? 2 : 1) :		 				  (sizeof(type) == sizeof(int)) ? 0 :                                       ((long)ap & 1) ? sizeof(type) :                                                           sizeof(type) - 1 )),    (__va_argref(type)             ? (** (type **) (ap)) : (* (type *) (ap)) ))
N#else
S#define va_arg(ap, type)                                                 \
S( (ap -= 1 + (__va_argref(type) ? (((int)ap & 1) ? 2 : 1) : 		 \
S				  (sizeof(type) == sizeof(int)) ? 0 :    \
S                                   ((int)ap & 1) ? sizeof(type)      :   \
S                                                   sizeof(type) - 1 )),  \
S   (__va_argref(type)             ? (** (type **) (ap)) : (* (type *) (ap)) ))
X#define va_arg(ap, type)                                                 ( (ap -= 1 + (__va_argref(type) ? (((int)ap & 1) ? 2 : 1) : 		 				  (sizeof(type) == sizeof(int)) ? 0 :                                       ((int)ap & 1) ? sizeof(type)      :                                                      sizeof(type) - 1 )),     (__va_argref(type)             ? (** (type **) (ap)) : (* (type *) (ap)) ))
N#endif
N
N#endif /* _STDARG */
N
N#if defined(__cplusplus) && !defined(_CPP_STYLE_HEADER)
X#if 0L && !0L
Susing std::va_list;
N#endif /* _CPP_STYLE_HEADER */
N
L 10 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/stdio.h" 2
N
N
N#ifdef __cplusplus
S//----------------------------------------------------------------------------
S// <cstdio> IS RECOMMENDED OVER <stdio.h>.  <stdio.h> IS PROVIDED FOR
S// COMPATIBILITY WITH C AND THIS USAGE IS DEPRECATED IN C++
S//----------------------------------------------------------------------------
Sextern "C" namespace std {
N#endif
N
N/****************************************************************************/
N/* TYPES THAT ANSI REQUIRES TO BE DEFINED                                   */
N/****************************************************************************/
N#ifndef _SIZE_T
N#define _SIZE_T
Ntypedef __SIZE_T_TYPE__ size_t;
Xtypedef unsigned long size_t;
N#endif
N
Ntypedef struct {
N      int fd;                    /* File descriptor */
N      unsigned char* buf;        /* Pointer to start of buffer */
N      unsigned char* pos;        /* Position in buffer */
N      unsigned char* bufend;     /* Pointer to end of buffer */
N      unsigned char* buff_stop;  /* Pointer to last read char in buffer */
N      unsigned int   flags;      /* File status flags (see below) */
N} FILE;
N
N#ifndef _FPOS_T
N#define _FPOS_T
Ntypedef long fpos_t;
N#endif /* _FPOS_T */
N
N/****************************************************************************/
N/* DEVICE AND STREAM RELATED MACROS                                         */
N/****************************************************************************/
N/****************************************************************************/
N/* MACROS THAT DEFINE AND USE FILE STATUS FLAGS                             */
N/****************************************************************************/
N
N#define _IOFBF       0x0001
N#define _IOLBF       0x0002
N#define _IONBF       0x0004
N#define _BUFFALOC    0x0008
N#define _MODER       0x0010
N#define _MODEW       0x0020
N#define _MODERW      0x0040
N#define _MODEA       0x0080
N#define _MODEBIN     0x0100
N#define _STATEOF     0x0200
N#define _STATERR     0x0400
N#define _UNGETC      0x0800
N#define _TMPFILE     0x1000
N
N#define _SET(_fp, _b)      (((_fp)->flags) |= (_b))
N#define _UNSET(_fp, _b)    (((_fp)->flags) &= ~(_b))
N#define _STCHK(_fp, _b)    (((_fp)->flags) & (_b))
N#define _BUFFMODE(_fp)     (((_fp)->flags) & (_IOFBF | _IOLBF | _IONBF))
N#define _ACCMODE(_fp)      (((_fp)->flags) & (_MODER | _MODEW))
N
N/****************************************************************************/
N/* MACROS THAT ANSI REQUIRES TO BE DEFINED                                  */
N/****************************************************************************/
N#define BUFSIZ          256 
N
N#define FOPEN_MAX       _NFILE
N#define FILENAME_MAX    256  
N#define TMP_MAX         65535
N
N#define stdin     (&_ftable[0])      
N#define stdout    (&_ftable[1])
N#define stderr    (&_ftable[2])
N
N#define L_tmpnam  _LTMPNAM
N
N
N#define SEEK_SET  (0x0000)
N#define SEEK_CUR  (0x0001)
N#define SEEK_END  (0x0002)
N
N#ifndef NULL
N#define NULL 0
N#endif
N
N#ifndef EOF
N#define EOF    (-1)
N#endif
N
N
N/******** END OF ANSI MACROS ************************************************/
N
N#define P_tmpdir        ""                   /* Path for temp files         */
N
N/****************************************************************************/
N/* DEVICE AND STREAM RELATED DATA STRUCTURES AND MACROS                     */
N/****************************************************************************/
N#define _NFILE           10                   /* Max number of files open   */
N#define _LTMPNAM         16                   /* Length of temp name        */
N
Nextern _DATA_ACCESS FILE _ftable[_NFILE];
Xextern  FILE _ftable[10];
Nextern _DATA_ACCESS char _tmpnams[_NFILE][_LTMPNAM];
Xextern  char _tmpnams[10][16];
N
N/****************************************************************************/
N/*   FUNCTION DEFINITIONS  - ANSI                                           */
N/****************************************************************************/
N/****************************************************************************/
N/* OPERATIONS ON FILES                                                      */
N/****************************************************************************/
Nextern _CODE_ACCESS int     remove(const char *_file);
Xextern  int     remove(const char *_file);
Nextern _CODE_ACCESS int     rename(const char *_old, const char *_new);
Xextern  int     rename(const char *_old, const char *_new);
Nextern _CODE_ACCESS FILE   *tmpfile(void);
Xextern  FILE   *tmpfile(void);
Nextern _CODE_ACCESS char   *tmpnam(char *_s);
Xextern  char   *tmpnam(char *_s);
N
N/****************************************************************************/
N/* FILE ACCESS FUNCTIONS                                                    */
N/****************************************************************************/
Nextern _CODE_ACCESS int     fclose(FILE *_fp); 
Xextern  int     fclose(FILE *_fp); 
Nextern _CODE_ACCESS FILE   *fopen(const char *_fname, const char *_mode);
Xextern  FILE   *fopen(const char *_fname, const char *_mode);
Nextern _CODE_ACCESS FILE   *freopen(const char *_fname, const char *_mode,
Xextern  FILE   *freopen(const char *_fname, const char *_mode,
N			            register FILE *_fp);
Nextern _CODE_ACCESS void    setbuf(register FILE *_fp, char *_buf);
Xextern  void    setbuf(register FILE *_fp, char *_buf);
Nextern _CODE_ACCESS int     setvbuf(register FILE *_fp, register char *_buf, 
Xextern  int     setvbuf(register FILE *_fp, register char *_buf, 
N			            register int _type, register size_t _size);
Nextern _CODE_ACCESS int     fflush(register FILE *_fp); 
Xextern  int     fflush(register FILE *_fp); 
N
N/****************************************************************************/
N/* FORMATTED INPUT/OUTPUT FUNCTIONS                                         */
N/****************************************************************************/
Nextern _CODE_ACCESS int fprintf(FILE *_fp, const char *_format, ...);
Xextern  int fprintf(FILE *_fp, const char *_format, ...);
Nextern _CODE_ACCESS int fscanf(FILE *_fp, const char *_fmt, ...);
Xextern  int fscanf(FILE *_fp, const char *_fmt, ...);
Nextern _CODE_ACCESS int printf(const char *_format, ...);
Xextern  int printf(const char *_format, ...);
Nextern _CODE_ACCESS int scanf(const char *_fmt, ...);
Xextern  int scanf(const char *_fmt, ...);
Nextern _CODE_ACCESS int sprintf(char *_string, const char *_format, ...);
Xextern  int sprintf(char *_string, const char *_format, ...);
Nextern _CODE_ACCESS int snprintf(char *_string, size_t _n, 
Xextern  int snprintf(char *_string, size_t _n, 
N				 const char *_format, ...);
Nextern _CODE_ACCESS int sscanf(const char *_str, const char *_fmt, ...);
Xextern  int sscanf(const char *_str, const char *_fmt, ...);
Nextern _CODE_ACCESS int vfprintf(FILE *_fp, const char *_format, va_list _ap);
Xextern  int vfprintf(FILE *_fp, const char *_format, va_list _ap);
Nextern _CODE_ACCESS int vprintf(const char *_format, va_list _ap);
Xextern  int vprintf(const char *_format, va_list _ap);
Nextern _CODE_ACCESS int vsprintf(char *_string, const char *_format,
Xextern  int vsprintf(char *_string, const char *_format,
N				 va_list _ap);
Nextern _CODE_ACCESS int vsnprintf(char *_string, size_t _n, 
Xextern  int vsnprintf(char *_string, size_t _n, 
N				  const char *_format, va_list _ap);
N
N/****************************************************************************/
N/* CHARACTER INPUT/OUTPUT FUNCTIONS                                         */
N/****************************************************************************/
Nextern _CODE_ACCESS int     fgetc(register FILE *_fp);
Xextern  int     fgetc(register FILE *_fp);
Nextern _CODE_ACCESS char   *fgets(char *_ptr, register int _size,
Xextern  char   *fgets(char *_ptr, register int _size,
N				  register FILE *_fp);
Nextern _CODE_ACCESS int     fputc(int _c, register FILE *_fp);
Xextern  int     fputc(int _c, register FILE *_fp);
Nextern _CODE_ACCESS int     fputs(const char *_ptr, register FILE *_fp);
Xextern  int     fputs(const char *_ptr, register FILE *_fp);
Nextern _CODE_ACCESS int     getc(FILE *_p);
Xextern  int     getc(FILE *_p);
Nextern _CODE_ACCESS int     getchar(void);
Xextern  int     getchar(void);
Nextern _CODE_ACCESS char   *gets(char *_ptr); 
Xextern  char   *gets(char *_ptr); 
Nextern _CODE_ACCESS int     putc(int _x, FILE *_fp);
Xextern  int     putc(int _x, FILE *_fp);
Nextern _CODE_ACCESS int     putchar(int _x);
Xextern  int     putchar(int _x);
Nextern _CODE_ACCESS int     puts(const char *_ptr); 
Xextern  int     puts(const char *_ptr); 
Nextern _CODE_ACCESS int     ungetc(int _c, register FILE *_fp);
Xextern  int     ungetc(int _c, register FILE *_fp);
N
N/****************************************************************************/
N/* DIRECT INPUT/OUTPUT FUNCTIONS                                            */
N/****************************************************************************/
Nextern _CODE_ACCESS size_t  fread(void *_ptr, size_t _size, size_t _count,
Xextern  size_t  fread(void *_ptr, size_t _size, size_t _count,
N				  FILE *_fp);
Nextern _CODE_ACCESS size_t  fwrite(const void *_ptr, size_t _size,
Xextern  size_t  fwrite(const void *_ptr, size_t _size,
N				   size_t _count, register FILE *_fp); 
N
N/****************************************************************************/
N/* FILE POSITIONING FUNCTIONS                                               */
N/****************************************************************************/
Nextern _CODE_ACCESS int     fgetpos(FILE *_fp, fpos_t *_pos);
Xextern  int     fgetpos(FILE *_fp, fpos_t *_pos);
Nextern _CODE_ACCESS int     fseek(register FILE *_fp, long _offset,
Xextern  int     fseek(register FILE *_fp, long _offset,
N				  int _ptrname);
Nextern _CODE_ACCESS int     fsetpos(FILE *_fp, const fpos_t *_pos);
Xextern  int     fsetpos(FILE *_fp, const fpos_t *_pos);
Nextern _CODE_ACCESS long    ftell(FILE *_fp);
Xextern  long    ftell(FILE *_fp);
Nextern _CODE_ACCESS void    rewind(register FILE *_fp); 
Xextern  void    rewind(register FILE *_fp); 
N
N/****************************************************************************/
N/* ERROR-HANDLING FUNCTIONS                                                 */
N/****************************************************************************/
Nextern _CODE_ACCESS void    clearerr(FILE *_fp);
Xextern  void    clearerr(FILE *_fp);
Nextern _CODE_ACCESS int     feof(FILE *_fp);
Xextern  int     feof(FILE *_fp);
Nextern _CODE_ACCESS int     ferror(FILE *_fp);
Xextern  int     ferror(FILE *_fp);
Nextern _CODE_ACCESS void    perror(const char *_s);
Xextern  void    perror(const char *_s);
N
N#define _getchar()      getc(stdin)
N#define _putchar(_x)    putc((_x), stdout)
N#define _clearerr(_fp)   ((void) ((_fp)->flags &= ~(_STATERR | _STATEOF)))
N
N#define _ferror(_x)     ((_x)->flags & _STATERR)
N
N#define _remove(_fl)    (unlink((_fl)))
N
N#ifdef __cplusplus
S} /* extern "C" namespace std */
N#endif  /* __cplusplus */
N
N#endif  /* #ifndef _STDIO */
N
N#if defined(__cplusplus) && !defined(_CPP_STYLE_HEADER)
X#if 0L && !0L
Susing std::size_t;
Susing std::FILE;
Susing std::fpos_t;
Susing std::_ftable;
Susing std::_tmpnams;
Susing std::remove;
Susing std::rename;
Susing std::tmpfile;
Susing std::tmpnam;
Susing std::fclose;
Susing std::fopen;
Susing std::freopen;
Susing std::setbuf;
Susing std::setvbuf;
Susing std::fflush;
Susing std::fprintf;
Susing std::fscanf;
Susing std::printf;
Susing std::scanf;
Susing std::sprintf;
Susing std::sscanf;
Susing std::vfprintf;
Susing std::vprintf;
Susing std::vsprintf;
Susing std::fgetc;
Susing std::fgets;
Susing std::fputc;
Susing std::fputs;
Susing std::getc;
Susing std::getchar;
Susing std::gets;
Susing std::putc;
Susing std::putchar;
Susing std::puts;
Susing std::ungetc;
Susing std::fread;
Susing std::fwrite;
Susing std::fgetpos;
Susing std::fseek;
Susing std::fsetpos;
Susing std::ftell;
Susing std::rewind;
Susing std::clearerr;
Susing std::feof;
Susing std::ferror;
Susing std::perror;
S
N#endif  /* _CPP_STYLE_HEADER */
N
N
L 11 "../src/cores/f_stdlib.c" 2
N#include <stdlib.h>
L 1 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/stdlib.h" 1
N/*****************************************************************************/
N/* stdlib.h   v5.2.6                                                         */
N/* Copyright (c) 1993-2010 Texas Instruments Incorporated                    */
N/*****************************************************************************/
N
N#ifndef _STDLIB
N#define _STDLIB
N
N
N#ifdef __cplusplus
S//----------------------------------------------------------------------------
S// <cstdlib> IS RECOMMENDED OVER <stdlib.h>.  <stdlib.h> IS PROVIDED FOR 
S// COMPATIBILITY WITH C AND THIS USAGE IS DEPRECATED IN C++
S//----------------------------------------------------------------------------
Sextern "C" namespace std {
N#endif /* !__cplusplus */
N
Ntypedef struct { int quot, rem; } div_t;
N
Ntypedef struct { long quot, rem; } ldiv_t;
N
N#define _LLONG_AVAILABLE 1
Ntypedef struct { long long quot, rem; } lldiv_t;
N
N#define MB_CUR_MAX    1
N
N#ifndef NULL
S#define NULL          0
N#endif
N
N#ifndef _SIZE_T
S#define _SIZE_T
Stypedef __SIZE_T_TYPE__ size_t;
N#endif
N
N#ifndef __cplusplus
N#ifndef _WCHAR_T
N#define _WCHAR_T
Ntypedef __WCHAR_T_TYPE__ wchar_t;
Xtypedef unsigned int wchar_t;
N#endif
N#endif
N
N#define EXIT_FAILURE  1
N#define EXIT_SUCCESS  0
N
N#define RAND_MAX      32767
N
N#include <linkage.h>
N
N/*---------------------------------------------------------------*/
N/* NOTE - Normally, abs, labs, and fabs are expanded inline, so  */
N/*        no formal definition is really required. However, ANSI */
N/*        requires that they exist as separate functions, so     */
N/*        they are supplied in the library.  The prototype is    */
N/*        here mainly for documentation.                         */
N/*---------------------------------------------------------------*/
N    _CODE_ACCESS  int       abs(int _val); 
X      int       abs(int _val); 
N    _CODE_ACCESS  long      labs(long _val);
X      long      labs(long _val);
N#if defined(_LLONG_AVAILABLE)
X#if 1L
N    _CODE_ACCESS  long long llabs(long long _val);
X      long long llabs(long long _val);
N#endif
N    _CODE_ACCESS int       atoi(const char *_st);
X     int       atoi(const char *_st);
N    _CODE_ACCESS long      atol(const char *_st);
X     long      atol(const char *_st);
N#if defined(_LLONG_AVAILABLE)
X#if 1L
N    _CODE_ACCESS long long atoll(const char *_st);
X     long long atoll(const char *_st);
N#endif
N    _CODE_ACCESS int       ltoa(long val, char *buffer);
X     int       ltoa(long val, char *buffer);
N          _IDECL double    atof(const char *_st);
X          extern  double    atof(const char *_st);
N
N    _CODE_ACCESS long      strtol(const char *_st, char **_endptr, int _base);
X     long      strtol(const char *_st, char **_endptr, int _base);
N    _CODE_ACCESS unsigned long strtoul(const char *_st, char **_endptr,
X     unsigned long strtoul(const char *_st, char **_endptr,
N    					  int _base);
N#if defined(_LLONG_AVAILABLE)
X#if 1L
N    _CODE_ACCESS long long strtoll(const char *_st, char **_endptr, int _base);
X     long long strtoll(const char *_st, char **_endptr, int _base);
N    _CODE_ACCESS unsigned long long strtoull(const char *_st, char **_endptr,
X     unsigned long long strtoull(const char *_st, char **_endptr,
N					     int _base);
N#endif
N    _CODE_ACCESS double    strtod(const char *_st, char **_endptr);
X     double    strtod(const char *_st, char **_endptr);
N    _CODE_ACCESS long double strtold(const char *_st, char **_endptr);
X     long double strtold(const char *_st, char **_endptr);
N    
N    _CODE_ACCESS int    rand(void);
X     int    rand(void);
N    _CODE_ACCESS void   srand(unsigned _seed);
X     void   srand(unsigned _seed);
N    
N    _CODE_ACCESS void  *calloc(size_t _num, size_t _size);
X     void  *calloc(size_t _num, size_t _size);
N    _CODE_ACCESS void  *malloc(size_t _size);
X     void  *malloc(size_t _size);
N    _CODE_ACCESS void  *realloc(void *_ptr, size_t _size);
X     void  *realloc(void *_ptr, size_t _size);
N    _CODE_ACCESS void   free(void *_ptr);
X     void   free(void *_ptr);
N    _CODE_ACCESS void  *memalign(size_t _aln, size_t _size);
X     void  *memalign(size_t _aln, size_t _size);
N    
N    _CODE_ACCESS void   abort(void); 
X     void   abort(void); 
N    _CODE_ACCESS int    atexit(void (*_func)(void));
X     int    atexit(void (*_func)(void));
N    _CODE_ACCESS void  *bsearch(const void *_key, const void *_base,
X     void  *bsearch(const void *_key, const void *_base,
N    				   size_t _nmemb, size_t _size, 
N    			           int (*compar)(const void *,const void *));
N    _CODE_ACCESS void   qsort(void *_base, size_t _nmemb, size_t _size, 
X     void   qsort(void *_base, size_t _nmemb, size_t _size, 
N    			         int (*_compar)(const void *, const void *));
N    _CODE_ACCESS void   exit(int _status);
X     void   exit(int _status);
N    
N    _CODE_ACCESS div_t  div(int _numer, int _denom);
X     div_t  div(int _numer, int _denom);
N    _CODE_ACCESS ldiv_t ldiv(long _numer, long _denom);
X     ldiv_t ldiv(long _numer, long _denom);
N#if defined(_LLONG_AVAILABLE)
X#if 1L
N    _CODE_ACCESS lldiv_t lldiv(long long _numer, long long _denom);
X     lldiv_t lldiv(long long _numer, long long _denom);
N#endif
N
N    _CODE_ACCESS char  *getenv(const char *_string);
X     char  *getenv(const char *_string);
N    _CODE_ACCESS int    system(const char *_name);
X     int    system(const char *_name);
N
N    _CODE_ACCESS int    mblen(const char *, size_t);
X     int    mblen(const char *, size_t);
N    _CODE_ACCESS size_t mbstowcs(wchar_t *, const char *, size_t);
X     size_t mbstowcs(wchar_t *, const char *, size_t);
N    _CODE_ACCESS int    mbtowc(wchar_t *, const char *, size_t);
X     int    mbtowc(wchar_t *, const char *, size_t);
N
N    _CODE_ACCESS size_t wcstombs(char *, const wchar_t *, size_t);
X     size_t wcstombs(char *, const wchar_t *, size_t);
N    _CODE_ACCESS int    wctomb(char *, wchar_t);
X     int    wctomb(char *, wchar_t);
N
N#ifdef __cplusplus
S} /* extern "C" namespace std */
N#endif /* __cplusplus */
N
N
N#ifdef _INLINE
S
S#ifdef __cplusplus
Snamespace std {
S#endif
S
Sstatic __inline double atof(const char *_st) 
S{
S  return strtod(_st, (char **)0); 
S}
S
S#ifdef __cplusplus
S} /* namespace std */
S#endif
S
N#endif  /* _INLINE */
N
N#endif  /* ! _STDLIB */
N
N#if defined(__cplusplus) && !defined(_CPP_STYLE_HEADER)
X#if 0L && !0L
Susing std::div_t;
Susing std::ldiv_t;
S#if defined(_LLONG_AVAILABLE)
Susing std::lldiv_t;
S#endif
Susing std::size_t;
Susing std::abs;
Susing std::labs;
Susing std::atoi;
Susing std::atol;
S#if defined(_LLONG_AVAILABLE)
Susing std::llabs;
Susing std::atoll;
S#endif
Susing std::atof;
Susing std::strtol;
Susing std::strtoul;
S#if defined(_LLONG_AVAILABLE)
Susing std::strtoll;
Susing std::strtoull;
S#endif
Susing std::strtod;
Susing std::rand;
Susing std::srand;
Susing std::calloc;
Susing std::malloc;
Susing std::realloc;
Susing std::free;
Susing std::memalign;
Susing std::abort;
Susing std::atexit;
Susing std::bsearch;
Susing std::qsort;
Susing std::exit;
Susing std::div;
Susing std::ldiv;
S#if defined(_LLONG_AVAILABLE)
Susing std::lldiv;
S#endif
Susing std::getenv;
Susing std::system;
N#endif /* ! _CPP_STYLE_HEADER */
N
N#include <stdlibf.h>     /* far versions of stdlib fns */
L 1 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/stdlibf.h" 1
N/*****************************************************************************/
N/* stdlibf.h   v5.2.6                                                        */
N/*     far versions of stdlib.h functions                                    */
N/* Copyright (c) 1996-2010 Texas Instruments Incorporated                    */
N/*****************************************************************************/
N#ifndef _STDLIBF
N#define _STDLIBF
N
N#ifndef __cplusplus
N_CODE_ACCESS long          far_strtol (const far char *st, far char **endptr, 
X long          far_strtol (const far char *st, far char **endptr, 
N				   int base);
N_CODE_ACCESS unsigned long far_strtoul(const far char *st, far char **endptr, 
X unsigned long far_strtoul(const far char *st, far char **endptr, 
N				   int base);
N_CODE_ACCESS double        far_strtod (const far char *st, far char **endptr);
X double        far_strtod (const far char *st, far char **endptr);
N_CODE_ACCESS long double   far_strtold (const far char *st, far char **endptr);
X long double   far_strtold (const far char *st, far char **endptr);
N_CODE_ACCESS long long     far_strtoll(const far char *st, far char **endptr, 
X long long     far_strtoll(const far char *st, far char **endptr, 
N		 						    int base);
N_CODE_ACCESS unsigned long long far_strtoull(const far char *st, 
X unsigned long long far_strtoull(const far char *st, 
N                                                   far char **endptr, int base);
N_CODE_ACCESS int           far_atoi(const far char *st);
X int           far_atoi(const far char *st);
N_CODE_ACCESS long          far_atol(const far char *st);
X long          far_atol(const far char *st);
N_IDECL       double        far_atof(const far char *st);
Xextern        double        far_atof(const far char *st);
N_CODE_ACCESS long long     far_atoll(const far char *st);
X long long     far_atoll(const far char *st);
N
N_CODE_ACCESS far void     *far_calloc  (unsigned long num, unsigned long size);
X far void     *far_calloc  (unsigned long num, unsigned long size);
N_CODE_ACCESS far void     *far_malloc  (unsigned long size);
X far void     *far_malloc  (unsigned long size);
N_CODE_ACCESS far void     *far_realloc (far void *ptr, unsigned long size);
X far void     *far_realloc (far void *ptr, unsigned long size);
N_CODE_ACCESS void          far_free    (far void *ptr);
X void          far_free    (far void *ptr);
N
N_CODE_ACCESS far void     *far_bsearch(const far void *key, 
X far void     *far_bsearch(const far void *key, 
N                                       const far void *base, 
N			               size_t nmemb, size_t size, 
N			               int (*compar)(const far void *,
N                                                     const far void *));
N_CODE_ACCESS void          far_qsort  (far void *base, 
X void          far_qsort  (far void *base, 
N                                       size_t nmemb, size_t size,
N			               int (*compar)(const far void *, 
N                                                     const far void *));
N
N_CODE_ACCESS int	   free_memory(void);
X int	   free_memory(void);
N_CODE_ACCESS int           max_free(void);
X int           max_free(void);
N_CODE_ACCESS void         *chkheap();
X void         *chkheap();
N
N#ifdef _INLINE
Sstatic __inline double far_atof(const far char *st) 
S{ 
S   return far_strtod(st, NULL);
S}
N#endif /* _INLINE */
N
N#else /* __cplusplus */
S
Snamespace std {
S
Sextern "C" int	       free_memory(void);
Sextern "C" int         max_free(void);
Sextern "C" void        *chkheap();
S
S_CODE_ACCESS long      far_calloc  (unsigned long num, unsigned long size);
S_CODE_ACCESS long      far_malloc  (unsigned long size);
S_CODE_ACCESS long      far_realloc (long ptr, unsigned long size);
S_CODE_ACCESS void      far_free    (long ptr);
S_CODE_ACCESS long      far_free_memory(void);
S_CODE_ACCESS long      far_max_free(void);
S_CODE_ACCESS long      far_chkheap(void);
S
S}
N#endif /* __cplusplus */
N#endif /* _STDLIBF */
N
N#if defined(__cplusplus) && !defined(_CPP_STYLE_HEADER)
X#if 0L && !0L
Susing std::free_memory; 
Susing std::max_free;
Susing std::chkheap;
Susing std::far_calloc;
Susing std::far_malloc;
Susing std::far_realloc;
Susing std::far_free;
Susing std::far_free_memory; 
Susing std::far_max_free;
Susing std::far_chkheap;
N#endif /* _CPP_STYLE_HEADER */
L 184 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/stdlib.h" 2
L 12 "../src/cores/f_stdlib.c" 2
N#include <string.h>
L 1 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/string.h" 1
N/*****************************************************************************/
N/* string.h   v5.2.6                                                         */
N/* Copyright (c) 1993-2010 Texas Instruments Incorporated                    */
N/*****************************************************************************/
N
N#ifndef _STRING
N#define _STRING
N
N#ifdef __cplusplus
S//----------------------------------------------------------------------------
S// <cstring> IS RECOMMENDED OVER <string.h>.  <string.h> IS PROVIDED FOR
S// COMPATIBILITY WITH C AND THIS USAGE IS DEPRECATED IN C++
S//----------------------------------------------------------------------------
Sextern "C" namespace std
S{
N#endif /* __cplusplus */
N 
N#ifndef NULL
S#define NULL 0
N#endif
N
N#ifndef _SIZE_T
S#define _SIZE_T
Stypedef __SIZE_T_TYPE__ size_t;
N#endif
N
N#include <linkage.h>
N
N#if defined(_OPTIMIZE_FOR_SPACE) && (defined(__TMS470__) || 		\
N				     defined(__TMS320C2000__)  ||       \
N                                     defined(__MSP430__))
X#if 1L && (0L || 						     1L  ||                                            0L)
N#define _OPT_IDECL
N#else
S#define _OPT_IDECL	_IDECL
N#endif
N
N_OPT_IDECL size_t  strlen(const char *_string);
X size_t  strlen(const char *_string);
N
N_OPT_IDECL char *strcpy(char *_dest, const char *_src);
X char *strcpy(char *_dest, const char *_src);
N_OPT_IDECL char *strncpy(char *_to, const char *_from, size_t _n);
X char *strncpy(char *_to, const char *_from, size_t _n);
N_OPT_IDECL char *strcat(char *_string1, const char *_string2);
X char *strcat(char *_string1, const char *_string2);
N_OPT_IDECL char *strncat(char *_to, const char *_from, size_t _n);
X char *strncat(char *_to, const char *_from, size_t _n);
N_OPT_IDECL char *strchr(const char *_string, int _c);
X char *strchr(const char *_string, int _c);
N_OPT_IDECL char *strrchr(const char *_string, int _c);
X char *strrchr(const char *_string, int _c);
N
N_OPT_IDECL int  strcmp(const char *_string1, const char *_string2);
X int  strcmp(const char *_string1, const char *_string2);
N_OPT_IDECL int  strncmp(const char *_string1, const char *_string2, size_t _n);
X int  strncmp(const char *_string1, const char *_string2, size_t _n);
N
N_CODE_ACCESS int     strcoll(const char *_string1, const char *_string2);
X int     strcoll(const char *_string1, const char *_string2);
N_CODE_ACCESS size_t  strxfrm(char *_to, const char *_from, size_t _n);
X size_t  strxfrm(char *_to, const char *_from, size_t _n);
N_CODE_ACCESS char   *strpbrk(const char *_string, const char *_chs);
X char   *strpbrk(const char *_string, const char *_chs);
N_CODE_ACCESS size_t  strspn(const char *_string, const char *_chs);
X size_t  strspn(const char *_string, const char *_chs);
N_CODE_ACCESS size_t  strcspn(const char *_string, const char *_chs);
X size_t  strcspn(const char *_string, const char *_chs);
N_CODE_ACCESS char   *strstr(const char *_string1, const char *_string2);
X char   *strstr(const char *_string1, const char *_string2);
N_CODE_ACCESS char   *strtok(char *_str1, const char *_str2);
X char   *strtok(char *_str1, const char *_str2);
N_CODE_ACCESS char   *strerror(int _errno);
X char   *strerror(int _errno);
N
N_CODE_ACCESS void   *memmove(void *_s1, const void *_s2, size_t _n);
X void   *memmove(void *_s1, const void *_s2, size_t _n);
N
N_OPT_IDECL int     memcmp(const void *_cs, const void *_ct, size_t _n);
X int     memcmp(const void *_cs, const void *_ct, size_t _n);
N_OPT_IDECL void   *memchr(const void *_cs, int _c, size_t _n);
X void   *memchr(const void *_cs, int _c, size_t _n);
N
N_OPT_IDECL   void   *memset(void *_mem, int _ch, size_t _n);
X   void   *memset(void *_mem, int _ch, size_t _n);
N
N
N#ifndef __cplusplus
N#define far_memcpy __memcpy_ff
N#define far_strcpy strcpy_ff
Nsize_t    far_strlen(const far char *s);
Nchar     *strcpy_nf(char *s1, const char far *s2);
Nchar far *strcpy_fn(char far *s1, const char *s2);
Nchar far *strcpy_ff(char far *s1, const char far *s2);
Nfar char *far_strncpy(far char *s1, far const char *s2, size_t n);
Nfar char *far_strcat(far char *s1, const far char *s2);
Nfar char *far_strncat(far char *s1, const far char *s2, size_t n);
Nfar char *far_strchr(const far char *s, int c);
Nfar char *far_strrchr(const far char *s, int c);
Nint       far_strcmp(const far char *s1, const far char *s2);
Nint       far_strncmp(const far char *s1, const far char *s2, size_t n);
Nint       far_strcoll(const far char *s1, const far char *s2);
Nsize_t    far_strxfrm(far char *s1, const far char *s2, size_t n);
Nfar char *far_strpbrk(const far char *s1, const far char *s2);
Nsize_t    far_strspn(const far char *s1, const far char *s2);
Nsize_t    far_strcspn(const far char *s1, const far char *s2);
Nfar char *far_strstr(const far char *s1, const far char *s2);
Nfar char *far_strtok(far char *s1, const far char *s2);
Nfar char *far_strerror(int errno);
Nvoid far *far_memmove(far void *s1, far const void *s2, size_t n);
Nvoid     *__memcpy_nf (void *_s1, far const void *_s2, size_t _n);
Nvoid far *__memcpy_fn (far void *_s1, const void *_s2, size_t _n);
Nvoid far *__memcpy_ff (far void *_s1, far const void *_s2, size_t _n);
Nint       far_memcmp(const far void *s1, const far void *s2, size_t n);
Nfar void *far_memchr(const far void *s, int c, size_t n);
Nfar void *far_memset(far void *s, int c, size_t n);
Nfar void *far_memlcpy(far void *to, const far void *from, unsigned long n);
Nfar void *far_memlmove(far void *to, const far void *from, unsigned long n);
N#else /* __cplusplus */
Slong      far_memlcpy(long to, long from, unsigned long n);
Slong      far_memlmove(long to, long from, unsigned long n);
N#endif /* __cplusplus */
N
N
N#ifdef __cplusplus
S} /* extern "C" namespace std */
N#endif /* __cplusplus */
N
N#if defined(_INLINE) || defined(_STRING_IMPLEMENTATION)
X#if 0L || 0L
S
S#if (defined(_STRING_IMPLEMENTATION) ||					\
S     !(defined(_OPTIMIZE_FOR_SPACE) && (defined(__TMS470__) || 		\
S					defined(__TMS320C2000__)  ||    \
S                                        defined(__MSP430__))))
X#if (defined(_STRING_IMPLEMENTATION) ||					     !(defined(_OPTIMIZE_FOR_SPACE) && (defined(__TMS470__) || 							defined(__TMS320C2000__)  ||                                            defined(__MSP430__))))
S
S#ifdef __cplusplus
Snamespace std {
S#endif
S
S#if (defined(_OPTIMIZE_FOR_SPACE) && (defined(__TMS470__) || 		\
S				      defined(__TMS320C2000__) ||       \
S                                      defined(__MSP430__)))
X#if (defined(_OPTIMIZE_FOR_SPACE) && (defined(__TMS470__) || 						      defined(__TMS320C2000__) ||                                             defined(__MSP430__)))
S#define _OPT_IDEFN
S#else
S#define _OPT_IDEFN	_IDEFN
S#endif
S
S#if defined(_INLINE) || defined(_STRLEN)
S_OPT_IDEFN size_t strlen(const char *string)
S{
S   size_t      n = (size_t)-1;
S   const char *s = string;
S
S   do n++; while (*s++);
S   return n;
S}
S#endif /* _INLINE || _STRLEN */
S
S#if defined(_INLINE) || defined(_STRCPY)
S_OPT_IDEFN char *strcpy(register char *dest, register const char *src)
S{
S     register char       *d = dest;     
S     register const char *s = src;
S
S     while (*d++ = *s++);
S     return dest;
S}
S#endif /* _INLINE || _STRCPY */
S
S#if defined(_INLINE) || defined(_STRNCPY)
S_OPT_IDEFN char *strncpy(register char *dest,
S		     register const char *src,
S		     register size_t n)
S{
S     if (n) 
S     {
S	 register char       *d = dest;
S	 register const char *s = src;
S	 while ((*d++ = *s++) && --n);              /* COPY STRING         */
S	 if (n-- > 1) do *d++ = '\0'; while (--n);  /* TERMINATION PADDING */
S     }
S     return dest;
S}
S#endif /* _INLINE || _STRNCPY  */
S
S#if defined(_INLINE) || defined(_STRCAT)
S_OPT_IDEFN char *strcat(char *string1, const char *string2)
S{
S   char       *s1 = string1;
S   const char *s2 = string2;
S
S   while (*s1) s1++;		     /* FIND END OF STRING   */
S   while (*s1++ = *s2++);	     /* APPEND SECOND STRING */
S   return string1;
S}
S#endif /* _INLINE || _STRCAT */
S
S#if defined(_INLINE) || defined(_STRNCAT)
S_OPT_IDEFN char *strncat(char *dest, const char *src, register size_t n)
S{
S    if (n)
S    {
S	char       *d = dest;
S	const char *s = src;
S
S	while (*d) d++;                      /* FIND END OF STRING   */
S
S	while (n--)
S	  if (!(*d++ = *s++)) return dest; /* APPEND SECOND STRING */
S	*d = 0;
S    }
S    return dest;
S}
S#endif /* _INLINE || _STRNCAT */
S
S#if defined(_INLINE) || defined(_STRCHR)
S_OPT_IDEFN char *strchr(const char *string, int c)
S{
S   char        tch, ch  = c;
S   const char *s        = string;
S
S   for (;;)
S   {
S       if ((tch = *s) == ch) return (char *) s;
S       if (!tch)             return (char *) 0;
S       s++;
S   }
S}
S#endif /* _INLINE || _STRCHR */
S
S#if defined(_INLINE) || defined(_STRRCHR)
S_OPT_IDEFN char *strrchr(const char *string, int c)
S{
S   char        tch, ch = c;
S   char       *result  = 0;
S   const char *s       = string;
S
S   for (;;)
S   {
S      if ((tch = *s) == ch) result = (char *) s;
S      if (!tch) break;
S      s++;
S   }
S
S   return result;
S}
S#endif /* _INLINE || _STRRCHR */
S
S#if defined(_INLINE) || defined(_STRCMP)
S_OPT_IDEFN int strcmp(register const char *string1,
S		  register const char *string2)
S{
S   register int c1, res;
S
S   for (;;)
S   {
S       c1  = (unsigned char)*string1++;
S       res = c1 - (unsigned char)*string2++;
S
S       if (c1 == 0 || res != 0) break;
S   }
S
S   return res;
S}
S#endif /* _INLINE || _STRCMP */
S
S#if defined(_INLINE) || defined(_STRNCMP)
S_OPT_IDEFN int strncmp(const char *string1, const char *string2, size_t n)
S{
S     if (n) 
S     {
S	 const char *s1 = string1;
S	 const char *s2 = string2;
S	 unsigned char cp;
S	 int         result;
S
S	 do 
S	    if (result = (unsigned char)*s1++ - (cp = (unsigned char)*s2++))
S                return result;
S	 while (cp && --n);
S     }
S     return 0;
S}
S#endif /* _INLINE || _STRNCMP */
S
S#if defined(_INLINE) || defined(_MEMCMP)
S_OPT_IDEFN int memcmp(const void *cs, const void *ct, size_t n)
S{
S   if (n) 
S   {
S       const unsigned char *mem1 = (unsigned char *)cs;
S       const unsigned char *mem2 = (unsigned char *)ct;
S       int                 cp1, cp2;
S
S       while ((cp1 = *mem1++) == (cp2 = *mem2++) && --n);
S       return cp1 - cp2;
S   }
S   return 0;
S}
S#endif /* _INLINE || _MEMCMP */
S
S#if defined(_INLINE) || defined(_MEMCHR)
S_OPT_IDEFN void *memchr(const void *cs, int c, size_t n)
S{
S   if (n)
S   {
S      const unsigned char *mem = (unsigned char *)cs;   
S      unsigned char        ch  = c;
S
S      do 
S         if ( *mem == ch ) return (void *)mem;
S         else mem++;
S      while (--n);
S   }
S   return NULL;
S}
S#endif /* _INLINE || _MEMCHR */
S
S#if ((defined(_INLINE) || defined(_MEMSET)) && !defined(_TMS320C6X)) && !defined(__TMS470__)
S_OPT_IDEFN void *memset(void *mem, register int ch, register size_t length)
S{
S     register char *m = (char *)mem;
S
S     while (length--) *m++ = ch;
S     return mem;
S}
S#endif /* _INLINE || _MEMSET */
S
S#ifdef __cplusplus
S} /* namespace std */
S#endif
S
S#endif /* (_STRING_IMPLEMENTATION || !(_OPTIMIZE_FOR_SPACE && __TMS470__)) */
S
N#endif /* (_INLINE || _STRING_IMPLEMENTATION) */
N
N#endif /* ! _STRING */
N
N#if defined(__cplusplus) && !defined(_CPP_STYLE_HEADER)
X#if 0L && !0L
Susing std::size_t;
Susing std::strlen;
Susing std::strcpy;
Susing std::strncpy;
Susing std::strcat;
Susing std::strncat;
Susing std::strchr;
Susing std::strrchr;
Susing std::strcmp;
Susing std::strncmp;
Susing std::strcoll;
Susing std::strxfrm;
Susing std::strpbrk;
Susing std::strspn;
Susing std::strcspn;
Susing std::strstr;
Susing std::strtok;
Susing std::strerror;
Susing std::memmove;
Susing std::memcpy;
Susing std::memcmp;
Susing std::memchr;
Susing std::memset;
S
Susing std::far_memlcpy;
Susing std::far_memlmove;
S
N#endif /* _CPP_STYLE_HEADER */
N
L 13 "../src/cores/f_stdlib.c" 2
N
N#include "f_stdlib.h"
L 1 "..\src\cores\f_stdlib.h" 1
N/*** f_stdlib.h - stdlib ***/
N
N/*** Copyright(C) 2011 Sansei System Co.,Ltd. ***/
N
N/*** HISTORY ***
N * 2011/03/02 mimu
N              First Version
N */
N
N/*** NOTE ***
N */
N
N#ifndef	INC_f_stdlib_H
N#define	INC_f_stdlib_H
N
N#ifdef	__cplusplus
Sextern "C" {
N#endif
N
N
Nchar * f_itoa( int val, char * p, int base );
Nchar * f_ultoa( unsigned long val, char * p, int base );
Nchar * f_ltoa( long val, char * p, int base );
N
N#define	itoa	f_itoa
N#define	ultoa	f_ultoa
N#define	ltoa	f_ltoa
N
N#ifdef	__cplusplus
S} /* extern "C" */
N#endif
N
N#endif	/* INC_f_stdlib_H */
N
N/*** end of file : f_stdlib.h ***/
L 15 "../src/cores/f_stdlib.c" 2
N
Nstatic const char strTbl[] = { '0','1','2','3','4','5','6','7','8','9','a','b','c','d','e','f', };
Nchar * f_itoa( int val, char * pTop, int base )
N{
N	if( (base<=1) || (base>16) ) {
N		*pTop = '\0';
N	} else {
N		switch( base ) {
N		case 10:
N			sprintf( pTop, "%d", val );
N			break;
N		case 16:
N			sprintf( pTop, "%x", val );
N			break;
N		default:
N			if( val ) {
N				char buff[sizeof(int)*8]; /* when base=2, max string length */
N				int bNeg;
N				int len;
N				char * p;
N
N				if( val > 0 ) {
N					bNeg = 0;
N				} else {
N					bNeg = 1;
N					val = -val;
N				}
N
N				for( len=0; (len<32) && (val>0); len++) {
N					buff[len] = strTbl[val % base];
N					val /= base;
N					len++;
N				}
N
N				p = pTop;
N				if( bNeg ) {
N					*p = '-';
N					p++;
N				}
N				for( ; len>0; len--, p++) {
N					*p = buff[len];
N				}
N				*p = '\0';
N			} else {
N				sprintf( pTop, "0" );
N			}
N		}
N	}
N
N	return pTop;
N}
N
Nchar * f_ultoa( unsigned long val, char * pTop, int base )
N{
N	if( (base<=1) || (base>16) ) {
N		*pTop = '\0';
N	} else {
N		switch( base ) {
N		case 10:
N			sprintf( pTop, "%lu", val );
N			break;
N		case 16:
N			sprintf( pTop, "%lx", val );
N			break;
N		default:
N			if( val ) {
N				char buff[sizeof(long)*8]; /* when base=2, max string length */
N				int len;
N				char * p;
N
N				for( len=0; (len<32) && (val>0); len++) {
N					buff[len] = strTbl[val % base];
N					val /= base;
N					len++;
N				}
N
N				p = pTop;
N				for( ; len>0; len--, p++) {
N					*p = buff[len];
N				}
N				*p = '\0';
N			} else {
N				sprintf( pTop, "0" );
N			}
N		}
N	}
N
N	return pTop;
N}
N
Nchar * f_ltoa( long val, char * pTop, int base )
N{
N	if( (base<=1) || (base>16) ) {
N		*pTop = '\0';
N	} else {
N		switch( base ) {
N		case 10:
N			sprintf( pTop, "%d", val );
N			break;
N		case 16:
N			sprintf( pTop, "%x", val );
N			break;
N		default:
N			if( val ) {
N				char buff[sizeof(long)*8]; /* when base=2, max string length */
N				int bNeg;
N				int len;
N				char * p;
N
N				if( val > 0 ) {
N					bNeg = 0;
N				} else {
N					bNeg = 1;
N					val = -val;
N				}
N
N				for( len=0; (len<32) && (val>0); len++) {
N					buff[len] = strTbl[val % base];
N					val /= base;
N					len++;
N				}
N
N				p = pTop;
N				if( bNeg ) {
N					*p = '-';
N					p++;
N				}
N				for( ; len>0; len--, p++) {
N					*p = buff[len];
N				}
N				*p = '\0';
N			} else {
N				sprintf( pTop, "0" );
N			}
N		}
N	}
N
N	return pTop;
N}
N
N/*** end of file : f_stdlib.c ***/
