/*** tms320f28035.h - TI TMS320F28035 ***/

/*** Copyright(C) 2011 Sansei System Co.,Ltd. ***/

/*** HISTORY ***
 * 2011/02/22 mimu
              First Version
 */

#ifndef	INC_tms320f28035_H
#define	INC_tms320f28035_H


/*** Core control ***/
extern cregister volatile unsigned int IFR;
extern cregister volatile unsigned int IER;

#define  EINT   asm(" clrc INTM")
#define  DINT   asm(" setc INTM")
#define  ERTM   asm(" clrc DBGM")
#define  DRTM   asm(" setc DBGM")
#define  EALLOW asm(" EALLOW")
#define  EDIS   asm(" EDIS")
#define  ESTOP0 asm(" ESTOP0")


/*** Memory Map ***/

#define	PIE_VECT_ADRS	0x000d00


#endif	/* INC_tms320f28035_H */

/*** end of file : tms320f28035.h ***/
