/*** f_const.h - fpalette const data define ***/

/*** Copyright(C) 2011 Sansei System Co.,Ltd. ***/

/*** HISTORY ***
 * 2011/02/28 mimu
              First Version
 */

#ifndef	INC_f_const_H
#define	INC_f_const_H

#ifdef	__cplusplus
extern "C" {
#endif

#define LOW		0x00
#define HIGH	0x01
#define	TOGGLE	0x02
#define	RISING	0x10
#define	FALLING	0x20
#define	BOTH	0x30

#define	INPUT	0
#define	OUTPUT	1
#define	MODE_2	2
#define	MODE_3	3

#define true 0x1
#define false 0x0

//#define PI 3.1415926535897932384626433832795
//#define HALF_PI 1.5707963267948966192313216916398
//#define TWO_PI 6.283185307179586476925286766559
//#define DEG_TO_RAD 0.017453292519943295769236907684886
//#define RAD_TO_DEG 57.295779513082320876798154814105

//#define SERIAL  0x0
//#define DISPLAY 0x1

#define LSBFIRST 0
#define MSBFIRST 1

//#define CHANGE 1
//#define FALLING 2
//#define RISING 3

//#if defined(__AVR_ATmega1280__) || defined(__AVR_ATmega2560__)
//#define INTERNAL1V1 2
//#define INTERNAL2V56 3
//#else
//#define INTERNAL 3
//#endif

//#define DEFAULT 1
//#define EXTERNAL 0



#ifdef	__cplusplus
} /* extern "C" */
#endif

#endif	/* INC_f_const_H */

/*** end of file : f_const.h ***/
