/*** f_gpio_digitalWrite.c - fpalette GPIO contorl : digitalWrite() ***/

/*** Copyright(C) 2011 Sansei System Co.,Ltd. ***/

/*** HISTORY ***
 * 2011/03/01 mimu
              First Version
 */

/*** NOTE ***/

/*** INCLUDE ***/
#include "f_gpio.h"

#include "tms320f28035/gpioDrv.h"

/*** DEFINE ***/

/*** FUNCTION ***/

/*** WORK ***/

/*******************************************************************************
 *
 */
void digitalWrite( uint8_t pin, uint8_t data )
{
	switch( data ) {
	case HIGH:		gpioSet( pin );		break;
	case LOW:		gpioClear( pin );	break;
	case TOGGLE:	gpioToggle( pin );	break;
	}
}

/*** end of file : f_gpio_digitalWrite.c ***/
