/*** f_math.h - fpalette Math. ***/

/*** Copyright(C) 2011 Sansei System Co.,Ltd. ***/

/*** HISTORY ***
 * 2011/02/28 mimu
              Fist Version
 */

#ifndef	INC_f_math_H
#define	INC_f_math_H

#ifdef	__cplusplus
extern "C" {
#endif

/* undefine stdlib's abs if encountered */
#ifdef abs
#undef abs
#endif

#define min(a,b) ((a)<(b)?(a):(b))
#define max(a,b) ((a)>(b)?(a):(b))
#define abs(x) ((x)>0?(x):-(x))
#define constrain(amt,low,high) ((amt)<(low)?(low):((amt)>(high)?(high):(amt)))
#define round(x)     ((x)>=0?(long)((x)+0.5):(long)((x)-0.5))
#define radians(deg) ((deg)*DEG_TO_RAD)
#define degrees(rad) ((rad)*RAD_TO_DEG)
#define sq(x) ((x)*(x))



#ifdef	__cplusplus
}
#endif	/* extern "C" */

#endif	/* INC_f_math_H */

/*** end of file : f_math.h ***/
