/*** f_time.h - fpalette time/timer ***/

/*** Copyright(C) 2011 Sansei System Co.,Ltd. ***/

/*** HISTORY ***
 * 2011/03/01 mimu
              First Version
 */

#ifndef	INC_f_time_H
#define	INC_f_time_H

#include "f_types.h"

#ifdef	__cplusplus
extern "C" {
#endif

//#define clockCyclesPerMicrosecond() ( F_CPU / 1000000L )
//#define clockCyclesToMicroseconds(a) ( ((a) * 1000L) / (F_CPU / 1000L) )
//#define microsecondsToClockCycles(a) ( ((a) * (F_CPU / 1000L)) / 1000L )

int f_time_init( void );

typedef struct f_time_t {
	unsigned long uSec;

	unsigned long start;
}fTime;

unsigned long millis(void);
unsigned long micros(void);

void timeAlarmSet( fTime * alarm );
int  timeAlarmCheck( fTime * alarm );

void timeMeasureStart( fTime * measure );
void timeMeasureGet( fTime * measure );

void delay( unsigned long mSec );
void delayMicroseconds(unsigned int us);


#ifdef	__cplusplus
}
#endif

#endif	/* INC_f_time_H */

/*** end of file : f_time.h ***/
