/*******************************************************************************
 * Serial
 */
#include "WProgram.h"
#include "HardwareSerial.h"

void setup();
void loop();

static int count;
static const char testStr[] = { 't','e','s','t','\n', };
#define	recodeof(_v)	(sizeof(_v)/sizeof(_v[0]))
void setup()
{
	pinMode(GPIO_NO_CPU_LED, OUTPUT);


	count = 0;
}

void loop()
{

	digitalWrite(GPIO_NO_CPU_LED, LOW);    // set the LED on

	Serial.begin( 9600 );

	Serial.write( "hello\n" );
	Serial.write( "\n" );
	Serial.write( (const uint8_t *)testStr, recodeof(testStr) );

	count++;

	Serial.print( 78 );
	Serial.print( 1.23456);
	Serial.print( byte(78) );
	Serial.print( 'N' );
	Serial.print( 78, BYTE );
	Serial.print( 78, BIN );
	Serial.print( 78, OCT );
	Serial.print( 78, DEC );
	Serial.print( 78, HEX );
	Serial.print( 1.23456, 0 );
	Serial.print( 1.23456, 2 );
	Serial.print( 1.23456, 4 );
	Serial.print( count );

	Serial.println( 78 );
	Serial.println( 1.23456);
	Serial.println( byte(78) );
	Serial.println( 'N' );
	Serial.println( 78, BYTE );
	Serial.println( 78, BIN );
	Serial.println( 78, OCT );
	Serial.println( 78, DEC );
	Serial.println( 78, HEX );
	Serial.println( 1.23456, 0 );
	Serial.println( 1.23456, 2 );
	Serial.println( 1.23456, 4 );
	Serial.println( count );

	{
		int num;
		int c;

		for( num=0; num==0; ) {
			num = Serial.available();
		}
		c = Serial.peek();
		c = Serial.read();

		for( num=0; num==0; ) {
			num = Serial.available();
		}

		Serial.flush();

		for( ; num != 0; ) {
			num = Serial.available();
		}

	}


	Serial.end();

	digitalWrite(GPIO_NO_CPU_LED, HIGH);   // set the LED Off
}
