/*** ringLib.c - Ring Buffer Manager ***/

/*** Copyright(C) 1989-2011 Kazuya Mimura ***/
/*** Copyrigth(C) 2011 Sansei System Co.,Ltd. ***/

/*** HISTORY ***
 * 2011/02/16 mimu
              Clean-up & remodify
 * 1989/07/xx mimu
              First Version
 */

#ifndef	INC_ringLib_H
#define	INC_ringLib_H

typedef	struct ring_t {
	unsigned char * pDataTop;
	int				size;

	unsigned char * pGet;
	unsigned char * pSetNext;
	unsigned char * pDataBotom;
} Ring;

int ringInit( Ring * pRing );
int ringSet( Ring * pRing, unsigned char * pData, int size );
int ringGet( Ring * pRing, unsigned char * pData, int size );

#endif	/* INC_ringLib_H */
/*** end of file : ringLib.c ***/
