L 1 "../src/Blink.cpp"
N
N/*******************************************************************************
N * Blink
N */
N#if 0
S#include "WProgram.h"
Svoid setup();
Svoid loop();
Svoid setup() {
S  // initialize the digital pin as an output.
S  // Pin 13 has an LED connected on most Arduino boards:
S  pinMode(GPIO_NO_CPU_LED, OUTPUT);
S}
S
Svoid loop() {
S  digitalWrite(GPIO_NO_CPU_LED, HIGH);   // set the LED on
S  delay(1000);              // wait for a second
S  digitalWrite(GPIO_NO_CPU_LED, LOW);    // set the LED off
S  delay(1000);              // wait for a second
S}
S
N#endif
N
N/*******************************************************************************
N * INPUT[0,2,4,6] -> OUTPUT[1,3,5,7] test
N */
N#if 0
S
S#include "WProgram.h"
S
Svoid setup( void )
S{
S	pinMode( 0, INPUT );
S	pinMode( 1, OUTPUT );
S	pinMode( 2, INPUT );
S	pinMode( 3, OUTPUT );
S	pinMode( 4, INPUT );
S	pinMode( 5, OUTPUT );
S	pinMode( 6, INPUT );
S	pinMode( 7, OUTPUT );
S
S}
S
Svoid loop( void )
S{
S	int val;
S
S	val = digitalRead(  0 );
S	      digitalWrite( 1, val );
S
S	val = digitalRead(  2 );
S	      digitalWrite( 3, val );
S
S	val = digitalRead(  4 );
S	      digitalWrite( 5, val );
S
S	val = digitalRead(  6 );
S	      digitalWrite( 7, val );
S
S}
S
N#endif
N
N/*******************************************************************************
N * Timer output
N */
N#if 0
S#include "WProgram.h"
S
Sstatic int count;
Svoid setup( void )
S{
S	count = 0;
S
S	pinMode( 0, INPUT );
S	pinMode( 1, OUTPUT );
S	pinMode( 2, INPUT );
S	pinMode( 3, OUTPUT );
S	pinMode( 4, INPUT );
S	pinMode( 5, OUTPUT );
S	pinMode( 6, INPUT );
S	pinMode( 7, OUTPUT );
S
S}
S
Svoid loop( void )
S{
S
S	if( count & 1 ) {
S		digitalWrite( 1, HIGH );
S	} else {
S		digitalWrite( 1, LOW );
S	}
S
S	if( count & 2 ) {
S		digitalWrite( 3, HIGH );
S	} else {
S		digitalWrite( 3, LOW );
S	}
S
S	if( count & 4 ) {
S		digitalWrite( 5, HIGH );
S	} else {
S		digitalWrite( 5, LOW );
S	}
S
S	if( count & 8 ) {
S		digitalWrite( 7, HIGH );
S	} else {
S		digitalWrite( 7, LOW );
S	}
S
S	count ++;
S
S//	delay( 1 );
S//	delayMicroseconds( 1000 );
S//	delayMicroseconds( 500 );
S	delayMicroseconds( 100 );
S//	delayMicroseconds( 10000 );
S}
S
N#endif
N/*******************************************************************************
N * pulseIn test
N */
N#if 0
S#include "WProgram.h"
S
Sunsigned long min[4];
Sunsigned long max[4];
Sunsigned long avg[4];
Sunsigned long val[4];
Svoid setup( void )
S{
S	int i;
S
S	pinMode( 0, INPUT );
S	pinMode( 1, OUTPUT );
S	pinMode( 2, INPUT );
S	pinMode( 3, OUTPUT );
S	pinMode( 4, INPUT );
S	pinMode( 5, OUTPUT );
S	pinMode( 6, INPUT );
S	pinMode( 7, OUTPUT );
S
S	for( i=0; i<4; i++ ) {
S		min[i] = pulseIn( (i<<1), HIGH );
S		max[i] = min[i];
S		avg[i] = min[i];
S	}
S
S}
S
Svoid loop( void )
S{
S	int i;
S
S	for( i=0; i<4; i++ ) {
S		val[i] = pulseIn( (i<<1), HIGH );
S		if( min[i] > val[i] ) {
S			min[i] = val[i];
S		}
S		if( max[i]< val[i] ) {
S			max[i] = val[i];
S		}
S		avg[i] += val[i];
S		avg[i] /= 2;
S	}
S}
S
N#endif
N
N/*******************************************************************************
N * shiftOut
N */
N#if 0
S#include "WProgram.h"
S
Sint outData;
S
Svoid setup( void )
S{
S
S	pinMode( 0, INPUT );
S	pinMode( 1, OUTPUT );
S	pinMode( 2, INPUT );
S	pinMode( 3, OUTPUT );
S	pinMode( 4, INPUT );
S	pinMode( 5, OUTPUT );
S	pinMode( 6, INPUT );
S	pinMode( 7, OUTPUT );
S
S	outData = 0;
S
S	digitalWrite( 1, HIGH );
S}
S
Svoid loop( void )
S{
S	digitalWrite( 1, LOW );
S//	shiftOut( 3, 5, MSBFIRST, outData );
S	shiftOut( 3, 5, LSBFIRST, outData );
S	digitalWrite( 1, HIGH );
S
S	outData ++;
S	delay( 1000 );
S}
S
N#endif
N/*******************************************************************************
N * pwm
N */
N#if 0
S#include "WProgram.h"
S
S#include "tms320f28035/pwmDrv.h"
S//static float duty;
Sstatic int duty255;
Svoid setup( void )
S{
S
S	pinMode(GPIO_NO_CPU_LED, OUTPUT);
S
S//	pwm_ch_init( 0 );
S//	pwm_ch_init( 1 );
S
S	analogWrite( 0, 1 );
S//	duty = 0.0;
S	duty255 = 0;
S}
S
Svoid loop( void )
S{
S//	pwm_duty( 0, (duty+10)/2 );
S//	pwm_duty( 1, duty );
S
S	analogWrite( 1, duty255 );
S//	duty += 10.0;
S//	if( duty > 100 ) {
S//		duty = 0.0;
S//	}
S	duty255 += 51;
S	if( duty255 > 255 ) {
S		duty255 = 0;
S	}
S
S  digitalWrite(GPIO_NO_CPU_LED, HIGH);   // set the LED Off
S  delay(1000);              // wait for a second
S  digitalWrite(GPIO_NO_CPU_LED, LOW);    // set the LED on
S  delay(1000);              // wait for a second
S}
S
N#endif
N
N/*******************************************************************************
N * Serial
N */
N#include "WProgram.h"
L 1 "D:/project/fpalette/ccs4/fpalette/ide_led/src/cores/WProgram.h" 1
N#ifndef WProgram_h
N#define WProgram_h
N
N#include <stdlib.h>
L 1 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/stdlib.h" 1
N/*****************************************************************************/
N/* stdlib.h   v5.2.6                                                         */
N/* Copyright (c) 1993-2010 Texas Instruments Incorporated                    */
N/*****************************************************************************/
N
N#ifndef _STDLIB
N#define _STDLIB
N
N
N#ifdef __cplusplus
N//----------------------------------------------------------------------------
N// <cstdlib> IS RECOMMENDED OVER <stdlib.h>.  <stdlib.h> IS PROVIDED FOR 
N// COMPATIBILITY WITH C AND THIS USAGE IS DEPRECATED IN C++
N//----------------------------------------------------------------------------
Nextern "C" namespace std {
N#endif /* !__cplusplus */
N
Ntypedef struct { int quot, rem; } div_t;
N
Ntypedef struct { long quot, rem; } ldiv_t;
N
N#define _LLONG_AVAILABLE 1
Ntypedef struct { long long quot, rem; } lldiv_t;
N
N#define MB_CUR_MAX    1
N
N#ifndef NULL
N#define NULL          0
N#endif
N
N#ifndef _SIZE_T
N#define _SIZE_T
Ntypedef __SIZE_T_TYPE__ size_t;
Xtypedef unsigned long size_t;
N#endif
N
N#ifndef __cplusplus
S#ifndef _WCHAR_T
S#define _WCHAR_T
Stypedef __WCHAR_T_TYPE__ wchar_t;
S#endif
N#endif
N
N#define EXIT_FAILURE  1
N#define EXIT_SUCCESS  0
N
N#define RAND_MAX      32767
N
N#include <linkage.h>
L 1 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/linkage.h" 1
N/*****************************************************************************/
N/* linkage.h   v5.2.6                                                         */
N/* Copyright (c) 1998-2010 Texas Instruments Incorporated                    */
N/*****************************************************************************/
N
N#ifndef _LINKAGE
N#define _LINKAGE
N
N/* No modifiers needed to access code */
N
N#define _CODE_ACCESS
N
N/*--------------------------------------------------------------------------*/
N/* Define _DATA_ACCESS ==> how to access RTS global or static data          */
N/*--------------------------------------------------------------------------*/
N#ifndef _FAR_RTS
N#define _DATA_ACCESS
N#else
S#define _DATA_ACCESS far
N#endif
N#define _DATA_ACCESS_NEAR
N
N/*--------------------------------------------------------------------------*/
N/* Define _OPTIMIZE_FOR_SPACE ==> Always optimize for space.                */
N/*--------------------------------------------------------------------------*/
N#ifndef _OPTIMIZE_FOR_SPACE
S#define _OPTIMIZE_FOR_SPACE 1
N#endif
N
N/*--------------------------------------------------------------------------*/
N/* Define _IDECL ==> how inline functions are declared                      */
N/*--------------------------------------------------------------------------*/
N#ifdef _INLINE
S#define _IDECL static __inline
S#define _IDEFN static __inline
N#else
N#define _IDECL extern _CODE_ACCESS
N#define _IDEFN _CODE_ACCESS
N#endif
N
N#endif /* _LINKAGE */
L 49 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/stdlib.h" 2
N
N/*---------------------------------------------------------------*/
N/* NOTE - Normally, abs, labs, and fabs are expanded inline, so  */
N/*        no formal definition is really required. However, ANSI */
N/*        requires that they exist as separate functions, so     */
N/*        they are supplied in the library.  The prototype is    */
N/*        here mainly for documentation.                         */
N/*---------------------------------------------------------------*/
N    _CODE_ACCESS  int       abs(int _val); 
X      int       abs(int _val); 
N    _CODE_ACCESS  long      labs(long _val);
X      long      labs(long _val);
N#if defined(_LLONG_AVAILABLE)
X#if 1L
N    _CODE_ACCESS  long long llabs(long long _val);
X      long long llabs(long long _val);
N#endif
N    _CODE_ACCESS int       atoi(const char *_st);
X     int       atoi(const char *_st);
N    _CODE_ACCESS long      atol(const char *_st);
X     long      atol(const char *_st);
N#if defined(_LLONG_AVAILABLE)
X#if 1L
N    _CODE_ACCESS long long atoll(const char *_st);
X     long long atoll(const char *_st);
N#endif
N    _CODE_ACCESS int       ltoa(long val, char *buffer);
X     int       ltoa(long val, char *buffer);
N          _IDECL double    atof(const char *_st);
X          extern  double    atof(const char *_st);
N
N    _CODE_ACCESS long      strtol(const char *_st, char **_endptr, int _base);
X     long      strtol(const char *_st, char **_endptr, int _base);
N    _CODE_ACCESS unsigned long strtoul(const char *_st, char **_endptr,
X     unsigned long strtoul(const char *_st, char **_endptr,
N    					  int _base);
N#if defined(_LLONG_AVAILABLE)
X#if 1L
N    _CODE_ACCESS long long strtoll(const char *_st, char **_endptr, int _base);
X     long long strtoll(const char *_st, char **_endptr, int _base);
N    _CODE_ACCESS unsigned long long strtoull(const char *_st, char **_endptr,
X     unsigned long long strtoull(const char *_st, char **_endptr,
N					     int _base);
N#endif
N    _CODE_ACCESS double    strtod(const char *_st, char **_endptr);
X     double    strtod(const char *_st, char **_endptr);
N    _CODE_ACCESS long double strtold(const char *_st, char **_endptr);
X     long double strtold(const char *_st, char **_endptr);
N    
N    _CODE_ACCESS int    rand(void);
X     int    rand(void);
N    _CODE_ACCESS void   srand(unsigned _seed);
X     void   srand(unsigned _seed);
N    
N    _CODE_ACCESS void  *calloc(size_t _num, size_t _size);
X     void  *calloc(size_t _num, size_t _size);
N    _CODE_ACCESS void  *malloc(size_t _size);
X     void  *malloc(size_t _size);
N    _CODE_ACCESS void  *realloc(void *_ptr, size_t _size);
X     void  *realloc(void *_ptr, size_t _size);
N    _CODE_ACCESS void   free(void *_ptr);
X     void   free(void *_ptr);
N    _CODE_ACCESS void  *memalign(size_t _aln, size_t _size);
X     void  *memalign(size_t _aln, size_t _size);
N    
N    _CODE_ACCESS void   abort(void); 
X     void   abort(void); 
N    _CODE_ACCESS int    atexit(void (*_func)(void));
X     int    atexit(void (*_func)(void));
N    _CODE_ACCESS void  *bsearch(const void *_key, const void *_base,
X     void  *bsearch(const void *_key, const void *_base,
N    				   size_t _nmemb, size_t _size, 
N    			           int (*compar)(const void *,const void *));
N    _CODE_ACCESS void   qsort(void *_base, size_t _nmemb, size_t _size, 
X     void   qsort(void *_base, size_t _nmemb, size_t _size, 
N    			         int (*_compar)(const void *, const void *));
N    _CODE_ACCESS void   exit(int _status);
X     void   exit(int _status);
N    
N    _CODE_ACCESS div_t  div(int _numer, int _denom);
X     div_t  div(int _numer, int _denom);
N    _CODE_ACCESS ldiv_t ldiv(long _numer, long _denom);
X     ldiv_t ldiv(long _numer, long _denom);
N#if defined(_LLONG_AVAILABLE)
X#if 1L
N    _CODE_ACCESS lldiv_t lldiv(long long _numer, long long _denom);
X     lldiv_t lldiv(long long _numer, long long _denom);
N#endif
N
N    _CODE_ACCESS char  *getenv(const char *_string);
X     char  *getenv(const char *_string);
N    _CODE_ACCESS int    system(const char *_name);
X     int    system(const char *_name);
N
N    _CODE_ACCESS int    mblen(const char *, size_t);
X     int    mblen(const char *, size_t);
N    _CODE_ACCESS size_t mbstowcs(wchar_t *, const char *, size_t);
X     size_t mbstowcs(wchar_t *, const char *, size_t);
N    _CODE_ACCESS int    mbtowc(wchar_t *, const char *, size_t);
X     int    mbtowc(wchar_t *, const char *, size_t);
N
N    _CODE_ACCESS size_t wcstombs(char *, const wchar_t *, size_t);
X     size_t wcstombs(char *, const wchar_t *, size_t);
N    _CODE_ACCESS int    wctomb(char *, wchar_t);
X     int    wctomb(char *, wchar_t);
N
N#ifdef __cplusplus
N} /* extern "C" namespace std */
N#endif /* __cplusplus */
N
N
N#ifdef _INLINE
S
S#ifdef __cplusplus
Snamespace std {
S#endif
S
Sstatic __inline double atof(const char *_st) 
S{
S  return strtod(_st, (char **)0); 
S}
S
S#ifdef __cplusplus
S} /* namespace std */
S#endif
S
N#endif  /* _INLINE */
N
N#endif  /* ! _STDLIB */
N
N#if defined(__cplusplus) && !defined(_CPP_STYLE_HEADER)
X#if 1L && !0L
Nusing std::div_t;
Nusing std::ldiv_t;
N#if defined(_LLONG_AVAILABLE)
X#if 1L
Nusing std::lldiv_t;
N#endif
Nusing std::size_t;
Nusing std::abs;
Nusing std::labs;
Nusing std::atoi;
Nusing std::atol;
N#if defined(_LLONG_AVAILABLE)
X#if 1L
Nusing std::llabs;
Nusing std::atoll;
N#endif
Nusing std::atof;
Nusing std::strtol;
Nusing std::strtoul;
N#if defined(_LLONG_AVAILABLE)
X#if 1L
Nusing std::strtoll;
Nusing std::strtoull;
N#endif
Nusing std::strtod;
Nusing std::rand;
Nusing std::srand;
Nusing std::calloc;
Nusing std::malloc;
Nusing std::realloc;
Nusing std::free;
Nusing std::memalign;
Nusing std::abort;
Nusing std::atexit;
Nusing std::bsearch;
Nusing std::qsort;
Nusing std::exit;
Nusing std::div;
Nusing std::ldiv;
N#if defined(_LLONG_AVAILABLE)
X#if 1L
Nusing std::lldiv;
N#endif
Nusing std::getenv;
Nusing std::system;
N#endif /* ! _CPP_STYLE_HEADER */
N
N#include <stdlibf.h>     /* far versions of stdlib fns */
L 1 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/stdlibf.h" 1
N/*****************************************************************************/
N/* stdlibf.h   v5.2.6                                                        */
N/*     far versions of stdlib.h functions                                    */
N/* Copyright (c) 1996-2010 Texas Instruments Incorporated                    */
N/*****************************************************************************/
N#ifndef _STDLIBF
N#define _STDLIBF
N
N#ifndef __cplusplus
S_CODE_ACCESS long          far_strtol (const far char *st, far char **endptr, 
S				   int base);
S_CODE_ACCESS unsigned long far_strtoul(const far char *st, far char **endptr, 
S				   int base);
S_CODE_ACCESS double        far_strtod (const far char *st, far char **endptr);
S_CODE_ACCESS long double   far_strtold (const far char *st, far char **endptr);
S_CODE_ACCESS long long     far_strtoll(const far char *st, far char **endptr, 
S		 						    int base);
S_CODE_ACCESS unsigned long long far_strtoull(const far char *st, 
S                                                   far char **endptr, int base);
S_CODE_ACCESS int           far_atoi(const far char *st);
S_CODE_ACCESS long          far_atol(const far char *st);
S_IDECL       double        far_atof(const far char *st);
S_CODE_ACCESS long long     far_atoll(const far char *st);
S
S_CODE_ACCESS far void     *far_calloc  (unsigned long num, unsigned long size);
S_CODE_ACCESS far void     *far_malloc  (unsigned long size);
S_CODE_ACCESS far void     *far_realloc (far void *ptr, unsigned long size);
S_CODE_ACCESS void          far_free    (far void *ptr);
S
S_CODE_ACCESS far void     *far_bsearch(const far void *key, 
S                                       const far void *base, 
S			               size_t nmemb, size_t size, 
S			               int (*compar)(const far void *,
S                                                     const far void *));
S_CODE_ACCESS void          far_qsort  (far void *base, 
S                                       size_t nmemb, size_t size,
S			               int (*compar)(const far void *, 
S                                                     const far void *));
S
S_CODE_ACCESS int	   free_memory(void);
S_CODE_ACCESS int           max_free(void);
S_CODE_ACCESS void         *chkheap();
S
S#ifdef _INLINE
Sstatic __inline double far_atof(const far char *st) 
S{ 
S   return far_strtod(st, NULL);
S}
S#endif /* _INLINE */
S
N#else /* __cplusplus */
N
Nnamespace std {
N
Nextern "C" int	       free_memory(void);
Nextern "C" int         max_free(void);
Nextern "C" void        *chkheap();
N
N_CODE_ACCESS long      far_calloc  (unsigned long num, unsigned long size);
X long      far_calloc  (unsigned long num, unsigned long size);
N_CODE_ACCESS long      far_malloc  (unsigned long size);
X long      far_malloc  (unsigned long size);
N_CODE_ACCESS long      far_realloc (long ptr, unsigned long size);
X long      far_realloc (long ptr, unsigned long size);
N_CODE_ACCESS void      far_free    (long ptr);
X void      far_free    (long ptr);
N_CODE_ACCESS long      far_free_memory(void);
X long      far_free_memory(void);
N_CODE_ACCESS long      far_max_free(void);
X long      far_max_free(void);
N_CODE_ACCESS long      far_chkheap(void);
X long      far_chkheap(void);
N
N}
N#endif /* __cplusplus */
N#endif /* _STDLIBF */
N
N#if defined(__cplusplus) && !defined(_CPP_STYLE_HEADER)
X#if 1L && !0L
Nusing std::free_memory; 
Nusing std::max_free;
Nusing std::chkheap;
Nusing std::far_calloc;
Nusing std::far_malloc;
Nusing std::far_realloc;
Nusing std::far_free;
Nusing std::far_free_memory; 
Nusing std::far_max_free;
Nusing std::far_chkheap;
N#endif /* _CPP_STYLE_HEADER */
L 184 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/stdlib.h" 2
L 5 "D:/project/fpalette/ccs4/fpalette/ide_led/src/cores/WProgram.h" 2
N#include <string.h>
L 1 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/string.h" 1
N/*****************************************************************************/
N/* string.h   v5.2.6                                                         */
N/* Copyright (c) 1993-2010 Texas Instruments Incorporated                    */
N/*****************************************************************************/
N
N#ifndef _STRING
N#define _STRING
N
N#ifdef __cplusplus
N//----------------------------------------------------------------------------
N// <cstring> IS RECOMMENDED OVER <string.h>.  <string.h> IS PROVIDED FOR
N// COMPATIBILITY WITH C AND THIS USAGE IS DEPRECATED IN C++
N//----------------------------------------------------------------------------
Nextern "C" namespace std
N{
N#endif /* __cplusplus */
N 
N#ifndef NULL
S#define NULL 0
N#endif
N
N#ifndef _SIZE_T
S#define _SIZE_T
Stypedef __SIZE_T_TYPE__ size_t;
N#endif
N
N#include <linkage.h>
N
N#if defined(_OPTIMIZE_FOR_SPACE) && (defined(__TMS470__) || 		\
N				     defined(__TMS320C2000__)  ||       \
N                                     defined(__MSP430__))
X#if 1L && (0L || 						     1L  ||                                            0L)
N#define _OPT_IDECL
N#else
S#define _OPT_IDECL	_IDECL
N#endif
N
N_OPT_IDECL size_t  strlen(const char *_string);
X size_t  strlen(const char *_string);
N
N_OPT_IDECL char *strcpy(char *_dest, const char *_src);
X char *strcpy(char *_dest, const char *_src);
N_OPT_IDECL char *strncpy(char *_to, const char *_from, size_t _n);
X char *strncpy(char *_to, const char *_from, size_t _n);
N_OPT_IDECL char *strcat(char *_string1, const char *_string2);
X char *strcat(char *_string1, const char *_string2);
N_OPT_IDECL char *strncat(char *_to, const char *_from, size_t _n);
X char *strncat(char *_to, const char *_from, size_t _n);
N_OPT_IDECL char *strchr(const char *_string, int _c);
X char *strchr(const char *_string, int _c);
N_OPT_IDECL char *strrchr(const char *_string, int _c);
X char *strrchr(const char *_string, int _c);
N
N_OPT_IDECL int  strcmp(const char *_string1, const char *_string2);
X int  strcmp(const char *_string1, const char *_string2);
N_OPT_IDECL int  strncmp(const char *_string1, const char *_string2, size_t _n);
X int  strncmp(const char *_string1, const char *_string2, size_t _n);
N
N_CODE_ACCESS int     strcoll(const char *_string1, const char *_string2);
X int     strcoll(const char *_string1, const char *_string2);
N_CODE_ACCESS size_t  strxfrm(char *_to, const char *_from, size_t _n);
X size_t  strxfrm(char *_to, const char *_from, size_t _n);
N_CODE_ACCESS char   *strpbrk(const char *_string, const char *_chs);
X char   *strpbrk(const char *_string, const char *_chs);
N_CODE_ACCESS size_t  strspn(const char *_string, const char *_chs);
X size_t  strspn(const char *_string, const char *_chs);
N_CODE_ACCESS size_t  strcspn(const char *_string, const char *_chs);
X size_t  strcspn(const char *_string, const char *_chs);
N_CODE_ACCESS char   *strstr(const char *_string1, const char *_string2);
X char   *strstr(const char *_string1, const char *_string2);
N_CODE_ACCESS char   *strtok(char *_str1, const char *_str2);
X char   *strtok(char *_str1, const char *_str2);
N_CODE_ACCESS char   *strerror(int _errno);
X char   *strerror(int _errno);
N
N_CODE_ACCESS void   *memmove(void *_s1, const void *_s2, size_t _n);
X void   *memmove(void *_s1, const void *_s2, size_t _n);
N
N_OPT_IDECL int     memcmp(const void *_cs, const void *_ct, size_t _n);
X int     memcmp(const void *_cs, const void *_ct, size_t _n);
N_OPT_IDECL void   *memchr(const void *_cs, int _c, size_t _n);
X void   *memchr(const void *_cs, int _c, size_t _n);
N
N_OPT_IDECL   void   *memset(void *_mem, int _ch, size_t _n);
X   void   *memset(void *_mem, int _ch, size_t _n);
N
N
N#ifndef __cplusplus
S#define far_memcpy __memcpy_ff
S#define far_strcpy strcpy_ff
Ssize_t    far_strlen(const far char *s);
Schar     *strcpy_nf(char *s1, const char far *s2);
Schar far *strcpy_fn(char far *s1, const char *s2);
Schar far *strcpy_ff(char far *s1, const char far *s2);
Sfar char *far_strncpy(far char *s1, far const char *s2, size_t n);
Sfar char *far_strcat(far char *s1, const far char *s2);
Sfar char *far_strncat(far char *s1, const far char *s2, size_t n);
Sfar char *far_strchr(const far char *s, int c);
Sfar char *far_strrchr(const far char *s, int c);
Sint       far_strcmp(const far char *s1, const far char *s2);
Sint       far_strncmp(const far char *s1, const far char *s2, size_t n);
Sint       far_strcoll(const far char *s1, const far char *s2);
Ssize_t    far_strxfrm(far char *s1, const far char *s2, size_t n);
Sfar char *far_strpbrk(const far char *s1, const far char *s2);
Ssize_t    far_strspn(const far char *s1, const far char *s2);
Ssize_t    far_strcspn(const far char *s1, const far char *s2);
Sfar char *far_strstr(const far char *s1, const far char *s2);
Sfar char *far_strtok(far char *s1, const far char *s2);
Sfar char *far_strerror(int errno);
Svoid far *far_memmove(far void *s1, far const void *s2, size_t n);
Svoid     *__memcpy_nf (void *_s1, far const void *_s2, size_t _n);
Svoid far *__memcpy_fn (far void *_s1, const void *_s2, size_t _n);
Svoid far *__memcpy_ff (far void *_s1, far const void *_s2, size_t _n);
Sint       far_memcmp(const far void *s1, const far void *s2, size_t n);
Sfar void *far_memchr(const far void *s, int c, size_t n);
Sfar void *far_memset(far void *s, int c, size_t n);
Sfar void *far_memlcpy(far void *to, const far void *from, unsigned long n);
Sfar void *far_memlmove(far void *to, const far void *from, unsigned long n);
N#else /* __cplusplus */
Nlong      far_memlcpy(long to, long from, unsigned long n);
Nlong      far_memlmove(long to, long from, unsigned long n);
N#endif /* __cplusplus */
N
N
N#ifdef __cplusplus
N} /* extern "C" namespace std */
N#endif /* __cplusplus */
N
N#if defined(_INLINE) || defined(_STRING_IMPLEMENTATION)
X#if 0L || 0L
S
S#if (defined(_STRING_IMPLEMENTATION) ||					\
S     !(defined(_OPTIMIZE_FOR_SPACE) && (defined(__TMS470__) || 		\
S					defined(__TMS320C2000__)  ||    \
S                                        defined(__MSP430__))))
X#if (defined(_STRING_IMPLEMENTATION) ||					     !(defined(_OPTIMIZE_FOR_SPACE) && (defined(__TMS470__) || 							defined(__TMS320C2000__)  ||                                            defined(__MSP430__))))
S
S#ifdef __cplusplus
Snamespace std {
S#endif
S
S#if (defined(_OPTIMIZE_FOR_SPACE) && (defined(__TMS470__) || 		\
S				      defined(__TMS320C2000__) ||       \
S                                      defined(__MSP430__)))
X#if (defined(_OPTIMIZE_FOR_SPACE) && (defined(__TMS470__) || 						      defined(__TMS320C2000__) ||                                             defined(__MSP430__)))
S#define _OPT_IDEFN
S#else
S#define _OPT_IDEFN	_IDEFN
S#endif
S
S#if defined(_INLINE) || defined(_STRLEN)
S_OPT_IDEFN size_t strlen(const char *string)
S{
S   size_t      n = (size_t)-1;
S   const char *s = string;
S
S   do n++; while (*s++);
S   return n;
S}
S#endif /* _INLINE || _STRLEN */
S
S#if defined(_INLINE) || defined(_STRCPY)
S_OPT_IDEFN char *strcpy(register char *dest, register const char *src)
S{
S     register char       *d = dest;     
S     register const char *s = src;
S
S     while (*d++ = *s++);
S     return dest;
S}
S#endif /* _INLINE || _STRCPY */
S
S#if defined(_INLINE) || defined(_STRNCPY)
S_OPT_IDEFN char *strncpy(register char *dest,
S		     register const char *src,
S		     register size_t n)
S{
S     if (n) 
S     {
S	 register char       *d = dest;
S	 register const char *s = src;
S	 while ((*d++ = *s++) && --n);              /* COPY STRING         */
S	 if (n-- > 1) do *d++ = '\0'; while (--n);  /* TERMINATION PADDING */
S     }
S     return dest;
S}
S#endif /* _INLINE || _STRNCPY  */
S
S#if defined(_INLINE) || defined(_STRCAT)
S_OPT_IDEFN char *strcat(char *string1, const char *string2)
S{
S   char       *s1 = string1;
S   const char *s2 = string2;
S
S   while (*s1) s1++;		     /* FIND END OF STRING   */
S   while (*s1++ = *s2++);	     /* APPEND SECOND STRING */
S   return string1;
S}
S#endif /* _INLINE || _STRCAT */
S
S#if defined(_INLINE) || defined(_STRNCAT)
S_OPT_IDEFN char *strncat(char *dest, const char *src, register size_t n)
S{
S    if (n)
S    {
S	char       *d = dest;
S	const char *s = src;
S
S	while (*d) d++;                      /* FIND END OF STRING   */
S
S	while (n--)
S	  if (!(*d++ = *s++)) return dest; /* APPEND SECOND STRING */
S	*d = 0;
S    }
S    return dest;
S}
S#endif /* _INLINE || _STRNCAT */
S
S#if defined(_INLINE) || defined(_STRCHR)
S_OPT_IDEFN char *strchr(const char *string, int c)
S{
S   char        tch, ch  = c;
S   const char *s        = string;
S
S   for (;;)
S   {
S       if ((tch = *s) == ch) return (char *) s;
S       if (!tch)             return (char *) 0;
S       s++;
S   }
S}
S#endif /* _INLINE || _STRCHR */
S
S#if defined(_INLINE) || defined(_STRRCHR)
S_OPT_IDEFN char *strrchr(const char *string, int c)
S{
S   char        tch, ch = c;
S   char       *result  = 0;
S   const char *s       = string;
S
S   for (;;)
S   {
S      if ((tch = *s) == ch) result = (char *) s;
S      if (!tch) break;
S      s++;
S   }
S
S   return result;
S}
S#endif /* _INLINE || _STRRCHR */
S
S#if defined(_INLINE) || defined(_STRCMP)
S_OPT_IDEFN int strcmp(register const char *string1,
S		  register const char *string2)
S{
S   register int c1, res;
S
S   for (;;)
S   {
S       c1  = (unsigned char)*string1++;
S       res = c1 - (unsigned char)*string2++;
S
S       if (c1 == 0 || res != 0) break;
S   }
S
S   return res;
S}
S#endif /* _INLINE || _STRCMP */
S
S#if defined(_INLINE) || defined(_STRNCMP)
S_OPT_IDEFN int strncmp(const char *string1, const char *string2, size_t n)
S{
S     if (n) 
S     {
S	 const char *s1 = string1;
S	 const char *s2 = string2;
S	 unsigned char cp;
S	 int         result;
S
S	 do 
S	    if (result = (unsigned char)*s1++ - (cp = (unsigned char)*s2++))
S                return result;
S	 while (cp && --n);
S     }
S     return 0;
S}
S#endif /* _INLINE || _STRNCMP */
S
S#if defined(_INLINE) || defined(_MEMCMP)
S_OPT_IDEFN int memcmp(const void *cs, const void *ct, size_t n)
S{
S   if (n) 
S   {
S       const unsigned char *mem1 = (unsigned char *)cs;
S       const unsigned char *mem2 = (unsigned char *)ct;
S       int                 cp1, cp2;
S
S       while ((cp1 = *mem1++) == (cp2 = *mem2++) && --n);
S       return cp1 - cp2;
S   }
S   return 0;
S}
S#endif /* _INLINE || _MEMCMP */
S
S#if defined(_INLINE) || defined(_MEMCHR)
S_OPT_IDEFN void *memchr(const void *cs, int c, size_t n)
S{
S   if (n)
S   {
S      const unsigned char *mem = (unsigned char *)cs;   
S      unsigned char        ch  = c;
S
S      do 
S         if ( *mem == ch ) return (void *)mem;
S         else mem++;
S      while (--n);
S   }
S   return NULL;
S}
S#endif /* _INLINE || _MEMCHR */
S
S#if ((defined(_INLINE) || defined(_MEMSET)) && !defined(_TMS320C6X)) && !defined(__TMS470__)
S_OPT_IDEFN void *memset(void *mem, register int ch, register size_t length)
S{
S     register char *m = (char *)mem;
S
S     while (length--) *m++ = ch;
S     return mem;
S}
S#endif /* _INLINE || _MEMSET */
S
S#ifdef __cplusplus
S} /* namespace std */
S#endif
S
S#endif /* (_STRING_IMPLEMENTATION || !(_OPTIMIZE_FOR_SPACE && __TMS470__)) */
S
N#endif /* (_INLINE || _STRING_IMPLEMENTATION) */
N
N#endif /* ! _STRING */
N
N#if defined(__cplusplus) && !defined(_CPP_STYLE_HEADER)
X#if 1L && !0L
Nusing std::size_t;
Nusing std::strlen;
Nusing std::strcpy;
Nusing std::strncpy;
Nusing std::strcat;
Nusing std::strncat;
Nusing std::strchr;
Nusing std::strrchr;
Nusing std::strcmp;
Nusing std::strncmp;
Nusing std::strcoll;
Nusing std::strxfrm;
Nusing std::strpbrk;
Nusing std::strspn;
Nusing std::strcspn;
Nusing std::strstr;
Nusing std::strtok;
Nusing std::strerror;
Nusing std::memmove;
Nusing std::memcpy;
Nusing std::memcmp;
Nusing std::memchr;
Nusing std::memset;
N
Nusing std::far_memlcpy;
Nusing std::far_memlmove;
N
N#endif /* _CPP_STYLE_HEADER */
N
L 6 "D:/project/fpalette/ccs4/fpalette/ide_led/src/cores/WProgram.h" 2
N#include <math.h>
L 1 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/math.h" 1
N/*****************************************************************************/
N/* math.h     v5.2.6                                                         */
N/* Copyright (c) 1996-2010 Texas Instruments Incorporated                    */
N/*****************************************************************************/
N
N#ifndef _MATH
N#define _MATH
N
N
N#include <linkage.h>
N#include <float.h>
L 1 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/float.h" 1
N/*****************************************************************************/
N/* float.h    v5.2.6                                                         */
N/* Copyright (c) 1996-2010 Texas Instruments Incorporated                    */
N/*****************************************************************************/
N
N/********************************************************************/
N/*    KEY:  FLT_     - APPLIES TO TYPE FLOAT                        */
N/*          DBL_     - APPLIES TO TYPE DOUBLE                       */
N/*          LDBL_    - APPLIES TO TYPE LONG DOUBLE                  */
N/********************************************************************/
N#ifndef _FLOAT
N#define _FLOAT
N
N#define FLT_RADIX                         2   /* RADIX OF EXPONENT         */
N#define FLT_ROUNDS                        1   /* ROUND TO NEAREST          */
N 
N#define FLT_DIG                           6   /* DECIMAL PRECISION         */
N#define FLT_MANT_DIG                     24   /* BITS IN MANTISSA          */
N#define FLT_MIN_EXP                    -125   /* SMALLEST EXPONENT         */
N#define FLT_MAX_EXP                     128   /* LARGEST EXPONENT          */
N#define FLT_EPSILON        1.192092896E-07F   /* SMALLEST X WHERE 1+X != 1 */
N#define FLT_MIN            1.175494351E-38F   /* SMALLEST POSITIVE VALUE   */
N#define FLT_MAX            3.402823466E+38F   /* LARGEST POSITIVE VALUE    */
N#define FLT_MIN_10_EXP                  -37   /* MIN POWER OF 10           */
N#define FLT_MAX_10_EXP                   38   /* MAX POWER OF 10           */
N 
N#define DBL_DIG                           6   /* DECIMAL PRECISION         */
N#define DBL_MANT_DIG                     24   /* BITS IN MANTISSA          */
N#define DBL_MIN_EXP                    -125   /* SMALLEST EXPONENT         */
N#define DBL_MAX_EXP                     128   /* LARGEST EXPONENT          */
N#define DBL_EPSILON        1.192092896E-07    /* SMALLEST X WHERE 1+X != 1 */
N#define DBL_MIN            1.175494351E-38    /* SMALLEST POSITIVE VALUE   */
N#define DBL_MAX            3.402823466E+38    /* LARGEST POSITIVE VALUE    */
N#define DBL_MIN_10_EXP                  -37   /* MIN POWER OF 10           */
N#define DBL_MAX_10_EXP                   38   /* MAX POWER OF 10           */
N 
N#if defined(__TMS320C27X__)
X#if 0L
S
S#define LDBL_DIG                          6   /* DECIMAL PRECISION         */
S#define LDBL_MANT_DIG                    24   /* BITS IN MANTISSA          */
S#define LDBL_MIN_EXP                   -125   /* SMALLEST EXPONENT         */
S#define LDBL_MAX_EXP                    128   /* LARGEST EXPONENT          */
S#define LDBL_EPSILON       1.192092896E-07    /* SMALLEST X WHERE 1+X != 1 */
S#define LDBL_MIN           1.175494351E-38    /* SMALLEST POSITIVE VALUE   */
S#define LDBL_MAX           3.402823466E+38    /* LARGEST POSITIVE VALUE    */
S#define LDBL_MIN_10_EXP                 -37   /* MIN POWER OF 10           */
S#define LDBL_MAX_10_EXP                  38   /* MAX POWER OF 10           */
S
N#elif defined(__TMS320C28X__)
X#elif 1L
N
N#define LDBL_DIG                         15   /* DECIMAL PRECISION         */
N#define LDBL_MANT_DIG                    53   /* BITS IN MANTISSA          */
N#define LDBL_MIN_EXP                  -1021   /* SMALLEST EXPONENT         */
N#define LDBL_MAX_EXP                   1024   /* LARGEST EXPONENT          */
N#define LDBL_EPSILON 2.2204460492503131E-16L  /* SMALLEST X WHERE 1+X != 1 */
N#define LDBL_MIN    2.2250738585072014E-308L  /* SMALLEST POSITIVE VALUE   */
N#define LDBL_MAX    1.7976931348623157E+308L  /* LARGEST POSITIVE VALUE    */
N#define LDBL_MIN_10_EXP                -307   /* MIN POWER OF 10           */
N#define LDBL_MAX_10_EXP                 308   /* MAX POWER OF 10           */
N
N#endif /* __TMS320C28X__ */
N
N#endif /* _FLOAT */
L 12 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/math.h" 2
N#define HUGE_VAL   DBL_MAX
N#define HUGE_VALL  LDBL_MAX
N
N#ifdef __cplusplus
N//----------------------------------------------------------------------------
N// <cmath> IS RECOMMENDED OVER <math.h>.  <math.h> IS PROVIDED FOR 
N// COMPATIBILITY WITH C AND THIS USAGE IS DEPRECATED IN C++
N//----------------------------------------------------------------------------
Nextern "C" namespace std {
N#endif /* __cplusplus */
N
N/***************************************************************/
N/* FUNCTION DEFINITIONS.                                       */
N/***************************************************************/
N         double modf(double x, double *y); 
W "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/math.h" 27 36 type qualifiers are meaningless in this declaration
N         double far_modf(double x, far double *y); 
N         double asin(double x);
N         double acos(double x);
N         double atan(double x);
N         double atan2(double y, double x);
N__inline double ceil(double x)  { double y; return (modf(x, &y) > 0 ? y+1:y); }
N         double cos(double x);
N         double cosh(double x);
N         double exp(double x);
N         double fabs(double x);
N__inline double floor(double x) { double y; return (modf(x, &y) < 0 ? y-1:y); }
N         double fmod(double x, double y);
N         double frexp(double x, int *exp);
W "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/math.h" 40 37 type qualifiers are meaningless in this declaration
N         double far_frexp(double x, far int *exp);
N         double ldexp(double x, int exp);
N         double log(double x);
N         double log10(double x);
N         double pow(double x, double y);
N         double sin(double x);
N         double sinh(double x);
N         double tan(double x);
N         double tanh(double x);
N         double sqrt(double x);
N
N#ifdef __cplusplus
N} /* extern "C" namespace std */
N#endif /* __cplusplus */
N
N/*******************************************************************************/
N/* Overloaded version of math functions for float and long double in C++       */
N/*******************************************************************************/
N#endif /* _MATH */
N
N#if defined(__cplusplus) && !defined(_CPP_STYLE_HEADER)
X#if 1L && !0L
Nusing std::modf;
Nusing std::asin;
Nusing std::acos;
Nusing std::atan;
Nusing std::atan2;
Nusing std::ceil;
Nusing std::cos;
Nusing std::cosh;
Nusing std::exp;
Nusing std::fabs;
Nusing std::floor;
Nusing std::fmod;
Nusing std::frexp;
Nusing std::ldexp;
Nusing std::log;
Nusing std::log10;
Nusing std::pow;
Nusing std::sin;
Nusing std::sinh;
Nusing std::tan;
Nusing std::tanh;
Nusing std::sqrt;
N#endif /* _CPP_STYLE_HEADER */
N
L 7 "D:/project/fpalette/ccs4/fpalette/ide_led/src/cores/WProgram.h" 2
N
N#include "config.h"
L 1 "D:/project/fpalette/ccs4/fpalette/ide_led/src/bsp/config.h" 1
N/*** config.h ***/
N
N
N#ifndef	INC_config_H
N#define	INC_config_H
N
N/******************************************************************************/
N/* NvRam Configuration                                                        */
N/******************************************************************************/
N#define	FLASH_PROGRAM_SEC_NO		0
N#define	FLASH_PROGRAM_SEC_NUM		6
N
N#define	FLASH_BOOTLOADER_SEC_NO		(FLASH_PROGRAM_SEC_NO + FLASH_PROGRAM_SEC_NUM)
N#define	FLASH_BOOTLOADER_SEC_NUM	2
N
N/******************************************************************************/
N/* Driver Configuration                                                       */
N/******************************************************************************/
N
N/*** CPU TIMER ***/
N#define	SUPPORT_CPU_TIMER_0		/* !! ATTATION !! system need timer0 */
N//#define	SUPPORT_CPU_TIMER_1
N//#define	SUPPORT_CPU_TIMER_2
N
N/*** SCI ***/
N#define	SUPPORT_SCI_A
N
N/*** Flash Mem. ***/
N//#define	SUPPORT_FLASH
N
N/******************************************************************************/
N/* GPIO map                                                                   */
N/******************************************************************************/
N#define	GPIO_NO_CPU_LED	39
N
N//#define	GPIO_NO_SCIRXDA	7
N#define	GPIO_NO_SCIRXDA	28
N
N//#define	GPIO_NO_SCITXDA	12
N#define	GPIO_NO_SCITXDA	29
N
N
N/*-----------------------------------------------------------------------------
N      Specify the PLL control register (PLLCR) and divide select (DIVSEL) value.
N-----------------------------------------------------------------------------*/
N
N//#define DSP28_DIVSEL   0 // Enable /4 for SYSCLKOUT
N//#define DSP28_DIVSEL   1 // Disable /4 for SYSCKOUT
N#define DSP28_DIVSEL   2 // Enable /2 for SYSCLKOUT
N//#define DSP28_DIVSEL   3 // Enable /1 for SYSCLKOUT
N
N
N#define DSP28_PLLCR   12    // Uncomment for 60 MHz devices [60 MHz = (10MHz * 12)/2]
N//#define DSP28_PLLCR   11
N//#define DSP28_PLLCR   10
N//#define DSP28_PLLCR    9
N//#define DSP28_PLLCR    8      // Uncomment for 40 MHz devices [40 MHz = (10MHz * 8)/2]
N//#define DSP28_PLLCR    7
N//#define DSP28_PLLCR    6
N//#define DSP28_PLLCR    5
N//#define DSP28_PLLCR    4
N//#define DSP28_PLLCR    3
N//#define DSP28_PLLCR    2
N//#define DSP28_PLLCR    1
N//#define DSP28_PLLCR    0  // PLL is bypassed in this mode
N//----------------------------------------------------------------------------
N
N/*-----------------------------------------------------------------------------
N      Specify the clock rate of the CPU (SYSCLKOUT) in nS.
N
N      Take into account the input clock frequency and the PLL multiplier
N      selected in step 1.
N
N      Use one of the values provided, or define your own.
N      The trailing L is required tells the compiler to treat
N      the number as a 64-bit value.
N
N      Only one statement should be uncommented.
N
N      Example:   60 MHz devices:
N                 CLKIN is a 10 MHz crystal or internal 10 MHz oscillator
N
N                 In step 1 the user specified PLLCR = 0xC for a
N                 60 MHz CPU clock (SYSCLKOUT = 60 MHz).
N
N                 In this case, the CPU_RATE will be 16.667L
N                 Uncomment the line: #define CPU_RATE 16.667L
N
N-----------------------------------------------------------------------------*/
N
N#define CPU_RATE   16.667L   // for a 60MHz CPU clock speed (SYSCLKOUT)
N//#define CPU_RATE   20.000L   // for a 50MHz CPU clock speed  (SYSCLKOUT)
N//#define CPU_RATE   25.000L   // for a 40MHz CPU clock speed  (SYSCLKOUT)
N//#define CPU_RATE   33.333L   // for a 30MHz CPU clock speed  (SYSCLKOUT)
N//#define CPU_RATE   41.667L   // for a 24MHz CPU clock speed  (SYSCLKOUT)
N//#define CPU_RATE   50.000L   // for a 20MHz CPU clock speed  (SYSCLKOUT)
N//#define CPU_RATE   66.667L   // for a 15MHz CPU clock speed  (SYSCLKOUT)
N//#define CPU_RATE  100.000L   // for a 10MHz CPU clock speed  (SYSCLKOUT)
N
N#if 0
S//----------------------------------------------------------------------------
S
S// The following pointer to a function call calibrates the ADC and internal oscillators
S#define Device_cal (void   (*)(void))0x3D7C80
S
S//---------------------------------------------------------------------------
S// Include Example Header Files:
S//
S
S#include "DSP2803x_GlobalPrototypes.h"         // Prototypes for global functions within the
S                                               // .c files.
S#include "DSP2803x_EPwm_defines.h"             // Macros used for PWM examples.
S#include "DSP2803x_I2C_defines.h"              // Macros used for I2C examples.
S#include "DSP2803x_Cla_Defines.h"              // Macros used for CLA examples.
S
S
S#define   PARTNO_28030PAG   0xAA
S#define   PARTNO_28030PN    0xAB
S
S#define   PARTNO_28031PAG   0xAE
S#define   PARTNO_28031PN    0xAF
S
S#define   PARTNO_28032PAG   0xB2
S#define   PARTNO_28032PN    0xB3
S
S#define   PARTNO_28033PAG   0xB6
S#define   PARTNO_28033PN    0xB7
S
S#define   PARTNO_28034PAG   0xBA
S#define   PARTNO_28034PN    0xBB
S
S#define   PARTNO_28035PAG   0xBE
S#define   PARTNO_28035PN    0xBF
S
S// Include files not used with DSP/BIOS
S#ifndef DSP28_BIOS
S#include "DSP2803x_DefaultISR.h"
S#endif
N#endif
N
Nextern void DSP28x_usDelay(unsigned long Count);
N// DO NOT MODIFY THIS LINE.
N#define DELAY_US(A)  DSP28x_usDelay(((((long double) A * 1000.0L) / (long double)CPU_RATE) - 9.0L) / 5.0L)
N
N#endif	/* INC_config_H */
N
N/*** end of file : config.h ***/
L 9 "D:/project/fpalette/ccs4/fpalette/ide_led/src/cores/WProgram.h" 2
N
N//#include <avr/interrupt.h>	//mimutodo
N
N#include "wiring.h"
L 1 "D:\project\fpalette\ccs4\fpalette\ide_led\src\cores\wiring.h" 1
N/*
N  wiring.h - Partial implementation of the Wiring API for the ATmega8.
N  Part of Arduino - http://www.arduino.cc/
N
N  Copyright (c) 2005-2006 David A. Mellis
N
N  This library is free software; you can redistribute it and/or
N  modify it under the terms of the GNU Lesser General Public
N  License as published by the Free Software Foundation; either
N  version 2.1 of the License, or (at your option) any later version.
N
N  This library is distributed in the hope that it will be useful,
N  but WITHOUT ANY WARRANTY; without even the implied warranty of
N  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
N  Lesser General Public License for more details.
N
N  You should have received a copy of the GNU Lesser General
N  Public License along with this library; if not, write to the
N  Free Software Foundation, Inc., 59 Temple Place, Suite 330,
N  Boston, MA  02111-1307  USA
N
N  $Id$
N*/
N
N#ifndef Wiring_h
N#define Wiring_h
N
N//#include <avr/io.h>		 todomimu
N#include <stdlib.h>
L 1 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/stdlib.h" 1
N/*****************************************************************************/
N/* stdlib.h   v5.2.6                                                         */
N/* Copyright (c) 1993-2010 Texas Instruments Incorporated                    */
N/*****************************************************************************/
N
N#ifndef _STDLIB
S#define _STDLIB
S
S
S#ifdef __cplusplus
S//----------------------------------------------------------------------------
S// <cstdlib> IS RECOMMENDED OVER <stdlib.h>.  <stdlib.h> IS PROVIDED FOR 
S// COMPATIBILITY WITH C AND THIS USAGE IS DEPRECATED IN C++
S//----------------------------------------------------------------------------
Sextern "C" namespace std {
S#endif /* !__cplusplus */
S
Stypedef struct { int quot, rem; } div_t;
S
Stypedef struct { long quot, rem; } ldiv_t;
S
S#define _LLONG_AVAILABLE 1
Stypedef struct { long long quot, rem; } lldiv_t;
S
S#define MB_CUR_MAX    1
S
S#ifndef NULL
S#define NULL          0
S#endif
S
S#ifndef _SIZE_T
S#define _SIZE_T
Stypedef __SIZE_T_TYPE__ size_t;
S#endif
S
S#ifndef __cplusplus
S#ifndef _WCHAR_T
S#define _WCHAR_T
Stypedef __WCHAR_T_TYPE__ wchar_t;
S#endif
S#endif
S
S#define EXIT_FAILURE  1
S#define EXIT_SUCCESS  0
S
S#define RAND_MAX      32767
S
S#include <linkage.h>
S
S/*---------------------------------------------------------------*/
S/* NOTE - Normally, abs, labs, and fabs are expanded inline, so  */
S/*        no formal definition is really required. However, ANSI */
S/*        requires that they exist as separate functions, so     */
S/*        they are supplied in the library.  The prototype is    */
S/*        here mainly for documentation.                         */
S/*---------------------------------------------------------------*/
S    _CODE_ACCESS  int       abs(int _val); 
S    _CODE_ACCESS  long      labs(long _val);
S#if defined(_LLONG_AVAILABLE)
S    _CODE_ACCESS  long long llabs(long long _val);
S#endif
S    _CODE_ACCESS int       atoi(const char *_st);
S    _CODE_ACCESS long      atol(const char *_st);
S#if defined(_LLONG_AVAILABLE)
S    _CODE_ACCESS long long atoll(const char *_st);
S#endif
S    _CODE_ACCESS int       ltoa(long val, char *buffer);
S          _IDECL double    atof(const char *_st);
S
S    _CODE_ACCESS long      strtol(const char *_st, char **_endptr, int _base);
S    _CODE_ACCESS unsigned long strtoul(const char *_st, char **_endptr,
S    					  int _base);
S#if defined(_LLONG_AVAILABLE)
S    _CODE_ACCESS long long strtoll(const char *_st, char **_endptr, int _base);
S    _CODE_ACCESS unsigned long long strtoull(const char *_st, char **_endptr,
S					     int _base);
S#endif
S    _CODE_ACCESS double    strtod(const char *_st, char **_endptr);
S    _CODE_ACCESS long double strtold(const char *_st, char **_endptr);
S    
S    _CODE_ACCESS int    rand(void);
S    _CODE_ACCESS void   srand(unsigned _seed);
S    
S    _CODE_ACCESS void  *calloc(size_t _num, size_t _size);
S    _CODE_ACCESS void  *malloc(size_t _size);
S    _CODE_ACCESS void  *realloc(void *_ptr, size_t _size);
S    _CODE_ACCESS void   free(void *_ptr);
S    _CODE_ACCESS void  *memalign(size_t _aln, size_t _size);
S    
S    _CODE_ACCESS void   abort(void); 
S    _CODE_ACCESS int    atexit(void (*_func)(void));
S    _CODE_ACCESS void  *bsearch(const void *_key, const void *_base,
S    				   size_t _nmemb, size_t _size, 
S    			           int (*compar)(const void *,const void *));
S    _CODE_ACCESS void   qsort(void *_base, size_t _nmemb, size_t _size, 
S    			         int (*_compar)(const void *, const void *));
S    _CODE_ACCESS void   exit(int _status);
S    
S    _CODE_ACCESS div_t  div(int _numer, int _denom);
S    _CODE_ACCESS ldiv_t ldiv(long _numer, long _denom);
S#if defined(_LLONG_AVAILABLE)
S    _CODE_ACCESS lldiv_t lldiv(long long _numer, long long _denom);
S#endif
S
S    _CODE_ACCESS char  *getenv(const char *_string);
S    _CODE_ACCESS int    system(const char *_name);
S
S    _CODE_ACCESS int    mblen(const char *, size_t);
S    _CODE_ACCESS size_t mbstowcs(wchar_t *, const char *, size_t);
S    _CODE_ACCESS int    mbtowc(wchar_t *, const char *, size_t);
S
S    _CODE_ACCESS size_t wcstombs(char *, const wchar_t *, size_t);
S    _CODE_ACCESS int    wctomb(char *, wchar_t);
S
S#ifdef __cplusplus
S} /* extern "C" namespace std */
S#endif /* __cplusplus */
S
S
S#ifdef _INLINE
S
S#ifdef __cplusplus
Snamespace std {
S#endif
S
Sstatic __inline double atof(const char *_st) 
S{
S  return strtod(_st, (char **)0); 
S}
S
S#ifdef __cplusplus
S} /* namespace std */
S#endif
S
S#endif  /* _INLINE */
S
N#endif  /* ! _STDLIB */
N
N#if defined(__cplusplus) && !defined(_CPP_STYLE_HEADER)
X#if 1L && !0L
Nusing std::div_t;
Nusing std::ldiv_t;
N#if defined(_LLONG_AVAILABLE)
X#if 1L
Nusing std::lldiv_t;
N#endif
Nusing std::size_t;
Nusing std::abs;
Nusing std::labs;
Nusing std::atoi;
Nusing std::atol;
N#if defined(_LLONG_AVAILABLE)
X#if 1L
Nusing std::llabs;
Nusing std::atoll;
N#endif
Nusing std::atof;
Nusing std::strtol;
Nusing std::strtoul;
N#if defined(_LLONG_AVAILABLE)
X#if 1L
Nusing std::strtoll;
Nusing std::strtoull;
N#endif
Nusing std::strtod;
Nusing std::rand;
Nusing std::srand;
Nusing std::calloc;
Nusing std::malloc;
Nusing std::realloc;
Nusing std::free;
Nusing std::memalign;
Nusing std::abort;
Nusing std::atexit;
Nusing std::bsearch;
Nusing std::qsort;
Nusing std::exit;
Nusing std::div;
Nusing std::ldiv;
N#if defined(_LLONG_AVAILABLE)
X#if 1L
Nusing std::lldiv;
N#endif
Nusing std::getenv;
Nusing std::system;
N#endif /* ! _CPP_STYLE_HEADER */
N
N#include <stdlibf.h>     /* far versions of stdlib fns */
L 1 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/stdlibf.h" 1
N/*****************************************************************************/
N/* stdlibf.h   v5.2.6                                                        */
N/*     far versions of stdlib.h functions                                    */
N/* Copyright (c) 1996-2010 Texas Instruments Incorporated                    */
N/*****************************************************************************/
N#ifndef _STDLIBF
S#define _STDLIBF
S
S#ifndef __cplusplus
S_CODE_ACCESS long          far_strtol (const far char *st, far char **endptr, 
S				   int base);
S_CODE_ACCESS unsigned long far_strtoul(const far char *st, far char **endptr, 
S				   int base);
S_CODE_ACCESS double        far_strtod (const far char *st, far char **endptr);
S_CODE_ACCESS long double   far_strtold (const far char *st, far char **endptr);
S_CODE_ACCESS long long     far_strtoll(const far char *st, far char **endptr, 
S		 						    int base);
S_CODE_ACCESS unsigned long long far_strtoull(const far char *st, 
S                                                   far char **endptr, int base);
S_CODE_ACCESS int           far_atoi(const far char *st);
S_CODE_ACCESS long          far_atol(const far char *st);
S_IDECL       double        far_atof(const far char *st);
S_CODE_ACCESS long long     far_atoll(const far char *st);
S
S_CODE_ACCESS far void     *far_calloc  (unsigned long num, unsigned long size);
S_CODE_ACCESS far void     *far_malloc  (unsigned long size);
S_CODE_ACCESS far void     *far_realloc (far void *ptr, unsigned long size);
S_CODE_ACCESS void          far_free    (far void *ptr);
S
S_CODE_ACCESS far void     *far_bsearch(const far void *key, 
S                                       const far void *base, 
S			               size_t nmemb, size_t size, 
S			               int (*compar)(const far void *,
S                                                     const far void *));
S_CODE_ACCESS void          far_qsort  (far void *base, 
S                                       size_t nmemb, size_t size,
S			               int (*compar)(const far void *, 
S                                                     const far void *));
S
S_CODE_ACCESS int	   free_memory(void);
S_CODE_ACCESS int           max_free(void);
S_CODE_ACCESS void         *chkheap();
S
S#ifdef _INLINE
Sstatic __inline double far_atof(const far char *st) 
S{ 
S   return far_strtod(st, NULL);
S}
S#endif /* _INLINE */
S
S#else /* __cplusplus */
S
Snamespace std {
S
Sextern "C" int	       free_memory(void);
Sextern "C" int         max_free(void);
Sextern "C" void        *chkheap();
S
S_CODE_ACCESS long      far_calloc  (unsigned long num, unsigned long size);
S_CODE_ACCESS long      far_malloc  (unsigned long size);
S_CODE_ACCESS long      far_realloc (long ptr, unsigned long size);
S_CODE_ACCESS void      far_free    (long ptr);
S_CODE_ACCESS long      far_free_memory(void);
S_CODE_ACCESS long      far_max_free(void);
S_CODE_ACCESS long      far_chkheap(void);
S
S}
S#endif /* __cplusplus */
N#endif /* _STDLIBF */
N
N#if defined(__cplusplus) && !defined(_CPP_STYLE_HEADER)
X#if 1L && !0L
Nusing std::free_memory; 
Nusing std::max_free;
Nusing std::chkheap;
Nusing std::far_calloc;
Nusing std::far_malloc;
Nusing std::far_realloc;
Nusing std::far_free;
Nusing std::far_free_memory; 
Nusing std::far_max_free;
Nusing std::far_chkheap;
N#endif /* _CPP_STYLE_HEADER */
L 184 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/stdlib.h" 2
L 30 "D:\project\fpalette\ccs4\fpalette\ide_led\src\cores\wiring.h" 2
N#include "f_types.h"
L 1 "D:\project\fpalette\ccs4\fpalette\ide_led\src\cores\f_types.h" 1
N/*** f_types.h - ***/
N
N#ifndef	INC_f_types_H
N#define	INC_f_types_H
N
N#include <stdint.h>
L 1 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/stdint.h" 1
N/*****************************************************************************/
N/* STDINT.H v5.2.6                                                           */
N/* Copyright (c) 2002-2010 Texas Instruments Incorporated                    */
N/*****************************************************************************/
N#ifndef _STDINT_H_
N#define _STDINT_H_
N
N/* 7.18.1.1 Exact-width integer types */
N
N    typedef          int    int16_t;
N    typedef unsigned int   uint16_t;
N    typedef          long   int32_t;
N    typedef unsigned long  uint32_t;
N
N
N#if defined(__TMS470__) || defined(_TMS320C6X) || defined(__TMS320C28X__)
X#if 0L || 0L || 1L
N    typedef          long long  int64_t;
N    typedef unsigned long long uint64_t;
N#endif
N
N/* 7.18.1.2 Minimum-width integer types */
N
N    typedef  int16_t  int_least8_t;
N    typedef uint16_t uint_least8_t;
N
N    typedef  int16_t  int_least16_t;
N    typedef uint16_t uint_least16_t;
N    typedef  int32_t  int_least32_t;
N    typedef uint32_t uint_least32_t;
N
N
N#if defined(__TMS470__) || defined(_TMS320C6X) || defined(__TMS320C28X__)
X#if 0L || 0L || 1L
N    typedef  int64_t  int_least64_t;
N    typedef uint64_t uint_least64_t;
N#else
S/* sorry, int_least64_t not implemented for C54x, C55x, MSP430 */
N#endif
N
N/* 7.18.1.3 Fastest minimum-width integer types */
N
N    typedef  int16_t  int_fast8_t;
N    typedef uint16_t uint_fast8_t;
N    typedef  int16_t  int_fast16_t;
N    typedef uint16_t uint_fast16_t;
N
N    typedef  int32_t  int_fast32_t;
N    typedef uint32_t uint_fast32_t;
N
N
N#if defined(__TMS470__) || defined(_TMS320C6X) || defined(__TMS320C28X__)
X#if 0L || 0L || 1L
N    typedef  int64_t  int_fast64_t;
N    typedef uint64_t uint_fast64_t;
N#endif
N
N/* 7.18.1.4 Integer types capable of holding object pointers */
N    typedef          long intptr_t;
N    typedef unsigned long uintptr_t;
N
N/* 7.18.1.5 Greatest-width integer types */
N#if defined(__TMS320C55X__) || defined(__TMS470__) || defined(_TMS320C6X) || defined(__TMS320C28X__)
X#if 0L || 0L || 0L || 1L
N    typedef          long long intmax_t;
N    typedef unsigned long long uintmax_t;
N#elif defined(_TMS320C5XX) || defined(__TMS320C27X__) || defined(__MSP430__)
S    typedef          long intmax_t;
S    typedef unsigned long uintmax_t;
N#endif
N
N/* 
N   According to footnotes in the 1999 C standard, "C++ implementations
N   should define these macros only when __STDC_LIMIT_MACROS is defined
N   before <stdint.h> is included." 
N*/
N#if !defined(__cplusplus) || defined(__STDC_LIMIT_MACROS)
X#if !1L || 0L
S
S/* 7.18.2 Limits of specified width integer types */
S
S
S    #define  INT16_MAX  0x7fff
S    #define  INT16_MIN  (-INT16_MAX-1)
S    #define UINT16_MAX  0xffff
S
S    #define  INT32_MAX  0x7fffffff
S    #define  INT32_MIN  (-INT32_MAX-1)
S    #define UINT32_MAX  0xffffffff
S
S
S#if defined(__TMS470__) || defined(_TMS320C6X) || defined(__TMS320C28X__)
S    #define  INT64_MAX  0x7fffffffffffffff
S    #define  INT64_MIN  (-INT64_MAX-1)
S    #define UINT64_MAX  0xffffffffffffffff
S#endif
S
S    #define  INT_LEAST8_MAX   INT16_MAX
S    #define  INT_LEAST8_MIN   INT16_MIN
S    #define UINT_LEAST8_MAX   UINT16_MAX
S
S    #define  INT_LEAST16_MAX  INT16_MAX
S    #define  INT_LEAST16_MIN  INT16_MIN
S    #define UINT_LEAST16_MAX  UINT16_MAX
S    #define  INT_LEAST32_MAX  INT32_MAX
S    #define  INT_LEAST32_MIN  INT32_MIN
S    #define UINT_LEAST32_MAX  UINT32_MAX
S
S
S#if defined(__TMS470__) || defined(_TMS320C6X) || defined(__TMS320C28X__)
S    #define  INT_LEAST64_MAX  INT64_MAX
S    #define  INT_LEAST64_MIN  INT64_MIN
S    #define UINT_LEAST64_MAX  UINT64_MAX
S#endif
S
S    #define  INT_FAST8_MAX   INT16_MAX
S    #define  INT_FAST8_MIN   INT16_MIN
S    #define UINT_FAST8_MAX   UINT16_MAX
S    #define  INT_FAST16_MAX  INT16_MAX
S    #define  INT_FAST16_MIN  INT16_MIN
S    #define UINT_FAST16_MAX  UINT16_MAX
S
S    #define  INT_FAST32_MAX  INT32_MAX
S    #define  INT_FAST32_MIN  INT32_MIN
S    #define UINT_FAST32_MAX  UINT32_MAX
S
S
S#if defined(__TMS470__) || defined(_TMS320C6X) || defined(__TMS320C28X__)
S    #define  INT_FAST64_MAX  INT64_MAX
S    #define  INT_FAST64_MIN  INT64_MIN
S    #define UINT_FAST64_MAX  UINT64_MAX
S#endif
S
S    #define INTPTR_MAX   INT32_MAX
S    #define INTPTR_MIN   INT32_MIN
S    #define UINTPTR_MAX  UINT32_MAX
S
S#if defined(__TMS470__) || defined(_TMS320C6X) || defined(__TMS320C28X__)
S    #define INTMAX_MIN   INT64_MIN
S    #define INTMAX_MAX   INT64_MAX
S    #define UINTMAX_MAX  UINT64_MAX
S#elif defined(_TMS320C5XX) || defined(__TMS320C27X__) || defined(__MSP430__)
S    #define INTMAX_MIN   INT32_MIN
S    #define INTMAX_MAX   INT32_MAX
S    #define UINTMAX_MAX  UINT32_MAX
S#endif
S
S/* 7.18.3 Limits of other integer types */
S
S    #define PTRDIFF_MAX INT32_MAX
S    #define PTRDIFF_MIN INT32_MIN
S
S    #define SIG_ATOMIC_MIN INT32_MIN
S    #define SIG_ATOMIC_MAX INT32_MAX
S
S    #define SIZE_MAX INT32_MAX
S
S#ifndef WCHAR_MAX
S#define WCHAR_MAX 0xffffu
S#endif
S
S#ifndef WCHAR_MIN
S#define WCHAR_MIN 0
S#endif
S
S    #define WINT_MIN INT32_MIN
S    #define WINT_MAX INT32_MAX
S
S/* 7.18.4.1 Macros for minimum-width integer constants */
S
S/*
S   There is a defect report filed against the C99 standard concerning how 
S   the (U)INTN_C macros should be implemented.  Please refer to --
S   http://wwwold.dkuug.dk/JTC1/SC22/WG14/www/docs/dr_209.htm 
S   for more information.  These macros are implemented according to the
S   suggestion given at this web site.
S*/
S
S    #define  INT8_C(value)  ((int_least8_t)(value))
S    #define UINT8_C(value)  ((uint_least8_t)(value))
S    #define  INT16_C(value) ((int_least16_t)(value))
S    #define UINT16_C(value) ((uint_least16_t)(value))
S    #define  INT32_C(value) ((int_least32_t)(value))
S    #define UINT32_C(value) ((uint_least32_t)(value))
S
S
S#if defined(__TMS470__) || defined(_TMS320C6X) || defined(__TMS320C28X__)
S    #define  INT64_C(value) ((int_least64_t)(value))
S    #define UINT64_C(value) ((uint_least64_t)(value))
S#endif
S
S/* 7.18.4.2 Macros for greatest-width integer constants */
S
S    #define  INTMAX_C(value) ((intmax_t)(value))
S    #define UINTMAX_C(value) ((uintmax_t)(value))
S
N#endif /* !defined(__cplusplus) || defined(__STDC_LIMIT_MACROS) */
N
N#endif /* _STDINT_H_ */
L 7 "D:\project\fpalette\ccs4\fpalette\ide_led\src\cores\f_types.h" 2
N
N//typedef	unsigned short	uint16_t;
Ntypedef	unsigned char	uint8_t;
N
N
Ntypedef unsigned int word;
N
N//typedef uint8_t boolean;
Ntypedef unsigned int boolean;
Ntypedef uint8_t byte;
N
N#define lowByte(w) ((uint8_t) ((w) & 0xff))
N#define highByte(w) ((uint8_t) ((w) >> 8))
N
N#define bit(b) (1UL << (b))
N
N#define bitRead(value, bit) (((value) >> (bit)) & 0x01)
N#define bitSet(value, bit) ((value) |= (1UL << (bit)))
N#define bitClear(value, bit) ((value) &= ~(1UL << (bit)))
N#define bitWrite(value, bit, bitvalue) (bitvalue ? bitSet(value, bit) : bitClear(value, bit))
N
N
N#endif	/* INC_f_types_H */
N
N/*** end of file : f_types.h ***/
L 31 "D:\project\fpalette\ccs4\fpalette\ide_led\src\cores\wiring.h" 2
N#include "binary.h"
L 1 "D:\project\fpalette\ccs4\fpalette\ide_led\src\cores\binary.h" 1
N#ifndef Binary_h
N#define Binary_h
N
N#define B0 0
N#define B00 0
N#define B000 0
N#define B0000 0
N#define B00000 0
N#define B000000 0
N#define B0000000 0
N#define B00000000 0
N#define B1 1
N#define B01 1
N#define B001 1
N#define B0001 1
N#define B00001 1
N#define B000001 1
N#define B0000001 1
N#define B00000001 1
N#define B10 2
N#define B010 2
N#define B0010 2
N#define B00010 2
N#define B000010 2
N#define B0000010 2
N#define B00000010 2
N#define B11 3
N#define B011 3
N#define B0011 3
N#define B00011 3
N#define B000011 3
N#define B0000011 3
N#define B00000011 3
N#define B100 4
N#define B0100 4
N#define B00100 4
N#define B000100 4
N#define B0000100 4
N#define B00000100 4
N#define B101 5
N#define B0101 5
N#define B00101 5
N#define B000101 5
N#define B0000101 5
N#define B00000101 5
N#define B110 6
N#define B0110 6
N#define B00110 6
N#define B000110 6
N#define B0000110 6
N#define B00000110 6
N#define B111 7
N#define B0111 7
N#define B00111 7
N#define B000111 7
N#define B0000111 7
N#define B00000111 7
N#define B1000 8
N#define B01000 8
N#define B001000 8
N#define B0001000 8
N#define B00001000 8
N#define B1001 9
N#define B01001 9
N#define B001001 9
N#define B0001001 9
N#define B00001001 9
N#define B1010 10
N#define B01010 10
N#define B001010 10
N#define B0001010 10
N#define B00001010 10
N#define B1011 11
N#define B01011 11
N#define B001011 11
N#define B0001011 11
N#define B00001011 11
N#define B1100 12
N#define B01100 12
N#define B001100 12
N#define B0001100 12
N#define B00001100 12
N#define B1101 13
N#define B01101 13
N#define B001101 13
N#define B0001101 13
N#define B00001101 13
N#define B1110 14
N#define B01110 14
N#define B001110 14
N#define B0001110 14
N#define B00001110 14
N#define B1111 15
N#define B01111 15
N#define B001111 15
N#define B0001111 15
N#define B00001111 15
N#define B10000 16
N#define B010000 16
N#define B0010000 16
N#define B00010000 16
N#define B10001 17
N#define B010001 17
N#define B0010001 17
N#define B00010001 17
N#define B10010 18
N#define B010010 18
N#define B0010010 18
N#define B00010010 18
N#define B10011 19
N#define B010011 19
N#define B0010011 19
N#define B00010011 19
N#define B10100 20
N#define B010100 20
N#define B0010100 20
N#define B00010100 20
N#define B10101 21
N#define B010101 21
N#define B0010101 21
N#define B00010101 21
N#define B10110 22
N#define B010110 22
N#define B0010110 22
N#define B00010110 22
N#define B10111 23
N#define B010111 23
N#define B0010111 23
N#define B00010111 23
N#define B11000 24
N#define B011000 24
N#define B0011000 24
N#define B00011000 24
N#define B11001 25
N#define B011001 25
N#define B0011001 25
N#define B00011001 25
N#define B11010 26
N#define B011010 26
N#define B0011010 26
N#define B00011010 26
N#define B11011 27
N#define B011011 27
N#define B0011011 27
N#define B00011011 27
N#define B11100 28
N#define B011100 28
N#define B0011100 28
N#define B00011100 28
N#define B11101 29
N#define B011101 29
N#define B0011101 29
N#define B00011101 29
N#define B11110 30
N#define B011110 30
N#define B0011110 30
N#define B00011110 30
N#define B11111 31
N#define B011111 31
N#define B0011111 31
N#define B00011111 31
N#define B100000 32
N#define B0100000 32
N#define B00100000 32
N#define B100001 33
N#define B0100001 33
N#define B00100001 33
N#define B100010 34
N#define B0100010 34
N#define B00100010 34
N#define B100011 35
N#define B0100011 35
N#define B00100011 35
N#define B100100 36
N#define B0100100 36
N#define B00100100 36
N#define B100101 37
N#define B0100101 37
N#define B00100101 37
N#define B100110 38
N#define B0100110 38
N#define B00100110 38
N#define B100111 39
N#define B0100111 39
N#define B00100111 39
N#define B101000 40
N#define B0101000 40
N#define B00101000 40
N#define B101001 41
N#define B0101001 41
N#define B00101001 41
N#define B101010 42
N#define B0101010 42
N#define B00101010 42
N#define B101011 43
N#define B0101011 43
N#define B00101011 43
N#define B101100 44
N#define B0101100 44
N#define B00101100 44
N#define B101101 45
N#define B0101101 45
N#define B00101101 45
N#define B101110 46
N#define B0101110 46
N#define B00101110 46
N#define B101111 47
N#define B0101111 47
N#define B00101111 47
N#define B110000 48
N#define B0110000 48
N#define B00110000 48
N#define B110001 49
N#define B0110001 49
N#define B00110001 49
N#define B110010 50
N#define B0110010 50
N#define B00110010 50
N#define B110011 51
N#define B0110011 51
N#define B00110011 51
N#define B110100 52
N#define B0110100 52
N#define B00110100 52
N#define B110101 53
N#define B0110101 53
N#define B00110101 53
N#define B110110 54
N#define B0110110 54
N#define B00110110 54
N#define B110111 55
N#define B0110111 55
N#define B00110111 55
N#define B111000 56
N#define B0111000 56
N#define B00111000 56
N#define B111001 57
N#define B0111001 57
N#define B00111001 57
N#define B111010 58
N#define B0111010 58
N#define B00111010 58
N#define B111011 59
N#define B0111011 59
N#define B00111011 59
N#define B111100 60
N#define B0111100 60
N#define B00111100 60
N#define B111101 61
N#define B0111101 61
N#define B00111101 61
N#define B111110 62
N#define B0111110 62
N#define B00111110 62
N#define B111111 63
N#define B0111111 63
N#define B00111111 63
N#define B1000000 64
N#define B01000000 64
N#define B1000001 65
N#define B01000001 65
N#define B1000010 66
N#define B01000010 66
N#define B1000011 67
N#define B01000011 67
N#define B1000100 68
N#define B01000100 68
N#define B1000101 69
N#define B01000101 69
N#define B1000110 70
N#define B01000110 70
N#define B1000111 71
N#define B01000111 71
N#define B1001000 72
N#define B01001000 72
N#define B1001001 73
N#define B01001001 73
N#define B1001010 74
N#define B01001010 74
N#define B1001011 75
N#define B01001011 75
N#define B1001100 76
N#define B01001100 76
N#define B1001101 77
N#define B01001101 77
N#define B1001110 78
N#define B01001110 78
N#define B1001111 79
N#define B01001111 79
N#define B1010000 80
N#define B01010000 80
N#define B1010001 81
N#define B01010001 81
N#define B1010010 82
N#define B01010010 82
N#define B1010011 83
N#define B01010011 83
N#define B1010100 84
N#define B01010100 84
N#define B1010101 85
N#define B01010101 85
N#define B1010110 86
N#define B01010110 86
N#define B1010111 87
N#define B01010111 87
N#define B1011000 88
N#define B01011000 88
N#define B1011001 89
N#define B01011001 89
N#define B1011010 90
N#define B01011010 90
N#define B1011011 91
N#define B01011011 91
N#define B1011100 92
N#define B01011100 92
N#define B1011101 93
N#define B01011101 93
N#define B1011110 94
N#define B01011110 94
N#define B1011111 95
N#define B01011111 95
N#define B1100000 96
N#define B01100000 96
N#define B1100001 97
N#define B01100001 97
N#define B1100010 98
N#define B01100010 98
N#define B1100011 99
N#define B01100011 99
N#define B1100100 100
N#define B01100100 100
N#define B1100101 101
N#define B01100101 101
N#define B1100110 102
N#define B01100110 102
N#define B1100111 103
N#define B01100111 103
N#define B1101000 104
N#define B01101000 104
N#define B1101001 105
N#define B01101001 105
N#define B1101010 106
N#define B01101010 106
N#define B1101011 107
N#define B01101011 107
N#define B1101100 108
N#define B01101100 108
N#define B1101101 109
N#define B01101101 109
N#define B1101110 110
N#define B01101110 110
N#define B1101111 111
N#define B01101111 111
N#define B1110000 112
N#define B01110000 112
N#define B1110001 113
N#define B01110001 113
N#define B1110010 114
N#define B01110010 114
N#define B1110011 115
N#define B01110011 115
N#define B1110100 116
N#define B01110100 116
N#define B1110101 117
N#define B01110101 117
N#define B1110110 118
N#define B01110110 118
N#define B1110111 119
N#define B01110111 119
N#define B1111000 120
N#define B01111000 120
N#define B1111001 121
N#define B01111001 121
N#define B1111010 122
N#define B01111010 122
N#define B1111011 123
N#define B01111011 123
N#define B1111100 124
N#define B01111100 124
N#define B1111101 125
N#define B01111101 125
N#define B1111110 126
N#define B01111110 126
N#define B1111111 127
N#define B01111111 127
N#define B10000000 128
N#define B10000001 129
N#define B10000010 130
N#define B10000011 131
N#define B10000100 132
N#define B10000101 133
N#define B10000110 134
N#define B10000111 135
N#define B10001000 136
N#define B10001001 137
N#define B10001010 138
N#define B10001011 139
N#define B10001100 140
N#define B10001101 141
N#define B10001110 142
N#define B10001111 143
N#define B10010000 144
N#define B10010001 145
N#define B10010010 146
N#define B10010011 147
N#define B10010100 148
N#define B10010101 149
N#define B10010110 150
N#define B10010111 151
N#define B10011000 152
N#define B10011001 153
N#define B10011010 154
N#define B10011011 155
N#define B10011100 156
N#define B10011101 157
N#define B10011110 158
N#define B10011111 159
N#define B10100000 160
N#define B10100001 161
N#define B10100010 162
N#define B10100011 163
N#define B10100100 164
N#define B10100101 165
N#define B10100110 166
N#define B10100111 167
N#define B10101000 168
N#define B10101001 169
N#define B10101010 170
N#define B10101011 171
N#define B10101100 172
N#define B10101101 173
N#define B10101110 174
N#define B10101111 175
N#define B10110000 176
N#define B10110001 177
N#define B10110010 178
N#define B10110011 179
N#define B10110100 180
N#define B10110101 181
N#define B10110110 182
N#define B10110111 183
N#define B10111000 184
N#define B10111001 185
N#define B10111010 186
N#define B10111011 187
N#define B10111100 188
N#define B10111101 189
N#define B10111110 190
N#define B10111111 191
N#define B11000000 192
N#define B11000001 193
N#define B11000010 194
N#define B11000011 195
N#define B11000100 196
N#define B11000101 197
N#define B11000110 198
N#define B11000111 199
N#define B11001000 200
N#define B11001001 201
N#define B11001010 202
N#define B11001011 203
N#define B11001100 204
N#define B11001101 205
N#define B11001110 206
N#define B11001111 207
N#define B11010000 208
N#define B11010001 209
N#define B11010010 210
N#define B11010011 211
N#define B11010100 212
N#define B11010101 213
N#define B11010110 214
N#define B11010111 215
N#define B11011000 216
N#define B11011001 217
N#define B11011010 218
N#define B11011011 219
N#define B11011100 220
N#define B11011101 221
N#define B11011110 222
N#define B11011111 223
N#define B11100000 224
N#define B11100001 225
N#define B11100010 226
N#define B11100011 227
N#define B11100100 228
N#define B11100101 229
N#define B11100110 230
N#define B11100111 231
N#define B11101000 232
N#define B11101001 233
N#define B11101010 234
N#define B11101011 235
N#define B11101100 236
N#define B11101101 237
N#define B11101110 238
N#define B11101111 239
N#define B11110000 240
N#define B11110001 241
N#define B11110010 242
N#define B11110011 243
N#define B11110100 244
N#define B11110101 245
N#define B11110110 246
N#define B11110111 247
N#define B11111000 248
N#define B11111001 249
N#define B11111010 250
N#define B11111011 251
N#define B11111100 252
N#define B11111101 253
N#define B11111110 254
N#define B11111111 255
N
N#endif
L 32 "D:\project\fpalette\ccs4\fpalette\ide_led\src\cores\wiring.h" 2
N
N#ifdef __cplusplus
Nextern "C"{
N#endif
N
Nvoid setup(void);
Nvoid init(void);
Nvoid loop(void);
N
N#ifdef __cplusplus
N} /* extern "C" */
N#endif
N
N#endif
L 13 "D:/project/fpalette/ccs4/fpalette/ide_led/src/cores/WProgram.h" 2
N
N#ifdef __cplusplus
N#include "f_types.h"
N#include "f_const.h"
L 1 "D:\project\fpalette\ccs4\fpalette\ide_led\src\cores\f_const.h" 1
N/*** f_const.h - fpallet const data define ***/
N
N/*** Copyright(C) 2011 Sansei System Co.,Ltd. ***/
N
N/*** HISTORY ***
N * 2011/02/28 mimu
N              First Version
N */
N
N#ifndef	INC_f_const_H
N#define	INC_f_const_H
N
N#ifdef	__cplusplus
Nextern "C" {
N#endif
N
N#define LOW		0x0
N#define HIGH	0x1
N#define	TOGGLE	0x02
N
N#define	INPUT	0
N#define	OUTPUT	1
N#define	MODE_2	2
N#define	MODE_3	3
N
N#define true 0x1
N#define false 0x0
N
N//#define PI 3.1415926535897932384626433832795
N//#define HALF_PI 1.5707963267948966192313216916398
N//#define TWO_PI 6.283185307179586476925286766559
N//#define DEG_TO_RAD 0.017453292519943295769236907684886
N//#define RAD_TO_DEG 57.295779513082320876798154814105
N
N//#define SERIAL  0x0
N//#define DISPLAY 0x1
N
N#define LSBFIRST 0
N#define MSBFIRST 1
N
N//#define CHANGE 1
N//#define FALLING 2
N//#define RISING 3
N
N//#if defined(__AVR_ATmega1280__) || defined(__AVR_ATmega2560__)
N//#define INTERNAL1V1 2
N//#define INTERNAL2V56 3
N//#else
N//#define INTERNAL 3
N//#endif
N
N//#define DEFAULT 1
N//#define EXTERNAL 0
N
N
N
N#ifdef	__cplusplus
N} /* extern "C" */
N#endif
N
N#endif	/* INC_f_const_H */
N
N/*** end of file : f_const.h ***/
L 17 "D:/project/fpalette/ccs4/fpalette/ide_led/src/cores/WProgram.h" 2
N#include "f_gpio.h"
L 1 "D:\project\fpalette\ccs4\fpalette\ide_led\src\cores\f_gpio.h" 1
N/*** f_gpio.h - fpallet GPIO control ***/
N
N/*** Copyright(C) 2011 Sansei System Co.,Ltd. ***/
N
N/*** HISTORY ***
N * 2011/03/01 mimu
N              First Version
N */
N
N#ifndef	INC_f_gpio_H
N#define	INC_f_gpip_H
N
N#include "f_types.h"
N#include "f_const.h"
N
N#ifdef	__cplusplus
Nextern "C" {
N#endif
N
Nvoid pinMode( uint8_t pin, uint8_t mode );
Nvoid digitalWrite(uint8_t, uint8_t);
Nint digitalRead(uint8_t);
N
Nunsigned long pulseIn(uint8_t pin, uint8_t state, unsigned long timeout);
N
Nvoid shiftOut(uint8_t dataPin, uint8_t clockPin, uint8_t bitOrder, uint8_t val);
Nuint8_t shiftIn(uint8_t dataPin, uint8_t clockPin, uint8_t bitOrder);
N
N
N#ifdef	__cplusplus
N}	/* extern "C" */
N#endif
N
N#endif	/* INC_f_gpio_H */
N
N/*** end of file : f_gpio.h ***/
L 18 "D:/project/fpalette/ccs4/fpalette/ide_led/src/cores/WProgram.h" 2
N#include "f_time.h"
L 1 "D:\project\fpalette\ccs4\fpalette\ide_led\src\cores\f_time.h" 1
N/*** f_time.h - fpallet time/timer ***/
N
N/*** Copyright(C) 2011 Sansei System Co.,Ltd. ***/
N
N/*** HISTORY ***
N * 2011/03/01 mimu
N              First Version
N */
N
N#ifndef	INC_f_time_H
N#define	INC_f_time_H
N
N#include "f_types.h"
N
N#ifdef	__cplusplus
Nextern "C" {
N#endif
N
N//#define clockCyclesPerMicrosecond() ( F_CPU / 1000000L )
N//#define clockCyclesToMicroseconds(a) ( ((a) * 1000L) / (F_CPU / 1000L) )
N//#define microsecondsToClockCycles(a) ( ((a) * (F_CPU / 1000L)) / 1000L )
N
Nint f_time_init( void );
N
Ntypedef struct f_time_t {
N	unsigned long uSec;
N
N	unsigned long start;
N}fTime;
N
Nunsigned long millis(void);
Nunsigned long micros(void);
N
Nvoid timeAlarmSet( fTime * alarm );
Nint  timeAlarmCheck( fTime * alarm );
N
Nvoid timeMeasureStart( fTime * measure );
Nvoid timeMeasureGet( fTime * measure );
N
Nvoid delay( unsigned long mSec );
Nvoid delayMicroseconds(unsigned int us);
N
N
N#ifdef	__cplusplus
N}
N#endif
N
N#endif	/* INC_f_time_H */
N
N/*** end of file : f_time.h ***/
L 19 "D:/project/fpalette/ccs4/fpalette/ide_led/src/cores/WProgram.h" 2
N#include "f_analog.h"
L 1 "D:\project\fpalette\ccs4\fpalette\ide_led\src\cores\f_analog.h" 1
N/*** f_analog.h - fpallet A/D D/A conv. ***/
N
N/*** Copyright(C) 2011 Sansei System Co.,Ltd. ***/
N
N#ifndef	INC_f_analog_H
N#define	INC_f_analog_H
N
N#ifdef	__cplusplus
Nextern "C" {
N#endif
N
Nint analogRead(uint8_t);
Nvoid analogReference(uint8_t mode);
Nvoid analogWrite(uint8_t, int);
N
N
N#ifdef	__cplusplus
N}	/* extern "C" */
N#endif
N
N
N#endif	/* INC_f_analog_H */
N
N/*** end of file : f_analog.h ***/
L 20 "D:/project/fpalette/ccs4/fpalette/ide_led/src/cores/WProgram.h" 2
N
N#include "WCharacter.h"
L 1 "D:\project\fpalette\ccs4\fpalette\ide_led\src\cores\WCharacter.h" 1
N/*
N WCharacter.h - Character utility functions for Wiring & Arduino
N Copyright (c) 2010 Hernando Barragan.  All right reserved.
N
N This library is free software; you can redistribute it and/or
N modify it under the terms of the GNU Lesser General Public
N License as published by the Free Software Foundation; either
N version 2.1 of the License, or (at your option) any later version.
N
N This library is distributed in the hope that it will be useful,
N but WITHOUT ANY WARRANTY; without even the implied warranty of
N MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
N Lesser General Public License for more details.
N
N You should have received a copy of the GNU Lesser General Public
N License along with this library; if not, write to the Free Software
N Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
N */
N
N#ifndef Character_h
N#define Character_h
N
N#include <ctype.h>
L 1 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/ctype.h" 1
N/*****************************************************************************/
N/* ctype.h    v5.2.6                                                         */
N/* Copyright (c) 1993-2010 Texas Instruments Incorporated                    */
N/*****************************************************************************/
N
N/************************************************************************/
N/*                                                                      */
N/*  CHARACTER TYPING FUNCTIONS AND MACROS                               */
N/*                                                                      */
N/*  Note that in this implementation, either macros or functions may    */
N/*  be used.  Macros are prefixed with an underscore.                   */
N/*                                                                      */
N/************************************************************************/
N#ifndef _CTYPE
N#define _CTYPE
N
N#include <linkage.h>
N
N
N#ifdef __cplusplus
N//----------------------------------------------------------------------------
N// <cctype> IS RECOMMENDED OVER <ctype.h>.  <ctype.h> IS PROVIDED FOR
N// COMPATIBILITY WITH C AND THIS USAGE IS DEPRECATED IN C++
N//----------------------------------------------------------------------------
Nextern "C" namespace std
N{
N#endif /* __cplusplus */
N
Nextern _DATA_ACCESS const unsigned char _ctypes_[];
Xextern  const unsigned char _ctypes_[];
N
N/************************************************************************/
N/*   FUNCTION DECLARATIONS                                              */
N/************************************************************************/
N#include "_isfuncdcl.h"
L 1 "C:\Program Files (x86)\Texas Instruments\ccsv4\tools\compiler\c2000\include\_isfuncdcl.h" 1
N#include <linkage.h>
N_IDECL int isalnum(int _c);
Xextern  int isalnum(int _c);
N_IDECL int isalpha(int _c);
Xextern  int isalpha(int _c);
N_IDECL int iscntrl(int _c);
Xextern  int iscntrl(int _c);
N_IDECL int isdigit(int _c);
Xextern  int isdigit(int _c);
N_IDECL int isgraph(int _c);
Xextern  int isgraph(int _c);
N_IDECL int islower(int _c);
Xextern  int islower(int _c);
N_IDECL int isprint(int _c);
Xextern  int isprint(int _c);
N_IDECL int ispunct(int _c);
Xextern  int ispunct(int _c);
N_IDECL int isspace(int _c);
Xextern  int isspace(int _c);
N_IDECL int isupper(int _c);
Xextern  int isupper(int _c);
N_IDECL int isxdigit(int _c);
Xextern  int isxdigit(int _c);
N_IDECL int isascii(int _c);
Xextern  int isascii(int _c);
N_IDECL int toascii(int _c);
Xextern  int toascii(int _c);
N
L 35 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/ctype.h" 2
N
N_IDECL int toupper(int _c);
Xextern  int toupper(int _c);
N_IDECL int tolower(int _c);
Xextern  int tolower(int _c);
N
N#ifdef __cplusplus
N} /* extern "C" namespace std */
N#endif /* __cplusplus */
N
N
N/************************************************************************/
N/*  On this ELSE path, all the TI ctype table and ctype bit flags are   */
N/*  defined.                                                            */
N/************************************************************************/
N/************************************************************************/
N/*  MACRO DEFINITIONS                                                   */
N/************************************************************************/
N#define _U_   0x01       /* control chars     */
N#define _L_   0x02       /* lower case letter */
N#define _N_   0x04       /* digit             */
N#define _S_   0x08       /* white space       */
N#define _P_   0x10       /* punctuation       */
N#define _C_   0x20       /* control chars     */
N#define _H_   0x40       /* A-F, a-f and 0-9  */
N#define _B_   0x80       /* blank             */
N
N#define _isalnum(a)  (_ctypes_[(a)+1] & (_U_ | _L_ | _N_))
N#define _isalpha(a)  (_ctypes_[(a)+1] & (_U_ | _L_))
N#define _iscntrl(a)  (_ctypes_[(a)+1] & _C_)
N#define _isdigit(a)  (_ctypes_[(a)+1] & _N_)
N#define _isgraph(a)  (_ctypes_[(a)+1] & (_U_ | _L_ | _N_ | _P_))
N#define _islower(a)  (_ctypes_[(a)+1] & _L_)
N#define _isprint(a)  (_ctypes_[(a)+1] & (_B_ | _U_ | _L_ | _N_ | _P_))
N#define _ispunct(a)  (_ctypes_[(a)+1] & _P_)
N#define _isspace(a)  (_ctypes_[(a)+1] & _S_)
N#define _isupper(a)  (_ctypes_[(a)+1] & _U_)
N#define _isxdigit(a) (_ctypes_[(a)+1] & _H_)
N
N
N#define _isascii(a)  (((a) & ~0x7F) == 0)
N#define _toupper(b)  ((_islower(b)) ? (b) - ('a' - 'A') : (b))
N#define _tolower(b)  ((_isupper(b)) ? (b) + ('a' - 'A') : (b))
N#define _toascii(a)  ((a) & 0x7F)
N
N#ifdef _INLINE
S
S#ifdef __cplusplus
Susing std::_ctypes_;
Snamespace std {
S#endif /* __cplusplus */
S
S#include "_isfuncdef.h"
S
S/****************************************************************************/
S/*  tolower                                                                 */
S/****************************************************************************/
Sstatic __inline int tolower(int ch)
S{
S   /*
S    This code depends on two assumptions: (1) all of the letters of the
S    alphabet of a given case are contiguous, and (2) the lower and upper
S    case forms of each letter are displaced from each other by the same
S    constant value.
S   */
S
S   if ( (unsigned int)(ch - 'A') <= (unsigned int)('Z' - 'A')) ch += 'a' - 'A';
S   return ch;
S}
S
S/****************************************************************************/
S/*  toupper                                                                 */
S/****************************************************************************/
Sstatic __inline int toupper(int ch)
S{
S   /*
S    This code depends on two assumptions: (1) all of the letters of the
S    alphabet of a given case are contiguous, and (2) the lower and upper
S    case forms of each letter are displaced from each other by the same
S    constant value.
S   */
S
S   if ( (unsigned int)(ch - 'a') <= (unsigned int)('z' - 'a')) ch -= 'a' - 'A';
S   return ch;
S}
S
S#ifdef __cplusplus
S}
S#endif /* __cplusplus */
S
N#endif /* _INLINE */
N
N#endif /* ! _CTYPE */
N
N#if defined(__cplusplus) && !defined(_CPP_STYLE_HEADER)
X#if 1L && !0L
Nusing std::_ctypes_;
Nusing std::isalnum;
Nusing std::isalpha;
Nusing std::iscntrl;
Nusing std::isdigit;
Nusing std::isgraph;
Nusing std::islower;
Nusing std::isprint;
Nusing std::ispunct;
Nusing std::isspace;
Nusing std::isupper;
Nusing std::isxdigit;
Nusing std::isascii;
Nusing std::toupper;
Nusing std::tolower;
Nusing std::toascii;
N#endif /* ! _CPP_STYLE_HEADER */
N
L 24 "D:\project\fpalette\ccs4\fpalette\ide_led\src\cores\WCharacter.h" 2
N
N#if 1
N/*******************************************************************************
N * Checks for an alphanumeric character.
N * It is equivalent to (isalpha(c) || isdigit(c)).
N */
N#ifdef	_INLINE
Sstatic inline boolean isAlphaNumeric(int c) { return ( isalnum(c) == 0 ? false : true); }
N#else
N#ifndef	WCharacter_C
Nboolean isAlphaNumeric(int c);
N#else
Sboolean isAlphaNumeric(int c) { return ( isalnum(c) == 0 ? false : true); }
N#endif
N#endif
N
N
N/*******************************************************************************
N * Checks for an alphabetic character.
N * It is equivalent to (isupper(c) || islower(c)).
N */
N#ifdef	_INLINE
Sstatic inline boolean isAlpha(int c)
S{
S	return ( isalpha(c) == 0 ? false : true);
S}
N#else
N#ifndef	WCharacter_C
Ninline boolean isAlpha(int c);
N#else
Sinline boolean isAlpha(int c)
S{
S	return ( isalpha(c) == 0 ? false : true);
S}
N#endif
N#endif
N
N/*******************************************************************************
N * Checks whether c is a 7-bit unsigned char value
N * that fits into the ASCII character set.
N */
N#ifdef	_INLINE
Sstatic inline boolean isAscii(int c) { return ( isascii (c) == 0 ? false : true); }
N#else
N#ifndef	WCharacter_C
Nboolean isAscii(int c);
N#else
Sboolean isAscii(int c) { return ( isascii (c) == 0 ? false : true); }
N#endif
N#endif
N
N
N/*******************************************************************************
N * Checks for a blank character, that is, a space or a tab.
N */
N#ifdef	_INLINE
Sstatic inline boolean isWhitespace(int c) { return ( (c==' ') || (c=='\t') ); }
N#else
N#ifndef	WCharacter_C
Nboolean isWhitespace(int c);
N#else
Sboolean isWhitespace(int c) { return ( (c==' ') || (c=='\t') ); };
N#endif
N#endif
N
N/*******************************************************************************
N * Checks for a control character.
N */
N#ifdef	_INLINE
Sstatic inline boolean isControl(int c) { return ( iscntrl (c) == 0 ? false : true); }
N#else
N#ifndef	WCharacter_C
Nboolean isControl(int c);
N#else
Sboolean isControl(int c) { return ( iscntrl (c) == 0 ? false : true); }
N#endif
N#endif
N
N/*******************************************************************************
N * Checks for a digit (0 through 9).
N */
N#ifdef	_INLINE
Sstatic inline boolean isDigit(int c) { return ( isdigit (c) == 0 ? false : true); }
N#else
N#ifndef	WCharacter_C
Nboolean isDigit(int c);
N#else
Sboolean isDigit(int c) { return ( isdigit (c) == 0 ? false : true); }
N#endif
N#endif
N
N
N/*******************************************************************************
N * Checks for any printable character except space.
N */
N#ifdef	_INLINE
Sstatic inline boolean isGraph(int c) { return ( isgraph (c) == 0 ? false : true); }
N#else
N#ifndef	WCharacter_C
Nboolean isGraph(int c);
N#else
Sboolean isGraph(int c) { return ( isgraph (c) == 0 ? false : true); }
N#endif
N#endif
N
N
N/*******************************************************************************
N * Checks for a lower-case character.
N */
N#ifdef	_INLINE
Sstatic inline boolean isLowerCase(int c) { return (islower (c) == 0 ? false : true); }
N#else
N#ifndef	WCharacter_C
Nboolean isLowerCase(int c);
N#else
Sboolean isLowerCase(int c) { return (islower (c) == 0 ? false : true); }
N#endif
N#endif
N
N/*******************************************************************************
N * Checks for any printable character including space.
N */
N#ifdef	_INLINE
Sstatic inline boolean isPrintable(int c) { return ( isprint (c) == 0 ? false : true); }
N#else
N#ifndef	WCharacter_C
Nboolean isPrintable(int c);
N#else
Sboolean isPrintable(int c) { return ( isprint (c) == 0 ? false : true); }
N#endif
N#endif
N
N/*******************************************************************************
N * Checks for any printable character which is not a space
N * or an alphanumeric character.
N */
N#ifdef	_INLINE
Sstatic inline boolean isPunct(int c) { return ( ispunct (c) == 0 ? false : true); }
N#else
N#ifndef	WCharacter_C
Nboolean isPunct(int c);
N#else
Sboolean isPunct(int c) { return ( ispunct (c) == 0 ? false : true); }
N#endif
N#endif
N
N/*******************************************************************************
N * Checks for white-space characters. For the avr-libc library,
N * these are: space, formfeed ('\f'), newline ('\n'), carriage
N * return ('\r'), horizontal tab ('\t'), and vertical tab ('\v').
N */
N#ifdef	_INLINE
Sstatic inline boolean isSpace(int c) { return ( isspace (c) == 0 ? false : true); }
N#else
N#ifndef	WCharacter_C
Nboolean isSpace(int c);
N#else
Sboolean isSpace(int c) { return ( isspace (c) == 0 ? false : true); }
N#endif
N#endif
N
N/*******************************************************************************
N * Checks for an uppercase letter.
N */
N#ifdef	_INLINE
Sstatic inline boolean isUpperCase(int c) { return ( isupper (c) == 0 ? false : true); }
N#else
N#ifndef	WCharacter_C
Nboolean isUpperCase(int c);
N#else
Sboolean isUpperCase(int c) { return ( isupper (c) == 0 ? false : true); }
N#endif
N#endif
N
N/*******************************************************************************
N * Checks for a hexadecimal digits, i.e. one of 0 1 2 3 4 5 6 7
N * 8 9 a b c d e f A B C D E F.
N */
N#ifdef	_INLINE
Sstatic inline boolean isHexadecimalDigit(int c) { return ( isxdigit (c) == 0 ? false : true); }
N#else
N#ifndef	WCharacter_C
Nboolean isHexadecimalDigit(int c);
N#else
Sboolean isHexadecimalDigit(int c) { return ( isxdigit (c) == 0 ? false : true); }
N#endif
N#endif
N
N/*******************************************************************************
N * Converts c to a 7-bit unsigned char value that fits into the
N * ASCII character set, by clearing the high-order bits.
N */
N#ifdef	_INLINE
Sstatic inline int scii(int c) { return toascii (c); }
N#else
N#ifndef	WCharacter_C
Nint scii(int c);
N#else
Sint scii(int c) { return toascii (c); }
N#endif
N#endif
N
N/*******************************************************************************
N * Converts the letter c to lower case, if possible.
N * Warning:
N * Many people will be unhappy if you use this function.
N * This function will convert accented letters into random
N * characters.
N *
N */
N#ifdef	_INLINE
Sstatic inline int owerCase(int c) { return tolower (c); }
N#else
N#ifndef	WCharacter_C
Nint owerCase(int c);
N#else
Sint owerCase(int c) { return tolower (c); }
N#endif
N#endif
N
N/*******************************************************************************
N * Converts the letter c to upper case, if possible.
N */
N#ifdef	_INLINE
Sstatic inline int toUpperCase(int c) { return toupper (c); }
N#else
N#ifndef	WCharacter_C
Nint toUpperCase(int c);
N#else
Sint toUpperCase(int c) { return toupper (c); }
N#endif
N#endif
N
N
N#else
S// WCharacter.h prototypes
Sinline boolean isAlphaNumeric(int c) __attribute__((always_inline));
Sinline boolean isAlpha(int c) __attribute__((always_inline));
Sinline boolean isAscii(int c) __attribute__((always_inline));
Sinline boolean isWhitespace(int c) __attribute__((always_inline));
Sinline boolean isControl(int c) __attribute__((always_inline));
Sinline boolean isDigit(int c) __attribute__((always_inline));
Sinline boolean isGraph(int c) __attribute__((always_inline));
Sinline boolean isLowerCase(int c) __attribute__((always_inline));
Sinline boolean isPrintable(int c) __attribute__((always_inline));
Sinline boolean isPunct(int c) __attribute__((always_inline));
Sinline boolean isSpace(int c) __attribute__((always_inline));
Sinline boolean isUpperCase(int c) __attribute__((always_inline));
Sinline boolean isHexadecimalDigit(int c) __attribute__((always_inline));
Sinline int toAscii(int c) __attribute__((always_inline));
Sinline int toLowerCase(int c) __attribute__((always_inline));
Sinline int toUpperCase(int c)__attribute__((always_inline));
S
S
S// Checks for an alphanumeric character.
S// It is equivalent to (isalpha(c) || isdigit(c)).
Sinline boolean isAlphaNumeric(int c)
S{
S  return ( isalnum(c) == 0 ? false : true);
S}
S
S
S// Checks for an alphabetic character.
S// It is equivalent to (isupper(c) || islower(c)).
Sinline boolean isAlpha(int c)
S{
S  return ( isalpha(c) == 0 ? false : true);
S}
S
S
S// Checks whether c is a 7-bit unsigned char value
S// that fits into the ASCII character set.
Sinline boolean isAscii(int c)
S{
S  return ( isascii (c) == 0 ? false : true);
S}
S
S
S// Checks for a blank character, that is, a space or a tab.
Sinline boolean isWhitespace(int c)
S{
S  return ( isblank (c) == 0 ? false : true);
S}
S
S
S// Checks for a control character.
Sinline boolean isControl(int c)
S{
S  return ( iscntrl (c) == 0 ? false : true);
S}
S
S
S// Checks for a digit (0 through 9).
Sinline boolean isDigit(int c)
S{
S  return ( isdigit (c) == 0 ? false : true);
S}
S
S
S// Checks for any printable character except space.
Sinline boolean isGraph(int c)
S{
S  return ( isgraph (c) == 0 ? false : true);
S}
S
S
S// Checks for a lower-case character.
Sinline boolean isLowerCase(int c)
S{
S  return (islower (c) == 0 ? false : true);
S}
S
S
S// Checks for any printable character including space.
Sinline boolean isPrintable(int c)
S{
S  return ( isprint (c) == 0 ? false : true);
S}
S
S
S// Checks for any printable character which is not a space
S// or an alphanumeric character.
Sinline boolean isPunct(int c)
S{
S  return ( ispunct (c) == 0 ? false : true);
S}
S
S
S// Checks for white-space characters. For the avr-libc library,
S// these are: space, formfeed ('\f'), newline ('\n'), carriage
S// return ('\r'), horizontal tab ('\t'), and vertical tab ('\v').
Sinline boolean isSpace(int c)
S{
S  return ( isspace (c) == 0 ? false : true);
S}
S
S
S// Checks for an uppercase letter.
Sinline boolean isUpperCase(int c)
S{
S  return ( isupper (c) == 0 ? false : true);
S}
S
S
S// Checks for a hexadecimal digits, i.e. one of 0 1 2 3 4 5 6 7
S// 8 9 a b c d e f A B C D E F.
Sinline boolean isHexadecimalDigit(int c)
S{
S  return ( isxdigit (c) == 0 ? false : true);
S}
S
S
S// Converts c to a 7-bit unsigned char value that fits into the
S// ASCII character set, by clearing the high-order bits.
Sinline int toAscii(int c)
S{
S  return toascii (c);
S}
S
S
S// Warning:
S// Many people will be unhappy if you use this function.
S// This function will convert accented letters into random
S// characters.
S
S// Converts the letter c to lower case, if possible.
Sinline int toLowerCase(int c)
S{
S  return tolower (c);
S}
S
S
S// Converts the letter c to upper case, if possible.
Sinline int toUpperCase(int c)
S{
S  return toupper (c);
S}
N#endif
N
N#endif
L 22 "D:/project/fpalette/ccs4/fpalette/ide_led/src/cores/WProgram.h" 2
N//#include "WString.h"
N//#include "HardwareSerial.h"	//mimutodo
N
Nuint16_t makeWord(uint16_t w);
Nuint16_t makeWord(byte h, byte l);
N
N//#define word(...) makeWord(__VA_ARGS__)	// mimutodo
N
Nunsigned long pulseIn(uint8_t pin, uint8_t state, unsigned long timeout = 1000000L);
N
Nvoid tone(uint8_t _pin, unsigned int frequency, unsigned long duration = 0);
Nvoid noTone(uint8_t _pin);
N
N/* WMath prototypes */
Nlong random(long);
Nlong random(long, long);
Nvoid randomSeed(unsigned int);
Nlong map(long, long, long, long, long);
N
N//#if defined(__AVR_ATmega1280__) || defined(__AVR_ATmega2560__)	mimutodo
N//const static uint8_t A0 = 54;										mimutodo
N//const static uint8_t A1 = 55;										mimutodo
N//const static uint8_t A2 = 56;										mimutodo
N//const static uint8_t A3 = 57;										mimutodo
N//const static uint8_t A4 = 58;										mimutodo
N//const static uint8_t A5 = 59;										mimutodo
N//const static uint8_t A6 = 60;										mimutodo
N//const static uint8_t A7 = 61;										mimutodo
N//const static uint8_t A8 = 62;										mimutodo
N//const static uint8_t A9 = 63;										mimutodo
N//const static uint8_t A10 = 64;									mimutodo
N//const static uint8_t A11 = 65;									mimutodo
N//const static uint8_t A12 = 66;									mimutodo
N//const static uint8_t A13 = 67;									mimutodo
N//const static uint8_t A14 = 68;									mimutodo
N//const static uint8_t A15 = 69;									mimutodo
N//#else																mimutodo
N//const static uint8_t A0 = 14;										mimutodo
N//const static uint8_t A1 = 15;										mimutodo
N//const static uint8_t A2 = 16;										mimutodo
N//const static uint8_t A3 = 17;										mimutodo
N//const static uint8_t A4 = 18;										mimutodo
N//const static uint8_t A5 = 19;										mimutodo
N//const static uint8_t A6 = 20;										mimutodo
N//const static uint8_t A7 = 21;										mimutodo
N//#endif
N
N#endif
N
N#endif
L 259 "../src/Blink.cpp" 2
N#include "HardwareSerial.h"
L 1 "D:/project/fpalette/ccs4/fpalette/ide_led/src/cores/HardwareSerial.h" 1
N/*
N  HardwareSerial.h - Hardware serial library for Wiring
N  Copyright (c) 2006 Nicholas Zambetti.  All right reserved.
N
N  This library is free software; you can redistribute it and/or
N  modify it under the terms of the GNU Lesser General Public
N  License as published by the Free Software Foundation; either
N  version 2.1 of the License, or (at your option) any later version.
N
N  This library is distributed in the hope that it will be useful,
N  but WITHOUT ANY WARRANTY; without even the implied warranty of
N  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
N  Lesser General Public License for more details.
N
N  You should have received a copy of the GNU Lesser General Public
N  License along with this library; if not, write to the Free Software
N  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
N
N  Modified 28 September 2010 by Mark Sproul
N*/
N
N#ifndef HardwareSerial_h
N#define HardwareSerial_h
N
N#include <inttypes.h>
L 1 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/inttypes.h" 1
N/*****************************************************************************/
N/* INTTYPES.H v5.2.6                                                         */
N/* Copyright (c) 2002-2010 Texas Instruments Incorporated                    */
N/*****************************************************************************/
N#ifndef _INTTYPES_H_
N#define _INTTYPES_H_
N
N#include <stdint.h>
N
N/* 7.8 Format conversion of integer types */
N
Ntypedef struct { intmax_t quot, rem; } imaxdiv_t;
N
N/* 
N   According to footnotes in the 1999 C standard, "C++ implementations
N   should define these macros only when __STDC_FORMAT_MACROS is defined
N   before <inttypes.h> is included." 
N*/
N#if !defined(__cplusplus) || defined(__STDC_FORMAT_MACROS)
X#if !1L || 0L
S#include "_fmt_specifier.h"
N#endif /* !defined(__cplusplus) || defined(__STDC_FORMAT_MACROS) */
N
N/* 7.8.2 Functions for greatest-width integer types */
N#include <linkage.h>
N
N_CODE_ACCESS intmax_t  imaxabs(intmax_t j);
X intmax_t  imaxabs(intmax_t j);
N_CODE_ACCESS imaxdiv_t imaxdiv(intmax_t numer, intmax_t denom);
X imaxdiv_t imaxdiv(intmax_t numer, intmax_t denom);
N_CODE_ACCESS intmax_t  strtoimax(const char * restrict nptr, 
X intmax_t  strtoimax(const char * restrict nptr, 
N		    char ** restrict endptr, int base);
N_CODE_ACCESS uintmax_t strtoumax(const char * restrict nptr, 
X uintmax_t strtoumax(const char * restrict nptr, 
N		    char ** restrict endptr, int base);
N
N#endif /* _INTTYPES_H_ */
L 26 "D:/project/fpalette/ccs4/fpalette/ide_led/src/cores/HardwareSerial.h" 2
N
N#include "Stream.h"
L 1 "D:\project\fpalette\ccs4\fpalette\ide_led\src\cores\Stream.h" 1
N/*
N  Stream.h - base class for character-based streams.
N  Copyright (c) 2010 David A. Mellis.  All right reserved.
N
N  This library is free software; you can redistribute it and/or
N  modify it under the terms of the GNU Lesser General Public
N  License as published by the Free Software Foundation; either
N  version 2.1 of the License, or (at your option) any later version.
N
N  This library is distributed in the hope that it will be useful,
N  but WITHOUT ANY WARRANTY; without even the implied warranty of
N  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
N  Lesser General Public License for more details.
N
N  You should have received a copy of the GNU Lesser General Public
N  License along with this library; if not, write to the Free Software
N  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
N*/
N
N#ifndef Stream_h
N#define Stream_h
N
N#include <inttypes.h>
N#include "Print.h"
L 1 "D:\project\fpalette\ccs4\fpalette\ide_led\src\cores\Print.h" 1
N/*
N  Print.h - Base class that provides print() and println()
N  Copyright (c) 2008 David A. Mellis.  All right reserved.
N
N  This library is free software; you can redistribute it and/or
N  modify it under the terms of the GNU Lesser General Public
N  License as published by the Free Software Foundation; either
N  version 2.1 of the License, or (at your option) any later version.
N
N  This library is distributed in the hope that it will be useful,
N  but WITHOUT ANY WARRANTY; without even the implied warranty of
N  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
N  Lesser General Public License for more details.
N
N  You should have received a copy of the GNU Lesser General Public
N  License along with this library; if not, write to the Free Software
N  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
N*/
N
N#ifndef Print_h
N#define Print_h
N
N#include <inttypes.h>
N#include <stdio.h> // for size_t
L 1 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/stdio.h" 1
N/*****************************************************************************/
N/* STDIO.H v5.2.6                                                            */
N/* Copyright (c) 1993-2010 Texas Instruments Incorporated                    */
N/*****************************************************************************/
N#ifndef _STDIO 
N#define _STDIO
N
N#include <linkage.h>
N#include <stdarg.h>
L 1 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/stdarg.h" 1
N/*****************************************************************************/
N/* stdarg.h   v5.2.6                                                         */
N/* Copyright (c) 1996-2010 Texas Instruments Incorporated                    */
N/*****************************************************************************/
N
N#ifndef _STDARG
N#define _STDARG
N
N#include <linkage.h>
N
N#ifdef __cplusplus
N#define va_start(ap, parmN) (ap = ((std::va_list)__va_parmadr(parmN)))
Nnamespace std {
N#else
S#define va_start(ap, parmN) (ap = ((va_list)__va_parmadr(parmN)))
N#endif /* __cplusplus */
N
Ntypedef char *va_list;
N
N#ifdef __cplusplus
N} /* namespace std */
N#endif
N
N#define va_end(ap)
N
N/****************************************************************************/
N/* RETURN THE NEXT VALUE ON THE STACK ...                                   */
N/*                                                                          */
N/* (<advance ap>, <access the value>) BECOMES ...                           */
N/*                                                                          */
N/* ap -= 1 (stack grows toward high addresses)                              */
N/* ap -= 1 more if type is long or float                                    */
N/* ap -= 1 more if type is long or float and to account for alignment       */
N/*       if necessary                                                       */
N/*                                                                          */
N/* if      (<type is passed by address [struct or union]>) return **ap;     */
N/* else if (<type is integer size>)                        return *ap;      */
N/*                                                                          */
N/* LONG/FLOATS ARE ALWAYS ALIGNED ON AN EVEN WORD BOUNDARY, EVEN WHEN       */
N/* PASSED AS PARAMETERS, THUS ap MUST BE ALIGNED FOR THOSE ACCESSES.        */
N/****************************************************************************/
N#if __LARGE_MODEL__
X#if 1
N#define va_arg(ap, type)                                                 \
N( (ap -= 1 + (__va_argref(type) ? (((long)ap & 1) ? 2 : 1) :		 \
N				  (sizeof(type) == sizeof(int)) ? 0 :    \
N                                   ((long)ap & 1) ? sizeof(type) :       \
N                                                    sizeof(type) - 1 )), \
N   (__va_argref(type)             ? (** (type **) (ap)) : (* (type *) (ap)) ))
X#define va_arg(ap, type)                                                 ( (ap -= 1 + (__va_argref(type) ? (((long)ap & 1) ? 2 : 1) :		 				  (sizeof(type) == sizeof(int)) ? 0 :                                       ((long)ap & 1) ? sizeof(type) :                                                           sizeof(type) - 1 )),    (__va_argref(type)             ? (** (type **) (ap)) : (* (type *) (ap)) ))
N#else
S#define va_arg(ap, type)                                                 \
S( (ap -= 1 + (__va_argref(type) ? (((int)ap & 1) ? 2 : 1) : 		 \
S				  (sizeof(type) == sizeof(int)) ? 0 :    \
S                                   ((int)ap & 1) ? sizeof(type)      :   \
S                                                   sizeof(type) - 1 )),  \
S   (__va_argref(type)             ? (** (type **) (ap)) : (* (type *) (ap)) ))
X#define va_arg(ap, type)                                                 ( (ap -= 1 + (__va_argref(type) ? (((int)ap & 1) ? 2 : 1) : 		 				  (sizeof(type) == sizeof(int)) ? 0 :                                       ((int)ap & 1) ? sizeof(type)      :                                                      sizeof(type) - 1 )),     (__va_argref(type)             ? (** (type **) (ap)) : (* (type *) (ap)) ))
N#endif
N
N#endif /* _STDARG */
N
N#if defined(__cplusplus) && !defined(_CPP_STYLE_HEADER)
X#if 1L && !0L
Nusing std::va_list;
N#endif /* _CPP_STYLE_HEADER */
N
L 10 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/stdio.h" 2
N
N
N#ifdef __cplusplus
N//----------------------------------------------------------------------------
N// <cstdio> IS RECOMMENDED OVER <stdio.h>.  <stdio.h> IS PROVIDED FOR
N// COMPATIBILITY WITH C AND THIS USAGE IS DEPRECATED IN C++
N//----------------------------------------------------------------------------
Nextern "C" namespace std {
N#endif
N
N/****************************************************************************/
N/* TYPES THAT ANSI REQUIRES TO BE DEFINED                                   */
N/****************************************************************************/
N#ifndef _SIZE_T
S#define _SIZE_T
Stypedef __SIZE_T_TYPE__ size_t;
N#endif
N
Ntypedef struct {
N      int fd;                    /* File descriptor */
N      unsigned char* buf;        /* Pointer to start of buffer */
N      unsigned char* pos;        /* Position in buffer */
N      unsigned char* bufend;     /* Pointer to end of buffer */
N      unsigned char* buff_stop;  /* Pointer to last read char in buffer */
N      unsigned int   flags;      /* File status flags (see below) */
N} FILE;
N
N#ifndef _FPOS_T
N#define _FPOS_T
Ntypedef long fpos_t;
N#endif /* _FPOS_T */
N
N/****************************************************************************/
N/* DEVICE AND STREAM RELATED MACROS                                         */
N/****************************************************************************/
N/****************************************************************************/
N/* MACROS THAT DEFINE AND USE FILE STATUS FLAGS                             */
N/****************************************************************************/
N
N#define _IOFBF       0x0001
N#define _IOLBF       0x0002
N#define _IONBF       0x0004
N#define _BUFFALOC    0x0008
N#define _MODER       0x0010
N#define _MODEW       0x0020
N#define _MODERW      0x0040
N#define _MODEA       0x0080
N#define _MODEBIN     0x0100
N#define _STATEOF     0x0200
N#define _STATERR     0x0400
N#define _UNGETC      0x0800
N#define _TMPFILE     0x1000
N
N#define _SET(_fp, _b)      (((_fp)->flags) |= (_b))
N#define _UNSET(_fp, _b)    (((_fp)->flags) &= ~(_b))
N#define _STCHK(_fp, _b)    (((_fp)->flags) & (_b))
N#define _BUFFMODE(_fp)     (((_fp)->flags) & (_IOFBF | _IOLBF | _IONBF))
N#define _ACCMODE(_fp)      (((_fp)->flags) & (_MODER | _MODEW))
N
N/****************************************************************************/
N/* MACROS THAT ANSI REQUIRES TO BE DEFINED                                  */
N/****************************************************************************/
N#define BUFSIZ          256 
N
N#define FOPEN_MAX       _NFILE
N#define FILENAME_MAX    256  
N#define TMP_MAX         65535
N
N#define stdin     (&_ftable[0])      
N#define stdout    (&_ftable[1])
N#define stderr    (&_ftable[2])
N
N#define L_tmpnam  _LTMPNAM
N
N
N#define SEEK_SET  (0x0000)
N#define SEEK_CUR  (0x0001)
N#define SEEK_END  (0x0002)
N
N#ifndef NULL
S#define NULL 0
N#endif
N
N#ifndef EOF
N#define EOF    (-1)
N#endif
N
N
N/******** END OF ANSI MACROS ************************************************/
N
N#define P_tmpdir        ""                   /* Path for temp files         */
N
N/****************************************************************************/
N/* DEVICE AND STREAM RELATED DATA STRUCTURES AND MACROS                     */
N/****************************************************************************/
N#define _NFILE           10                   /* Max number of files open   */
N#define _LTMPNAM         16                   /* Length of temp name        */
N
Nextern _DATA_ACCESS FILE _ftable[_NFILE];
Xextern  FILE _ftable[10];
Nextern _DATA_ACCESS char _tmpnams[_NFILE][_LTMPNAM];
Xextern  char _tmpnams[10][16];
N
N/****************************************************************************/
N/*   FUNCTION DEFINITIONS  - ANSI                                           */
N/****************************************************************************/
N/****************************************************************************/
N/* OPERATIONS ON FILES                                                      */
N/****************************************************************************/
Nextern _CODE_ACCESS int     remove(const char *_file);
Xextern  int     remove(const char *_file);
Nextern _CODE_ACCESS int     rename(const char *_old, const char *_new);
Xextern  int     rename(const char *_old, const char *_new);
Nextern _CODE_ACCESS FILE   *tmpfile(void);
Xextern  FILE   *tmpfile(void);
Nextern _CODE_ACCESS char   *tmpnam(char *_s);
Xextern  char   *tmpnam(char *_s);
N
N/****************************************************************************/
N/* FILE ACCESS FUNCTIONS                                                    */
N/****************************************************************************/
Nextern _CODE_ACCESS int     fclose(FILE *_fp); 
Xextern  int     fclose(FILE *_fp); 
Nextern _CODE_ACCESS FILE   *fopen(const char *_fname, const char *_mode);
Xextern  FILE   *fopen(const char *_fname, const char *_mode);
Nextern _CODE_ACCESS FILE   *freopen(const char *_fname, const char *_mode,
Xextern  FILE   *freopen(const char *_fname, const char *_mode,
N			            register FILE *_fp);
Nextern _CODE_ACCESS void    setbuf(register FILE *_fp, char *_buf);
Xextern  void    setbuf(register FILE *_fp, char *_buf);
Nextern _CODE_ACCESS int     setvbuf(register FILE *_fp, register char *_buf, 
Xextern  int     setvbuf(register FILE *_fp, register char *_buf, 
N			            register int _type, register size_t _size);
Nextern _CODE_ACCESS int     fflush(register FILE *_fp); 
Xextern  int     fflush(register FILE *_fp); 
N
N/****************************************************************************/
N/* FORMATTED INPUT/OUTPUT FUNCTIONS                                         */
N/****************************************************************************/
Nextern _CODE_ACCESS int fprintf(FILE *_fp, const char *_format, ...);
Xextern  int fprintf(FILE *_fp, const char *_format, ...);
Nextern _CODE_ACCESS int fscanf(FILE *_fp, const char *_fmt, ...);
Xextern  int fscanf(FILE *_fp, const char *_fmt, ...);
Nextern _CODE_ACCESS int printf(const char *_format, ...);
Xextern  int printf(const char *_format, ...);
Nextern _CODE_ACCESS int scanf(const char *_fmt, ...);
Xextern  int scanf(const char *_fmt, ...);
Nextern _CODE_ACCESS int sprintf(char *_string, const char *_format, ...);
Xextern  int sprintf(char *_string, const char *_format, ...);
Nextern _CODE_ACCESS int snprintf(char *_string, size_t _n, 
Xextern  int snprintf(char *_string, size_t _n, 
N				 const char *_format, ...);
Nextern _CODE_ACCESS int sscanf(const char *_str, const char *_fmt, ...);
Xextern  int sscanf(const char *_str, const char *_fmt, ...);
Nextern _CODE_ACCESS int vfprintf(FILE *_fp, const char *_format, va_list _ap);
Xextern  int vfprintf(FILE *_fp, const char *_format, va_list _ap);
Nextern _CODE_ACCESS int vprintf(const char *_format, va_list _ap);
Xextern  int vprintf(const char *_format, va_list _ap);
Nextern _CODE_ACCESS int vsprintf(char *_string, const char *_format,
Xextern  int vsprintf(char *_string, const char *_format,
N				 va_list _ap);
Nextern _CODE_ACCESS int vsnprintf(char *_string, size_t _n, 
Xextern  int vsnprintf(char *_string, size_t _n, 
N				  const char *_format, va_list _ap);
N
N/****************************************************************************/
N/* CHARACTER INPUT/OUTPUT FUNCTIONS                                         */
N/****************************************************************************/
Nextern _CODE_ACCESS int     fgetc(register FILE *_fp);
Xextern  int     fgetc(register FILE *_fp);
Nextern _CODE_ACCESS char   *fgets(char *_ptr, register int _size,
Xextern  char   *fgets(char *_ptr, register int _size,
N				  register FILE *_fp);
Nextern _CODE_ACCESS int     fputc(int _c, register FILE *_fp);
Xextern  int     fputc(int _c, register FILE *_fp);
Nextern _CODE_ACCESS int     fputs(const char *_ptr, register FILE *_fp);
Xextern  int     fputs(const char *_ptr, register FILE *_fp);
Nextern _CODE_ACCESS int     getc(FILE *_p);
Xextern  int     getc(FILE *_p);
Nextern _CODE_ACCESS int     getchar(void);
Xextern  int     getchar(void);
Nextern _CODE_ACCESS char   *gets(char *_ptr); 
Xextern  char   *gets(char *_ptr); 
Nextern _CODE_ACCESS int     putc(int _x, FILE *_fp);
Xextern  int     putc(int _x, FILE *_fp);
Nextern _CODE_ACCESS int     putchar(int _x);
Xextern  int     putchar(int _x);
Nextern _CODE_ACCESS int     puts(const char *_ptr); 
Xextern  int     puts(const char *_ptr); 
Nextern _CODE_ACCESS int     ungetc(int _c, register FILE *_fp);
Xextern  int     ungetc(int _c, register FILE *_fp);
N
N/****************************************************************************/
N/* DIRECT INPUT/OUTPUT FUNCTIONS                                            */
N/****************************************************************************/
Nextern _CODE_ACCESS size_t  fread(void *_ptr, size_t _size, size_t _count,
Xextern  size_t  fread(void *_ptr, size_t _size, size_t _count,
N				  FILE *_fp);
Nextern _CODE_ACCESS size_t  fwrite(const void *_ptr, size_t _size,
Xextern  size_t  fwrite(const void *_ptr, size_t _size,
N				   size_t _count, register FILE *_fp); 
N
N/****************************************************************************/
N/* FILE POSITIONING FUNCTIONS                                               */
N/****************************************************************************/
Nextern _CODE_ACCESS int     fgetpos(FILE *_fp, fpos_t *_pos);
Xextern  int     fgetpos(FILE *_fp, fpos_t *_pos);
Nextern _CODE_ACCESS int     fseek(register FILE *_fp, long _offset,
Xextern  int     fseek(register FILE *_fp, long _offset,
N				  int _ptrname);
Nextern _CODE_ACCESS int     fsetpos(FILE *_fp, const fpos_t *_pos);
Xextern  int     fsetpos(FILE *_fp, const fpos_t *_pos);
Nextern _CODE_ACCESS long    ftell(FILE *_fp);
Xextern  long    ftell(FILE *_fp);
Nextern _CODE_ACCESS void    rewind(register FILE *_fp); 
Xextern  void    rewind(register FILE *_fp); 
N
N/****************************************************************************/
N/* ERROR-HANDLING FUNCTIONS                                                 */
N/****************************************************************************/
Nextern _CODE_ACCESS void    clearerr(FILE *_fp);
Xextern  void    clearerr(FILE *_fp);
Nextern _CODE_ACCESS int     feof(FILE *_fp);
Xextern  int     feof(FILE *_fp);
Nextern _CODE_ACCESS int     ferror(FILE *_fp);
Xextern  int     ferror(FILE *_fp);
Nextern _CODE_ACCESS void    perror(const char *_s);
Xextern  void    perror(const char *_s);
N
N#define _getchar()      getc(stdin)
N#define _putchar(_x)    putc((_x), stdout)
N#define _clearerr(_fp)   ((void) ((_fp)->flags &= ~(_STATERR | _STATEOF)))
N
N#define _ferror(_x)     ((_x)->flags & _STATERR)
N
N#define _remove(_fl)    (unlink((_fl)))
N
N#ifdef __cplusplus
N} /* extern "C" namespace std */
N#endif  /* __cplusplus */
N
N#endif  /* #ifndef _STDIO */
N
N#if defined(__cplusplus) && !defined(_CPP_STYLE_HEADER)
X#if 1L && !0L
Nusing std::size_t;
Nusing std::FILE;
Nusing std::fpos_t;
Nusing std::_ftable;
Nusing std::_tmpnams;
Nusing std::remove;
Nusing std::rename;
Nusing std::tmpfile;
Nusing std::tmpnam;
Nusing std::fclose;
Nusing std::fopen;
Nusing std::freopen;
Nusing std::setbuf;
Nusing std::setvbuf;
Nusing std::fflush;
Nusing std::fprintf;
Nusing std::fscanf;
Nusing std::printf;
Nusing std::scanf;
Nusing std::sprintf;
Nusing std::sscanf;
Nusing std::vfprintf;
Nusing std::vprintf;
Nusing std::vsprintf;
Nusing std::fgetc;
Nusing std::fgets;
Nusing std::fputc;
Nusing std::fputs;
Nusing std::getc;
Nusing std::getchar;
Nusing std::gets;
Nusing std::putc;
Nusing std::putchar;
Nusing std::puts;
Nusing std::ungetc;
Nusing std::fread;
Nusing std::fwrite;
Nusing std::fgetpos;
Nusing std::fseek;
Nusing std::fsetpos;
Nusing std::ftell;
Nusing std::rewind;
Nusing std::clearerr;
Nusing std::feof;
Nusing std::ferror;
Nusing std::perror;
N
N#endif  /* _CPP_STYLE_HEADER */
N
N
L 25 "D:\project\fpalette\ccs4\fpalette\ide_led\src\cores\Print.h" 2
N
N#include "f_types.h"
N#include "WString.h"
L 1 "D:\project\fpalette\ccs4\fpalette\ide_led\src\cores\WString.h" 1
N/*
N  WString.h - String library for Wiring & Arduino
N  Copyright (c) 2009-10 Hernando Barragan.  All right reserved.
N
N  This library is free software; you can redistribute it and/or
N  modify it under the terms of the GNU Lesser General Public
N  License as published by the Free Software Foundation; either
N  version 2.1 of the License, or (at your option) any later version.
N
N  This library is distributed in the hope that it will be useful,
N  but WITHOUT ANY WARRANTY; without even the implied warranty of
N  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
N  Lesser General Public License for more details.
N
N  You should have received a copy of the GNU Lesser General Public
N  License along with this library; if not, write to the Free Software
N  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
N*/
N
N#ifndef String_h
N#define String_h
N
N//#include "WProgram.h"
N#include <stdlib.h>
L 1 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/stdlib.h" 1
N/*****************************************************************************/
N/* stdlib.h   v5.2.6                                                         */
N/* Copyright (c) 1993-2010 Texas Instruments Incorporated                    */
N/*****************************************************************************/
N
N#ifndef _STDLIB
S#define _STDLIB
S
S
S#ifdef __cplusplus
S//----------------------------------------------------------------------------
S// <cstdlib> IS RECOMMENDED OVER <stdlib.h>.  <stdlib.h> IS PROVIDED FOR 
S// COMPATIBILITY WITH C AND THIS USAGE IS DEPRECATED IN C++
S//----------------------------------------------------------------------------
Sextern "C" namespace std {
S#endif /* !__cplusplus */
S
Stypedef struct { int quot, rem; } div_t;
S
Stypedef struct { long quot, rem; } ldiv_t;
S
S#define _LLONG_AVAILABLE 1
Stypedef struct { long long quot, rem; } lldiv_t;
S
S#define MB_CUR_MAX    1
S
S#ifndef NULL
S#define NULL          0
S#endif
S
S#ifndef _SIZE_T
S#define _SIZE_T
Stypedef __SIZE_T_TYPE__ size_t;
S#endif
S
S#ifndef __cplusplus
S#ifndef _WCHAR_T
S#define _WCHAR_T
Stypedef __WCHAR_T_TYPE__ wchar_t;
S#endif
S#endif
S
S#define EXIT_FAILURE  1
S#define EXIT_SUCCESS  0
S
S#define RAND_MAX      32767
S
S#include <linkage.h>
S
S/*---------------------------------------------------------------*/
S/* NOTE - Normally, abs, labs, and fabs are expanded inline, so  */
S/*        no formal definition is really required. However, ANSI */
S/*        requires that they exist as separate functions, so     */
S/*        they are supplied in the library.  The prototype is    */
S/*        here mainly for documentation.                         */
S/*---------------------------------------------------------------*/
S    _CODE_ACCESS  int       abs(int _val); 
S    _CODE_ACCESS  long      labs(long _val);
S#if defined(_LLONG_AVAILABLE)
S    _CODE_ACCESS  long long llabs(long long _val);
S#endif
S    _CODE_ACCESS int       atoi(const char *_st);
S    _CODE_ACCESS long      atol(const char *_st);
S#if defined(_LLONG_AVAILABLE)
S    _CODE_ACCESS long long atoll(const char *_st);
S#endif
S    _CODE_ACCESS int       ltoa(long val, char *buffer);
S          _IDECL double    atof(const char *_st);
S
S    _CODE_ACCESS long      strtol(const char *_st, char **_endptr, int _base);
S    _CODE_ACCESS unsigned long strtoul(const char *_st, char **_endptr,
S    					  int _base);
S#if defined(_LLONG_AVAILABLE)
S    _CODE_ACCESS long long strtoll(const char *_st, char **_endptr, int _base);
S    _CODE_ACCESS unsigned long long strtoull(const char *_st, char **_endptr,
S					     int _base);
S#endif
S    _CODE_ACCESS double    strtod(const char *_st, char **_endptr);
S    _CODE_ACCESS long double strtold(const char *_st, char **_endptr);
S    
S    _CODE_ACCESS int    rand(void);
S    _CODE_ACCESS void   srand(unsigned _seed);
S    
S    _CODE_ACCESS void  *calloc(size_t _num, size_t _size);
S    _CODE_ACCESS void  *malloc(size_t _size);
S    _CODE_ACCESS void  *realloc(void *_ptr, size_t _size);
S    _CODE_ACCESS void   free(void *_ptr);
S    _CODE_ACCESS void  *memalign(size_t _aln, size_t _size);
S    
S    _CODE_ACCESS void   abort(void); 
S    _CODE_ACCESS int    atexit(void (*_func)(void));
S    _CODE_ACCESS void  *bsearch(const void *_key, const void *_base,
S    				   size_t _nmemb, size_t _size, 
S    			           int (*compar)(const void *,const void *));
S    _CODE_ACCESS void   qsort(void *_base, size_t _nmemb, size_t _size, 
S    			         int (*_compar)(const void *, const void *));
S    _CODE_ACCESS void   exit(int _status);
S    
S    _CODE_ACCESS div_t  div(int _numer, int _denom);
S    _CODE_ACCESS ldiv_t ldiv(long _numer, long _denom);
S#if defined(_LLONG_AVAILABLE)
S    _CODE_ACCESS lldiv_t lldiv(long long _numer, long long _denom);
S#endif
S
S    _CODE_ACCESS char  *getenv(const char *_string);
S    _CODE_ACCESS int    system(const char *_name);
S
S    _CODE_ACCESS int    mblen(const char *, size_t);
S    _CODE_ACCESS size_t mbstowcs(wchar_t *, const char *, size_t);
S    _CODE_ACCESS int    mbtowc(wchar_t *, const char *, size_t);
S
S    _CODE_ACCESS size_t wcstombs(char *, const wchar_t *, size_t);
S    _CODE_ACCESS int    wctomb(char *, wchar_t);
S
S#ifdef __cplusplus
S} /* extern "C" namespace std */
S#endif /* __cplusplus */
S
S
S#ifdef _INLINE
S
S#ifdef __cplusplus
Snamespace std {
S#endif
S
Sstatic __inline double atof(const char *_st) 
S{
S  return strtod(_st, (char **)0); 
S}
S
S#ifdef __cplusplus
S} /* namespace std */
S#endif
S
S#endif  /* _INLINE */
S
N#endif  /* ! _STDLIB */
N
N#if defined(__cplusplus) && !defined(_CPP_STYLE_HEADER)
X#if 1L && !0L
Nusing std::div_t;
Nusing std::ldiv_t;
N#if defined(_LLONG_AVAILABLE)
X#if 1L
Nusing std::lldiv_t;
N#endif
Nusing std::size_t;
Nusing std::abs;
Nusing std::labs;
Nusing std::atoi;
Nusing std::atol;
N#if defined(_LLONG_AVAILABLE)
X#if 1L
Nusing std::llabs;
Nusing std::atoll;
N#endif
Nusing std::atof;
Nusing std::strtol;
Nusing std::strtoul;
N#if defined(_LLONG_AVAILABLE)
X#if 1L
Nusing std::strtoll;
Nusing std::strtoull;
N#endif
Nusing std::strtod;
Nusing std::rand;
Nusing std::srand;
Nusing std::calloc;
Nusing std::malloc;
Nusing std::realloc;
Nusing std::free;
Nusing std::memalign;
Nusing std::abort;
Nusing std::atexit;
Nusing std::bsearch;
Nusing std::qsort;
Nusing std::exit;
Nusing std::div;
Nusing std::ldiv;
N#if defined(_LLONG_AVAILABLE)
X#if 1L
Nusing std::lldiv;
N#endif
Nusing std::getenv;
Nusing std::system;
N#endif /* ! _CPP_STYLE_HEADER */
N
N#include <stdlibf.h>     /* far versions of stdlib fns */
L 1 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/stdlibf.h" 1
N/*****************************************************************************/
N/* stdlibf.h   v5.2.6                                                        */
N/*     far versions of stdlib.h functions                                    */
N/* Copyright (c) 1996-2010 Texas Instruments Incorporated                    */
N/*****************************************************************************/
N#ifndef _STDLIBF
S#define _STDLIBF
S
S#ifndef __cplusplus
S_CODE_ACCESS long          far_strtol (const far char *st, far char **endptr, 
S				   int base);
S_CODE_ACCESS unsigned long far_strtoul(const far char *st, far char **endptr, 
S				   int base);
S_CODE_ACCESS double        far_strtod (const far char *st, far char **endptr);
S_CODE_ACCESS long double   far_strtold (const far char *st, far char **endptr);
S_CODE_ACCESS long long     far_strtoll(const far char *st, far char **endptr, 
S		 						    int base);
S_CODE_ACCESS unsigned long long far_strtoull(const far char *st, 
S                                                   far char **endptr, int base);
S_CODE_ACCESS int           far_atoi(const far char *st);
S_CODE_ACCESS long          far_atol(const far char *st);
S_IDECL       double        far_atof(const far char *st);
S_CODE_ACCESS long long     far_atoll(const far char *st);
S
S_CODE_ACCESS far void     *far_calloc  (unsigned long num, unsigned long size);
S_CODE_ACCESS far void     *far_malloc  (unsigned long size);
S_CODE_ACCESS far void     *far_realloc (far void *ptr, unsigned long size);
S_CODE_ACCESS void          far_free    (far void *ptr);
S
S_CODE_ACCESS far void     *far_bsearch(const far void *key, 
S                                       const far void *base, 
S			               size_t nmemb, size_t size, 
S			               int (*compar)(const far void *,
S                                                     const far void *));
S_CODE_ACCESS void          far_qsort  (far void *base, 
S                                       size_t nmemb, size_t size,
S			               int (*compar)(const far void *, 
S                                                     const far void *));
S
S_CODE_ACCESS int	   free_memory(void);
S_CODE_ACCESS int           max_free(void);
S_CODE_ACCESS void         *chkheap();
S
S#ifdef _INLINE
Sstatic __inline double far_atof(const far char *st) 
S{ 
S   return far_strtod(st, NULL);
S}
S#endif /* _INLINE */
S
S#else /* __cplusplus */
S
Snamespace std {
S
Sextern "C" int	       free_memory(void);
Sextern "C" int         max_free(void);
Sextern "C" void        *chkheap();
S
S_CODE_ACCESS long      far_calloc  (unsigned long num, unsigned long size);
S_CODE_ACCESS long      far_malloc  (unsigned long size);
S_CODE_ACCESS long      far_realloc (long ptr, unsigned long size);
S_CODE_ACCESS void      far_free    (long ptr);
S_CODE_ACCESS long      far_free_memory(void);
S_CODE_ACCESS long      far_max_free(void);
S_CODE_ACCESS long      far_chkheap(void);
S
S}
S#endif /* __cplusplus */
N#endif /* _STDLIBF */
N
N#if defined(__cplusplus) && !defined(_CPP_STYLE_HEADER)
X#if 1L && !0L
Nusing std::free_memory; 
Nusing std::max_free;
Nusing std::chkheap;
Nusing std::far_calloc;
Nusing std::far_malloc;
Nusing std::far_realloc;
Nusing std::far_free;
Nusing std::far_free_memory; 
Nusing std::far_max_free;
Nusing std::far_chkheap;
N#endif /* _CPP_STYLE_HEADER */
L 184 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/stdlib.h" 2
L 25 "D:\project\fpalette\ccs4\fpalette\ide_led\src\cores\WString.h" 2
N#include <string.h>
L 1 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/string.h" 1
N/*****************************************************************************/
N/* string.h   v5.2.6                                                         */
N/* Copyright (c) 1993-2010 Texas Instruments Incorporated                    */
N/*****************************************************************************/
N
N#ifndef _STRING
S#define _STRING
S
S#ifdef __cplusplus
S//----------------------------------------------------------------------------
S// <cstring> IS RECOMMENDED OVER <string.h>.  <string.h> IS PROVIDED FOR
S// COMPATIBILITY WITH C AND THIS USAGE IS DEPRECATED IN C++
S//----------------------------------------------------------------------------
Sextern "C" namespace std
S{
S#endif /* __cplusplus */
S 
S#ifndef NULL
S#define NULL 0
S#endif
S
S#ifndef _SIZE_T
S#define _SIZE_T
Stypedef __SIZE_T_TYPE__ size_t;
S#endif
S
S#include <linkage.h>
S
S#if defined(_OPTIMIZE_FOR_SPACE) && (defined(__TMS470__) || 		\
S				     defined(__TMS320C2000__)  ||       \
S                                     defined(__MSP430__))
X#if defined(_OPTIMIZE_FOR_SPACE) && (defined(__TMS470__) || 						     defined(__TMS320C2000__)  ||                                            defined(__MSP430__))
S#define _OPT_IDECL
S#else
S#define _OPT_IDECL	_IDECL
S#endif
S
S_OPT_IDECL size_t  strlen(const char *_string);
S
S_OPT_IDECL char *strcpy(char *_dest, const char *_src);
S_OPT_IDECL char *strncpy(char *_to, const char *_from, size_t _n);
S_OPT_IDECL char *strcat(char *_string1, const char *_string2);
S_OPT_IDECL char *strncat(char *_to, const char *_from, size_t _n);
S_OPT_IDECL char *strchr(const char *_string, int _c);
S_OPT_IDECL char *strrchr(const char *_string, int _c);
S
S_OPT_IDECL int  strcmp(const char *_string1, const char *_string2);
S_OPT_IDECL int  strncmp(const char *_string1, const char *_string2, size_t _n);
S
S_CODE_ACCESS int     strcoll(const char *_string1, const char *_string2);
S_CODE_ACCESS size_t  strxfrm(char *_to, const char *_from, size_t _n);
S_CODE_ACCESS char   *strpbrk(const char *_string, const char *_chs);
S_CODE_ACCESS size_t  strspn(const char *_string, const char *_chs);
S_CODE_ACCESS size_t  strcspn(const char *_string, const char *_chs);
S_CODE_ACCESS char   *strstr(const char *_string1, const char *_string2);
S_CODE_ACCESS char   *strtok(char *_str1, const char *_str2);
S_CODE_ACCESS char   *strerror(int _errno);
S
S_CODE_ACCESS void   *memmove(void *_s1, const void *_s2, size_t _n);
S
S_OPT_IDECL int     memcmp(const void *_cs, const void *_ct, size_t _n);
S_OPT_IDECL void   *memchr(const void *_cs, int _c, size_t _n);
S
S_OPT_IDECL   void   *memset(void *_mem, int _ch, size_t _n);
S
S
S#ifndef __cplusplus
S#define far_memcpy __memcpy_ff
S#define far_strcpy strcpy_ff
Ssize_t    far_strlen(const far char *s);
Schar     *strcpy_nf(char *s1, const char far *s2);
Schar far *strcpy_fn(char far *s1, const char *s2);
Schar far *strcpy_ff(char far *s1, const char far *s2);
Sfar char *far_strncpy(far char *s1, far const char *s2, size_t n);
Sfar char *far_strcat(far char *s1, const far char *s2);
Sfar char *far_strncat(far char *s1, const far char *s2, size_t n);
Sfar char *far_strchr(const far char *s, int c);
Sfar char *far_strrchr(const far char *s, int c);
Sint       far_strcmp(const far char *s1, const far char *s2);
Sint       far_strncmp(const far char *s1, const far char *s2, size_t n);
Sint       far_strcoll(const far char *s1, const far char *s2);
Ssize_t    far_strxfrm(far char *s1, const far char *s2, size_t n);
Sfar char *far_strpbrk(const far char *s1, const far char *s2);
Ssize_t    far_strspn(const far char *s1, const far char *s2);
Ssize_t    far_strcspn(const far char *s1, const far char *s2);
Sfar char *far_strstr(const far char *s1, const far char *s2);
Sfar char *far_strtok(far char *s1, const far char *s2);
Sfar char *far_strerror(int errno);
Svoid far *far_memmove(far void *s1, far const void *s2, size_t n);
Svoid     *__memcpy_nf (void *_s1, far const void *_s2, size_t _n);
Svoid far *__memcpy_fn (far void *_s1, const void *_s2, size_t _n);
Svoid far *__memcpy_ff (far void *_s1, far const void *_s2, size_t _n);
Sint       far_memcmp(const far void *s1, const far void *s2, size_t n);
Sfar void *far_memchr(const far void *s, int c, size_t n);
Sfar void *far_memset(far void *s, int c, size_t n);
Sfar void *far_memlcpy(far void *to, const far void *from, unsigned long n);
Sfar void *far_memlmove(far void *to, const far void *from, unsigned long n);
S#else /* __cplusplus */
Slong      far_memlcpy(long to, long from, unsigned long n);
Slong      far_memlmove(long to, long from, unsigned long n);
S#endif /* __cplusplus */
S
S
S#ifdef __cplusplus
S} /* extern "C" namespace std */
S#endif /* __cplusplus */
S
S#if defined(_INLINE) || defined(_STRING_IMPLEMENTATION)
S
S#if (defined(_STRING_IMPLEMENTATION) ||					\
S     !(defined(_OPTIMIZE_FOR_SPACE) && (defined(__TMS470__) || 		\
S					defined(__TMS320C2000__)  ||    \
S                                        defined(__MSP430__))))
X#if (defined(_STRING_IMPLEMENTATION) ||					     !(defined(_OPTIMIZE_FOR_SPACE) && (defined(__TMS470__) || 							defined(__TMS320C2000__)  ||                                            defined(__MSP430__))))
S
S#ifdef __cplusplus
Snamespace std {
S#endif
S
S#if (defined(_OPTIMIZE_FOR_SPACE) && (defined(__TMS470__) || 		\
S				      defined(__TMS320C2000__) ||       \
S                                      defined(__MSP430__)))
X#if (defined(_OPTIMIZE_FOR_SPACE) && (defined(__TMS470__) || 						      defined(__TMS320C2000__) ||                                             defined(__MSP430__)))
S#define _OPT_IDEFN
S#else
S#define _OPT_IDEFN	_IDEFN
S#endif
S
S#if defined(_INLINE) || defined(_STRLEN)
S_OPT_IDEFN size_t strlen(const char *string)
S{
S   size_t      n = (size_t)-1;
S   const char *s = string;
S
S   do n++; while (*s++);
S   return n;
S}
S#endif /* _INLINE || _STRLEN */
S
S#if defined(_INLINE) || defined(_STRCPY)
S_OPT_IDEFN char *strcpy(register char *dest, register const char *src)
S{
S     register char       *d = dest;     
S     register const char *s = src;
S
S     while (*d++ = *s++);
S     return dest;
S}
S#endif /* _INLINE || _STRCPY */
S
S#if defined(_INLINE) || defined(_STRNCPY)
S_OPT_IDEFN char *strncpy(register char *dest,
S		     register const char *src,
S		     register size_t n)
S{
S     if (n) 
S     {
S	 register char       *d = dest;
S	 register const char *s = src;
S	 while ((*d++ = *s++) && --n);              /* COPY STRING         */
S	 if (n-- > 1) do *d++ = '\0'; while (--n);  /* TERMINATION PADDING */
S     }
S     return dest;
S}
S#endif /* _INLINE || _STRNCPY  */
S
S#if defined(_INLINE) || defined(_STRCAT)
S_OPT_IDEFN char *strcat(char *string1, const char *string2)
S{
S   char       *s1 = string1;
S   const char *s2 = string2;
S
S   while (*s1) s1++;		     /* FIND END OF STRING   */
S   while (*s1++ = *s2++);	     /* APPEND SECOND STRING */
S   return string1;
S}
S#endif /* _INLINE || _STRCAT */
S
S#if defined(_INLINE) || defined(_STRNCAT)
S_OPT_IDEFN char *strncat(char *dest, const char *src, register size_t n)
S{
S    if (n)
S    {
S	char       *d = dest;
S	const char *s = src;
S
S	while (*d) d++;                      /* FIND END OF STRING   */
S
S	while (n--)
S	  if (!(*d++ = *s++)) return dest; /* APPEND SECOND STRING */
S	*d = 0;
S    }
S    return dest;
S}
S#endif /* _INLINE || _STRNCAT */
S
S#if defined(_INLINE) || defined(_STRCHR)
S_OPT_IDEFN char *strchr(const char *string, int c)
S{
S   char        tch, ch  = c;
S   const char *s        = string;
S
S   for (;;)
S   {
S       if ((tch = *s) == ch) return (char *) s;
S       if (!tch)             return (char *) 0;
S       s++;
S   }
S}
S#endif /* _INLINE || _STRCHR */
S
S#if defined(_INLINE) || defined(_STRRCHR)
S_OPT_IDEFN char *strrchr(const char *string, int c)
S{
S   char        tch, ch = c;
S   char       *result  = 0;
S   const char *s       = string;
S
S   for (;;)
S   {
S      if ((tch = *s) == ch) result = (char *) s;
S      if (!tch) break;
S      s++;
S   }
S
S   return result;
S}
S#endif /* _INLINE || _STRRCHR */
S
S#if defined(_INLINE) || defined(_STRCMP)
S_OPT_IDEFN int strcmp(register const char *string1,
S		  register const char *string2)
S{
S   register int c1, res;
S
S   for (;;)
S   {
S       c1  = (unsigned char)*string1++;
S       res = c1 - (unsigned char)*string2++;
S
S       if (c1 == 0 || res != 0) break;
S   }
S
S   return res;
S}
S#endif /* _INLINE || _STRCMP */
S
S#if defined(_INLINE) || defined(_STRNCMP)
S_OPT_IDEFN int strncmp(const char *string1, const char *string2, size_t n)
S{
S     if (n) 
S     {
S	 const char *s1 = string1;
S	 const char *s2 = string2;
S	 unsigned char cp;
S	 int         result;
S
S	 do 
S	    if (result = (unsigned char)*s1++ - (cp = (unsigned char)*s2++))
S                return result;
S	 while (cp && --n);
S     }
S     return 0;
S}
S#endif /* _INLINE || _STRNCMP */
S
S#if defined(_INLINE) || defined(_MEMCMP)
S_OPT_IDEFN int memcmp(const void *cs, const void *ct, size_t n)
S{
S   if (n) 
S   {
S       const unsigned char *mem1 = (unsigned char *)cs;
S       const unsigned char *mem2 = (unsigned char *)ct;
S       int                 cp1, cp2;
S
S       while ((cp1 = *mem1++) == (cp2 = *mem2++) && --n);
S       return cp1 - cp2;
S   }
S   return 0;
S}
S#endif /* _INLINE || _MEMCMP */
S
S#if defined(_INLINE) || defined(_MEMCHR)
S_OPT_IDEFN void *memchr(const void *cs, int c, size_t n)
S{
S   if (n)
S   {
S      const unsigned char *mem = (unsigned char *)cs;   
S      unsigned char        ch  = c;
S
S      do 
S         if ( *mem == ch ) return (void *)mem;
S         else mem++;
S      while (--n);
S   }
S   return NULL;
S}
S#endif /* _INLINE || _MEMCHR */
S
S#if ((defined(_INLINE) || defined(_MEMSET)) && !defined(_TMS320C6X)) && !defined(__TMS470__)
S_OPT_IDEFN void *memset(void *mem, register int ch, register size_t length)
S{
S     register char *m = (char *)mem;
S
S     while (length--) *m++ = ch;
S     return mem;
S}
S#endif /* _INLINE || _MEMSET */
S
S#ifdef __cplusplus
S} /* namespace std */
S#endif
S
S#endif /* (_STRING_IMPLEMENTATION || !(_OPTIMIZE_FOR_SPACE && __TMS470__)) */
S
S#endif /* (_INLINE || _STRING_IMPLEMENTATION) */
S
N#endif /* ! _STRING */
N
N#if defined(__cplusplus) && !defined(_CPP_STYLE_HEADER)
X#if 1L && !0L
Nusing std::size_t;
Nusing std::strlen;
Nusing std::strcpy;
Nusing std::strncpy;
Nusing std::strcat;
Nusing std::strncat;
Nusing std::strchr;
Nusing std::strrchr;
Nusing std::strcmp;
Nusing std::strncmp;
Nusing std::strcoll;
Nusing std::strxfrm;
Nusing std::strpbrk;
Nusing std::strspn;
Nusing std::strcspn;
Nusing std::strstr;
Nusing std::strtok;
Nusing std::strerror;
Nusing std::memmove;
Nusing std::memcpy;
Nusing std::memcmp;
Nusing std::memchr;
Nusing std::memset;
N
Nusing std::far_memlcpy;
Nusing std::far_memlmove;
N
N#endif /* _CPP_STYLE_HEADER */
N
L 26 "D:\project\fpalette\ccs4\fpalette\ide_led\src\cores\WString.h" 2
N#include <ctype.h>
L 1 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/ctype.h" 1
N/*****************************************************************************/
N/* ctype.h    v5.2.6                                                         */
N/* Copyright (c) 1993-2010 Texas Instruments Incorporated                    */
N/*****************************************************************************/
N
N/************************************************************************/
N/*                                                                      */
N/*  CHARACTER TYPING FUNCTIONS AND MACROS                               */
N/*                                                                      */
N/*  Note that in this implementation, either macros or functions may    */
N/*  be used.  Macros are prefixed with an underscore.                   */
N/*                                                                      */
N/************************************************************************/
N#ifndef _CTYPE
S#define _CTYPE
S
S#include <linkage.h>
S
S
S#ifdef __cplusplus
S//----------------------------------------------------------------------------
S// <cctype> IS RECOMMENDED OVER <ctype.h>.  <ctype.h> IS PROVIDED FOR
S// COMPATIBILITY WITH C AND THIS USAGE IS DEPRECATED IN C++
S//----------------------------------------------------------------------------
Sextern "C" namespace std
S{
S#endif /* __cplusplus */
S
Sextern _DATA_ACCESS const unsigned char _ctypes_[];
S
S/************************************************************************/
S/*   FUNCTION DECLARATIONS                                              */
S/************************************************************************/
S#include "_isfuncdcl.h"
S
S_IDECL int toupper(int _c);
S_IDECL int tolower(int _c);
S
S#ifdef __cplusplus
S} /* extern "C" namespace std */
S#endif /* __cplusplus */
S
S
S/************************************************************************/
S/*  On this ELSE path, all the TI ctype table and ctype bit flags are   */
S/*  defined.                                                            */
S/************************************************************************/
S/************************************************************************/
S/*  MACRO DEFINITIONS                                                   */
S/************************************************************************/
S#define _U_   0x01       /* control chars     */
S#define _L_   0x02       /* lower case letter */
S#define _N_   0x04       /* digit             */
S#define _S_   0x08       /* white space       */
S#define _P_   0x10       /* punctuation       */
S#define _C_   0x20       /* control chars     */
S#define _H_   0x40       /* A-F, a-f and 0-9  */
S#define _B_   0x80       /* blank             */
S
S#define _isalnum(a)  (_ctypes_[(a)+1] & (_U_ | _L_ | _N_))
S#define _isalpha(a)  (_ctypes_[(a)+1] & (_U_ | _L_))
S#define _iscntrl(a)  (_ctypes_[(a)+1] & _C_)
S#define _isdigit(a)  (_ctypes_[(a)+1] & _N_)
S#define _isgraph(a)  (_ctypes_[(a)+1] & (_U_ | _L_ | _N_ | _P_))
S#define _islower(a)  (_ctypes_[(a)+1] & _L_)
S#define _isprint(a)  (_ctypes_[(a)+1] & (_B_ | _U_ | _L_ | _N_ | _P_))
S#define _ispunct(a)  (_ctypes_[(a)+1] & _P_)
S#define _isspace(a)  (_ctypes_[(a)+1] & _S_)
S#define _isupper(a)  (_ctypes_[(a)+1] & _U_)
S#define _isxdigit(a) (_ctypes_[(a)+1] & _H_)
S
S
S#define _isascii(a)  (((a) & ~0x7F) == 0)
S#define _toupper(b)  ((_islower(b)) ? (b) - ('a' - 'A') : (b))
S#define _tolower(b)  ((_isupper(b)) ? (b) + ('a' - 'A') : (b))
S#define _toascii(a)  ((a) & 0x7F)
S
S#ifdef _INLINE
S
S#ifdef __cplusplus
Susing std::_ctypes_;
Snamespace std {
S#endif /* __cplusplus */
S
S#include "_isfuncdef.h"
S
S/****************************************************************************/
S/*  tolower                                                                 */
S/****************************************************************************/
Sstatic __inline int tolower(int ch)
S{
S   /*
S    This code depends on two assumptions: (1) all of the letters of the
S    alphabet of a given case are contiguous, and (2) the lower and upper
S    case forms of each letter are displaced from each other by the same
S    constant value.
S   */
S
S   if ( (unsigned int)(ch - 'A') <= (unsigned int)('Z' - 'A')) ch += 'a' - 'A';
S   return ch;
S}
S
S/****************************************************************************/
S/*  toupper                                                                 */
S/****************************************************************************/
Sstatic __inline int toupper(int ch)
S{
S   /*
S    This code depends on two assumptions: (1) all of the letters of the
S    alphabet of a given case are contiguous, and (2) the lower and upper
S    case forms of each letter are displaced from each other by the same
S    constant value.
S   */
S
S   if ( (unsigned int)(ch - 'a') <= (unsigned int)('z' - 'a')) ch -= 'a' - 'A';
S   return ch;
S}
S
S#ifdef __cplusplus
S}
S#endif /* __cplusplus */
S
S#endif /* _INLINE */
S
N#endif /* ! _CTYPE */
N
N#if defined(__cplusplus) && !defined(_CPP_STYLE_HEADER)
X#if 1L && !0L
Nusing std::_ctypes_;
Nusing std::isalnum;
Nusing std::isalpha;
Nusing std::iscntrl;
Nusing std::isdigit;
Nusing std::isgraph;
Nusing std::islower;
Nusing std::isprint;
Nusing std::ispunct;
Nusing std::isspace;
Nusing std::isupper;
Nusing std::isxdigit;
Nusing std::isascii;
Nusing std::toupper;
Nusing std::tolower;
Nusing std::toascii;
N#endif /* ! _CPP_STYLE_HEADER */
N
L 27 "D:\project\fpalette\ccs4\fpalette\ide_led\src\cores\WString.h" 2
N
Nclass String
N{
N  public:
N    // constructors
N    String( const char *value = "" );
N    String( const String &value );
N    String( const char );
N    String( const unsigned char );
N    String( const int, const int base=10);
N    String( const unsigned int, const int base=10 );
N    String( const long, const int base=10 );
N    String( const unsigned long, const int base=10 );
N    ~String() { free(_buffer); _length = _capacity = 0;}     //added _length = _capacity = 0;
N
N    // operators
N    const String & operator = ( const String &rhs );
N    const String & operator +=( const String &rhs );
N    //const String & operator +=( const char );
N    int operator ==( const String &rhs ) const;
N    int	operator !=( const String &rhs ) const;
N    int	operator < ( const String &rhs ) const;
N    int	operator > ( const String &rhs ) const;
N    int	operator <=( const String &rhs ) const;
N    int	operator >=( const String &rhs ) const;
N    char operator []( unsigned int index ) const;
N    char& operator []( unsigned int index );
N    //operator const char *() const { return _buffer; }
N
N    // general methods
N    char charAt( unsigned int index ) const;
N    int	compareTo( const String &anotherString ) const;
N//    unsigned char endsWith( const String &suffix ) const;
N//    unsigned char equals( const String &anObject ) const;
N//    unsigned char equalsIgnoreCase( const String &anotherString ) const;
N    boolean endsWith( const String &suffix ) const;
N    boolean equals( const String &anObject ) const;
N    boolean equalsIgnoreCase( const String &anotherString ) const;
N
N    int	indexOf( char ch ) const;
N    int	indexOf( char ch, unsigned int fromIndex ) const;
N    int	indexOf( const String &str ) const;
N    int	indexOf( const String &str, unsigned int fromIndex ) const;
N    int	lastIndexOf( char ch ) const;
N    int	lastIndexOf( char ch, unsigned int fromIndex ) const;
N    int	lastIndexOf( const String &str ) const;
N    int	lastIndexOf( const String &str, unsigned int fromIndex ) const;
N    /*const*/ unsigned int length( ) const { return _length; }
N    void setCharAt(unsigned int index, const char ch);
N//    unsigned char startsWith( const String &prefix ) const;
N//    unsigned char startsWith( const String &prefix, unsigned int toffset ) const;
N    boolean startsWith( const String &prefix ) const;
N    boolean startsWith( const String &prefix, unsigned int toffset ) const;
N    String substring( unsigned int beginIndex ) const;
N    String substring( unsigned int beginIndex, unsigned int endIndex ) const;
N    String toLowerCase( ) const;
N    String toUpperCase( ) const;
N    String trim( ) const;
N    void getBytes(unsigned char *buf, unsigned int bufsize);
N    void toCharArray(char *buf, unsigned int bufsize);
N    long toInt( );
N    const String& concat( const String &str );
N    String replace( char oldChar, char newChar );
N    String replace( const String& match, const String& replace );
N
N    friend String operator + ( String lhs, const String &rhs );
N
N  protected:
N    char *_buffer;	     // the actual char array
N    unsigned int _capacity;  // the array length minus one (for the '\0')
N    unsigned int _length;    // the String length (not counting the '\0')
N
N    void getBuffer(unsigned int maxStrLen);
N
N  private:
N
N};
N
N// allocate buffer space
Ninline void String::getBuffer(unsigned int maxStrLen)
N{
N  _capacity = maxStrLen;
N  _buffer = (char *) malloc(_capacity + 1);
N  if (_buffer == NULL) _length = _capacity = 0;
X  if (_buffer == 0) _length = _capacity = 0;
N}
N
Ninline String operator+( String lhs, const String &rhs )
N{
N  return lhs += rhs;
N}
N
N
N#endif
L 28 "D:\project\fpalette\ccs4\fpalette\ide_led\src\cores\Print.h" 2
N
N#define DEC 10
N#define HEX 16
N#define OCT 8
N#define BIN 2
N#define BYTE 0
N
Nclass Print
N{
N  private:
N    void printNumber(unsigned long, uint8_t);
N    void printFloat(double, uint8_t);
N  public:
N    virtual void write(uint8_t) = 0;
N    virtual void write(const char *str);
N    virtual void write(const uint8_t *buffer, size_t size);
N
N    void print(const String &);
N    void print(const char[]);
N    void print(char, int = BYTE);
X    void print(char, int = 0);
N    void print(unsigned char, int = BYTE);
X    void print(unsigned char, int = 0);
N    void print(int, int = DEC);
X    void print(int, int = 10);
N    void print(unsigned int, int = DEC);
X    void print(unsigned int, int = 10);
N    void print(long, int = DEC);
X    void print(long, int = 10);
N    void print(unsigned long, int = DEC);
X    void print(unsigned long, int = 10);
N    void print(double, int = 2);
N
N    void println(const String &s);
N    void println(const char[]);
N    void println(char, int = BYTE);
X    void println(char, int = 0);
N    void println(unsigned char, int = BYTE);
X    void println(unsigned char, int = 0);
N    void println(int, int = DEC);
X    void println(int, int = 10);
N    void println(unsigned int, int = DEC);
X    void println(unsigned int, int = 10);
N    void println(long, int = DEC);
X    void println(long, int = 10);
N    void println(unsigned long, int = DEC);
X    void println(unsigned long, int = 10);
N    void println(double, int = 2);
N    void println(void);
N};
N
N#endif
L 25 "D:\project\fpalette\ccs4\fpalette\ide_led\src\cores\Stream.h" 2
N
Nclass Stream : public Print
N{
N  public:
N    virtual int available() = 0;
N    virtual int read() = 0;
N    virtual int peek() = 0;
N    virtual void flush() = 0;
N};
N
N#endif
L 28 "D:/project/fpalette/ccs4/fpalette/ide_led/src/cores/HardwareSerial.h" 2
N
Nstruct ring_buffer;
N
Nclass HardwareSerial : public Stream
N{
Nprivate:
N//	ring_buffer *_rx_buffer;
N//	volatile uint8_t *_ubrrh;
N//	volatile uint8_t *_ubrrl;
N//	volatile uint8_t *_ucsra;
N//	volatile uint8_t *_ucsrb;
N//	volatile uint8_t *_udr;
N//	uint8_t _rxen;
N//	uint8_t _txen;
N//	uint8_t _rxcie;
N//	uint8_t _udre;
N//	uint8_t _u2x;
Npublic:
N//	HardwareSerial(ring_buffer *rx_buffer,
N//      volatile uint8_t *ubrrh, volatile uint8_t *ubrrl,
N//      volatile uint8_t *ucsra, volatile uint8_t *ucsrb,
N//      volatile uint8_t *udr,
N//      uint8_t rxen, uint8_t txen, uint8_t rxcie, uint8_t udre, uint8_t u2x);
N	HardwareSerial( );
N	int begin(long bps);
N	void end();
N	virtual int available(void);
N	virtual int peek(void);
N	virtual int read(void);
N	virtual void flush(void);
N	virtual void write(uint8_t);
N	using Print::write; // pull in write(str) and write(buf, size) from Print
N};
N
Nextern HardwareSerial Serial;
N
N
N#endif	/* HardwareSerial_H */
L 260 "../src/Blink.cpp" 2
N
Nvoid setup();
Nvoid loop();
N
Nstatic int count;
Nstatic const char testStr[] = { 't','e','s','t','\n', };
N#define	recodeof(_v)	(sizeof(_v)/sizeof(_v[0]))
Nvoid setup()
N{
N	pinMode(GPIO_NO_CPU_LED, OUTPUT);
X	pinMode(39, 1);
N
N
N	count = 0;
N}
N
Nvoid loop()
N{
N
N	digitalWrite(GPIO_NO_CPU_LED, LOW);    // set the LED on
X	digitalWrite(39, 0x0);    
N
N	Serial.begin( 9600 );
N
N	Serial.write( "hello\n" );
N	Serial.write( "\n" );
N	Serial.write( (const uint8_t *)testStr, recodeof(testStr) );
X	Serial.write( (const uint8_t *)testStr, (sizeof(testStr)/sizeof(testStr[0])) );
N
N	count++;
N
N	Serial.print( 78 );
N	Serial.print( 1.23456);
N	Serial.print( byte(78) );
N	Serial.print( 'N' );
N	Serial.print( 78, BYTE );
X	Serial.print( 78, 0 );
N	Serial.print( 78, BIN );
X	Serial.print( 78, 2 );
N	Serial.print( 78, OCT );
X	Serial.print( 78, 8 );
N	Serial.print( 78, DEC );
X	Serial.print( 78, 10 );
N	Serial.print( 78, HEX );
X	Serial.print( 78, 16 );
N	Serial.print( 1.23456, 0 );
N	Serial.print( 1.23456, 2 );
N	Serial.print( 1.23456, 4 );
N	Serial.print( count );
N
N	Serial.println( 78 );
N	Serial.println( 1.23456);
N	Serial.println( byte(78) );
N	Serial.println( 'N' );
N	Serial.println( 78, BYTE );
X	Serial.println( 78, 0 );
N	Serial.println( 78, BIN );
X	Serial.println( 78, 2 );
N	Serial.println( 78, OCT );
X	Serial.println( 78, 8 );
N	Serial.println( 78, DEC );
X	Serial.println( 78, 10 );
N	Serial.println( 78, HEX );
X	Serial.println( 78, 16 );
N	Serial.println( 1.23456, 0 );
N	Serial.println( 1.23456, 2 );
N	Serial.println( 1.23456, 4 );
N	Serial.println( count );
N
N	{
N		int num;
N		int c;
N
N		for( num=0; num==0; ) {
N			num = Serial.available();
N		}
N		c = Serial.peek();
N		c = Serial.read();
N
N		for( num=0; num==0; ) {
N			num = Serial.available();
N		}
N
N		Serial.flush();
N
N		for( ; num != 0; ) {
N			num = Serial.available();
N		}
N
W "../src/Blink.cpp" 318 7 variable "c" was set but never used
N	}
N
N
N	Serial.end();
N
N	digitalWrite(GPIO_NO_CPU_LED, HIGH);   // set the LED Off
X	digitalWrite(39, 0x1);   
N}
N
