L 1 "../src/cores/Print.cpp"
N/*
N Print.cpp - Base class that provides print() and println()
N Copyright (c) 2008 David A. Mellis.  All right reserved.
N
N This library is free software; you can redistribute it and/or
N modify it under the terms of the GNU Lesser General Public
N License as published by the Free Software Foundation; either
N version 2.1 of the License, or (at your option) any later version.
N
N This library is distributed in the hope that it will be useful,
N but WITHOUT ANY WARRANTY; without even the implied warranty of
N MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
N Lesser General Public License for more details.
N
N You should have received a copy of the GNU Lesser General Public
N License along with this library; if not, write to the Free Software
N Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
N
N Modified 23 November 2006 by David A. Mellis
N */
N
N#include <stdlib.h>
L 1 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/stdlib.h" 1
N/*****************************************************************************/
N/* stdlib.h   v5.2.6                                                         */
N/* Copyright (c) 1993-2010 Texas Instruments Incorporated                    */
N/*****************************************************************************/
N
N#ifndef _STDLIB
N#define _STDLIB
N
N
N#ifdef __cplusplus
N//----------------------------------------------------------------------------
N// <cstdlib> IS RECOMMENDED OVER <stdlib.h>.  <stdlib.h> IS PROVIDED FOR 
N// COMPATIBILITY WITH C AND THIS USAGE IS DEPRECATED IN C++
N//----------------------------------------------------------------------------
Nextern "C" namespace std {
N#endif /* !__cplusplus */
N
Ntypedef struct { int quot, rem; } div_t;
N
Ntypedef struct { long quot, rem; } ldiv_t;
N
N#define _LLONG_AVAILABLE 1
Ntypedef struct { long long quot, rem; } lldiv_t;
N
N#define MB_CUR_MAX    1
N
N#ifndef NULL
N#define NULL          0
N#endif
N
N#ifndef _SIZE_T
N#define _SIZE_T
Ntypedef __SIZE_T_TYPE__ size_t;
Xtypedef unsigned long size_t;
N#endif
N
N#ifndef __cplusplus
S#ifndef _WCHAR_T
S#define _WCHAR_T
Stypedef __WCHAR_T_TYPE__ wchar_t;
S#endif
N#endif
N
N#define EXIT_FAILURE  1
N#define EXIT_SUCCESS  0
N
N#define RAND_MAX      32767
N
N#include <linkage.h>
L 1 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/linkage.h" 1
N/*****************************************************************************/
N/* linkage.h   v5.2.6                                                         */
N/* Copyright (c) 1998-2010 Texas Instruments Incorporated                    */
N/*****************************************************************************/
N
N#ifndef _LINKAGE
N#define _LINKAGE
N
N/* No modifiers needed to access code */
N
N#define _CODE_ACCESS
N
N/*--------------------------------------------------------------------------*/
N/* Define _DATA_ACCESS ==> how to access RTS global or static data          */
N/*--------------------------------------------------------------------------*/
N#ifndef _FAR_RTS
N#define _DATA_ACCESS
N#else
S#define _DATA_ACCESS far
N#endif
N#define _DATA_ACCESS_NEAR
N
N/*--------------------------------------------------------------------------*/
N/* Define _OPTIMIZE_FOR_SPACE ==> Always optimize for space.                */
N/*--------------------------------------------------------------------------*/
N#ifndef _OPTIMIZE_FOR_SPACE
S#define _OPTIMIZE_FOR_SPACE 1
N#endif
N
N/*--------------------------------------------------------------------------*/
N/* Define _IDECL ==> how inline functions are declared                      */
N/*--------------------------------------------------------------------------*/
N#ifdef _INLINE
S#define _IDECL static __inline
S#define _IDEFN static __inline
N#else
N#define _IDECL extern _CODE_ACCESS
N#define _IDEFN _CODE_ACCESS
N#endif
N
N#endif /* _LINKAGE */
L 49 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/stdlib.h" 2
N
N/*---------------------------------------------------------------*/
N/* NOTE - Normally, abs, labs, and fabs are expanded inline, so  */
N/*        no formal definition is really required. However, ANSI */
N/*        requires that they exist as separate functions, so     */
N/*        they are supplied in the library.  The prototype is    */
N/*        here mainly for documentation.                         */
N/*---------------------------------------------------------------*/
N    _CODE_ACCESS  int       abs(int _val); 
X      int       abs(int _val); 
N    _CODE_ACCESS  long      labs(long _val);
X      long      labs(long _val);
N#if defined(_LLONG_AVAILABLE)
X#if 1L
N    _CODE_ACCESS  long long llabs(long long _val);
X      long long llabs(long long _val);
N#endif
N    _CODE_ACCESS int       atoi(const char *_st);
X     int       atoi(const char *_st);
N    _CODE_ACCESS long      atol(const char *_st);
X     long      atol(const char *_st);
N#if defined(_LLONG_AVAILABLE)
X#if 1L
N    _CODE_ACCESS long long atoll(const char *_st);
X     long long atoll(const char *_st);
N#endif
N    _CODE_ACCESS int       ltoa(long val, char *buffer);
X     int       ltoa(long val, char *buffer);
N          _IDECL double    atof(const char *_st);
X          extern  double    atof(const char *_st);
N
N    _CODE_ACCESS long      strtol(const char *_st, char **_endptr, int _base);
X     long      strtol(const char *_st, char **_endptr, int _base);
N    _CODE_ACCESS unsigned long strtoul(const char *_st, char **_endptr,
X     unsigned long strtoul(const char *_st, char **_endptr,
N    					  int _base);
N#if defined(_LLONG_AVAILABLE)
X#if 1L
N    _CODE_ACCESS long long strtoll(const char *_st, char **_endptr, int _base);
X     long long strtoll(const char *_st, char **_endptr, int _base);
N    _CODE_ACCESS unsigned long long strtoull(const char *_st, char **_endptr,
X     unsigned long long strtoull(const char *_st, char **_endptr,
N					     int _base);
N#endif
N    _CODE_ACCESS double    strtod(const char *_st, char **_endptr);
X     double    strtod(const char *_st, char **_endptr);
N    _CODE_ACCESS long double strtold(const char *_st, char **_endptr);
X     long double strtold(const char *_st, char **_endptr);
N    
N    _CODE_ACCESS int    rand(void);
X     int    rand(void);
N    _CODE_ACCESS void   srand(unsigned _seed);
X     void   srand(unsigned _seed);
N    
N    _CODE_ACCESS void  *calloc(size_t _num, size_t _size);
X     void  *calloc(size_t _num, size_t _size);
N    _CODE_ACCESS void  *malloc(size_t _size);
X     void  *malloc(size_t _size);
N    _CODE_ACCESS void  *realloc(void *_ptr, size_t _size);
X     void  *realloc(void *_ptr, size_t _size);
N    _CODE_ACCESS void   free(void *_ptr);
X     void   free(void *_ptr);
N    _CODE_ACCESS void  *memalign(size_t _aln, size_t _size);
X     void  *memalign(size_t _aln, size_t _size);
N    
N    _CODE_ACCESS void   abort(void); 
X     void   abort(void); 
N    _CODE_ACCESS int    atexit(void (*_func)(void));
X     int    atexit(void (*_func)(void));
N    _CODE_ACCESS void  *bsearch(const void *_key, const void *_base,
X     void  *bsearch(const void *_key, const void *_base,
N    				   size_t _nmemb, size_t _size, 
N    			           int (*compar)(const void *,const void *));
N    _CODE_ACCESS void   qsort(void *_base, size_t _nmemb, size_t _size, 
X     void   qsort(void *_base, size_t _nmemb, size_t _size, 
N    			         int (*_compar)(const void *, const void *));
N    _CODE_ACCESS void   exit(int _status);
X     void   exit(int _status);
N    
N    _CODE_ACCESS div_t  div(int _numer, int _denom);
X     div_t  div(int _numer, int _denom);
N    _CODE_ACCESS ldiv_t ldiv(long _numer, long _denom);
X     ldiv_t ldiv(long _numer, long _denom);
N#if defined(_LLONG_AVAILABLE)
X#if 1L
N    _CODE_ACCESS lldiv_t lldiv(long long _numer, long long _denom);
X     lldiv_t lldiv(long long _numer, long long _denom);
N#endif
N
N    _CODE_ACCESS char  *getenv(const char *_string);
X     char  *getenv(const char *_string);
N    _CODE_ACCESS int    system(const char *_name);
X     int    system(const char *_name);
N
N    _CODE_ACCESS int    mblen(const char *, size_t);
X     int    mblen(const char *, size_t);
N    _CODE_ACCESS size_t mbstowcs(wchar_t *, const char *, size_t);
X     size_t mbstowcs(wchar_t *, const char *, size_t);
N    _CODE_ACCESS int    mbtowc(wchar_t *, const char *, size_t);
X     int    mbtowc(wchar_t *, const char *, size_t);
N
N    _CODE_ACCESS size_t wcstombs(char *, const wchar_t *, size_t);
X     size_t wcstombs(char *, const wchar_t *, size_t);
N    _CODE_ACCESS int    wctomb(char *, wchar_t);
X     int    wctomb(char *, wchar_t);
N
N#ifdef __cplusplus
N} /* extern "C" namespace std */
N#endif /* __cplusplus */
N
N
N#ifdef _INLINE
S
S#ifdef __cplusplus
Snamespace std {
S#endif
S
Sstatic __inline double atof(const char *_st) 
S{
S  return strtod(_st, (char **)0); 
S}
S
S#ifdef __cplusplus
S} /* namespace std */
S#endif
S
N#endif  /* _INLINE */
N
N#endif  /* ! _STDLIB */
N
N#if defined(__cplusplus) && !defined(_CPP_STYLE_HEADER)
X#if 1L && !0L
Nusing std::div_t;
Nusing std::ldiv_t;
N#if defined(_LLONG_AVAILABLE)
X#if 1L
Nusing std::lldiv_t;
N#endif
Nusing std::size_t;
Nusing std::abs;
Nusing std::labs;
Nusing std::atoi;
Nusing std::atol;
N#if defined(_LLONG_AVAILABLE)
X#if 1L
Nusing std::llabs;
Nusing std::atoll;
N#endif
Nusing std::atof;
Nusing std::strtol;
Nusing std::strtoul;
N#if defined(_LLONG_AVAILABLE)
X#if 1L
Nusing std::strtoll;
Nusing std::strtoull;
N#endif
Nusing std::strtod;
Nusing std::rand;
Nusing std::srand;
Nusing std::calloc;
Nusing std::malloc;
Nusing std::realloc;
Nusing std::free;
Nusing std::memalign;
Nusing std::abort;
Nusing std::atexit;
Nusing std::bsearch;
Nusing std::qsort;
Nusing std::exit;
Nusing std::div;
Nusing std::ldiv;
N#if defined(_LLONG_AVAILABLE)
X#if 1L
Nusing std::lldiv;
N#endif
Nusing std::getenv;
Nusing std::system;
N#endif /* ! _CPP_STYLE_HEADER */
N
N#include <stdlibf.h>     /* far versions of stdlib fns */
L 1 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/stdlibf.h" 1
N/*****************************************************************************/
N/* stdlibf.h   v5.2.6                                                        */
N/*     far versions of stdlib.h functions                                    */
N/* Copyright (c) 1996-2010 Texas Instruments Incorporated                    */
N/*****************************************************************************/
N#ifndef _STDLIBF
N#define _STDLIBF
N
N#ifndef __cplusplus
S_CODE_ACCESS long          far_strtol (const far char *st, far char **endptr, 
S				   int base);
S_CODE_ACCESS unsigned long far_strtoul(const far char *st, far char **endptr, 
S				   int base);
S_CODE_ACCESS double        far_strtod (const far char *st, far char **endptr);
S_CODE_ACCESS long double   far_strtold (const far char *st, far char **endptr);
S_CODE_ACCESS long long     far_strtoll(const far char *st, far char **endptr, 
S		 						    int base);
S_CODE_ACCESS unsigned long long far_strtoull(const far char *st, 
S                                                   far char **endptr, int base);
S_CODE_ACCESS int           far_atoi(const far char *st);
S_CODE_ACCESS long          far_atol(const far char *st);
S_IDECL       double        far_atof(const far char *st);
S_CODE_ACCESS long long     far_atoll(const far char *st);
S
S_CODE_ACCESS far void     *far_calloc  (unsigned long num, unsigned long size);
S_CODE_ACCESS far void     *far_malloc  (unsigned long size);
S_CODE_ACCESS far void     *far_realloc (far void *ptr, unsigned long size);
S_CODE_ACCESS void          far_free    (far void *ptr);
S
S_CODE_ACCESS far void     *far_bsearch(const far void *key, 
S                                       const far void *base, 
S			               size_t nmemb, size_t size, 
S			               int (*compar)(const far void *,
S                                                     const far void *));
S_CODE_ACCESS void          far_qsort  (far void *base, 
S                                       size_t nmemb, size_t size,
S			               int (*compar)(const far void *, 
S                                                     const far void *));
S
S_CODE_ACCESS int	   free_memory(void);
S_CODE_ACCESS int           max_free(void);
S_CODE_ACCESS void         *chkheap();
S
S#ifdef _INLINE
Sstatic __inline double far_atof(const far char *st) 
S{ 
S   return far_strtod(st, NULL);
S}
S#endif /* _INLINE */
S
N#else /* __cplusplus */
N
Nnamespace std {
N
Nextern "C" int	       free_memory(void);
Nextern "C" int         max_free(void);
Nextern "C" void        *chkheap();
N
N_CODE_ACCESS long      far_calloc  (unsigned long num, unsigned long size);
X long      far_calloc  (unsigned long num, unsigned long size);
N_CODE_ACCESS long      far_malloc  (unsigned long size);
X long      far_malloc  (unsigned long size);
N_CODE_ACCESS long      far_realloc (long ptr, unsigned long size);
X long      far_realloc (long ptr, unsigned long size);
N_CODE_ACCESS void      far_free    (long ptr);
X void      far_free    (long ptr);
N_CODE_ACCESS long      far_free_memory(void);
X long      far_free_memory(void);
N_CODE_ACCESS long      far_max_free(void);
X long      far_max_free(void);
N_CODE_ACCESS long      far_chkheap(void);
X long      far_chkheap(void);
N
N}
N#endif /* __cplusplus */
N#endif /* _STDLIBF */
N
N#if defined(__cplusplus) && !defined(_CPP_STYLE_HEADER)
X#if 1L && !0L
Nusing std::free_memory; 
Nusing std::max_free;
Nusing std::chkheap;
Nusing std::far_calloc;
Nusing std::far_malloc;
Nusing std::far_realloc;
Nusing std::far_free;
Nusing std::far_free_memory; 
Nusing std::far_max_free;
Nusing std::far_chkheap;
N#endif /* _CPP_STYLE_HEADER */
L 184 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/stdlib.h" 2
L 23 "../src/cores/Print.cpp" 2
N#include <stdio.h>
L 1 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/stdio.h" 1
N/*****************************************************************************/
N/* STDIO.H v5.2.6                                                            */
N/* Copyright (c) 1993-2010 Texas Instruments Incorporated                    */
N/*****************************************************************************/
N#ifndef _STDIO 
N#define _STDIO
N
N#include <linkage.h>
N#include <stdarg.h>
L 1 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/stdarg.h" 1
N/*****************************************************************************/
N/* stdarg.h   v5.2.6                                                         */
N/* Copyright (c) 1996-2010 Texas Instruments Incorporated                    */
N/*****************************************************************************/
N
N#ifndef _STDARG
N#define _STDARG
N
N#include <linkage.h>
N
N#ifdef __cplusplus
N#define va_start(ap, parmN) (ap = ((std::va_list)__va_parmadr(parmN)))
Nnamespace std {
N#else
S#define va_start(ap, parmN) (ap = ((va_list)__va_parmadr(parmN)))
N#endif /* __cplusplus */
N
Ntypedef char *va_list;
N
N#ifdef __cplusplus
N} /* namespace std */
N#endif
N
N#define va_end(ap)
N
N/****************************************************************************/
N/* RETURN THE NEXT VALUE ON THE STACK ...                                   */
N/*                                                                          */
N/* (<advance ap>, <access the value>) BECOMES ...                           */
N/*                                                                          */
N/* ap -= 1 (stack grows toward high addresses)                              */
N/* ap -= 1 more if type is long or float                                    */
N/* ap -= 1 more if type is long or float and to account for alignment       */
N/*       if necessary                                                       */
N/*                                                                          */
N/* if      (<type is passed by address [struct or union]>) return **ap;     */
N/* else if (<type is integer size>)                        return *ap;      */
N/*                                                                          */
N/* LONG/FLOATS ARE ALWAYS ALIGNED ON AN EVEN WORD BOUNDARY, EVEN WHEN       */
N/* PASSED AS PARAMETERS, THUS ap MUST BE ALIGNED FOR THOSE ACCESSES.        */
N/****************************************************************************/
N#if __LARGE_MODEL__
X#if 1
N#define va_arg(ap, type)                                                 \
N( (ap -= 1 + (__va_argref(type) ? (((long)ap & 1) ? 2 : 1) :		 \
N				  (sizeof(type) == sizeof(int)) ? 0 :    \
N                                   ((long)ap & 1) ? sizeof(type) :       \
N                                                    sizeof(type) - 1 )), \
N   (__va_argref(type)             ? (** (type **) (ap)) : (* (type *) (ap)) ))
X#define va_arg(ap, type)                                                 ( (ap -= 1 + (__va_argref(type) ? (((long)ap & 1) ? 2 : 1) :		 				  (sizeof(type) == sizeof(int)) ? 0 :                                       ((long)ap & 1) ? sizeof(type) :                                                           sizeof(type) - 1 )),    (__va_argref(type)             ? (** (type **) (ap)) : (* (type *) (ap)) ))
N#else
S#define va_arg(ap, type)                                                 \
S( (ap -= 1 + (__va_argref(type) ? (((int)ap & 1) ? 2 : 1) : 		 \
S				  (sizeof(type) == sizeof(int)) ? 0 :    \
S                                   ((int)ap & 1) ? sizeof(type)      :   \
S                                                   sizeof(type) - 1 )),  \
S   (__va_argref(type)             ? (** (type **) (ap)) : (* (type *) (ap)) ))
X#define va_arg(ap, type)                                                 ( (ap -= 1 + (__va_argref(type) ? (((int)ap & 1) ? 2 : 1) : 		 				  (sizeof(type) == sizeof(int)) ? 0 :                                       ((int)ap & 1) ? sizeof(type)      :                                                      sizeof(type) - 1 )),     (__va_argref(type)             ? (** (type **) (ap)) : (* (type *) (ap)) ))
N#endif
N
N#endif /* _STDARG */
N
N#if defined(__cplusplus) && !defined(_CPP_STYLE_HEADER)
X#if 1L && !0L
Nusing std::va_list;
N#endif /* _CPP_STYLE_HEADER */
N
L 10 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/stdio.h" 2
N
N
N#ifdef __cplusplus
N//----------------------------------------------------------------------------
N// <cstdio> IS RECOMMENDED OVER <stdio.h>.  <stdio.h> IS PROVIDED FOR
N// COMPATIBILITY WITH C AND THIS USAGE IS DEPRECATED IN C++
N//----------------------------------------------------------------------------
Nextern "C" namespace std {
N#endif
N
N/****************************************************************************/
N/* TYPES THAT ANSI REQUIRES TO BE DEFINED                                   */
N/****************************************************************************/
N#ifndef _SIZE_T
S#define _SIZE_T
Stypedef __SIZE_T_TYPE__ size_t;
N#endif
N
Ntypedef struct {
N      int fd;                    /* File descriptor */
N      unsigned char* buf;        /* Pointer to start of buffer */
N      unsigned char* pos;        /* Position in buffer */
N      unsigned char* bufend;     /* Pointer to end of buffer */
N      unsigned char* buff_stop;  /* Pointer to last read char in buffer */
N      unsigned int   flags;      /* File status flags (see below) */
N} FILE;
N
N#ifndef _FPOS_T
N#define _FPOS_T
Ntypedef long fpos_t;
N#endif /* _FPOS_T */
N
N/****************************************************************************/
N/* DEVICE AND STREAM RELATED MACROS                                         */
N/****************************************************************************/
N/****************************************************************************/
N/* MACROS THAT DEFINE AND USE FILE STATUS FLAGS                             */
N/****************************************************************************/
N
N#define _IOFBF       0x0001
N#define _IOLBF       0x0002
N#define _IONBF       0x0004
N#define _BUFFALOC    0x0008
N#define _MODER       0x0010
N#define _MODEW       0x0020
N#define _MODERW      0x0040
N#define _MODEA       0x0080
N#define _MODEBIN     0x0100
N#define _STATEOF     0x0200
N#define _STATERR     0x0400
N#define _UNGETC      0x0800
N#define _TMPFILE     0x1000
N
N#define _SET(_fp, _b)      (((_fp)->flags) |= (_b))
N#define _UNSET(_fp, _b)    (((_fp)->flags) &= ~(_b))
N#define _STCHK(_fp, _b)    (((_fp)->flags) & (_b))
N#define _BUFFMODE(_fp)     (((_fp)->flags) & (_IOFBF | _IOLBF | _IONBF))
N#define _ACCMODE(_fp)      (((_fp)->flags) & (_MODER | _MODEW))
N
N/****************************************************************************/
N/* MACROS THAT ANSI REQUIRES TO BE DEFINED                                  */
N/****************************************************************************/
N#define BUFSIZ          256 
N
N#define FOPEN_MAX       _NFILE
N#define FILENAME_MAX    256  
N#define TMP_MAX         65535
N
N#define stdin     (&_ftable[0])      
N#define stdout    (&_ftable[1])
N#define stderr    (&_ftable[2])
N
N#define L_tmpnam  _LTMPNAM
N
N
N#define SEEK_SET  (0x0000)
N#define SEEK_CUR  (0x0001)
N#define SEEK_END  (0x0002)
N
N#ifndef NULL
S#define NULL 0
N#endif
N
N#ifndef EOF
N#define EOF    (-1)
N#endif
N
N
N/******** END OF ANSI MACROS ************************************************/
N
N#define P_tmpdir        ""                   /* Path for temp files         */
N
N/****************************************************************************/
N/* DEVICE AND STREAM RELATED DATA STRUCTURES AND MACROS                     */
N/****************************************************************************/
N#define _NFILE           10                   /* Max number of files open   */
N#define _LTMPNAM         16                   /* Length of temp name        */
N
Nextern _DATA_ACCESS FILE _ftable[_NFILE];
Xextern  FILE _ftable[10];
Nextern _DATA_ACCESS char _tmpnams[_NFILE][_LTMPNAM];
Xextern  char _tmpnams[10][16];
N
N/****************************************************************************/
N/*   FUNCTION DEFINITIONS  - ANSI                                           */
N/****************************************************************************/
N/****************************************************************************/
N/* OPERATIONS ON FILES                                                      */
N/****************************************************************************/
Nextern _CODE_ACCESS int     remove(const char *_file);
Xextern  int     remove(const char *_file);
Nextern _CODE_ACCESS int     rename(const char *_old, const char *_new);
Xextern  int     rename(const char *_old, const char *_new);
Nextern _CODE_ACCESS FILE   *tmpfile(void);
Xextern  FILE   *tmpfile(void);
Nextern _CODE_ACCESS char   *tmpnam(char *_s);
Xextern  char   *tmpnam(char *_s);
N
N/****************************************************************************/
N/* FILE ACCESS FUNCTIONS                                                    */
N/****************************************************************************/
Nextern _CODE_ACCESS int     fclose(FILE *_fp); 
Xextern  int     fclose(FILE *_fp); 
Nextern _CODE_ACCESS FILE   *fopen(const char *_fname, const char *_mode);
Xextern  FILE   *fopen(const char *_fname, const char *_mode);
Nextern _CODE_ACCESS FILE   *freopen(const char *_fname, const char *_mode,
Xextern  FILE   *freopen(const char *_fname, const char *_mode,
N			            register FILE *_fp);
Nextern _CODE_ACCESS void    setbuf(register FILE *_fp, char *_buf);
Xextern  void    setbuf(register FILE *_fp, char *_buf);
Nextern _CODE_ACCESS int     setvbuf(register FILE *_fp, register char *_buf, 
Xextern  int     setvbuf(register FILE *_fp, register char *_buf, 
N			            register int _type, register size_t _size);
Nextern _CODE_ACCESS int     fflush(register FILE *_fp); 
Xextern  int     fflush(register FILE *_fp); 
N
N/****************************************************************************/
N/* FORMATTED INPUT/OUTPUT FUNCTIONS                                         */
N/****************************************************************************/
Nextern _CODE_ACCESS int fprintf(FILE *_fp, const char *_format, ...);
Xextern  int fprintf(FILE *_fp, const char *_format, ...);
Nextern _CODE_ACCESS int fscanf(FILE *_fp, const char *_fmt, ...);
Xextern  int fscanf(FILE *_fp, const char *_fmt, ...);
Nextern _CODE_ACCESS int printf(const char *_format, ...);
Xextern  int printf(const char *_format, ...);
Nextern _CODE_ACCESS int scanf(const char *_fmt, ...);
Xextern  int scanf(const char *_fmt, ...);
Nextern _CODE_ACCESS int sprintf(char *_string, const char *_format, ...);
Xextern  int sprintf(char *_string, const char *_format, ...);
Nextern _CODE_ACCESS int snprintf(char *_string, size_t _n, 
Xextern  int snprintf(char *_string, size_t _n, 
N				 const char *_format, ...);
Nextern _CODE_ACCESS int sscanf(const char *_str, const char *_fmt, ...);
Xextern  int sscanf(const char *_str, const char *_fmt, ...);
Nextern _CODE_ACCESS int vfprintf(FILE *_fp, const char *_format, va_list _ap);
Xextern  int vfprintf(FILE *_fp, const char *_format, va_list _ap);
Nextern _CODE_ACCESS int vprintf(const char *_format, va_list _ap);
Xextern  int vprintf(const char *_format, va_list _ap);
Nextern _CODE_ACCESS int vsprintf(char *_string, const char *_format,
Xextern  int vsprintf(char *_string, const char *_format,
N				 va_list _ap);
Nextern _CODE_ACCESS int vsnprintf(char *_string, size_t _n, 
Xextern  int vsnprintf(char *_string, size_t _n, 
N				  const char *_format, va_list _ap);
N
N/****************************************************************************/
N/* CHARACTER INPUT/OUTPUT FUNCTIONS                                         */
N/****************************************************************************/
Nextern _CODE_ACCESS int     fgetc(register FILE *_fp);
Xextern  int     fgetc(register FILE *_fp);
Nextern _CODE_ACCESS char   *fgets(char *_ptr, register int _size,
Xextern  char   *fgets(char *_ptr, register int _size,
N				  register FILE *_fp);
Nextern _CODE_ACCESS int     fputc(int _c, register FILE *_fp);
Xextern  int     fputc(int _c, register FILE *_fp);
Nextern _CODE_ACCESS int     fputs(const char *_ptr, register FILE *_fp);
Xextern  int     fputs(const char *_ptr, register FILE *_fp);
Nextern _CODE_ACCESS int     getc(FILE *_p);
Xextern  int     getc(FILE *_p);
Nextern _CODE_ACCESS int     getchar(void);
Xextern  int     getchar(void);
Nextern _CODE_ACCESS char   *gets(char *_ptr); 
Xextern  char   *gets(char *_ptr); 
Nextern _CODE_ACCESS int     putc(int _x, FILE *_fp);
Xextern  int     putc(int _x, FILE *_fp);
Nextern _CODE_ACCESS int     putchar(int _x);
Xextern  int     putchar(int _x);
Nextern _CODE_ACCESS int     puts(const char *_ptr); 
Xextern  int     puts(const char *_ptr); 
Nextern _CODE_ACCESS int     ungetc(int _c, register FILE *_fp);
Xextern  int     ungetc(int _c, register FILE *_fp);
N
N/****************************************************************************/
N/* DIRECT INPUT/OUTPUT FUNCTIONS                                            */
N/****************************************************************************/
Nextern _CODE_ACCESS size_t  fread(void *_ptr, size_t _size, size_t _count,
Xextern  size_t  fread(void *_ptr, size_t _size, size_t _count,
N				  FILE *_fp);
Nextern _CODE_ACCESS size_t  fwrite(const void *_ptr, size_t _size,
Xextern  size_t  fwrite(const void *_ptr, size_t _size,
N				   size_t _count, register FILE *_fp); 
N
N/****************************************************************************/
N/* FILE POSITIONING FUNCTIONS                                               */
N/****************************************************************************/
Nextern _CODE_ACCESS int     fgetpos(FILE *_fp, fpos_t *_pos);
Xextern  int     fgetpos(FILE *_fp, fpos_t *_pos);
Nextern _CODE_ACCESS int     fseek(register FILE *_fp, long _offset,
Xextern  int     fseek(register FILE *_fp, long _offset,
N				  int _ptrname);
Nextern _CODE_ACCESS int     fsetpos(FILE *_fp, const fpos_t *_pos);
Xextern  int     fsetpos(FILE *_fp, const fpos_t *_pos);
Nextern _CODE_ACCESS long    ftell(FILE *_fp);
Xextern  long    ftell(FILE *_fp);
Nextern _CODE_ACCESS void    rewind(register FILE *_fp); 
Xextern  void    rewind(register FILE *_fp); 
N
N/****************************************************************************/
N/* ERROR-HANDLING FUNCTIONS                                                 */
N/****************************************************************************/
Nextern _CODE_ACCESS void    clearerr(FILE *_fp);
Xextern  void    clearerr(FILE *_fp);
Nextern _CODE_ACCESS int     feof(FILE *_fp);
Xextern  int     feof(FILE *_fp);
Nextern _CODE_ACCESS int     ferror(FILE *_fp);
Xextern  int     ferror(FILE *_fp);
Nextern _CODE_ACCESS void    perror(const char *_s);
Xextern  void    perror(const char *_s);
N
N#define _getchar()      getc(stdin)
N#define _putchar(_x)    putc((_x), stdout)
N#define _clearerr(_fp)   ((void) ((_fp)->flags &= ~(_STATERR | _STATEOF)))
N
N#define _ferror(_x)     ((_x)->flags & _STATERR)
N
N#define _remove(_fl)    (unlink((_fl)))
N
N#ifdef __cplusplus
N} /* extern "C" namespace std */
N#endif  /* __cplusplus */
N
N#endif  /* #ifndef _STDIO */
N
N#if defined(__cplusplus) && !defined(_CPP_STYLE_HEADER)
X#if 1L && !0L
Nusing std::size_t;
Nusing std::FILE;
Nusing std::fpos_t;
Nusing std::_ftable;
Nusing std::_tmpnams;
Nusing std::remove;
Nusing std::rename;
Nusing std::tmpfile;
Nusing std::tmpnam;
Nusing std::fclose;
Nusing std::fopen;
Nusing std::freopen;
Nusing std::setbuf;
Nusing std::setvbuf;
Nusing std::fflush;
Nusing std::fprintf;
Nusing std::fscanf;
Nusing std::printf;
Nusing std::scanf;
Nusing std::sprintf;
Nusing std::sscanf;
Nusing std::vfprintf;
Nusing std::vprintf;
Nusing std::vsprintf;
Nusing std::fgetc;
Nusing std::fgets;
Nusing std::fputc;
Nusing std::fputs;
Nusing std::getc;
Nusing std::getchar;
Nusing std::gets;
Nusing std::putc;
Nusing std::putchar;
Nusing std::puts;
Nusing std::ungetc;
Nusing std::fread;
Nusing std::fwrite;
Nusing std::fgetpos;
Nusing std::fseek;
Nusing std::fsetpos;
Nusing std::ftell;
Nusing std::rewind;
Nusing std::clearerr;
Nusing std::feof;
Nusing std::ferror;
Nusing std::perror;
N
N#endif  /* _CPP_STYLE_HEADER */
N
N
L 24 "../src/cores/Print.cpp" 2
N#include <string.h>
L 1 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/string.h" 1
N/*****************************************************************************/
N/* string.h   v5.2.6                                                         */
N/* Copyright (c) 1993-2010 Texas Instruments Incorporated                    */
N/*****************************************************************************/
N
N#ifndef _STRING
N#define _STRING
N
N#ifdef __cplusplus
N//----------------------------------------------------------------------------
N// <cstring> IS RECOMMENDED OVER <string.h>.  <string.h> IS PROVIDED FOR
N// COMPATIBILITY WITH C AND THIS USAGE IS DEPRECATED IN C++
N//----------------------------------------------------------------------------
Nextern "C" namespace std
N{
N#endif /* __cplusplus */
N 
N#ifndef NULL
S#define NULL 0
N#endif
N
N#ifndef _SIZE_T
S#define _SIZE_T
Stypedef __SIZE_T_TYPE__ size_t;
N#endif
N
N#include <linkage.h>
N
N#if defined(_OPTIMIZE_FOR_SPACE) && (defined(__TMS470__) || 		\
N				     defined(__TMS320C2000__)  ||       \
N                                     defined(__MSP430__))
X#if 1L && (0L || 						     1L  ||                                            0L)
N#define _OPT_IDECL
N#else
S#define _OPT_IDECL	_IDECL
N#endif
N
N_OPT_IDECL size_t  strlen(const char *_string);
X size_t  strlen(const char *_string);
N
N_OPT_IDECL char *strcpy(char *_dest, const char *_src);
X char *strcpy(char *_dest, const char *_src);
N_OPT_IDECL char *strncpy(char *_to, const char *_from, size_t _n);
X char *strncpy(char *_to, const char *_from, size_t _n);
N_OPT_IDECL char *strcat(char *_string1, const char *_string2);
X char *strcat(char *_string1, const char *_string2);
N_OPT_IDECL char *strncat(char *_to, const char *_from, size_t _n);
X char *strncat(char *_to, const char *_from, size_t _n);
N_OPT_IDECL char *strchr(const char *_string, int _c);
X char *strchr(const char *_string, int _c);
N_OPT_IDECL char *strrchr(const char *_string, int _c);
X char *strrchr(const char *_string, int _c);
N
N_OPT_IDECL int  strcmp(const char *_string1, const char *_string2);
X int  strcmp(const char *_string1, const char *_string2);
N_OPT_IDECL int  strncmp(const char *_string1, const char *_string2, size_t _n);
X int  strncmp(const char *_string1, const char *_string2, size_t _n);
N
N_CODE_ACCESS int     strcoll(const char *_string1, const char *_string2);
X int     strcoll(const char *_string1, const char *_string2);
N_CODE_ACCESS size_t  strxfrm(char *_to, const char *_from, size_t _n);
X size_t  strxfrm(char *_to, const char *_from, size_t _n);
N_CODE_ACCESS char   *strpbrk(const char *_string, const char *_chs);
X char   *strpbrk(const char *_string, const char *_chs);
N_CODE_ACCESS size_t  strspn(const char *_string, const char *_chs);
X size_t  strspn(const char *_string, const char *_chs);
N_CODE_ACCESS size_t  strcspn(const char *_string, const char *_chs);
X size_t  strcspn(const char *_string, const char *_chs);
N_CODE_ACCESS char   *strstr(const char *_string1, const char *_string2);
X char   *strstr(const char *_string1, const char *_string2);
N_CODE_ACCESS char   *strtok(char *_str1, const char *_str2);
X char   *strtok(char *_str1, const char *_str2);
N_CODE_ACCESS char   *strerror(int _errno);
X char   *strerror(int _errno);
N
N_CODE_ACCESS void   *memmove(void *_s1, const void *_s2, size_t _n);
X void   *memmove(void *_s1, const void *_s2, size_t _n);
N
N_OPT_IDECL int     memcmp(const void *_cs, const void *_ct, size_t _n);
X int     memcmp(const void *_cs, const void *_ct, size_t _n);
N_OPT_IDECL void   *memchr(const void *_cs, int _c, size_t _n);
X void   *memchr(const void *_cs, int _c, size_t _n);
N
N_OPT_IDECL   void   *memset(void *_mem, int _ch, size_t _n);
X   void   *memset(void *_mem, int _ch, size_t _n);
N
N
N#ifndef __cplusplus
S#define far_memcpy __memcpy_ff
S#define far_strcpy strcpy_ff
Ssize_t    far_strlen(const far char *s);
Schar     *strcpy_nf(char *s1, const char far *s2);
Schar far *strcpy_fn(char far *s1, const char *s2);
Schar far *strcpy_ff(char far *s1, const char far *s2);
Sfar char *far_strncpy(far char *s1, far const char *s2, size_t n);
Sfar char *far_strcat(far char *s1, const far char *s2);
Sfar char *far_strncat(far char *s1, const far char *s2, size_t n);
Sfar char *far_strchr(const far char *s, int c);
Sfar char *far_strrchr(const far char *s, int c);
Sint       far_strcmp(const far char *s1, const far char *s2);
Sint       far_strncmp(const far char *s1, const far char *s2, size_t n);
Sint       far_strcoll(const far char *s1, const far char *s2);
Ssize_t    far_strxfrm(far char *s1, const far char *s2, size_t n);
Sfar char *far_strpbrk(const far char *s1, const far char *s2);
Ssize_t    far_strspn(const far char *s1, const far char *s2);
Ssize_t    far_strcspn(const far char *s1, const far char *s2);
Sfar char *far_strstr(const far char *s1, const far char *s2);
Sfar char *far_strtok(far char *s1, const far char *s2);
Sfar char *far_strerror(int errno);
Svoid far *far_memmove(far void *s1, far const void *s2, size_t n);
Svoid     *__memcpy_nf (void *_s1, far const void *_s2, size_t _n);
Svoid far *__memcpy_fn (far void *_s1, const void *_s2, size_t _n);
Svoid far *__memcpy_ff (far void *_s1, far const void *_s2, size_t _n);
Sint       far_memcmp(const far void *s1, const far void *s2, size_t n);
Sfar void *far_memchr(const far void *s, int c, size_t n);
Sfar void *far_memset(far void *s, int c, size_t n);
Sfar void *far_memlcpy(far void *to, const far void *from, unsigned long n);
Sfar void *far_memlmove(far void *to, const far void *from, unsigned long n);
N#else /* __cplusplus */
Nlong      far_memlcpy(long to, long from, unsigned long n);
Nlong      far_memlmove(long to, long from, unsigned long n);
N#endif /* __cplusplus */
N
N
N#ifdef __cplusplus
N} /* extern "C" namespace std */
N#endif /* __cplusplus */
N
N#if defined(_INLINE) || defined(_STRING_IMPLEMENTATION)
X#if 0L || 0L
S
S#if (defined(_STRING_IMPLEMENTATION) ||					\
S     !(defined(_OPTIMIZE_FOR_SPACE) && (defined(__TMS470__) || 		\
S					defined(__TMS320C2000__)  ||    \
S                                        defined(__MSP430__))))
X#if (defined(_STRING_IMPLEMENTATION) ||					     !(defined(_OPTIMIZE_FOR_SPACE) && (defined(__TMS470__) || 							defined(__TMS320C2000__)  ||                                            defined(__MSP430__))))
S
S#ifdef __cplusplus
Snamespace std {
S#endif
S
S#if (defined(_OPTIMIZE_FOR_SPACE) && (defined(__TMS470__) || 		\
S				      defined(__TMS320C2000__) ||       \
S                                      defined(__MSP430__)))
X#if (defined(_OPTIMIZE_FOR_SPACE) && (defined(__TMS470__) || 						      defined(__TMS320C2000__) ||                                             defined(__MSP430__)))
S#define _OPT_IDEFN
S#else
S#define _OPT_IDEFN	_IDEFN
S#endif
S
S#if defined(_INLINE) || defined(_STRLEN)
S_OPT_IDEFN size_t strlen(const char *string)
S{
S   size_t      n = (size_t)-1;
S   const char *s = string;
S
S   do n++; while (*s++);
S   return n;
S}
S#endif /* _INLINE || _STRLEN */
S
S#if defined(_INLINE) || defined(_STRCPY)
S_OPT_IDEFN char *strcpy(register char *dest, register const char *src)
S{
S     register char       *d = dest;     
S     register const char *s = src;
S
S     while (*d++ = *s++);
S     return dest;
S}
S#endif /* _INLINE || _STRCPY */
S
S#if defined(_INLINE) || defined(_STRNCPY)
S_OPT_IDEFN char *strncpy(register char *dest,
S		     register const char *src,
S		     register size_t n)
S{
S     if (n) 
S     {
S	 register char       *d = dest;
S	 register const char *s = src;
S	 while ((*d++ = *s++) && --n);              /* COPY STRING         */
S	 if (n-- > 1) do *d++ = '\0'; while (--n);  /* TERMINATION PADDING */
S     }
S     return dest;
S}
S#endif /* _INLINE || _STRNCPY  */
S
S#if defined(_INLINE) || defined(_STRCAT)
S_OPT_IDEFN char *strcat(char *string1, const char *string2)
S{
S   char       *s1 = string1;
S   const char *s2 = string2;
S
S   while (*s1) s1++;		     /* FIND END OF STRING   */
S   while (*s1++ = *s2++);	     /* APPEND SECOND STRING */
S   return string1;
S}
S#endif /* _INLINE || _STRCAT */
S
S#if defined(_INLINE) || defined(_STRNCAT)
S_OPT_IDEFN char *strncat(char *dest, const char *src, register size_t n)
S{
S    if (n)
S    {
S	char       *d = dest;
S	const char *s = src;
S
S	while (*d) d++;                      /* FIND END OF STRING   */
S
S	while (n--)
S	  if (!(*d++ = *s++)) return dest; /* APPEND SECOND STRING */
S	*d = 0;
S    }
S    return dest;
S}
S#endif /* _INLINE || _STRNCAT */
S
S#if defined(_INLINE) || defined(_STRCHR)
S_OPT_IDEFN char *strchr(const char *string, int c)
S{
S   char        tch, ch  = c;
S   const char *s        = string;
S
S   for (;;)
S   {
S       if ((tch = *s) == ch) return (char *) s;
S       if (!tch)             return (char *) 0;
S       s++;
S   }
S}
S#endif /* _INLINE || _STRCHR */
S
S#if defined(_INLINE) || defined(_STRRCHR)
S_OPT_IDEFN char *strrchr(const char *string, int c)
S{
S   char        tch, ch = c;
S   char       *result  = 0;
S   const char *s       = string;
S
S   for (;;)
S   {
S      if ((tch = *s) == ch) result = (char *) s;
S      if (!tch) break;
S      s++;
S   }
S
S   return result;
S}
S#endif /* _INLINE || _STRRCHR */
S
S#if defined(_INLINE) || defined(_STRCMP)
S_OPT_IDEFN int strcmp(register const char *string1,
S		  register const char *string2)
S{
S   register int c1, res;
S
S   for (;;)
S   {
S       c1  = (unsigned char)*string1++;
S       res = c1 - (unsigned char)*string2++;
S
S       if (c1 == 0 || res != 0) break;
S   }
S
S   return res;
S}
S#endif /* _INLINE || _STRCMP */
S
S#if defined(_INLINE) || defined(_STRNCMP)
S_OPT_IDEFN int strncmp(const char *string1, const char *string2, size_t n)
S{
S     if (n) 
S     {
S	 const char *s1 = string1;
S	 const char *s2 = string2;
S	 unsigned char cp;
S	 int         result;
S
S	 do 
S	    if (result = (unsigned char)*s1++ - (cp = (unsigned char)*s2++))
S                return result;
S	 while (cp && --n);
S     }
S     return 0;
S}
S#endif /* _INLINE || _STRNCMP */
S
S#if defined(_INLINE) || defined(_MEMCMP)
S_OPT_IDEFN int memcmp(const void *cs, const void *ct, size_t n)
S{
S   if (n) 
S   {
S       const unsigned char *mem1 = (unsigned char *)cs;
S       const unsigned char *mem2 = (unsigned char *)ct;
S       int                 cp1, cp2;
S
S       while ((cp1 = *mem1++) == (cp2 = *mem2++) && --n);
S       return cp1 - cp2;
S   }
S   return 0;
S}
S#endif /* _INLINE || _MEMCMP */
S
S#if defined(_INLINE) || defined(_MEMCHR)
S_OPT_IDEFN void *memchr(const void *cs, int c, size_t n)
S{
S   if (n)
S   {
S      const unsigned char *mem = (unsigned char *)cs;   
S      unsigned char        ch  = c;
S
S      do 
S         if ( *mem == ch ) return (void *)mem;
S         else mem++;
S      while (--n);
S   }
S   return NULL;
S}
S#endif /* _INLINE || _MEMCHR */
S
S#if ((defined(_INLINE) || defined(_MEMSET)) && !defined(_TMS320C6X)) && !defined(__TMS470__)
S_OPT_IDEFN void *memset(void *mem, register int ch, register size_t length)
S{
S     register char *m = (char *)mem;
S
S     while (length--) *m++ = ch;
S     return mem;
S}
S#endif /* _INLINE || _MEMSET */
S
S#ifdef __cplusplus
S} /* namespace std */
S#endif
S
S#endif /* (_STRING_IMPLEMENTATION || !(_OPTIMIZE_FOR_SPACE && __TMS470__)) */
S
N#endif /* (_INLINE || _STRING_IMPLEMENTATION) */
N
N#endif /* ! _STRING */
N
N#if defined(__cplusplus) && !defined(_CPP_STYLE_HEADER)
X#if 1L && !0L
Nusing std::size_t;
Nusing std::strlen;
Nusing std::strcpy;
Nusing std::strncpy;
Nusing std::strcat;
Nusing std::strncat;
Nusing std::strchr;
Nusing std::strrchr;
Nusing std::strcmp;
Nusing std::strncmp;
Nusing std::strcoll;
Nusing std::strxfrm;
Nusing std::strpbrk;
Nusing std::strspn;
Nusing std::strcspn;
Nusing std::strstr;
Nusing std::strtok;
Nusing std::strerror;
Nusing std::memmove;
Nusing std::memcpy;
Nusing std::memcmp;
Nusing std::memchr;
Nusing std::memset;
N
Nusing std::far_memlcpy;
Nusing std::far_memlmove;
N
N#endif /* _CPP_STYLE_HEADER */
N
L 25 "../src/cores/Print.cpp" 2
N#include <math.h>
L 1 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/math.h" 1
N/*****************************************************************************/
N/* math.h     v5.2.6                                                         */
N/* Copyright (c) 1996-2010 Texas Instruments Incorporated                    */
N/*****************************************************************************/
N
N#ifndef _MATH
N#define _MATH
N
N
N#include <linkage.h>
N#include <float.h>
L 1 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/float.h" 1
N/*****************************************************************************/
N/* float.h    v5.2.6                                                         */
N/* Copyright (c) 1996-2010 Texas Instruments Incorporated                    */
N/*****************************************************************************/
N
N/********************************************************************/
N/*    KEY:  FLT_     - APPLIES TO TYPE FLOAT                        */
N/*          DBL_     - APPLIES TO TYPE DOUBLE                       */
N/*          LDBL_    - APPLIES TO TYPE LONG DOUBLE                  */
N/********************************************************************/
N#ifndef _FLOAT
N#define _FLOAT
N
N#define FLT_RADIX                         2   /* RADIX OF EXPONENT         */
N#define FLT_ROUNDS                        1   /* ROUND TO NEAREST          */
N 
N#define FLT_DIG                           6   /* DECIMAL PRECISION         */
N#define FLT_MANT_DIG                     24   /* BITS IN MANTISSA          */
N#define FLT_MIN_EXP                    -125   /* SMALLEST EXPONENT         */
N#define FLT_MAX_EXP                     128   /* LARGEST EXPONENT          */
N#define FLT_EPSILON        1.192092896E-07F   /* SMALLEST X WHERE 1+X != 1 */
N#define FLT_MIN            1.175494351E-38F   /* SMALLEST POSITIVE VALUE   */
N#define FLT_MAX            3.402823466E+38F   /* LARGEST POSITIVE VALUE    */
N#define FLT_MIN_10_EXP                  -37   /* MIN POWER OF 10           */
N#define FLT_MAX_10_EXP                   38   /* MAX POWER OF 10           */
N 
N#define DBL_DIG                           6   /* DECIMAL PRECISION         */
N#define DBL_MANT_DIG                     24   /* BITS IN MANTISSA          */
N#define DBL_MIN_EXP                    -125   /* SMALLEST EXPONENT         */
N#define DBL_MAX_EXP                     128   /* LARGEST EXPONENT          */
N#define DBL_EPSILON        1.192092896E-07    /* SMALLEST X WHERE 1+X != 1 */
N#define DBL_MIN            1.175494351E-38    /* SMALLEST POSITIVE VALUE   */
N#define DBL_MAX            3.402823466E+38    /* LARGEST POSITIVE VALUE    */
N#define DBL_MIN_10_EXP                  -37   /* MIN POWER OF 10           */
N#define DBL_MAX_10_EXP                   38   /* MAX POWER OF 10           */
N 
N#if defined(__TMS320C27X__)
X#if 0L
S
S#define LDBL_DIG                          6   /* DECIMAL PRECISION         */
S#define LDBL_MANT_DIG                    24   /* BITS IN MANTISSA          */
S#define LDBL_MIN_EXP                   -125   /* SMALLEST EXPONENT         */
S#define LDBL_MAX_EXP                    128   /* LARGEST EXPONENT          */
S#define LDBL_EPSILON       1.192092896E-07    /* SMALLEST X WHERE 1+X != 1 */
S#define LDBL_MIN           1.175494351E-38    /* SMALLEST POSITIVE VALUE   */
S#define LDBL_MAX           3.402823466E+38    /* LARGEST POSITIVE VALUE    */
S#define LDBL_MIN_10_EXP                 -37   /* MIN POWER OF 10           */
S#define LDBL_MAX_10_EXP                  38   /* MAX POWER OF 10           */
S
N#elif defined(__TMS320C28X__)
X#elif 1L
N
N#define LDBL_DIG                         15   /* DECIMAL PRECISION         */
N#define LDBL_MANT_DIG                    53   /* BITS IN MANTISSA          */
N#define LDBL_MIN_EXP                  -1021   /* SMALLEST EXPONENT         */
N#define LDBL_MAX_EXP                   1024   /* LARGEST EXPONENT          */
N#define LDBL_EPSILON 2.2204460492503131E-16L  /* SMALLEST X WHERE 1+X != 1 */
N#define LDBL_MIN    2.2250738585072014E-308L  /* SMALLEST POSITIVE VALUE   */
N#define LDBL_MAX    1.7976931348623157E+308L  /* LARGEST POSITIVE VALUE    */
N#define LDBL_MIN_10_EXP                -307   /* MIN POWER OF 10           */
N#define LDBL_MAX_10_EXP                 308   /* MAX POWER OF 10           */
N
N#endif /* __TMS320C28X__ */
N
N#endif /* _FLOAT */
L 12 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/math.h" 2
N#define HUGE_VAL   DBL_MAX
N#define HUGE_VALL  LDBL_MAX
N
N#ifdef __cplusplus
N//----------------------------------------------------------------------------
N// <cmath> IS RECOMMENDED OVER <math.h>.  <math.h> IS PROVIDED FOR 
N// COMPATIBILITY WITH C AND THIS USAGE IS DEPRECATED IN C++
N//----------------------------------------------------------------------------
Nextern "C" namespace std {
N#endif /* __cplusplus */
N
N/***************************************************************/
N/* FUNCTION DEFINITIONS.                                       */
N/***************************************************************/
N         double modf(double x, double *y); 
W "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/math.h" 27 36 type qualifiers are meaningless in this declaration
N         double far_modf(double x, far double *y); 
N         double asin(double x);
N         double acos(double x);
N         double atan(double x);
N         double atan2(double y, double x);
N__inline double ceil(double x)  { double y; return (modf(x, &y) > 0 ? y+1:y); }
N         double cos(double x);
N         double cosh(double x);
N         double exp(double x);
N         double fabs(double x);
N__inline double floor(double x) { double y; return (modf(x, &y) < 0 ? y-1:y); }
N         double fmod(double x, double y);
N         double frexp(double x, int *exp);
W "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/math.h" 40 37 type qualifiers are meaningless in this declaration
N         double far_frexp(double x, far int *exp);
N         double ldexp(double x, int exp);
N         double log(double x);
N         double log10(double x);
N         double pow(double x, double y);
N         double sin(double x);
N         double sinh(double x);
N         double tan(double x);
N         double tanh(double x);
N         double sqrt(double x);
N
N#ifdef __cplusplus
N} /* extern "C" namespace std */
N#endif /* __cplusplus */
N
N/*******************************************************************************/
N/* Overloaded version of math functions for float and long double in C++       */
N/*******************************************************************************/
N#endif /* _MATH */
N
N#if defined(__cplusplus) && !defined(_CPP_STYLE_HEADER)
X#if 1L && !0L
Nusing std::modf;
Nusing std::asin;
Nusing std::acos;
Nusing std::atan;
Nusing std::atan2;
Nusing std::ceil;
Nusing std::cos;
Nusing std::cosh;
Nusing std::exp;
Nusing std::fabs;
Nusing std::floor;
Nusing std::fmod;
Nusing std::frexp;
Nusing std::ldexp;
Nusing std::log;
Nusing std::log10;
Nusing std::pow;
Nusing std::sin;
Nusing std::sinh;
Nusing std::tan;
Nusing std::tanh;
Nusing std::sqrt;
N#endif /* _CPP_STYLE_HEADER */
N
L 26 "../src/cores/Print.cpp" 2
N#include "wiring.h"
L 1 "..\src\cores\wiring.h" 1
N/*
N  wiring.h - Partial implementation of the Wiring API for the ATmega8.
N  Part of Arduino - http://www.arduino.cc/
N
N  Copyright (c) 2005-2006 David A. Mellis
N
N  This library is free software; you can redistribute it and/or
N  modify it under the terms of the GNU Lesser General Public
N  License as published by the Free Software Foundation; either
N  version 2.1 of the License, or (at your option) any later version.
N
N  This library is distributed in the hope that it will be useful,
N  but WITHOUT ANY WARRANTY; without even the implied warranty of
N  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
N  Lesser General Public License for more details.
N
N  You should have received a copy of the GNU Lesser General
N  Public License along with this library; if not, write to the
N  Free Software Foundation, Inc., 59 Temple Place, Suite 330,
N  Boston, MA  02111-1307  USA
N
N  $Id$
N*/
N
N#ifndef Wiring_h
N#define Wiring_h
N
N//#include <avr/io.h>		 todomimu
N#include <stdlib.h>
L 1 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/stdlib.h" 1
N/*****************************************************************************/
N/* stdlib.h   v5.2.6                                                         */
N/* Copyright (c) 1993-2010 Texas Instruments Incorporated                    */
N/*****************************************************************************/
N
N#ifndef _STDLIB
S#define _STDLIB
S
S
S#ifdef __cplusplus
S//----------------------------------------------------------------------------
S// <cstdlib> IS RECOMMENDED OVER <stdlib.h>.  <stdlib.h> IS PROVIDED FOR 
S// COMPATIBILITY WITH C AND THIS USAGE IS DEPRECATED IN C++
S//----------------------------------------------------------------------------
Sextern "C" namespace std {
S#endif /* !__cplusplus */
S
Stypedef struct { int quot, rem; } div_t;
S
Stypedef struct { long quot, rem; } ldiv_t;
S
S#define _LLONG_AVAILABLE 1
Stypedef struct { long long quot, rem; } lldiv_t;
S
S#define MB_CUR_MAX    1
S
S#ifndef NULL
S#define NULL          0
S#endif
S
S#ifndef _SIZE_T
S#define _SIZE_T
Stypedef __SIZE_T_TYPE__ size_t;
S#endif
S
S#ifndef __cplusplus
S#ifndef _WCHAR_T
S#define _WCHAR_T
Stypedef __WCHAR_T_TYPE__ wchar_t;
S#endif
S#endif
S
S#define EXIT_FAILURE  1
S#define EXIT_SUCCESS  0
S
S#define RAND_MAX      32767
S
S#include <linkage.h>
S
S/*---------------------------------------------------------------*/
S/* NOTE - Normally, abs, labs, and fabs are expanded inline, so  */
S/*        no formal definition is really required. However, ANSI */
S/*        requires that they exist as separate functions, so     */
S/*        they are supplied in the library.  The prototype is    */
S/*        here mainly for documentation.                         */
S/*---------------------------------------------------------------*/
S    _CODE_ACCESS  int       abs(int _val); 
S    _CODE_ACCESS  long      labs(long _val);
S#if defined(_LLONG_AVAILABLE)
S    _CODE_ACCESS  long long llabs(long long _val);
S#endif
S    _CODE_ACCESS int       atoi(const char *_st);
S    _CODE_ACCESS long      atol(const char *_st);
S#if defined(_LLONG_AVAILABLE)
S    _CODE_ACCESS long long atoll(const char *_st);
S#endif
S    _CODE_ACCESS int       ltoa(long val, char *buffer);
S          _IDECL double    atof(const char *_st);
S
S    _CODE_ACCESS long      strtol(const char *_st, char **_endptr, int _base);
S    _CODE_ACCESS unsigned long strtoul(const char *_st, char **_endptr,
S    					  int _base);
S#if defined(_LLONG_AVAILABLE)
S    _CODE_ACCESS long long strtoll(const char *_st, char **_endptr, int _base);
S    _CODE_ACCESS unsigned long long strtoull(const char *_st, char **_endptr,
S					     int _base);
S#endif
S    _CODE_ACCESS double    strtod(const char *_st, char **_endptr);
S    _CODE_ACCESS long double strtold(const char *_st, char **_endptr);
S    
S    _CODE_ACCESS int    rand(void);
S    _CODE_ACCESS void   srand(unsigned _seed);
S    
S    _CODE_ACCESS void  *calloc(size_t _num, size_t _size);
S    _CODE_ACCESS void  *malloc(size_t _size);
S    _CODE_ACCESS void  *realloc(void *_ptr, size_t _size);
S    _CODE_ACCESS void   free(void *_ptr);
S    _CODE_ACCESS void  *memalign(size_t _aln, size_t _size);
S    
S    _CODE_ACCESS void   abort(void); 
S    _CODE_ACCESS int    atexit(void (*_func)(void));
S    _CODE_ACCESS void  *bsearch(const void *_key, const void *_base,
S    				   size_t _nmemb, size_t _size, 
S    			           int (*compar)(const void *,const void *));
S    _CODE_ACCESS void   qsort(void *_base, size_t _nmemb, size_t _size, 
S    			         int (*_compar)(const void *, const void *));
S    _CODE_ACCESS void   exit(int _status);
S    
S    _CODE_ACCESS div_t  div(int _numer, int _denom);
S    _CODE_ACCESS ldiv_t ldiv(long _numer, long _denom);
S#if defined(_LLONG_AVAILABLE)
S    _CODE_ACCESS lldiv_t lldiv(long long _numer, long long _denom);
S#endif
S
S    _CODE_ACCESS char  *getenv(const char *_string);
S    _CODE_ACCESS int    system(const char *_name);
S
S    _CODE_ACCESS int    mblen(const char *, size_t);
S    _CODE_ACCESS size_t mbstowcs(wchar_t *, const char *, size_t);
S    _CODE_ACCESS int    mbtowc(wchar_t *, const char *, size_t);
S
S    _CODE_ACCESS size_t wcstombs(char *, const wchar_t *, size_t);
S    _CODE_ACCESS int    wctomb(char *, wchar_t);
S
S#ifdef __cplusplus
S} /* extern "C" namespace std */
S#endif /* __cplusplus */
S
S
S#ifdef _INLINE
S
S#ifdef __cplusplus
Snamespace std {
S#endif
S
Sstatic __inline double atof(const char *_st) 
S{
S  return strtod(_st, (char **)0); 
S}
S
S#ifdef __cplusplus
S} /* namespace std */
S#endif
S
S#endif  /* _INLINE */
S
N#endif  /* ! _STDLIB */
N
N#if defined(__cplusplus) && !defined(_CPP_STYLE_HEADER)
X#if 1L && !0L
Nusing std::div_t;
Nusing std::ldiv_t;
N#if defined(_LLONG_AVAILABLE)
X#if 1L
Nusing std::lldiv_t;
N#endif
Nusing std::size_t;
Nusing std::abs;
Nusing std::labs;
Nusing std::atoi;
Nusing std::atol;
N#if defined(_LLONG_AVAILABLE)
X#if 1L
Nusing std::llabs;
Nusing std::atoll;
N#endif
Nusing std::atof;
Nusing std::strtol;
Nusing std::strtoul;
N#if defined(_LLONG_AVAILABLE)
X#if 1L
Nusing std::strtoll;
Nusing std::strtoull;
N#endif
Nusing std::strtod;
Nusing std::rand;
Nusing std::srand;
Nusing std::calloc;
Nusing std::malloc;
Nusing std::realloc;
Nusing std::free;
Nusing std::memalign;
Nusing std::abort;
Nusing std::atexit;
Nusing std::bsearch;
Nusing std::qsort;
Nusing std::exit;
Nusing std::div;
Nusing std::ldiv;
N#if defined(_LLONG_AVAILABLE)
X#if 1L
Nusing std::lldiv;
N#endif
Nusing std::getenv;
Nusing std::system;
N#endif /* ! _CPP_STYLE_HEADER */
N
N#include <stdlibf.h>     /* far versions of stdlib fns */
L 1 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/stdlibf.h" 1
N/*****************************************************************************/
N/* stdlibf.h   v5.2.6                                                        */
N/*     far versions of stdlib.h functions                                    */
N/* Copyright (c) 1996-2010 Texas Instruments Incorporated                    */
N/*****************************************************************************/
N#ifndef _STDLIBF
S#define _STDLIBF
S
S#ifndef __cplusplus
S_CODE_ACCESS long          far_strtol (const far char *st, far char **endptr, 
S				   int base);
S_CODE_ACCESS unsigned long far_strtoul(const far char *st, far char **endptr, 
S				   int base);
S_CODE_ACCESS double        far_strtod (const far char *st, far char **endptr);
S_CODE_ACCESS long double   far_strtold (const far char *st, far char **endptr);
S_CODE_ACCESS long long     far_strtoll(const far char *st, far char **endptr, 
S		 						    int base);
S_CODE_ACCESS unsigned long long far_strtoull(const far char *st, 
S                                                   far char **endptr, int base);
S_CODE_ACCESS int           far_atoi(const far char *st);
S_CODE_ACCESS long          far_atol(const far char *st);
S_IDECL       double        far_atof(const far char *st);
S_CODE_ACCESS long long     far_atoll(const far char *st);
S
S_CODE_ACCESS far void     *far_calloc  (unsigned long num, unsigned long size);
S_CODE_ACCESS far void     *far_malloc  (unsigned long size);
S_CODE_ACCESS far void     *far_realloc (far void *ptr, unsigned long size);
S_CODE_ACCESS void          far_free    (far void *ptr);
S
S_CODE_ACCESS far void     *far_bsearch(const far void *key, 
S                                       const far void *base, 
S			               size_t nmemb, size_t size, 
S			               int (*compar)(const far void *,
S                                                     const far void *));
S_CODE_ACCESS void          far_qsort  (far void *base, 
S                                       size_t nmemb, size_t size,
S			               int (*compar)(const far void *, 
S                                                     const far void *));
S
S_CODE_ACCESS int	   free_memory(void);
S_CODE_ACCESS int           max_free(void);
S_CODE_ACCESS void         *chkheap();
S
S#ifdef _INLINE
Sstatic __inline double far_atof(const far char *st) 
S{ 
S   return far_strtod(st, NULL);
S}
S#endif /* _INLINE */
S
S#else /* __cplusplus */
S
Snamespace std {
S
Sextern "C" int	       free_memory(void);
Sextern "C" int         max_free(void);
Sextern "C" void        *chkheap();
S
S_CODE_ACCESS long      far_calloc  (unsigned long num, unsigned long size);
S_CODE_ACCESS long      far_malloc  (unsigned long size);
S_CODE_ACCESS long      far_realloc (long ptr, unsigned long size);
S_CODE_ACCESS void      far_free    (long ptr);
S_CODE_ACCESS long      far_free_memory(void);
S_CODE_ACCESS long      far_max_free(void);
S_CODE_ACCESS long      far_chkheap(void);
S
S}
S#endif /* __cplusplus */
N#endif /* _STDLIBF */
N
N#if defined(__cplusplus) && !defined(_CPP_STYLE_HEADER)
X#if 1L && !0L
Nusing std::free_memory; 
Nusing std::max_free;
Nusing std::chkheap;
Nusing std::far_calloc;
Nusing std::far_malloc;
Nusing std::far_realloc;
Nusing std::far_free;
Nusing std::far_free_memory; 
Nusing std::far_max_free;
Nusing std::far_chkheap;
N#endif /* _CPP_STYLE_HEADER */
L 184 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/stdlib.h" 2
L 30 "..\src\cores\wiring.h" 2
N#include "f_types.h"
L 1 "..\src\cores\f_types.h" 1
N/*** f_types.h - ***/
N
N#ifndef	INC_f_types_H
N#define	INC_f_types_H
N
N#include <stdint.h>
L 1 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/stdint.h" 1
N/*****************************************************************************/
N/* STDINT.H v5.2.6                                                           */
N/* Copyright (c) 2002-2010 Texas Instruments Incorporated                    */
N/*****************************************************************************/
N#ifndef _STDINT_H_
N#define _STDINT_H_
N
N/* 7.18.1.1 Exact-width integer types */
N
N    typedef          int    int16_t;
N    typedef unsigned int   uint16_t;
N    typedef          long   int32_t;
N    typedef unsigned long  uint32_t;
N
N
N#if defined(__TMS470__) || defined(_TMS320C6X) || defined(__TMS320C28X__)
X#if 0L || 0L || 1L
N    typedef          long long  int64_t;
N    typedef unsigned long long uint64_t;
N#endif
N
N/* 7.18.1.2 Minimum-width integer types */
N
N    typedef  int16_t  int_least8_t;
N    typedef uint16_t uint_least8_t;
N
N    typedef  int16_t  int_least16_t;
N    typedef uint16_t uint_least16_t;
N    typedef  int32_t  int_least32_t;
N    typedef uint32_t uint_least32_t;
N
N
N#if defined(__TMS470__) || defined(_TMS320C6X) || defined(__TMS320C28X__)
X#if 0L || 0L || 1L
N    typedef  int64_t  int_least64_t;
N    typedef uint64_t uint_least64_t;
N#else
S/* sorry, int_least64_t not implemented for C54x, C55x, MSP430 */
N#endif
N
N/* 7.18.1.3 Fastest minimum-width integer types */
N
N    typedef  int16_t  int_fast8_t;
N    typedef uint16_t uint_fast8_t;
N    typedef  int16_t  int_fast16_t;
N    typedef uint16_t uint_fast16_t;
N
N    typedef  int32_t  int_fast32_t;
N    typedef uint32_t uint_fast32_t;
N
N
N#if defined(__TMS470__) || defined(_TMS320C6X) || defined(__TMS320C28X__)
X#if 0L || 0L || 1L
N    typedef  int64_t  int_fast64_t;
N    typedef uint64_t uint_fast64_t;
N#endif
N
N/* 7.18.1.4 Integer types capable of holding object pointers */
N    typedef          long intptr_t;
N    typedef unsigned long uintptr_t;
N
N/* 7.18.1.5 Greatest-width integer types */
N#if defined(__TMS320C55X__) || defined(__TMS470__) || defined(_TMS320C6X) || defined(__TMS320C28X__)
X#if 0L || 0L || 0L || 1L
N    typedef          long long intmax_t;
N    typedef unsigned long long uintmax_t;
N#elif defined(_TMS320C5XX) || defined(__TMS320C27X__) || defined(__MSP430__)
S    typedef          long intmax_t;
S    typedef unsigned long uintmax_t;
N#endif
N
N/* 
N   According to footnotes in the 1999 C standard, "C++ implementations
N   should define these macros only when __STDC_LIMIT_MACROS is defined
N   before <stdint.h> is included." 
N*/
N#if !defined(__cplusplus) || defined(__STDC_LIMIT_MACROS)
X#if !1L || 0L
S
S/* 7.18.2 Limits of specified width integer types */
S
S
S    #define  INT16_MAX  0x7fff
S    #define  INT16_MIN  (-INT16_MAX-1)
S    #define UINT16_MAX  0xffff
S
S    #define  INT32_MAX  0x7fffffff
S    #define  INT32_MIN  (-INT32_MAX-1)
S    #define UINT32_MAX  0xffffffff
S
S
S#if defined(__TMS470__) || defined(_TMS320C6X) || defined(__TMS320C28X__)
S    #define  INT64_MAX  0x7fffffffffffffff
S    #define  INT64_MIN  (-INT64_MAX-1)
S    #define UINT64_MAX  0xffffffffffffffff
S#endif
S
S    #define  INT_LEAST8_MAX   INT16_MAX
S    #define  INT_LEAST8_MIN   INT16_MIN
S    #define UINT_LEAST8_MAX   UINT16_MAX
S
S    #define  INT_LEAST16_MAX  INT16_MAX
S    #define  INT_LEAST16_MIN  INT16_MIN
S    #define UINT_LEAST16_MAX  UINT16_MAX
S    #define  INT_LEAST32_MAX  INT32_MAX
S    #define  INT_LEAST32_MIN  INT32_MIN
S    #define UINT_LEAST32_MAX  UINT32_MAX
S
S
S#if defined(__TMS470__) || defined(_TMS320C6X) || defined(__TMS320C28X__)
S    #define  INT_LEAST64_MAX  INT64_MAX
S    #define  INT_LEAST64_MIN  INT64_MIN
S    #define UINT_LEAST64_MAX  UINT64_MAX
S#endif
S
S    #define  INT_FAST8_MAX   INT16_MAX
S    #define  INT_FAST8_MIN   INT16_MIN
S    #define UINT_FAST8_MAX   UINT16_MAX
S    #define  INT_FAST16_MAX  INT16_MAX
S    #define  INT_FAST16_MIN  INT16_MIN
S    #define UINT_FAST16_MAX  UINT16_MAX
S
S    #define  INT_FAST32_MAX  INT32_MAX
S    #define  INT_FAST32_MIN  INT32_MIN
S    #define UINT_FAST32_MAX  UINT32_MAX
S
S
S#if defined(__TMS470__) || defined(_TMS320C6X) || defined(__TMS320C28X__)
S    #define  INT_FAST64_MAX  INT64_MAX
S    #define  INT_FAST64_MIN  INT64_MIN
S    #define UINT_FAST64_MAX  UINT64_MAX
S#endif
S
S    #define INTPTR_MAX   INT32_MAX
S    #define INTPTR_MIN   INT32_MIN
S    #define UINTPTR_MAX  UINT32_MAX
S
S#if defined(__TMS470__) || defined(_TMS320C6X) || defined(__TMS320C28X__)
S    #define INTMAX_MIN   INT64_MIN
S    #define INTMAX_MAX   INT64_MAX
S    #define UINTMAX_MAX  UINT64_MAX
S#elif defined(_TMS320C5XX) || defined(__TMS320C27X__) || defined(__MSP430__)
S    #define INTMAX_MIN   INT32_MIN
S    #define INTMAX_MAX   INT32_MAX
S    #define UINTMAX_MAX  UINT32_MAX
S#endif
S
S/* 7.18.3 Limits of other integer types */
S
S    #define PTRDIFF_MAX INT32_MAX
S    #define PTRDIFF_MIN INT32_MIN
S
S    #define SIG_ATOMIC_MIN INT32_MIN
S    #define SIG_ATOMIC_MAX INT32_MAX
S
S    #define SIZE_MAX INT32_MAX
S
S#ifndef WCHAR_MAX
S#define WCHAR_MAX 0xffffu
S#endif
S
S#ifndef WCHAR_MIN
S#define WCHAR_MIN 0
S#endif
S
S    #define WINT_MIN INT32_MIN
S    #define WINT_MAX INT32_MAX
S
S/* 7.18.4.1 Macros for minimum-width integer constants */
S
S/*
S   There is a defect report filed against the C99 standard concerning how 
S   the (U)INTN_C macros should be implemented.  Please refer to --
S   http://wwwold.dkuug.dk/JTC1/SC22/WG14/www/docs/dr_209.htm 
S   for more information.  These macros are implemented according to the
S   suggestion given at this web site.
S*/
S
S    #define  INT8_C(value)  ((int_least8_t)(value))
S    #define UINT8_C(value)  ((uint_least8_t)(value))
S    #define  INT16_C(value) ((int_least16_t)(value))
S    #define UINT16_C(value) ((uint_least16_t)(value))
S    #define  INT32_C(value) ((int_least32_t)(value))
S    #define UINT32_C(value) ((uint_least32_t)(value))
S
S
S#if defined(__TMS470__) || defined(_TMS320C6X) || defined(__TMS320C28X__)
S    #define  INT64_C(value) ((int_least64_t)(value))
S    #define UINT64_C(value) ((uint_least64_t)(value))
S#endif
S
S/* 7.18.4.2 Macros for greatest-width integer constants */
S
S    #define  INTMAX_C(value) ((intmax_t)(value))
S    #define UINTMAX_C(value) ((uintmax_t)(value))
S
N#endif /* !defined(__cplusplus) || defined(__STDC_LIMIT_MACROS) */
N
N#endif /* _STDINT_H_ */
L 7 "..\src\cores\f_types.h" 2
N
N//typedef	unsigned short	uint16_t;
Ntypedef	unsigned char	uint8_t;
N
N
Ntypedef unsigned int word;
N
N//typedef uint8_t boolean;
Ntypedef unsigned int boolean;
Ntypedef uint8_t byte;
N
N#define lowByte(w) ((uint8_t) ((w) & 0xff))
N#define highByte(w) ((uint8_t) ((w) >> 8))
N
N#define bit(b) (1UL << (b))
N
N#define bitRead(value, bit) (((value) >> (bit)) & 0x01)
N#define bitSet(value, bit) ((value) |= (1UL << (bit)))
N#define bitClear(value, bit) ((value) &= ~(1UL << (bit)))
N#define bitWrite(value, bit, bitvalue) (bitvalue ? bitSet(value, bit) : bitClear(value, bit))
N
N
N#endif	/* INC_f_types_H */
N
N/*** end of file : f_types.h ***/
L 31 "..\src\cores\wiring.h" 2
N#include "binary.h"
L 1 "..\src\cores\binary.h" 1
N#ifndef Binary_h
N#define Binary_h
N
N#define B0 0
N#define B00 0
N#define B000 0
N#define B0000 0
N#define B00000 0
N#define B000000 0
N#define B0000000 0
N#define B00000000 0
N#define B1 1
N#define B01 1
N#define B001 1
N#define B0001 1
N#define B00001 1
N#define B000001 1
N#define B0000001 1
N#define B00000001 1
N#define B10 2
N#define B010 2
N#define B0010 2
N#define B00010 2
N#define B000010 2
N#define B0000010 2
N#define B00000010 2
N#define B11 3
N#define B011 3
N#define B0011 3
N#define B00011 3
N#define B000011 3
N#define B0000011 3
N#define B00000011 3
N#define B100 4
N#define B0100 4
N#define B00100 4
N#define B000100 4
N#define B0000100 4
N#define B00000100 4
N#define B101 5
N#define B0101 5
N#define B00101 5
N#define B000101 5
N#define B0000101 5
N#define B00000101 5
N#define B110 6
N#define B0110 6
N#define B00110 6
N#define B000110 6
N#define B0000110 6
N#define B00000110 6
N#define B111 7
N#define B0111 7
N#define B00111 7
N#define B000111 7
N#define B0000111 7
N#define B00000111 7
N#define B1000 8
N#define B01000 8
N#define B001000 8
N#define B0001000 8
N#define B00001000 8
N#define B1001 9
N#define B01001 9
N#define B001001 9
N#define B0001001 9
N#define B00001001 9
N#define B1010 10
N#define B01010 10
N#define B001010 10
N#define B0001010 10
N#define B00001010 10
N#define B1011 11
N#define B01011 11
N#define B001011 11
N#define B0001011 11
N#define B00001011 11
N#define B1100 12
N#define B01100 12
N#define B001100 12
N#define B0001100 12
N#define B00001100 12
N#define B1101 13
N#define B01101 13
N#define B001101 13
N#define B0001101 13
N#define B00001101 13
N#define B1110 14
N#define B01110 14
N#define B001110 14
N#define B0001110 14
N#define B00001110 14
N#define B1111 15
N#define B01111 15
N#define B001111 15
N#define B0001111 15
N#define B00001111 15
N#define B10000 16
N#define B010000 16
N#define B0010000 16
N#define B00010000 16
N#define B10001 17
N#define B010001 17
N#define B0010001 17
N#define B00010001 17
N#define B10010 18
N#define B010010 18
N#define B0010010 18
N#define B00010010 18
N#define B10011 19
N#define B010011 19
N#define B0010011 19
N#define B00010011 19
N#define B10100 20
N#define B010100 20
N#define B0010100 20
N#define B00010100 20
N#define B10101 21
N#define B010101 21
N#define B0010101 21
N#define B00010101 21
N#define B10110 22
N#define B010110 22
N#define B0010110 22
N#define B00010110 22
N#define B10111 23
N#define B010111 23
N#define B0010111 23
N#define B00010111 23
N#define B11000 24
N#define B011000 24
N#define B0011000 24
N#define B00011000 24
N#define B11001 25
N#define B011001 25
N#define B0011001 25
N#define B00011001 25
N#define B11010 26
N#define B011010 26
N#define B0011010 26
N#define B00011010 26
N#define B11011 27
N#define B011011 27
N#define B0011011 27
N#define B00011011 27
N#define B11100 28
N#define B011100 28
N#define B0011100 28
N#define B00011100 28
N#define B11101 29
N#define B011101 29
N#define B0011101 29
N#define B00011101 29
N#define B11110 30
N#define B011110 30
N#define B0011110 30
N#define B00011110 30
N#define B11111 31
N#define B011111 31
N#define B0011111 31
N#define B00011111 31
N#define B100000 32
N#define B0100000 32
N#define B00100000 32
N#define B100001 33
N#define B0100001 33
N#define B00100001 33
N#define B100010 34
N#define B0100010 34
N#define B00100010 34
N#define B100011 35
N#define B0100011 35
N#define B00100011 35
N#define B100100 36
N#define B0100100 36
N#define B00100100 36
N#define B100101 37
N#define B0100101 37
N#define B00100101 37
N#define B100110 38
N#define B0100110 38
N#define B00100110 38
N#define B100111 39
N#define B0100111 39
N#define B00100111 39
N#define B101000 40
N#define B0101000 40
N#define B00101000 40
N#define B101001 41
N#define B0101001 41
N#define B00101001 41
N#define B101010 42
N#define B0101010 42
N#define B00101010 42
N#define B101011 43
N#define B0101011 43
N#define B00101011 43
N#define B101100 44
N#define B0101100 44
N#define B00101100 44
N#define B101101 45
N#define B0101101 45
N#define B00101101 45
N#define B101110 46
N#define B0101110 46
N#define B00101110 46
N#define B101111 47
N#define B0101111 47
N#define B00101111 47
N#define B110000 48
N#define B0110000 48
N#define B00110000 48
N#define B110001 49
N#define B0110001 49
N#define B00110001 49
N#define B110010 50
N#define B0110010 50
N#define B00110010 50
N#define B110011 51
N#define B0110011 51
N#define B00110011 51
N#define B110100 52
N#define B0110100 52
N#define B00110100 52
N#define B110101 53
N#define B0110101 53
N#define B00110101 53
N#define B110110 54
N#define B0110110 54
N#define B00110110 54
N#define B110111 55
N#define B0110111 55
N#define B00110111 55
N#define B111000 56
N#define B0111000 56
N#define B00111000 56
N#define B111001 57
N#define B0111001 57
N#define B00111001 57
N#define B111010 58
N#define B0111010 58
N#define B00111010 58
N#define B111011 59
N#define B0111011 59
N#define B00111011 59
N#define B111100 60
N#define B0111100 60
N#define B00111100 60
N#define B111101 61
N#define B0111101 61
N#define B00111101 61
N#define B111110 62
N#define B0111110 62
N#define B00111110 62
N#define B111111 63
N#define B0111111 63
N#define B00111111 63
N#define B1000000 64
N#define B01000000 64
N#define B1000001 65
N#define B01000001 65
N#define B1000010 66
N#define B01000010 66
N#define B1000011 67
N#define B01000011 67
N#define B1000100 68
N#define B01000100 68
N#define B1000101 69
N#define B01000101 69
N#define B1000110 70
N#define B01000110 70
N#define B1000111 71
N#define B01000111 71
N#define B1001000 72
N#define B01001000 72
N#define B1001001 73
N#define B01001001 73
N#define B1001010 74
N#define B01001010 74
N#define B1001011 75
N#define B01001011 75
N#define B1001100 76
N#define B01001100 76
N#define B1001101 77
N#define B01001101 77
N#define B1001110 78
N#define B01001110 78
N#define B1001111 79
N#define B01001111 79
N#define B1010000 80
N#define B01010000 80
N#define B1010001 81
N#define B01010001 81
N#define B1010010 82
N#define B01010010 82
N#define B1010011 83
N#define B01010011 83
N#define B1010100 84
N#define B01010100 84
N#define B1010101 85
N#define B01010101 85
N#define B1010110 86
N#define B01010110 86
N#define B1010111 87
N#define B01010111 87
N#define B1011000 88
N#define B01011000 88
N#define B1011001 89
N#define B01011001 89
N#define B1011010 90
N#define B01011010 90
N#define B1011011 91
N#define B01011011 91
N#define B1011100 92
N#define B01011100 92
N#define B1011101 93
N#define B01011101 93
N#define B1011110 94
N#define B01011110 94
N#define B1011111 95
N#define B01011111 95
N#define B1100000 96
N#define B01100000 96
N#define B1100001 97
N#define B01100001 97
N#define B1100010 98
N#define B01100010 98
N#define B1100011 99
N#define B01100011 99
N#define B1100100 100
N#define B01100100 100
N#define B1100101 101
N#define B01100101 101
N#define B1100110 102
N#define B01100110 102
N#define B1100111 103
N#define B01100111 103
N#define B1101000 104
N#define B01101000 104
N#define B1101001 105
N#define B01101001 105
N#define B1101010 106
N#define B01101010 106
N#define B1101011 107
N#define B01101011 107
N#define B1101100 108
N#define B01101100 108
N#define B1101101 109
N#define B01101101 109
N#define B1101110 110
N#define B01101110 110
N#define B1101111 111
N#define B01101111 111
N#define B1110000 112
N#define B01110000 112
N#define B1110001 113
N#define B01110001 113
N#define B1110010 114
N#define B01110010 114
N#define B1110011 115
N#define B01110011 115
N#define B1110100 116
N#define B01110100 116
N#define B1110101 117
N#define B01110101 117
N#define B1110110 118
N#define B01110110 118
N#define B1110111 119
N#define B01110111 119
N#define B1111000 120
N#define B01111000 120
N#define B1111001 121
N#define B01111001 121
N#define B1111010 122
N#define B01111010 122
N#define B1111011 123
N#define B01111011 123
N#define B1111100 124
N#define B01111100 124
N#define B1111101 125
N#define B01111101 125
N#define B1111110 126
N#define B01111110 126
N#define B1111111 127
N#define B01111111 127
N#define B10000000 128
N#define B10000001 129
N#define B10000010 130
N#define B10000011 131
N#define B10000100 132
N#define B10000101 133
N#define B10000110 134
N#define B10000111 135
N#define B10001000 136
N#define B10001001 137
N#define B10001010 138
N#define B10001011 139
N#define B10001100 140
N#define B10001101 141
N#define B10001110 142
N#define B10001111 143
N#define B10010000 144
N#define B10010001 145
N#define B10010010 146
N#define B10010011 147
N#define B10010100 148
N#define B10010101 149
N#define B10010110 150
N#define B10010111 151
N#define B10011000 152
N#define B10011001 153
N#define B10011010 154
N#define B10011011 155
N#define B10011100 156
N#define B10011101 157
N#define B10011110 158
N#define B10011111 159
N#define B10100000 160
N#define B10100001 161
N#define B10100010 162
N#define B10100011 163
N#define B10100100 164
N#define B10100101 165
N#define B10100110 166
N#define B10100111 167
N#define B10101000 168
N#define B10101001 169
N#define B10101010 170
N#define B10101011 171
N#define B10101100 172
N#define B10101101 173
N#define B10101110 174
N#define B10101111 175
N#define B10110000 176
N#define B10110001 177
N#define B10110010 178
N#define B10110011 179
N#define B10110100 180
N#define B10110101 181
N#define B10110110 182
N#define B10110111 183
N#define B10111000 184
N#define B10111001 185
N#define B10111010 186
N#define B10111011 187
N#define B10111100 188
N#define B10111101 189
N#define B10111110 190
N#define B10111111 191
N#define B11000000 192
N#define B11000001 193
N#define B11000010 194
N#define B11000011 195
N#define B11000100 196
N#define B11000101 197
N#define B11000110 198
N#define B11000111 199
N#define B11001000 200
N#define B11001001 201
N#define B11001010 202
N#define B11001011 203
N#define B11001100 204
N#define B11001101 205
N#define B11001110 206
N#define B11001111 207
N#define B11010000 208
N#define B11010001 209
N#define B11010010 210
N#define B11010011 211
N#define B11010100 212
N#define B11010101 213
N#define B11010110 214
N#define B11010111 215
N#define B11011000 216
N#define B11011001 217
N#define B11011010 218
N#define B11011011 219
N#define B11011100 220
N#define B11011101 221
N#define B11011110 222
N#define B11011111 223
N#define B11100000 224
N#define B11100001 225
N#define B11100010 226
N#define B11100011 227
N#define B11100100 228
N#define B11100101 229
N#define B11100110 230
N#define B11100111 231
N#define B11101000 232
N#define B11101001 233
N#define B11101010 234
N#define B11101011 235
N#define B11101100 236
N#define B11101101 237
N#define B11101110 238
N#define B11101111 239
N#define B11110000 240
N#define B11110001 241
N#define B11110010 242
N#define B11110011 243
N#define B11110100 244
N#define B11110101 245
N#define B11110110 246
N#define B11110111 247
N#define B11111000 248
N#define B11111001 249
N#define B11111010 250
N#define B11111011 251
N#define B11111100 252
N#define B11111101 253
N#define B11111110 254
N#define B11111111 255
N
N#endif
L 32 "..\src\cores\wiring.h" 2
N
N#ifdef __cplusplus
Nextern "C"{
N#endif
N
Nvoid setup(void);
Nvoid init(void);
Nvoid loop(void);
N
N#ifdef __cplusplus
N} /* extern "C" */
N#endif
N
N#endif
L 27 "../src/cores/Print.cpp" 2
N
N#include "Print.h"
L 1 "..\src\cores\Print.h" 1
N/*
N  Print.h - Base class that provides print() and println()
N  Copyright (c) 2008 David A. Mellis.  All right reserved.
N
N  This library is free software; you can redistribute it and/or
N  modify it under the terms of the GNU Lesser General Public
N  License as published by the Free Software Foundation; either
N  version 2.1 of the License, or (at your option) any later version.
N
N  This library is distributed in the hope that it will be useful,
N  but WITHOUT ANY WARRANTY; without even the implied warranty of
N  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
N  Lesser General Public License for more details.
N
N  You should have received a copy of the GNU Lesser General Public
N  License along with this library; if not, write to the Free Software
N  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
N*/
N
N#ifndef Print_h
N#define Print_h
N
N#include <inttypes.h>
L 1 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/inttypes.h" 1
N/*****************************************************************************/
N/* INTTYPES.H v5.2.6                                                         */
N/* Copyright (c) 2002-2010 Texas Instruments Incorporated                    */
N/*****************************************************************************/
N#ifndef _INTTYPES_H_
N#define _INTTYPES_H_
N
N#include <stdint.h>
N
N/* 7.8 Format conversion of integer types */
N
Ntypedef struct { intmax_t quot, rem; } imaxdiv_t;
N
N/* 
N   According to footnotes in the 1999 C standard, "C++ implementations
N   should define these macros only when __STDC_FORMAT_MACROS is defined
N   before <inttypes.h> is included." 
N*/
N#if !defined(__cplusplus) || defined(__STDC_FORMAT_MACROS)
X#if !1L || 0L
S#include "_fmt_specifier.h"
N#endif /* !defined(__cplusplus) || defined(__STDC_FORMAT_MACROS) */
N
N/* 7.8.2 Functions for greatest-width integer types */
N#include <linkage.h>
N
N_CODE_ACCESS intmax_t  imaxabs(intmax_t j);
X intmax_t  imaxabs(intmax_t j);
N_CODE_ACCESS imaxdiv_t imaxdiv(intmax_t numer, intmax_t denom);
X imaxdiv_t imaxdiv(intmax_t numer, intmax_t denom);
N_CODE_ACCESS intmax_t  strtoimax(const char * restrict nptr, 
X intmax_t  strtoimax(const char * restrict nptr, 
N		    char ** restrict endptr, int base);
N_CODE_ACCESS uintmax_t strtoumax(const char * restrict nptr, 
X uintmax_t strtoumax(const char * restrict nptr, 
N		    char ** restrict endptr, int base);
N
N#endif /* _INTTYPES_H_ */
L 24 "..\src\cores\Print.h" 2
N#include <stdio.h> // for size_t
L 1 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/stdio.h" 1
N/*****************************************************************************/
N/* STDIO.H v5.2.6                                                            */
N/* Copyright (c) 1993-2010 Texas Instruments Incorporated                    */
N/*****************************************************************************/
N#ifndef _STDIO 
S#define _STDIO
S
S#include <linkage.h>
S#include <stdarg.h>
S
S
S#ifdef __cplusplus
S//----------------------------------------------------------------------------
S// <cstdio> IS RECOMMENDED OVER <stdio.h>.  <stdio.h> IS PROVIDED FOR
S// COMPATIBILITY WITH C AND THIS USAGE IS DEPRECATED IN C++
S//----------------------------------------------------------------------------
Sextern "C" namespace std {
S#endif
S
S/****************************************************************************/
S/* TYPES THAT ANSI REQUIRES TO BE DEFINED                                   */
S/****************************************************************************/
S#ifndef _SIZE_T
S#define _SIZE_T
Stypedef __SIZE_T_TYPE__ size_t;
S#endif
S
Stypedef struct {
S      int fd;                    /* File descriptor */
S      unsigned char* buf;        /* Pointer to start of buffer */
S      unsigned char* pos;        /* Position in buffer */
S      unsigned char* bufend;     /* Pointer to end of buffer */
S      unsigned char* buff_stop;  /* Pointer to last read char in buffer */
S      unsigned int   flags;      /* File status flags (see below) */
S} FILE;
S
S#ifndef _FPOS_T
S#define _FPOS_T
Stypedef long fpos_t;
S#endif /* _FPOS_T */
S
S/****************************************************************************/
S/* DEVICE AND STREAM RELATED MACROS                                         */
S/****************************************************************************/
S/****************************************************************************/
S/* MACROS THAT DEFINE AND USE FILE STATUS FLAGS                             */
S/****************************************************************************/
S
S#define _IOFBF       0x0001
S#define _IOLBF       0x0002
S#define _IONBF       0x0004
S#define _BUFFALOC    0x0008
S#define _MODER       0x0010
S#define _MODEW       0x0020
S#define _MODERW      0x0040
S#define _MODEA       0x0080
S#define _MODEBIN     0x0100
S#define _STATEOF     0x0200
S#define _STATERR     0x0400
S#define _UNGETC      0x0800
S#define _TMPFILE     0x1000
S
S#define _SET(_fp, _b)      (((_fp)->flags) |= (_b))
S#define _UNSET(_fp, _b)    (((_fp)->flags) &= ~(_b))
S#define _STCHK(_fp, _b)    (((_fp)->flags) & (_b))
S#define _BUFFMODE(_fp)     (((_fp)->flags) & (_IOFBF | _IOLBF | _IONBF))
S#define _ACCMODE(_fp)      (((_fp)->flags) & (_MODER | _MODEW))
S
S/****************************************************************************/
S/* MACROS THAT ANSI REQUIRES TO BE DEFINED                                  */
S/****************************************************************************/
S#define BUFSIZ          256 
S
S#define FOPEN_MAX       _NFILE
S#define FILENAME_MAX    256  
S#define TMP_MAX         65535
S
S#define stdin     (&_ftable[0])      
S#define stdout    (&_ftable[1])
S#define stderr    (&_ftable[2])
S
S#define L_tmpnam  _LTMPNAM
S
S
S#define SEEK_SET  (0x0000)
S#define SEEK_CUR  (0x0001)
S#define SEEK_END  (0x0002)
S
S#ifndef NULL
S#define NULL 0
S#endif
S
S#ifndef EOF
S#define EOF    (-1)
S#endif
S
S
S/******** END OF ANSI MACROS ************************************************/
S
S#define P_tmpdir        ""                   /* Path for temp files         */
S
S/****************************************************************************/
S/* DEVICE AND STREAM RELATED DATA STRUCTURES AND MACROS                     */
S/****************************************************************************/
S#define _NFILE           10                   /* Max number of files open   */
S#define _LTMPNAM         16                   /* Length of temp name        */
S
Sextern _DATA_ACCESS FILE _ftable[_NFILE];
Sextern _DATA_ACCESS char _tmpnams[_NFILE][_LTMPNAM];
S
S/****************************************************************************/
S/*   FUNCTION DEFINITIONS  - ANSI                                           */
S/****************************************************************************/
S/****************************************************************************/
S/* OPERATIONS ON FILES                                                      */
S/****************************************************************************/
Sextern _CODE_ACCESS int     remove(const char *_file);
Sextern _CODE_ACCESS int     rename(const char *_old, const char *_new);
Sextern _CODE_ACCESS FILE   *tmpfile(void);
Sextern _CODE_ACCESS char   *tmpnam(char *_s);
S
S/****************************************************************************/
S/* FILE ACCESS FUNCTIONS                                                    */
S/****************************************************************************/
Sextern _CODE_ACCESS int     fclose(FILE *_fp); 
Sextern _CODE_ACCESS FILE   *fopen(const char *_fname, const char *_mode);
Sextern _CODE_ACCESS FILE   *freopen(const char *_fname, const char *_mode,
S			            register FILE *_fp);
Sextern _CODE_ACCESS void    setbuf(register FILE *_fp, char *_buf);
Sextern _CODE_ACCESS int     setvbuf(register FILE *_fp, register char *_buf, 
S			            register int _type, register size_t _size);
Sextern _CODE_ACCESS int     fflush(register FILE *_fp); 
S
S/****************************************************************************/
S/* FORMATTED INPUT/OUTPUT FUNCTIONS                                         */
S/****************************************************************************/
Sextern _CODE_ACCESS int fprintf(FILE *_fp, const char *_format, ...);
Sextern _CODE_ACCESS int fscanf(FILE *_fp, const char *_fmt, ...);
Sextern _CODE_ACCESS int printf(const char *_format, ...);
Sextern _CODE_ACCESS int scanf(const char *_fmt, ...);
Sextern _CODE_ACCESS int sprintf(char *_string, const char *_format, ...);
Sextern _CODE_ACCESS int snprintf(char *_string, size_t _n, 
S				 const char *_format, ...);
Sextern _CODE_ACCESS int sscanf(const char *_str, const char *_fmt, ...);
Sextern _CODE_ACCESS int vfprintf(FILE *_fp, const char *_format, va_list _ap);
Sextern _CODE_ACCESS int vprintf(const char *_format, va_list _ap);
Sextern _CODE_ACCESS int vsprintf(char *_string, const char *_format,
S				 va_list _ap);
Sextern _CODE_ACCESS int vsnprintf(char *_string, size_t _n, 
S				  const char *_format, va_list _ap);
S
S/****************************************************************************/
S/* CHARACTER INPUT/OUTPUT FUNCTIONS                                         */
S/****************************************************************************/
Sextern _CODE_ACCESS int     fgetc(register FILE *_fp);
Sextern _CODE_ACCESS char   *fgets(char *_ptr, register int _size,
S				  register FILE *_fp);
Sextern _CODE_ACCESS int     fputc(int _c, register FILE *_fp);
Sextern _CODE_ACCESS int     fputs(const char *_ptr, register FILE *_fp);
Sextern _CODE_ACCESS int     getc(FILE *_p);
Sextern _CODE_ACCESS int     getchar(void);
Sextern _CODE_ACCESS char   *gets(char *_ptr); 
Sextern _CODE_ACCESS int     putc(int _x, FILE *_fp);
Sextern _CODE_ACCESS int     putchar(int _x);
Sextern _CODE_ACCESS int     puts(const char *_ptr); 
Sextern _CODE_ACCESS int     ungetc(int _c, register FILE *_fp);
S
S/****************************************************************************/
S/* DIRECT INPUT/OUTPUT FUNCTIONS                                            */
S/****************************************************************************/
Sextern _CODE_ACCESS size_t  fread(void *_ptr, size_t _size, size_t _count,
S				  FILE *_fp);
Sextern _CODE_ACCESS size_t  fwrite(const void *_ptr, size_t _size,
S				   size_t _count, register FILE *_fp); 
S
S/****************************************************************************/
S/* FILE POSITIONING FUNCTIONS                                               */
S/****************************************************************************/
Sextern _CODE_ACCESS int     fgetpos(FILE *_fp, fpos_t *_pos);
Sextern _CODE_ACCESS int     fseek(register FILE *_fp, long _offset,
S				  int _ptrname);
Sextern _CODE_ACCESS int     fsetpos(FILE *_fp, const fpos_t *_pos);
Sextern _CODE_ACCESS long    ftell(FILE *_fp);
Sextern _CODE_ACCESS void    rewind(register FILE *_fp); 
S
S/****************************************************************************/
S/* ERROR-HANDLING FUNCTIONS                                                 */
S/****************************************************************************/
Sextern _CODE_ACCESS void    clearerr(FILE *_fp);
Sextern _CODE_ACCESS int     feof(FILE *_fp);
Sextern _CODE_ACCESS int     ferror(FILE *_fp);
Sextern _CODE_ACCESS void    perror(const char *_s);
S
S#define _getchar()      getc(stdin)
S#define _putchar(_x)    putc((_x), stdout)
S#define _clearerr(_fp)   ((void) ((_fp)->flags &= ~(_STATERR | _STATEOF)))
S
S#define _ferror(_x)     ((_x)->flags & _STATERR)
S
S#define _remove(_fl)    (unlink((_fl)))
S
S#ifdef __cplusplus
S} /* extern "C" namespace std */
S#endif  /* __cplusplus */
S
N#endif  /* #ifndef _STDIO */
N
N#if defined(__cplusplus) && !defined(_CPP_STYLE_HEADER)
X#if 1L && !0L
Nusing std::size_t;
Nusing std::FILE;
Nusing std::fpos_t;
Nusing std::_ftable;
Nusing std::_tmpnams;
Nusing std::remove;
Nusing std::rename;
Nusing std::tmpfile;
Nusing std::tmpnam;
Nusing std::fclose;
Nusing std::fopen;
Nusing std::freopen;
Nusing std::setbuf;
Nusing std::setvbuf;
Nusing std::fflush;
Nusing std::fprintf;
Nusing std::fscanf;
Nusing std::printf;
Nusing std::scanf;
Nusing std::sprintf;
Nusing std::sscanf;
Nusing std::vfprintf;
Nusing std::vprintf;
Nusing std::vsprintf;
Nusing std::fgetc;
Nusing std::fgets;
Nusing std::fputc;
Nusing std::fputs;
Nusing std::getc;
Nusing std::getchar;
Nusing std::gets;
Nusing std::putc;
Nusing std::putchar;
Nusing std::puts;
Nusing std::ungetc;
Nusing std::fread;
Nusing std::fwrite;
Nusing std::fgetpos;
Nusing std::fseek;
Nusing std::fsetpos;
Nusing std::ftell;
Nusing std::rewind;
Nusing std::clearerr;
Nusing std::feof;
Nusing std::ferror;
Nusing std::perror;
N
N#endif  /* _CPP_STYLE_HEADER */
N
N
L 25 "..\src\cores\Print.h" 2
N
N#include "f_types.h"
N#include "WString.h"
L 1 "..\src\cores\WString.h" 1
N/*
N  WString.h - String library for Wiring & Arduino
N  Copyright (c) 2009-10 Hernando Barragan.  All right reserved.
N
N  This library is free software; you can redistribute it and/or
N  modify it under the terms of the GNU Lesser General Public
N  License as published by the Free Software Foundation; either
N  version 2.1 of the License, or (at your option) any later version.
N
N  This library is distributed in the hope that it will be useful,
N  but WITHOUT ANY WARRANTY; without even the implied warranty of
N  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
N  Lesser General Public License for more details.
N
N  You should have received a copy of the GNU Lesser General Public
N  License along with this library; if not, write to the Free Software
N  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
N*/
N
N#ifndef String_h
N#define String_h
N
N//#include "WProgram.h"
N#include <stdlib.h>
L 1 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/stdlib.h" 1
N/*****************************************************************************/
N/* stdlib.h   v5.2.6                                                         */
N/* Copyright (c) 1993-2010 Texas Instruments Incorporated                    */
N/*****************************************************************************/
N
N#ifndef _STDLIB
S#define _STDLIB
S
S
S#ifdef __cplusplus
S//----------------------------------------------------------------------------
S// <cstdlib> IS RECOMMENDED OVER <stdlib.h>.  <stdlib.h> IS PROVIDED FOR 
S// COMPATIBILITY WITH C AND THIS USAGE IS DEPRECATED IN C++
S//----------------------------------------------------------------------------
Sextern "C" namespace std {
S#endif /* !__cplusplus */
S
Stypedef struct { int quot, rem; } div_t;
S
Stypedef struct { long quot, rem; } ldiv_t;
S
S#define _LLONG_AVAILABLE 1
Stypedef struct { long long quot, rem; } lldiv_t;
S
S#define MB_CUR_MAX    1
S
S#ifndef NULL
S#define NULL          0
S#endif
S
S#ifndef _SIZE_T
S#define _SIZE_T
Stypedef __SIZE_T_TYPE__ size_t;
S#endif
S
S#ifndef __cplusplus
S#ifndef _WCHAR_T
S#define _WCHAR_T
Stypedef __WCHAR_T_TYPE__ wchar_t;
S#endif
S#endif
S
S#define EXIT_FAILURE  1
S#define EXIT_SUCCESS  0
S
S#define RAND_MAX      32767
S
S#include <linkage.h>
S
S/*---------------------------------------------------------------*/
S/* NOTE - Normally, abs, labs, and fabs are expanded inline, so  */
S/*        no formal definition is really required. However, ANSI */
S/*        requires that they exist as separate functions, so     */
S/*        they are supplied in the library.  The prototype is    */
S/*        here mainly for documentation.                         */
S/*---------------------------------------------------------------*/
S    _CODE_ACCESS  int       abs(int _val); 
S    _CODE_ACCESS  long      labs(long _val);
S#if defined(_LLONG_AVAILABLE)
S    _CODE_ACCESS  long long llabs(long long _val);
S#endif
S    _CODE_ACCESS int       atoi(const char *_st);
S    _CODE_ACCESS long      atol(const char *_st);
S#if defined(_LLONG_AVAILABLE)
S    _CODE_ACCESS long long atoll(const char *_st);
S#endif
S    _CODE_ACCESS int       ltoa(long val, char *buffer);
S          _IDECL double    atof(const char *_st);
S
S    _CODE_ACCESS long      strtol(const char *_st, char **_endptr, int _base);
S    _CODE_ACCESS unsigned long strtoul(const char *_st, char **_endptr,
S    					  int _base);
S#if defined(_LLONG_AVAILABLE)
S    _CODE_ACCESS long long strtoll(const char *_st, char **_endptr, int _base);
S    _CODE_ACCESS unsigned long long strtoull(const char *_st, char **_endptr,
S					     int _base);
S#endif
S    _CODE_ACCESS double    strtod(const char *_st, char **_endptr);
S    _CODE_ACCESS long double strtold(const char *_st, char **_endptr);
S    
S    _CODE_ACCESS int    rand(void);
S    _CODE_ACCESS void   srand(unsigned _seed);
S    
S    _CODE_ACCESS void  *calloc(size_t _num, size_t _size);
S    _CODE_ACCESS void  *malloc(size_t _size);
S    _CODE_ACCESS void  *realloc(void *_ptr, size_t _size);
S    _CODE_ACCESS void   free(void *_ptr);
S    _CODE_ACCESS void  *memalign(size_t _aln, size_t _size);
S    
S    _CODE_ACCESS void   abort(void); 
S    _CODE_ACCESS int    atexit(void (*_func)(void));
S    _CODE_ACCESS void  *bsearch(const void *_key, const void *_base,
S    				   size_t _nmemb, size_t _size, 
S    			           int (*compar)(const void *,const void *));
S    _CODE_ACCESS void   qsort(void *_base, size_t _nmemb, size_t _size, 
S    			         int (*_compar)(const void *, const void *));
S    _CODE_ACCESS void   exit(int _status);
S    
S    _CODE_ACCESS div_t  div(int _numer, int _denom);
S    _CODE_ACCESS ldiv_t ldiv(long _numer, long _denom);
S#if defined(_LLONG_AVAILABLE)
S    _CODE_ACCESS lldiv_t lldiv(long long _numer, long long _denom);
S#endif
S
S    _CODE_ACCESS char  *getenv(const char *_string);
S    _CODE_ACCESS int    system(const char *_name);
S
S    _CODE_ACCESS int    mblen(const char *, size_t);
S    _CODE_ACCESS size_t mbstowcs(wchar_t *, const char *, size_t);
S    _CODE_ACCESS int    mbtowc(wchar_t *, const char *, size_t);
S
S    _CODE_ACCESS size_t wcstombs(char *, const wchar_t *, size_t);
S    _CODE_ACCESS int    wctomb(char *, wchar_t);
S
S#ifdef __cplusplus
S} /* extern "C" namespace std */
S#endif /* __cplusplus */
S
S
S#ifdef _INLINE
S
S#ifdef __cplusplus
Snamespace std {
S#endif
S
Sstatic __inline double atof(const char *_st) 
S{
S  return strtod(_st, (char **)0); 
S}
S
S#ifdef __cplusplus
S} /* namespace std */
S#endif
S
S#endif  /* _INLINE */
S
N#endif  /* ! _STDLIB */
N
N#if defined(__cplusplus) && !defined(_CPP_STYLE_HEADER)
X#if 1L && !0L
Nusing std::div_t;
Nusing std::ldiv_t;
N#if defined(_LLONG_AVAILABLE)
X#if 1L
Nusing std::lldiv_t;
N#endif
Nusing std::size_t;
Nusing std::abs;
Nusing std::labs;
Nusing std::atoi;
Nusing std::atol;
N#if defined(_LLONG_AVAILABLE)
X#if 1L
Nusing std::llabs;
Nusing std::atoll;
N#endif
Nusing std::atof;
Nusing std::strtol;
Nusing std::strtoul;
N#if defined(_LLONG_AVAILABLE)
X#if 1L
Nusing std::strtoll;
Nusing std::strtoull;
N#endif
Nusing std::strtod;
Nusing std::rand;
Nusing std::srand;
Nusing std::calloc;
Nusing std::malloc;
Nusing std::realloc;
Nusing std::free;
Nusing std::memalign;
Nusing std::abort;
Nusing std::atexit;
Nusing std::bsearch;
Nusing std::qsort;
Nusing std::exit;
Nusing std::div;
Nusing std::ldiv;
N#if defined(_LLONG_AVAILABLE)
X#if 1L
Nusing std::lldiv;
N#endif
Nusing std::getenv;
Nusing std::system;
N#endif /* ! _CPP_STYLE_HEADER */
N
N#include <stdlibf.h>     /* far versions of stdlib fns */
L 1 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/stdlibf.h" 1
N/*****************************************************************************/
N/* stdlibf.h   v5.2.6                                                        */
N/*     far versions of stdlib.h functions                                    */
N/* Copyright (c) 1996-2010 Texas Instruments Incorporated                    */
N/*****************************************************************************/
N#ifndef _STDLIBF
S#define _STDLIBF
S
S#ifndef __cplusplus
S_CODE_ACCESS long          far_strtol (const far char *st, far char **endptr, 
S				   int base);
S_CODE_ACCESS unsigned long far_strtoul(const far char *st, far char **endptr, 
S				   int base);
S_CODE_ACCESS double        far_strtod (const far char *st, far char **endptr);
S_CODE_ACCESS long double   far_strtold (const far char *st, far char **endptr);
S_CODE_ACCESS long long     far_strtoll(const far char *st, far char **endptr, 
S		 						    int base);
S_CODE_ACCESS unsigned long long far_strtoull(const far char *st, 
S                                                   far char **endptr, int base);
S_CODE_ACCESS int           far_atoi(const far char *st);
S_CODE_ACCESS long          far_atol(const far char *st);
S_IDECL       double        far_atof(const far char *st);
S_CODE_ACCESS long long     far_atoll(const far char *st);
S
S_CODE_ACCESS far void     *far_calloc  (unsigned long num, unsigned long size);
S_CODE_ACCESS far void     *far_malloc  (unsigned long size);
S_CODE_ACCESS far void     *far_realloc (far void *ptr, unsigned long size);
S_CODE_ACCESS void          far_free    (far void *ptr);
S
S_CODE_ACCESS far void     *far_bsearch(const far void *key, 
S                                       const far void *base, 
S			               size_t nmemb, size_t size, 
S			               int (*compar)(const far void *,
S                                                     const far void *));
S_CODE_ACCESS void          far_qsort  (far void *base, 
S                                       size_t nmemb, size_t size,
S			               int (*compar)(const far void *, 
S                                                     const far void *));
S
S_CODE_ACCESS int	   free_memory(void);
S_CODE_ACCESS int           max_free(void);
S_CODE_ACCESS void         *chkheap();
S
S#ifdef _INLINE
Sstatic __inline double far_atof(const far char *st) 
S{ 
S   return far_strtod(st, NULL);
S}
S#endif /* _INLINE */
S
S#else /* __cplusplus */
S
Snamespace std {
S
Sextern "C" int	       free_memory(void);
Sextern "C" int         max_free(void);
Sextern "C" void        *chkheap();
S
S_CODE_ACCESS long      far_calloc  (unsigned long num, unsigned long size);
S_CODE_ACCESS long      far_malloc  (unsigned long size);
S_CODE_ACCESS long      far_realloc (long ptr, unsigned long size);
S_CODE_ACCESS void      far_free    (long ptr);
S_CODE_ACCESS long      far_free_memory(void);
S_CODE_ACCESS long      far_max_free(void);
S_CODE_ACCESS long      far_chkheap(void);
S
S}
S#endif /* __cplusplus */
N#endif /* _STDLIBF */
N
N#if defined(__cplusplus) && !defined(_CPP_STYLE_HEADER)
X#if 1L && !0L
Nusing std::free_memory; 
Nusing std::max_free;
Nusing std::chkheap;
Nusing std::far_calloc;
Nusing std::far_malloc;
Nusing std::far_realloc;
Nusing std::far_free;
Nusing std::far_free_memory; 
Nusing std::far_max_free;
Nusing std::far_chkheap;
N#endif /* _CPP_STYLE_HEADER */
L 184 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/stdlib.h" 2
L 25 "..\src\cores\WString.h" 2
N#include <string.h>
L 1 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/string.h" 1
N/*****************************************************************************/
N/* string.h   v5.2.6                                                         */
N/* Copyright (c) 1993-2010 Texas Instruments Incorporated                    */
N/*****************************************************************************/
N
N#ifndef _STRING
S#define _STRING
S
S#ifdef __cplusplus
S//----------------------------------------------------------------------------
S// <cstring> IS RECOMMENDED OVER <string.h>.  <string.h> IS PROVIDED FOR
S// COMPATIBILITY WITH C AND THIS USAGE IS DEPRECATED IN C++
S//----------------------------------------------------------------------------
Sextern "C" namespace std
S{
S#endif /* __cplusplus */
S 
S#ifndef NULL
S#define NULL 0
S#endif
S
S#ifndef _SIZE_T
S#define _SIZE_T
Stypedef __SIZE_T_TYPE__ size_t;
S#endif
S
S#include <linkage.h>
S
S#if defined(_OPTIMIZE_FOR_SPACE) && (defined(__TMS470__) || 		\
S				     defined(__TMS320C2000__)  ||       \
S                                     defined(__MSP430__))
X#if defined(_OPTIMIZE_FOR_SPACE) && (defined(__TMS470__) || 						     defined(__TMS320C2000__)  ||                                            defined(__MSP430__))
S#define _OPT_IDECL
S#else
S#define _OPT_IDECL	_IDECL
S#endif
S
S_OPT_IDECL size_t  strlen(const char *_string);
S
S_OPT_IDECL char *strcpy(char *_dest, const char *_src);
S_OPT_IDECL char *strncpy(char *_to, const char *_from, size_t _n);
S_OPT_IDECL char *strcat(char *_string1, const char *_string2);
S_OPT_IDECL char *strncat(char *_to, const char *_from, size_t _n);
S_OPT_IDECL char *strchr(const char *_string, int _c);
S_OPT_IDECL char *strrchr(const char *_string, int _c);
S
S_OPT_IDECL int  strcmp(const char *_string1, const char *_string2);
S_OPT_IDECL int  strncmp(const char *_string1, const char *_string2, size_t _n);
S
S_CODE_ACCESS int     strcoll(const char *_string1, const char *_string2);
S_CODE_ACCESS size_t  strxfrm(char *_to, const char *_from, size_t _n);
S_CODE_ACCESS char   *strpbrk(const char *_string, const char *_chs);
S_CODE_ACCESS size_t  strspn(const char *_string, const char *_chs);
S_CODE_ACCESS size_t  strcspn(const char *_string, const char *_chs);
S_CODE_ACCESS char   *strstr(const char *_string1, const char *_string2);
S_CODE_ACCESS char   *strtok(char *_str1, const char *_str2);
S_CODE_ACCESS char   *strerror(int _errno);
S
S_CODE_ACCESS void   *memmove(void *_s1, const void *_s2, size_t _n);
S
S_OPT_IDECL int     memcmp(const void *_cs, const void *_ct, size_t _n);
S_OPT_IDECL void   *memchr(const void *_cs, int _c, size_t _n);
S
S_OPT_IDECL   void   *memset(void *_mem, int _ch, size_t _n);
S
S
S#ifndef __cplusplus
S#define far_memcpy __memcpy_ff
S#define far_strcpy strcpy_ff
Ssize_t    far_strlen(const far char *s);
Schar     *strcpy_nf(char *s1, const char far *s2);
Schar far *strcpy_fn(char far *s1, const char *s2);
Schar far *strcpy_ff(char far *s1, const char far *s2);
Sfar char *far_strncpy(far char *s1, far const char *s2, size_t n);
Sfar char *far_strcat(far char *s1, const far char *s2);
Sfar char *far_strncat(far char *s1, const far char *s2, size_t n);
Sfar char *far_strchr(const far char *s, int c);
Sfar char *far_strrchr(const far char *s, int c);
Sint       far_strcmp(const far char *s1, const far char *s2);
Sint       far_strncmp(const far char *s1, const far char *s2, size_t n);
Sint       far_strcoll(const far char *s1, const far char *s2);
Ssize_t    far_strxfrm(far char *s1, const far char *s2, size_t n);
Sfar char *far_strpbrk(const far char *s1, const far char *s2);
Ssize_t    far_strspn(const far char *s1, const far char *s2);
Ssize_t    far_strcspn(const far char *s1, const far char *s2);
Sfar char *far_strstr(const far char *s1, const far char *s2);
Sfar char *far_strtok(far char *s1, const far char *s2);
Sfar char *far_strerror(int errno);
Svoid far *far_memmove(far void *s1, far const void *s2, size_t n);
Svoid     *__memcpy_nf (void *_s1, far const void *_s2, size_t _n);
Svoid far *__memcpy_fn (far void *_s1, const void *_s2, size_t _n);
Svoid far *__memcpy_ff (far void *_s1, far const void *_s2, size_t _n);
Sint       far_memcmp(const far void *s1, const far void *s2, size_t n);
Sfar void *far_memchr(const far void *s, int c, size_t n);
Sfar void *far_memset(far void *s, int c, size_t n);
Sfar void *far_memlcpy(far void *to, const far void *from, unsigned long n);
Sfar void *far_memlmove(far void *to, const far void *from, unsigned long n);
S#else /* __cplusplus */
Slong      far_memlcpy(long to, long from, unsigned long n);
Slong      far_memlmove(long to, long from, unsigned long n);
S#endif /* __cplusplus */
S
S
S#ifdef __cplusplus
S} /* extern "C" namespace std */
S#endif /* __cplusplus */
S
S#if defined(_INLINE) || defined(_STRING_IMPLEMENTATION)
S
S#if (defined(_STRING_IMPLEMENTATION) ||					\
S     !(defined(_OPTIMIZE_FOR_SPACE) && (defined(__TMS470__) || 		\
S					defined(__TMS320C2000__)  ||    \
S                                        defined(__MSP430__))))
X#if (defined(_STRING_IMPLEMENTATION) ||					     !(defined(_OPTIMIZE_FOR_SPACE) && (defined(__TMS470__) || 							defined(__TMS320C2000__)  ||                                            defined(__MSP430__))))
S
S#ifdef __cplusplus
Snamespace std {
S#endif
S
S#if (defined(_OPTIMIZE_FOR_SPACE) && (defined(__TMS470__) || 		\
S				      defined(__TMS320C2000__) ||       \
S                                      defined(__MSP430__)))
X#if (defined(_OPTIMIZE_FOR_SPACE) && (defined(__TMS470__) || 						      defined(__TMS320C2000__) ||                                             defined(__MSP430__)))
S#define _OPT_IDEFN
S#else
S#define _OPT_IDEFN	_IDEFN
S#endif
S
S#if defined(_INLINE) || defined(_STRLEN)
S_OPT_IDEFN size_t strlen(const char *string)
S{
S   size_t      n = (size_t)-1;
S   const char *s = string;
S
S   do n++; while (*s++);
S   return n;
S}
S#endif /* _INLINE || _STRLEN */
S
S#if defined(_INLINE) || defined(_STRCPY)
S_OPT_IDEFN char *strcpy(register char *dest, register const char *src)
S{
S     register char       *d = dest;     
S     register const char *s = src;
S
S     while (*d++ = *s++);
S     return dest;
S}
S#endif /* _INLINE || _STRCPY */
S
S#if defined(_INLINE) || defined(_STRNCPY)
S_OPT_IDEFN char *strncpy(register char *dest,
S		     register const char *src,
S		     register size_t n)
S{
S     if (n) 
S     {
S	 register char       *d = dest;
S	 register const char *s = src;
S	 while ((*d++ = *s++) && --n);              /* COPY STRING         */
S	 if (n-- > 1) do *d++ = '\0'; while (--n);  /* TERMINATION PADDING */
S     }
S     return dest;
S}
S#endif /* _INLINE || _STRNCPY  */
S
S#if defined(_INLINE) || defined(_STRCAT)
S_OPT_IDEFN char *strcat(char *string1, const char *string2)
S{
S   char       *s1 = string1;
S   const char *s2 = string2;
S
S   while (*s1) s1++;		     /* FIND END OF STRING   */
S   while (*s1++ = *s2++);	     /* APPEND SECOND STRING */
S   return string1;
S}
S#endif /* _INLINE || _STRCAT */
S
S#if defined(_INLINE) || defined(_STRNCAT)
S_OPT_IDEFN char *strncat(char *dest, const char *src, register size_t n)
S{
S    if (n)
S    {
S	char       *d = dest;
S	const char *s = src;
S
S	while (*d) d++;                      /* FIND END OF STRING   */
S
S	while (n--)
S	  if (!(*d++ = *s++)) return dest; /* APPEND SECOND STRING */
S	*d = 0;
S    }
S    return dest;
S}
S#endif /* _INLINE || _STRNCAT */
S
S#if defined(_INLINE) || defined(_STRCHR)
S_OPT_IDEFN char *strchr(const char *string, int c)
S{
S   char        tch, ch  = c;
S   const char *s        = string;
S
S   for (;;)
S   {
S       if ((tch = *s) == ch) return (char *) s;
S       if (!tch)             return (char *) 0;
S       s++;
S   }
S}
S#endif /* _INLINE || _STRCHR */
S
S#if defined(_INLINE) || defined(_STRRCHR)
S_OPT_IDEFN char *strrchr(const char *string, int c)
S{
S   char        tch, ch = c;
S   char       *result  = 0;
S   const char *s       = string;
S
S   for (;;)
S   {
S      if ((tch = *s) == ch) result = (char *) s;
S      if (!tch) break;
S      s++;
S   }
S
S   return result;
S}
S#endif /* _INLINE || _STRRCHR */
S
S#if defined(_INLINE) || defined(_STRCMP)
S_OPT_IDEFN int strcmp(register const char *string1,
S		  register const char *string2)
S{
S   register int c1, res;
S
S   for (;;)
S   {
S       c1  = (unsigned char)*string1++;
S       res = c1 - (unsigned char)*string2++;
S
S       if (c1 == 0 || res != 0) break;
S   }
S
S   return res;
S}
S#endif /* _INLINE || _STRCMP */
S
S#if defined(_INLINE) || defined(_STRNCMP)
S_OPT_IDEFN int strncmp(const char *string1, const char *string2, size_t n)
S{
S     if (n) 
S     {
S	 const char *s1 = string1;
S	 const char *s2 = string2;
S	 unsigned char cp;
S	 int         result;
S
S	 do 
S	    if (result = (unsigned char)*s1++ - (cp = (unsigned char)*s2++))
S                return result;
S	 while (cp && --n);
S     }
S     return 0;
S}
S#endif /* _INLINE || _STRNCMP */
S
S#if defined(_INLINE) || defined(_MEMCMP)
S_OPT_IDEFN int memcmp(const void *cs, const void *ct, size_t n)
S{
S   if (n) 
S   {
S       const unsigned char *mem1 = (unsigned char *)cs;
S       const unsigned char *mem2 = (unsigned char *)ct;
S       int                 cp1, cp2;
S
S       while ((cp1 = *mem1++) == (cp2 = *mem2++) && --n);
S       return cp1 - cp2;
S   }
S   return 0;
S}
S#endif /* _INLINE || _MEMCMP */
S
S#if defined(_INLINE) || defined(_MEMCHR)
S_OPT_IDEFN void *memchr(const void *cs, int c, size_t n)
S{
S   if (n)
S   {
S      const unsigned char *mem = (unsigned char *)cs;   
S      unsigned char        ch  = c;
S
S      do 
S         if ( *mem == ch ) return (void *)mem;
S         else mem++;
S      while (--n);
S   }
S   return NULL;
S}
S#endif /* _INLINE || _MEMCHR */
S
S#if ((defined(_INLINE) || defined(_MEMSET)) && !defined(_TMS320C6X)) && !defined(__TMS470__)
S_OPT_IDEFN void *memset(void *mem, register int ch, register size_t length)
S{
S     register char *m = (char *)mem;
S
S     while (length--) *m++ = ch;
S     return mem;
S}
S#endif /* _INLINE || _MEMSET */
S
S#ifdef __cplusplus
S} /* namespace std */
S#endif
S
S#endif /* (_STRING_IMPLEMENTATION || !(_OPTIMIZE_FOR_SPACE && __TMS470__)) */
S
S#endif /* (_INLINE || _STRING_IMPLEMENTATION) */
S
N#endif /* ! _STRING */
N
N#if defined(__cplusplus) && !defined(_CPP_STYLE_HEADER)
X#if 1L && !0L
Nusing std::size_t;
Nusing std::strlen;
Nusing std::strcpy;
Nusing std::strncpy;
Nusing std::strcat;
Nusing std::strncat;
Nusing std::strchr;
Nusing std::strrchr;
Nusing std::strcmp;
Nusing std::strncmp;
Nusing std::strcoll;
Nusing std::strxfrm;
Nusing std::strpbrk;
Nusing std::strspn;
Nusing std::strcspn;
Nusing std::strstr;
Nusing std::strtok;
Nusing std::strerror;
Nusing std::memmove;
Nusing std::memcpy;
Nusing std::memcmp;
Nusing std::memchr;
Nusing std::memset;
N
Nusing std::far_memlcpy;
Nusing std::far_memlmove;
N
N#endif /* _CPP_STYLE_HEADER */
N
L 26 "..\src\cores\WString.h" 2
N#include <ctype.h>
L 1 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/ctype.h" 1
N/*****************************************************************************/
N/* ctype.h    v5.2.6                                                         */
N/* Copyright (c) 1993-2010 Texas Instruments Incorporated                    */
N/*****************************************************************************/
N
N/************************************************************************/
N/*                                                                      */
N/*  CHARACTER TYPING FUNCTIONS AND MACROS                               */
N/*                                                                      */
N/*  Note that in this implementation, either macros or functions may    */
N/*  be used.  Macros are prefixed with an underscore.                   */
N/*                                                                      */
N/************************************************************************/
N#ifndef _CTYPE
N#define _CTYPE
N
N#include <linkage.h>
N
N
N#ifdef __cplusplus
N//----------------------------------------------------------------------------
N// <cctype> IS RECOMMENDED OVER <ctype.h>.  <ctype.h> IS PROVIDED FOR
N// COMPATIBILITY WITH C AND THIS USAGE IS DEPRECATED IN C++
N//----------------------------------------------------------------------------
Nextern "C" namespace std
N{
N#endif /* __cplusplus */
N
Nextern _DATA_ACCESS const unsigned char _ctypes_[];
Xextern  const unsigned char _ctypes_[];
N
N/************************************************************************/
N/*   FUNCTION DECLARATIONS                                              */
N/************************************************************************/
N#include "_isfuncdcl.h"
L 1 "C:\Program Files (x86)\Texas Instruments\ccsv4\tools\compiler\c2000\include\_isfuncdcl.h" 1
N#include <linkage.h>
N_IDECL int isalnum(int _c);
Xextern  int isalnum(int _c);
N_IDECL int isalpha(int _c);
Xextern  int isalpha(int _c);
N_IDECL int iscntrl(int _c);
Xextern  int iscntrl(int _c);
N_IDECL int isdigit(int _c);
Xextern  int isdigit(int _c);
N_IDECL int isgraph(int _c);
Xextern  int isgraph(int _c);
N_IDECL int islower(int _c);
Xextern  int islower(int _c);
N_IDECL int isprint(int _c);
Xextern  int isprint(int _c);
N_IDECL int ispunct(int _c);
Xextern  int ispunct(int _c);
N_IDECL int isspace(int _c);
Xextern  int isspace(int _c);
N_IDECL int isupper(int _c);
Xextern  int isupper(int _c);
N_IDECL int isxdigit(int _c);
Xextern  int isxdigit(int _c);
N_IDECL int isascii(int _c);
Xextern  int isascii(int _c);
N_IDECL int toascii(int _c);
Xextern  int toascii(int _c);
N
L 35 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/ctype.h" 2
N
N_IDECL int toupper(int _c);
Xextern  int toupper(int _c);
N_IDECL int tolower(int _c);
Xextern  int tolower(int _c);
N
N#ifdef __cplusplus
N} /* extern "C" namespace std */
N#endif /* __cplusplus */
N
N
N/************************************************************************/
N/*  On this ELSE path, all the TI ctype table and ctype bit flags are   */
N/*  defined.                                                            */
N/************************************************************************/
N/************************************************************************/
N/*  MACRO DEFINITIONS                                                   */
N/************************************************************************/
N#define _U_   0x01       /* control chars     */
N#define _L_   0x02       /* lower case letter */
N#define _N_   0x04       /* digit             */
N#define _S_   0x08       /* white space       */
N#define _P_   0x10       /* punctuation       */
N#define _C_   0x20       /* control chars     */
N#define _H_   0x40       /* A-F, a-f and 0-9  */
N#define _B_   0x80       /* blank             */
N
N#define _isalnum(a)  (_ctypes_[(a)+1] & (_U_ | _L_ | _N_))
N#define _isalpha(a)  (_ctypes_[(a)+1] & (_U_ | _L_))
N#define _iscntrl(a)  (_ctypes_[(a)+1] & _C_)
N#define _isdigit(a)  (_ctypes_[(a)+1] & _N_)
N#define _isgraph(a)  (_ctypes_[(a)+1] & (_U_ | _L_ | _N_ | _P_))
N#define _islower(a)  (_ctypes_[(a)+1] & _L_)
N#define _isprint(a)  (_ctypes_[(a)+1] & (_B_ | _U_ | _L_ | _N_ | _P_))
N#define _ispunct(a)  (_ctypes_[(a)+1] & _P_)
N#define _isspace(a)  (_ctypes_[(a)+1] & _S_)
N#define _isupper(a)  (_ctypes_[(a)+1] & _U_)
N#define _isxdigit(a) (_ctypes_[(a)+1] & _H_)
N
N
N#define _isascii(a)  (((a) & ~0x7F) == 0)
N#define _toupper(b)  ((_islower(b)) ? (b) - ('a' - 'A') : (b))
N#define _tolower(b)  ((_isupper(b)) ? (b) + ('a' - 'A') : (b))
N#define _toascii(a)  ((a) & 0x7F)
N
N#ifdef _INLINE
S
S#ifdef __cplusplus
Susing std::_ctypes_;
Snamespace std {
S#endif /* __cplusplus */
S
S#include "_isfuncdef.h"
S
S/****************************************************************************/
S/*  tolower                                                                 */
S/****************************************************************************/
Sstatic __inline int tolower(int ch)
S{
S   /*
S    This code depends on two assumptions: (1) all of the letters of the
S    alphabet of a given case are contiguous, and (2) the lower and upper
S    case forms of each letter are displaced from each other by the same
S    constant value.
S   */
S
S   if ( (unsigned int)(ch - 'A') <= (unsigned int)('Z' - 'A')) ch += 'a' - 'A';
S   return ch;
S}
S
S/****************************************************************************/
S/*  toupper                                                                 */
S/****************************************************************************/
Sstatic __inline int toupper(int ch)
S{
S   /*
S    This code depends on two assumptions: (1) all of the letters of the
S    alphabet of a given case are contiguous, and (2) the lower and upper
S    case forms of each letter are displaced from each other by the same
S    constant value.
S   */
S
S   if ( (unsigned int)(ch - 'a') <= (unsigned int)('z' - 'a')) ch -= 'a' - 'A';
S   return ch;
S}
S
S#ifdef __cplusplus
S}
S#endif /* __cplusplus */
S
N#endif /* _INLINE */
N
N#endif /* ! _CTYPE */
N
N#if defined(__cplusplus) && !defined(_CPP_STYLE_HEADER)
X#if 1L && !0L
Nusing std::_ctypes_;
Nusing std::isalnum;
Nusing std::isalpha;
Nusing std::iscntrl;
Nusing std::isdigit;
Nusing std::isgraph;
Nusing std::islower;
Nusing std::isprint;
Nusing std::ispunct;
Nusing std::isspace;
Nusing std::isupper;
Nusing std::isxdigit;
Nusing std::isascii;
Nusing std::toupper;
Nusing std::tolower;
Nusing std::toascii;
N#endif /* ! _CPP_STYLE_HEADER */
N
L 27 "..\src\cores\WString.h" 2
N
Nclass String
N{
N  public:
N    // constructors
N    String( const char *value = "" );
N    String( const String &value );
N    String( const char );
N    String( const unsigned char );
N    String( const int, const int base=10);
N    String( const unsigned int, const int base=10 );
N    String( const long, const int base=10 );
N    String( const unsigned long, const int base=10 );
N    ~String() { free(_buffer); _length = _capacity = 0;}     //added _length = _capacity = 0;
N
N    // operators
N    const String & operator = ( const String &rhs );
N    const String & operator +=( const String &rhs );
N    //const String & operator +=( const char );
N    int operator ==( const String &rhs ) const;
N    int	operator !=( const String &rhs ) const;
N    int	operator < ( const String &rhs ) const;
N    int	operator > ( const String &rhs ) const;
N    int	operator <=( const String &rhs ) const;
N    int	operator >=( const String &rhs ) const;
N    char operator []( unsigned int index ) const;
N    char& operator []( unsigned int index );
N    //operator const char *() const { return _buffer; }
N
N    // general methods
N    char charAt( unsigned int index ) const;
N    int	compareTo( const String &anotherString ) const;
N//    unsigned char endsWith( const String &suffix ) const;
N//    unsigned char equals( const String &anObject ) const;
N//    unsigned char equalsIgnoreCase( const String &anotherString ) const;
N    boolean endsWith( const String &suffix ) const;
N    boolean equals( const String &anObject ) const;
N    boolean equalsIgnoreCase( const String &anotherString ) const;
N
N    int	indexOf( char ch ) const;
N    int	indexOf( char ch, unsigned int fromIndex ) const;
N    int	indexOf( const String &str ) const;
N    int	indexOf( const String &str, unsigned int fromIndex ) const;
N    int	lastIndexOf( char ch ) const;
N    int	lastIndexOf( char ch, unsigned int fromIndex ) const;
N    int	lastIndexOf( const String &str ) const;
N    int	lastIndexOf( const String &str, unsigned int fromIndex ) const;
N    /*const*/ unsigned int length( ) const { return _length; }
N    void setCharAt(unsigned int index, const char ch);
N//    unsigned char startsWith( const String &prefix ) const;
N//    unsigned char startsWith( const String &prefix, unsigned int toffset ) const;
N    boolean startsWith( const String &prefix ) const;
N    boolean startsWith( const String &prefix, unsigned int toffset ) const;
N    String substring( unsigned int beginIndex ) const;
N    String substring( unsigned int beginIndex, unsigned int endIndex ) const;
N    String toLowerCase( ) const;
N    String toUpperCase( ) const;
N    String trim( ) const;
N    void getBytes(unsigned char *buf, unsigned int bufsize);
N    void toCharArray(char *buf, unsigned int bufsize);
N    long toInt( );
N    const String& concat( const String &str );
N    String replace( char oldChar, char newChar );
N    String replace( const String& match, const String& replace );
N
N    friend String operator + ( String lhs, const String &rhs );
N
N  protected:
N    char *_buffer;	     // the actual char array
N    unsigned int _capacity;  // the array length minus one (for the '\0')
N    unsigned int _length;    // the String length (not counting the '\0')
N
N    void getBuffer(unsigned int maxStrLen);
N
N  private:
N
N};
N
N// allocate buffer space
Ninline void String::getBuffer(unsigned int maxStrLen)
N{
N  _capacity = maxStrLen;
N  _buffer = (char *) malloc(_capacity + 1);
N  if (_buffer == NULL) _length = _capacity = 0;
X  if (_buffer == 0) _length = _capacity = 0;
N}
N
Ninline String operator+( String lhs, const String &rhs )
N{
N  return lhs += rhs;
N}
N
N
N#endif
L 28 "..\src\cores\Print.h" 2
N
N#define DEC 10
N#define HEX 16
N#define OCT 8
N#define BIN 2
N#define BYTE 0
N
Nclass Print
N{
N  private:
N    void printNumber(unsigned long, uint8_t);
N    void printFloat(double, uint8_t);
N  public:
N    virtual void write(uint8_t) = 0;
N    virtual void write(const char *str);
N    virtual void write(const uint8_t *buffer, size_t size);
N
N    void print(const String &);
N    void print(const char[]);
N    void print(char, int = BYTE);
X    void print(char, int = 0);
N    void print(unsigned char, int = BYTE);
X    void print(unsigned char, int = 0);
N    void print(int, int = DEC);
X    void print(int, int = 10);
N    void print(unsigned int, int = DEC);
X    void print(unsigned int, int = 10);
N    void print(long, int = DEC);
X    void print(long, int = 10);
N    void print(unsigned long, int = DEC);
X    void print(unsigned long, int = 10);
N    void print(double, int = 2);
N
N    void println(const String &s);
N    void println(const char[]);
N    void println(char, int = BYTE);
X    void println(char, int = 0);
N    void println(unsigned char, int = BYTE);
X    void println(unsigned char, int = 0);
N    void println(int, int = DEC);
X    void println(int, int = 10);
N    void println(unsigned int, int = DEC);
X    void println(unsigned int, int = 10);
N    void println(long, int = DEC);
X    void println(long, int = 10);
N    void println(unsigned long, int = DEC);
X    void println(unsigned long, int = 10);
N    void println(double, int = 2);
N    void println(void);
N};
N
N#endif
L 29 "../src/cores/Print.cpp" 2
N
N#if 0
N#else
N#include "tms320f28035/sciDrv.h"
L 1 "D:/project/fpalette/ccs4/fpalette/ide_led/src/bsp/tms320f28035/sciDrv.h" 1
N/*** sciDrv.h - TMS320F28035 (piccolo) SCI Driver ***/
N
N/*** Copyright(C) 2011 Sansei System Co.,Ltd. ***/
N
N/*** HISTORY ***
N * 2011/02/15 mimu
N              First Version
N */
N
N#ifndef	INC_sciDrv_H
N#define	INC_sciDrv_H
N
N#ifdef	__cplusplus
Nextern "C" {
N#endif
N
Nint sciDrvInit( unsigned long _baseClock );
Nint sciCtrl( unsigned long bps, int charLen, char parity, int stop );
Nint sciOpen( void );
Nint sciClose( void );
Nint sciTx( unsigned char * pData, int len, int lenMin );
Nint sciRx( unsigned char * pData, int len, int lenMin );
N
Nint sciRxSize( void );
Nint sciRxPeek( void );
Nvoid sciRxFlush( void );
N
N
N#ifdef	__cplusplus
N} /* extern "C" */
N#endif
N
N#endif	/* INC_sciDrv_H */
N
N/*** end of file : sciDrv.h ***/
L 33 "../src/cores/Print.cpp" 2
N//#define	_write_(val)	sciTx( &(val), 1, 1 )
N#endif
N
N// Public Methods //////////////////////////////////////////////////////////////
N
N/* default implementation: may be overridden */
Nvoid Print::write(const char *str)
N{
N  while (*str) {
N#if 0
S    write(*str++);
N#else
N    sciTx( (unsigned char *)str, 1, 1 );
N    str ++;
N#endif
N  }
N}
N
N/* default implementation: may be overridden */
Nvoid Print::write(const uint8_t *buffer, size_t size)
N{
N  while (size--) {
N#if 0
S    write(*buffer++);
N#else
N    sciTx( (unsigned char *)buffer, 1, 1 );
N    buffer++;
N#endif
N  }
N}
N
Nvoid Print::print(const String &s)
N{
N  for (int i = 0; i < s.length(); i++) {
N#if 0
S    write(s[i]);
N#else
N    unsigned char c = s[i];
N    sciTx( &c, 1, 1 );
N#endif
N  }
N}
N
Nvoid Print::print(const char str[])
N{
N#if 0
S  _write_(str);
N#else
N  int len = strlen( str );
N  sciTx( (unsigned char *)str, len, len );
N#endif
N}
N
Nvoid Print::print(char c, int base)
N{
N  print((long) c, base);
N}
N
Nvoid Print::print(unsigned char b, int base)
N{
N  print((unsigned long) b, base);
N}
N
Nvoid Print::print(int n, int base)
N{
N  print((long) n, base);
N}
N
Nvoid Print::print(unsigned int n, int base)
N{
N  print((unsigned long) n, base);
N}
N
Nvoid Print::print(long n, int base)
N{
N  if (base == 0) {
N#if 0
S    write(n);
N#else
N    sciTx( (unsigned char *)&n, sizeof(long), sizeof(long) );
N#endif
N  } else if (base == 10) {
N    if (n < 0) {
N      print('-');
N      n = -n;
N    }
N    printNumber(n, 10);
N  } else {
N    printNumber(n, base);
N  }
N}
N
Nvoid Print::print(unsigned long n, int base)
N{
N	if (base == 0) {
N#if 0
S		write(n);
N#else
N		sciTx( (unsigned char *)&n, sizeof(unsigned long), sizeof(unsigned long) );
N#endif
N	} else {
N		printNumber(n, base);
N	}
N}
N
Nvoid Print::print(double n, int digits)
N{
N  printFloat(n, digits);
N}
N
Nvoid Print::println(void)
N{
N  print('\r');
N  print('\n');
N}
N
Nvoid Print::println(const String &s)
N{
N  print(s);
N  println();
N}
N
Nvoid Print::println(const char c[])
N{
N  print(c);
N  println();
N}
N
Nvoid Print::println(char c, int base)
N{
N  print(c, base);
N  println();
N}
N
Nvoid Print::println(unsigned char b, int base)
N{
N  print(b, base);
N  println();
N}
N
Nvoid Print::println(int n, int base)
N{
N  print(n, base);
N  println();
N}
N
Nvoid Print::println(unsigned int n, int base)
N{
N  print(n, base);
N  println();
N}
N
Nvoid Print::println(long n, int base)
N{
N  print(n, base);
N  println();
N}
N
Nvoid Print::println(unsigned long n, int base)
N{
N  print(n, base);
N  println();
N}
N
Nvoid Print::println(double n, int digits)
N{
N  print(n, digits);
N  println();
N}
N
N// Private Methods /////////////////////////////////////////////////////////////
N
Nvoid Print::printNumber(unsigned long n, uint8_t base)
N{
N  unsigned char buf[8 * sizeof(long)]; // Assumes 8-bit chars.
N  unsigned long i = 0;
N
N  if (n == 0) {
N    print('0');
N    return;
N  }
N
N  while (n > 0) {
N    buf[i++] = n % base;
N    n /= base;
N  }
N
N  for (; i > 0; i--)
N    print((char) (buf[i - 1] < 10 ?
N      '0' + buf[i - 1] :
N      'A' + buf[i - 1] - 10));
N}
N
Nvoid Print::printFloat(double number, uint8_t digits)
N{
N  // Handle negative numbers
N  if (number < 0.0)
N  {
N     print('-');
N     number = -number;
N  }
N
N  // Round correctly so that print(1.999, 2) prints as "2.00"
N  double rounding = 0.5;
N  for (uint8_t i=0; i<digits; ++i)
N    rounding /= 10.0;
N
N  number += rounding;
N
N  // Extract the integer part of the number and print it
N  unsigned long int_part = (unsigned long)number;
N  double remainder = number - (double)int_part;
N  print(int_part);
N
N  // Print the decimal point, but only if there are digits beyond
N  if (digits > 0)
N    print(".");
N
N  // Extract digits from the remainder one at a time
N  while (digits-- > 0)
N  {
N    remainder *= 10.0;
N    int toPrint = int(remainder);
N    print(toPrint);
N    remainder -= toPrint;
N  }
N}
