L 1 "../src/cores/f_gpio_shift.c"
N/*** f_gpio_shift.c - shiftIn/Out() ***/
N
N/*** Copyright(C) 2011 Sansei System Co.,Ltd. ***/
N
N/*** HISTORY ***
N * 2011/03/04 mimu
N              First Version
N */
N
N/*** INCLUDE ***/
N#include "config.h"
L 1 "D:/project/fpalette/ccs4/fpalette/ide_led/src/bsp/config.h" 1
N/*** config.h ***/
N
N
N#ifndef	INC_config_H
N#define	INC_config_H
N
N/******************************************************************************/
N/* NvRam Configuration                                                        */
N/******************************************************************************/
N#define	FLASH_PROGRAM_SEC_NO		0
N#define	FLASH_PROGRAM_SEC_NUM		6
N
N#define	FLASH_BOOTLOADER_SEC_NO		(FLASH_PROGRAM_SEC_NO + FLASH_PROGRAM_SEC_NUM)
N#define	FLASH_BOOTLOADER_SEC_NUM	2
N
N/******************************************************************************/
N/* Driver Configuration                                                       */
N/******************************************************************************/
N
N/*** CPU TIMER ***/
N#define	SUPPORT_CPU_TIMER_0		/* !! ATTATION !! system need timer0 */
N//#define	SUPPORT_CPU_TIMER_1
N//#define	SUPPORT_CPU_TIMER_2
N
N/*** SCI ***/
N#define	SUPPORT_SCI_A
N
N/*** Flash Mem. ***/
N//#define	SUPPORT_FLASH
N
N/******************************************************************************/
N/* GPIO map                                                                   */
N/******************************************************************************/
N#define	GPIO_NO_CPU_LED	39
N
N//#define	GPIO_NO_SCIRXDA	7
N#define	GPIO_NO_SCIRXDA	28
N
N//#define	GPIO_NO_SCITXDA	12
N#define	GPIO_NO_SCITXDA	29
N
N
N/*-----------------------------------------------------------------------------
N      Specify the PLL control register (PLLCR) and divide select (DIVSEL) value.
N-----------------------------------------------------------------------------*/
N
N//#define DSP28_DIVSEL   0 // Enable /4 for SYSCLKOUT
N//#define DSP28_DIVSEL   1 // Disable /4 for SYSCKOUT
N#define DSP28_DIVSEL   2 // Enable /2 for SYSCLKOUT
N//#define DSP28_DIVSEL   3 // Enable /1 for SYSCLKOUT
N
N
N#define DSP28_PLLCR   12    // Uncomment for 60 MHz devices [60 MHz = (10MHz * 12)/2]
N//#define DSP28_PLLCR   11
N//#define DSP28_PLLCR   10
N//#define DSP28_PLLCR    9
N//#define DSP28_PLLCR    8      // Uncomment for 40 MHz devices [40 MHz = (10MHz * 8)/2]
N//#define DSP28_PLLCR    7
N//#define DSP28_PLLCR    6
N//#define DSP28_PLLCR    5
N//#define DSP28_PLLCR    4
N//#define DSP28_PLLCR    3
N//#define DSP28_PLLCR    2
N//#define DSP28_PLLCR    1
N//#define DSP28_PLLCR    0  // PLL is bypassed in this mode
N//----------------------------------------------------------------------------
N
N/*-----------------------------------------------------------------------------
N      Specify the clock rate of the CPU (SYSCLKOUT) in nS.
N
N      Take into account the input clock frequency and the PLL multiplier
N      selected in step 1.
N
N      Use one of the values provided, or define your own.
N      The trailing L is required tells the compiler to treat
N      the number as a 64-bit value.
N
N      Only one statement should be uncommented.
N
N      Example:   60 MHz devices:
N                 CLKIN is a 10 MHz crystal or internal 10 MHz oscillator
N
N                 In step 1 the user specified PLLCR = 0xC for a
N                 60 MHz CPU clock (SYSCLKOUT = 60 MHz).
N
N                 In this case, the CPU_RATE will be 16.667L
N                 Uncomment the line: #define CPU_RATE 16.667L
N
N-----------------------------------------------------------------------------*/
N
N#define CPU_RATE   16.667L   // for a 60MHz CPU clock speed (SYSCLKOUT)
N//#define CPU_RATE   20.000L   // for a 50MHz CPU clock speed  (SYSCLKOUT)
N//#define CPU_RATE   25.000L   // for a 40MHz CPU clock speed  (SYSCLKOUT)
N//#define CPU_RATE   33.333L   // for a 30MHz CPU clock speed  (SYSCLKOUT)
N//#define CPU_RATE   41.667L   // for a 24MHz CPU clock speed  (SYSCLKOUT)
N//#define CPU_RATE   50.000L   // for a 20MHz CPU clock speed  (SYSCLKOUT)
N//#define CPU_RATE   66.667L   // for a 15MHz CPU clock speed  (SYSCLKOUT)
N//#define CPU_RATE  100.000L   // for a 10MHz CPU clock speed  (SYSCLKOUT)
N
N#if 0
S//----------------------------------------------------------------------------
S
S// The following pointer to a function call calibrates the ADC and internal oscillators
S#define Device_cal (void   (*)(void))0x3D7C80
S
S//---------------------------------------------------------------------------
S// Include Example Header Files:
S//
S
S#include "DSP2803x_GlobalPrototypes.h"         // Prototypes for global functions within the
S                                               // .c files.
S#include "DSP2803x_EPwm_defines.h"             // Macros used for PWM examples.
S#include "DSP2803x_I2C_defines.h"              // Macros used for I2C examples.
S#include "DSP2803x_Cla_Defines.h"              // Macros used for CLA examples.
S
S
S#define   PARTNO_28030PAG   0xAA
S#define   PARTNO_28030PN    0xAB
S
S#define   PARTNO_28031PAG   0xAE
S#define   PARTNO_28031PN    0xAF
S
S#define   PARTNO_28032PAG   0xB2
S#define   PARTNO_28032PN    0xB3
S
S#define   PARTNO_28033PAG   0xB6
S#define   PARTNO_28033PN    0xB7
S
S#define   PARTNO_28034PAG   0xBA
S#define   PARTNO_28034PN    0xBB
S
S#define   PARTNO_28035PAG   0xBE
S#define   PARTNO_28035PN    0xBF
S
S// Include files not used with DSP/BIOS
S#ifndef DSP28_BIOS
S#include "DSP2803x_DefaultISR.h"
S#endif
N#endif
N
Nextern void DSP28x_usDelay(unsigned long Count);
N// DO NOT MODIFY THIS LINE.
N#define DELAY_US(A)  DSP28x_usDelay(((((long double) A * 1000.0L) / (long double)CPU_RATE) - 9.0L) / 5.0L)
N
N#endif	/* INC_config_H */
N
N/*** end of file : config.h ***/
L 12 "../src/cores/f_gpio_shift.c" 2
N#include "sysLib.h"
L 1 "D:/project/fpalette/ccs4/fpalette/ide_led/src/bsp/sysLib.h" 1
N/*** sysLib.h - system i/f header ***/
N
N/*** Copyright(C) 2008 mimu ***/
N
N/*** NOTE ***
N */
N
N/*** HISTORY ***
N * 2007/08/xx mimu@emb
N              First version for SH-4A
N */
N
N#ifndef	INC_sysLib_H
N#define	INC_sysLib_H
N
N#ifndef	_ASMLANGUAGE
N
N#include	"config.h"
N
N//#include	"kernel.h"
N
N#ifdef	__cplusplus
Sextern "C" {
N#endif
N
N
Nint sysInit( void );
N
Nvoid sysDummyFunc();
Nvoid sysHalt( const char * msg );
N
N/* interrupt mask */
Nint		sysIntLock( void );
Nvoid	sysIntUnlock( int );
N
Nvoid bspDelay100nSec( int count );
N
Nconst char * sysOptionStringSerch( const char * pOpt, int *pLen, char startcode );
N
N/* for interrupt */
Nint sysIntConnect( unsigned int vecNo, void (*pFunc)(unsigned int vecNo) );
Nint sysIntEnable( unsigned int vecNo );
Nint sysIntDisable( unsigned int vecNo );
N
N//void * sysAlloc( unsigned long size, unsigned long aligne, int bDma );
N
N//extern void cachePurge( void * p, unsigned long size);	/* this function defined in romInit.src */
N
N/*** for NV-RAM ***/
N
N#if 0
S//int sysNvRamInit( void );
S//
S//int	sysNvRamMacGet( int ch, unsigned char * pMac );
S//int sysNvRamMacSet( int ch, unsigned char * pMac );
S//
S//int sysNvRamNetGet( int ch, SysNetCfg * pNet );
S//int sysNvRamNetSet( int ch, SysNetCfg * pNet );
S//
S//int sysNvRamExceptionGet( SysException * pSysException );
S//
S//int sysNvRamConsoleBpsGet( void );
S//int sysNvRamConsoleBpsSet( int bps );
S//
S//int sysNvRamPasswordGet( unsigned char * password );
S//int sysNvRamPasswordSet( unsigned char * password, int len );
S//
S//int sysNvRamLcdContrastGet( void );
S//int sysNvRamLcdContrastSet( int contrast );
N#endif
N
N#if 0	/* move to sysNvRam.h */
Sint	sysNvRamMacGet( int ch, unsigned char * );
Sint sysNvRamMacSet( int ch, unsigned char * );
N#endif
N
N#ifdef	__cplusplus
S}
N#endif
N
N#endif	/* _ASMLANGUAGE */
N#endif	/* INC_sysLib_H */
N
N/*** end of file : sysLib.h ***/
L 13 "../src/cores/f_gpio_shift.c" 2
N
N#include "tms320f28035/gpioDrv.h"
L 1 "D:/project/fpalette/ccs4/fpalette/ide_led/src/bsp/tms320f28035/gpioDrv.h" 1
N/*** gpioDrv.h - TMS320F28035(piccolo) GPIO driver ***/
N
N/*** Copyright(C) 2011 Sansei System Co.,Ltd. ***/
N
N/*** HISTORY ***
N * 2011/02/09 mimu
N              First Version
N */
N
N#ifndef	INC_gpioDrv_H
N#define	INC_gpioDrv_H
N
N#ifdef	__cplusplus
Sextern "C" {
N#endif
N
N#define	GPIO_MAX	44
N#define	GPIO_NUM	45
N
Nint gpioInit( void );
Nint gpioConfig( int no, int mode );
N#define	GPIO_MODE_GPIO			0x001
N#define	GPIO_MODE_1				0x002
N#define	GPIO_MODE_2				0x004
N#define	GPIO_MODE_3				0x008
N
N#define	GPIO_MODE_IN			0x010
N#define	GPIO_MODE_OUT			0x020
N#define	GPIO_MODE_PULLUP_DIS	0x040
N#define	GPIO_MODE_PULLUP		0x080
N
N#define	GPIO_MODE_QUALIFIER_0	0x100
N#define	GPIO_MODE_QUALIFIER_1	0x200
N#define	GPIO_MODE_QUALIFIER_2	0x400
N#define	GPIO_MODE_QUALIFIER_3	0x800
N#define	GPIO_MODE_QUALIFILER(_x)	(0x100<<(_x))&0x0f00))
N
N#define	GPIO_CTRL_SET		0
N#define	GPIO_CTRL_CLR		1
N#define	GPIO_CTRL_TOGGLE	2
N#define	GPIO_CTRL_GET		3
Nint gpioCtrl( int no, int ctrl );
N
N//int gpioControl( int no, int bHigh );
N#define	gpioControl( _no, _bH )	(bH?gpioCtrl(_no, GPIO_CTRL_SET):gpioCtrl(_no, GPIO_CTRL_CLR))
N//int gpioSet( int no );
N#define	gpioSet( _no )		gpioCtrl( _no, GPIO_CTRL_SET )
N//int gpioClear( int no );
N#define	gpioClear( _no )	gpioCtrl( _no, GPIO_CTRL_CLR )
N//int gpioToggle( int no );
N#define	gpioToggle( _no )	gpioCtrl( _no, GPIO_CTRL_TOGGLE )
N//int gpioGet( int no );
N#define	gpioGet( _no )		gpioCtrl( _no, GPIO_CTRL_GET )
N
Nint gpioCtrlRegSet( int reg, int value );
N#define	GPIO_CTRLREG_QUALPRD_0_7	0		/* GPIO 0-7 */
N#define	GPIO_CTRLREG_QUALPRD_8_15	1		/* GPIO 8-15 */
N#define	GPIO_CTRLREG_QUALPRD_16_23	2		/* GPIO 16-23 */
N#define	GPIO_CTRLREG_QUALPRD_24_31	3		/* GPIO 24-31 */
N
N#define	GPIO_CTRLREG_QUBLPRD_32_39	4		/* GPIO 32-39 */
N#define	GPIO_CTRLREG_QUBLPRD_40_44	5		/* GPIO 32-44 */
N
N#ifdef	__cplusplus
S} /* extern "C" */
N#endif
N
N#endif	/* INC_gpioDrv_H */
N
N/*** end of file : gpioDrv.h ***/
L 15 "../src/cores/f_gpio_shift.c" 2
N
N#include "f_types.h"
L 1 "..\src\cores\f_types.h" 1
N/*** f_types.h - ***/
N
N#ifndef	INC_f_types_H
N#define	INC_f_types_H
N
N#include <stdint.h>
L 1 "C:/Program Files (x86)/Texas Instruments/ccsv4/tools/compiler/c2000/include/stdint.h" 1
N/*****************************************************************************/
N/* STDINT.H v5.2.6                                                           */
N/* Copyright (c) 2002-2010 Texas Instruments Incorporated                    */
N/*****************************************************************************/
N#ifndef _STDINT_H_
N#define _STDINT_H_
N
N/* 7.18.1.1 Exact-width integer types */
N
N    typedef          int    int16_t;
N    typedef unsigned int   uint16_t;
N    typedef          long   int32_t;
N    typedef unsigned long  uint32_t;
N
N
N#if defined(__TMS470__) || defined(_TMS320C6X) || defined(__TMS320C28X__)
X#if 0L || 0L || 1L
N    typedef          long long  int64_t;
N    typedef unsigned long long uint64_t;
N#endif
N
N/* 7.18.1.2 Minimum-width integer types */
N
N    typedef  int16_t  int_least8_t;
N    typedef uint16_t uint_least8_t;
N
N    typedef  int16_t  int_least16_t;
N    typedef uint16_t uint_least16_t;
N    typedef  int32_t  int_least32_t;
N    typedef uint32_t uint_least32_t;
N
N
N#if defined(__TMS470__) || defined(_TMS320C6X) || defined(__TMS320C28X__)
X#if 0L || 0L || 1L
N    typedef  int64_t  int_least64_t;
N    typedef uint64_t uint_least64_t;
N#else
S/* sorry, int_least64_t not implemented for C54x, C55x, MSP430 */
N#endif
N
N/* 7.18.1.3 Fastest minimum-width integer types */
N
N    typedef  int16_t  int_fast8_t;
N    typedef uint16_t uint_fast8_t;
N    typedef  int16_t  int_fast16_t;
N    typedef uint16_t uint_fast16_t;
N
N    typedef  int32_t  int_fast32_t;
N    typedef uint32_t uint_fast32_t;
N
N
N#if defined(__TMS470__) || defined(_TMS320C6X) || defined(__TMS320C28X__)
X#if 0L || 0L || 1L
N    typedef  int64_t  int_fast64_t;
N    typedef uint64_t uint_fast64_t;
N#endif
N
N/* 7.18.1.4 Integer types capable of holding object pointers */
N    typedef          long intptr_t;
N    typedef unsigned long uintptr_t;
N
N/* 7.18.1.5 Greatest-width integer types */
N#if defined(__TMS320C55X__) || defined(__TMS470__) || defined(_TMS320C6X) || defined(__TMS320C28X__)
X#if 0L || 0L || 0L || 1L
N    typedef          long long intmax_t;
N    typedef unsigned long long uintmax_t;
N#elif defined(_TMS320C5XX) || defined(__TMS320C27X__) || defined(__MSP430__)
S    typedef          long intmax_t;
S    typedef unsigned long uintmax_t;
N#endif
N
N/* 
N   According to footnotes in the 1999 C standard, "C++ implementations
N   should define these macros only when __STDC_LIMIT_MACROS is defined
N   before <stdint.h> is included." 
N*/
N#if !defined(__cplusplus) || defined(__STDC_LIMIT_MACROS)
X#if !0L || 0L
N
N/* 7.18.2 Limits of specified width integer types */
N
N
N    #define  INT16_MAX  0x7fff
N    #define  INT16_MIN  (-INT16_MAX-1)
N    #define UINT16_MAX  0xffff
N
N    #define  INT32_MAX  0x7fffffff
N    #define  INT32_MIN  (-INT32_MAX-1)
N    #define UINT32_MAX  0xffffffff
N
N
N#if defined(__TMS470__) || defined(_TMS320C6X) || defined(__TMS320C28X__)
X#if 0L || 0L || 1L
N    #define  INT64_MAX  0x7fffffffffffffff
N    #define  INT64_MIN  (-INT64_MAX-1)
N    #define UINT64_MAX  0xffffffffffffffff
N#endif
N
N    #define  INT_LEAST8_MAX   INT16_MAX
N    #define  INT_LEAST8_MIN   INT16_MIN
N    #define UINT_LEAST8_MAX   UINT16_MAX
N
N    #define  INT_LEAST16_MAX  INT16_MAX
N    #define  INT_LEAST16_MIN  INT16_MIN
N    #define UINT_LEAST16_MAX  UINT16_MAX
N    #define  INT_LEAST32_MAX  INT32_MAX
N    #define  INT_LEAST32_MIN  INT32_MIN
N    #define UINT_LEAST32_MAX  UINT32_MAX
N
N
N#if defined(__TMS470__) || defined(_TMS320C6X) || defined(__TMS320C28X__)
X#if 0L || 0L || 1L
N    #define  INT_LEAST64_MAX  INT64_MAX
N    #define  INT_LEAST64_MIN  INT64_MIN
N    #define UINT_LEAST64_MAX  UINT64_MAX
N#endif
N
N    #define  INT_FAST8_MAX   INT16_MAX
N    #define  INT_FAST8_MIN   INT16_MIN
N    #define UINT_FAST8_MAX   UINT16_MAX
N    #define  INT_FAST16_MAX  INT16_MAX
N    #define  INT_FAST16_MIN  INT16_MIN
N    #define UINT_FAST16_MAX  UINT16_MAX
N
N    #define  INT_FAST32_MAX  INT32_MAX
N    #define  INT_FAST32_MIN  INT32_MIN
N    #define UINT_FAST32_MAX  UINT32_MAX
N
N
N#if defined(__TMS470__) || defined(_TMS320C6X) || defined(__TMS320C28X__)
X#if 0L || 0L || 1L
N    #define  INT_FAST64_MAX  INT64_MAX
N    #define  INT_FAST64_MIN  INT64_MIN
N    #define UINT_FAST64_MAX  UINT64_MAX
N#endif
N
N    #define INTPTR_MAX   INT32_MAX
N    #define INTPTR_MIN   INT32_MIN
N    #define UINTPTR_MAX  UINT32_MAX
N
N#if defined(__TMS470__) || defined(_TMS320C6X) || defined(__TMS320C28X__)
X#if 0L || 0L || 1L
N    #define INTMAX_MIN   INT64_MIN
N    #define INTMAX_MAX   INT64_MAX
N    #define UINTMAX_MAX  UINT64_MAX
N#elif defined(_TMS320C5XX) || defined(__TMS320C27X__) || defined(__MSP430__)
S    #define INTMAX_MIN   INT32_MIN
S    #define INTMAX_MAX   INT32_MAX
S    #define UINTMAX_MAX  UINT32_MAX
N#endif
N
N/* 7.18.3 Limits of other integer types */
N
N    #define PTRDIFF_MAX INT32_MAX
N    #define PTRDIFF_MIN INT32_MIN
N
N    #define SIG_ATOMIC_MIN INT32_MIN
N    #define SIG_ATOMIC_MAX INT32_MAX
N
N    #define SIZE_MAX INT32_MAX
N
N#ifndef WCHAR_MAX
N#define WCHAR_MAX 0xffffu
N#endif
N
N#ifndef WCHAR_MIN
N#define WCHAR_MIN 0
N#endif
N
N    #define WINT_MIN INT32_MIN
N    #define WINT_MAX INT32_MAX
N
N/* 7.18.4.1 Macros for minimum-width integer constants */
N
N/*
N   There is a defect report filed against the C99 standard concerning how 
N   the (U)INTN_C macros should be implemented.  Please refer to --
N   http://wwwold.dkuug.dk/JTC1/SC22/WG14/www/docs/dr_209.htm 
N   for more information.  These macros are implemented according to the
N   suggestion given at this web site.
N*/
N
N    #define  INT8_C(value)  ((int_least8_t)(value))
N    #define UINT8_C(value)  ((uint_least8_t)(value))
N    #define  INT16_C(value) ((int_least16_t)(value))
N    #define UINT16_C(value) ((uint_least16_t)(value))
N    #define  INT32_C(value) ((int_least32_t)(value))
N    #define UINT32_C(value) ((uint_least32_t)(value))
N
N
N#if defined(__TMS470__) || defined(_TMS320C6X) || defined(__TMS320C28X__)
X#if 0L || 0L || 1L
N    #define  INT64_C(value) ((int_least64_t)(value))
N    #define UINT64_C(value) ((uint_least64_t)(value))
N#endif
N
N/* 7.18.4.2 Macros for greatest-width integer constants */
N
N    #define  INTMAX_C(value) ((intmax_t)(value))
N    #define UINTMAX_C(value) ((uintmax_t)(value))
N
N#endif /* !defined(__cplusplus) || defined(__STDC_LIMIT_MACROS) */
N
N#endif /* _STDINT_H_ */
L 7 "..\src\cores\f_types.h" 2
N
N//typedef	unsigned short	uint16_t;
Ntypedef	unsigned char	uint8_t;
N
N
Ntypedef unsigned int word;
N
N//typedef uint8_t boolean;
Ntypedef unsigned int boolean;
Ntypedef uint8_t byte;
N
N#define lowByte(w) ((uint8_t) ((w) & 0xff))
N#define highByte(w) ((uint8_t) ((w) >> 8))
N
N#define bit(b) (1UL << (b))
N
N#define bitRead(value, bit) (((value) >> (bit)) & 0x01)
N#define bitSet(value, bit) ((value) |= (1UL << (bit)))
N#define bitClear(value, bit) ((value) &= ~(1UL << (bit)))
N#define bitWrite(value, bit, bitvalue) (bitvalue ? bitSet(value, bit) : bitClear(value, bit))
N
N
N#endif	/* INC_f_types_H */
N
N/*** end of file : f_types.h ***/
L 17 "../src/cores/f_gpio_shift.c" 2
N#include "f_const.h"
L 1 "..\src\cores\f_const.h" 1
N/*** f_const.h - fpallet const data define ***/
N
N/*** Copyright(C) 2011 Sansei System Co.,Ltd. ***/
N
N/*** HISTORY ***
N * 2011/02/28 mimu
N              First Version
N */
N
N#ifndef	INC_f_const_H
N#define	INC_f_const_H
N
N#ifdef	__cplusplus
Sextern "C" {
N#endif
N
N#define LOW		0x0
N#define HIGH	0x1
N#define	TOGGLE	0x02
N
N#define	INPUT	0
N#define	OUTPUT	1
N#define	MODE_2	2
N#define	MODE_3	3
N
N#define true 0x1
N#define false 0x0
N
N//#define PI 3.1415926535897932384626433832795
N//#define HALF_PI 1.5707963267948966192313216916398
N//#define TWO_PI 6.283185307179586476925286766559
N//#define DEG_TO_RAD 0.017453292519943295769236907684886
N//#define RAD_TO_DEG 57.295779513082320876798154814105
N
N//#define SERIAL  0x0
N//#define DISPLAY 0x1
N
N#define LSBFIRST 0
N#define MSBFIRST 1
N
N//#define CHANGE 1
N//#define FALLING 2
N//#define RISING 3
N
N//#if defined(__AVR_ATmega1280__) || defined(__AVR_ATmega2560__)
N//#define INTERNAL1V1 2
N//#define INTERNAL2V56 3
N//#else
N//#define INTERNAL 3
N//#endif
N
N//#define DEFAULT 1
N//#define EXTERNAL 0
N
N
N
N#ifdef	__cplusplus
S} /* extern "C" */
N#endif
N
N#endif	/* INC_f_const_H */
N
N/*** end of file : f_const.h ***/
L 18 "../src/cores/f_gpio_shift.c" 2
N
N#include "f_gpio.h"
L 1 "..\src\cores\f_gpio.h" 1
N/*** f_gpio.h - fpallet GPIO control ***/
N
N/*** Copyright(C) 2011 Sansei System Co.,Ltd. ***/
N
N/*** HISTORY ***
N * 2011/03/01 mimu
N              First Version
N */
N
N#ifndef	INC_f_gpio_H
N#define	INC_f_gpip_H
N
N#include "f_types.h"
N#include "f_const.h"
N
N#ifdef	__cplusplus
Sextern "C" {
N#endif
N
Nvoid pinMode( uint8_t pin, uint8_t mode );
Nvoid digitalWrite(uint8_t, uint8_t);
Nint digitalRead(uint8_t);
N
Nunsigned long pulseIn(uint8_t pin, uint8_t state, unsigned long timeout);
N
Nvoid shiftOut(uint8_t dataPin, uint8_t clockPin, uint8_t bitOrder, uint8_t val);
Nuint8_t shiftIn(uint8_t dataPin, uint8_t clockPin, uint8_t bitOrder);
N
N
N#ifdef	__cplusplus
S}	/* extern "C" */
N#endif
N
N#endif	/* INC_f_gpio_H */
N
N/*** end of file : f_gpio.h ***/
L 20 "../src/cores/f_gpio_shift.c" 2
N
N/*** DEFINE ***/
N
N/*** FUNCTION ***/
N
N/*** WORK ***/
N
N/*******************************************************************************
N *
N */
Nvoid shiftOut( uint8_t dataNo, uint8_t clkNo, uint8_t order, uint8_t data )
N{
N	int bit;
N	uint8_t bitMask;
N
N	if( order == LSBFIRST ) {
X	if( order == 0 ) {
N		bitMask = 1;
N	} else {
N		bitMask = 0x80;
N	}
N
N	for( bit=0; bit<8; bit++ ) {
N		if( data & bitMask ) {
N			gpioSet( dataNo );
X			gpioCtrl( dataNo, 0 );
N		} else {
N			gpioClear( dataNo );
X			gpioCtrl( dataNo, 1 );
N		}
N		if( order == LSBFIRST ) {
X		if( order == 0 ) {
N			data >>= 1;
N		} else {
N			data <<= 1;
N		}
N		gpioSet( clkNo );
X		gpioCtrl( clkNo, 0 );
N		gpioClear( clkNo );
X		gpioCtrl( clkNo, 1 );
N	}
N
N}
N
N/*******************************************************************************
N *
N */
Nuint8_t shiftIn( uint8_t dataNo, uint8_t clkNo, uint8_t ordef )
N{
N	int data;
N	int bit;
N	int bitSet;
N
N	data = 0;
N
N	if( ordef == LSBFIRST ) {
X	if( ordef == 0 ) {
N		bitSet = 0x80;
N	} else {
N		bitSet = 1;
N	}
N
N	for( bit=0; bit<8; bit++ ) {
N		if( ordef == LSBFIRST ) {
X		if( ordef == 0 ) {
N			data >>= 1;
N		} else {
N			data <<= 1;
N		}
N		gpioSet( clkNo );
X		gpioCtrl( clkNo, 0 );
N		if( gpioGet( dataNo ) ) {
X		if( gpioCtrl( dataNo, 3 ) ) {
N			data |= bitSet;
N		}
N		gpioClear( clkNo );
X		gpioCtrl( clkNo, 1 );
N	}
N
N	return (uint8_t)data;
N}
N
