/*** flashDrv.h - TMS320F28035 Flash Memory Driver ***/

/*** HISTORY ***
 * 2011/02/23 mimu
              First Version
 */

#ifndef	INC_flashDrv_H
#define	INC_flashDrv_H

#define	FLASH_SEC_NUM	8	/* A to H */

int flashInit( void );
unsigned long flashSecSize( unsigned int secNo );
unsigned short * flashSecTop( unsigned int secNo );

int flashErase( unsigned int secNo, unsigned int secNum );
int flashWrite( int secNo, unsigned long offset, unsigned short * pData, unsigned short size );
int flashVerify( int secNo, unsigned long offset, unsigned short * pData, unsigned short size );


#endif	/* INC_flashDrv_H */
