#ifndef WProgram_h
#define WProgram_h

#include <stdlib.h>
#include <string.h>
#include <math.h>

#include "config.h"

//#include <avr/interrupt.h>	//mimutodo

#include "wiring.h"

#ifdef __cplusplus
#include "f_types.h"
#include "f_const.h"
#include "f_gpio.h"
#include "f_time.h"
#include "f_analog.h"

#include "WCharacter.h"
//#include "WString.h"
//#include "HardwareSerial.h"	//mimutodo

uint16_t makeWord(uint16_t w);
uint16_t makeWord(byte h, byte l);

//#define word(...) makeWord(__VA_ARGS__)	// mimutodo

unsigned long pulseIn(uint8_t pin, uint8_t state, unsigned long timeout = 1000000L);

#include "f_tone.h"
//void tone(uint8_t _pin, unsigned int frequency, unsigned long duration = 0);
//void noTone(uint8_t _pin);

/* WMath prototypes */
long random(long);
long random(long, long);
void randomSeed(unsigned int);
long map(long, long, long, long, long);

//#if defined(__AVR_ATmega1280__) || defined(__AVR_ATmega2560__)	mimutodo
//const static uint8_t A0 = 54;										mimutodo
//const static uint8_t A1 = 55;										mimutodo
//const static uint8_t A2 = 56;										mimutodo
//const static uint8_t A3 = 57;										mimutodo
//const static uint8_t A4 = 58;										mimutodo
//const static uint8_t A5 = 59;										mimutodo
//const static uint8_t A6 = 60;										mimutodo
//const static uint8_t A7 = 61;										mimutodo
//const static uint8_t A8 = 62;										mimutodo
//const static uint8_t A9 = 63;										mimutodo
//const static uint8_t A10 = 64;									mimutodo
//const static uint8_t A11 = 65;									mimutodo
//const static uint8_t A12 = 66;									mimutodo
//const static uint8_t A13 = 67;									mimutodo
//const static uint8_t A14 = 68;									mimutodo
//const static uint8_t A15 = 69;									mimutodo
//#else																mimutodo
//const static uint8_t A0 = 14;										mimutodo
//const static uint8_t A1 = 15;										mimutodo
//const static uint8_t A2 = 16;										mimutodo
//const static uint8_t A3 = 17;										mimutodo
//const static uint8_t A4 = 18;										mimutodo
//const static uint8_t A5 = 19;										mimutodo
//const static uint8_t A6 = 20;										mimutodo
//const static uint8_t A7 = 21;										mimutodo
//#endif

#endif

#endif
