/*** f_gpio.h - fpalette GPIO control ***/

/*** Copyright(C) 2011 Sansei System Co.,Ltd. ***/

/*** HISTORY ***
 * 2011/03/01 mimu
              First Version
 */

#ifndef	INC_f_gpio_H
#define	INC_f_gpip_H

#include "f_types.h"
#include "f_const.h"

#ifdef	__cplusplus

void pinMode( uint8_t pin, uint8_t mode );
void digitalWrite(uint8_t, uint8_t);
int digitalRead(uint8_t);

unsigned long pulseIn(uint8_t pin, uint8_t state, unsigned long timeout);

void shiftOut(uint8_t dataPin, uint8_t clockPin, uint8_t bitOrder, uint8_t val);
uint8_t shiftIn(uint8_t dataPin, uint8_t clockPin, uint8_t bitOrder);


#endif

#endif	/* INC_f_gpio_H */

/*** end of file : f_gpio.h ***/
