/*** f_int.h - fpalette interrupt control ***/

/*** Copyright(C) 2011 Sansei System Co.,Ltd. ***/

/*** HISTORY ***
 * 2011/03/01 mimu
              First Version
 */

#ifndef	INC_f_int_H
#define	INC_f_int_H

#ifdef	__cplusplus

#include "f_types.h"
#include "tms320f28035/tms320f28035.h"

#define interrupts()	DINT
#define noInterrupts()	EINT

void attachInterrupt(uint8_t, void (*)(void), int mode);
void attachInterrupt(int, void (*)(void) );
void detachInterrupt(int);

#endif

#endif	/* INC_f_int_H */

/*** end of file : f_int.h ***/
