/*** f_stdlib.h - stdlib ***/

/*** Copyright(C) 2011 Sansei System Co.,Ltd. ***/

/*** HISTORY ***
 * 2011/03/02 mimu
              First Version
 */

/*** NOTE ***
 */

#ifndef	INC_f_stdlib_H
#define	INC_f_stdlib_H

#ifdef	__cplusplus
extern "C" {
#endif


char * f_itoa( int val, char * p, int base );
char * f_ultoa( unsigned long val, char * p, int base );
char * f_ltoa( long val, char * p, int base );

#define	itoa	f_itoa
#define	ultoa	f_ultoa
#define	ltoa	f_ltoa

#ifdef	__cplusplus
} /* extern "C" */
#endif

#endif	/* INC_f_stdlib_H */

/*** end of file : f_stdlib.h ***/
